IMPLEMENTATION MODULE Disk;

IMPORT IntMen;
IMPORT Grawin;
IMPORT DDD;
IMPORT InOut;
IMPORT NewTerm;

FROM Strings  IMPORT Concat, Length;
FROM Str      IMPORT Match, CardToStr;

PROCEDURE TexOutput(fn : ARRAY OF CHAR; ext : ARRAY OF CHAR; xsize, ysize, winnum : CARDINAL);
VAR
  xywin,xzwin, yzwin, dddwin, count, obj, n, ii, i : CARDINAL;
  maxpoints, max : INTEGER;
  dpoi, pd, pd1, pd2 : DDD.DPoint;
  pda, pdb : DDD.DCoord;
  dsc : DDD.DScale;
  wul, crogddd, pp, wbr, worg, orgxy, orgxz, crorgxy, crorgxz, crorgyz, org, p, orgyz : Grawin.Coord;
  x, y, ax, ay, xr, yr : REAL;
  sc : REAL;

  flag, ok, hidden : BOOLEAN;
  str, cardstr : Grawin.LString;

BEGIN

  xywin:=DDD.GetXYWin();
  xzwin:=DDD.GetXZWin();
  yzwin:=DDD.GetYZWin();
  dddwin:=DDD.GetDDDWin();

  pp:=Grawin.GetWinGraphicSize(winnum);
  InOut.OpenNamedOutput(fn,'pic');
  InOut.WriteString("\unitlength=1.0mm");
  InOut.WriteLn;
  InOut.WriteString("\special{em:linewidth 0.4pt}");
  InOut.WriteLn;
  InOut.WriteString("\linethickness{0.4pt}");
  InOut.WriteLn;

  CardToStr(LONGCARD(xsize),cardstr,10,ok);
  Concat("\begin{picture}(",cardstr,str);
  Concat(str," , ",str);
  CardToStr(LONGCARD(ysize),cardstr,10,ok);
  Concat(str,cardstr,str);
  Concat(str,")",str);

  InOut.WriteString(str);
  InOut.WriteLn;

  wul:=Grawin.GetWinUpperLeft(winnum);
  wbr:=Grawin.GetWinBottomRight(winnum);
  worg:=Grawin.GetWinOrg(winnum);
  sc:=Grawin.GetWinZoom(winnum);
  count:=0;

  xr:=REAL(xsize)/REAL(wbr.x-wul.x);
  yr:=REAL(ysize)/REAL(wbr.y-wul.y);

  NewTerm.SetWindow(wul.x,wul.y,wbr.x,wbr.y);
  FOR obj:=DDD.GetFirstObjnum() TO DDD.GetLastObjnum() DO
    IF DDD.DoesObjExists(obj) THEN
      Grawin.Beep;
      IF winnum=xywin THEN org:=DDD.GetStObjXYOrg(obj); END;
      IF winnum=xywin THEN org:=DDD.GetStObjXZOrg(obj); END;
      IF winnum=yzwin THEN org:=DDD.GetStObjYZOrg(obj); END;
      IF winnum=dddwin THEN
        orgxy:=DDD.GetStObjXYOrg(obj);
        orgyz:=DDD.GetStObjYZOrg(obj);
        crorgxy:=Grawin.GetWinOrg(DDD.GetXYWin());
        crorgyz:=Grawin.GetWinOrg(DDD.GetYZWin());
        org:=Grawin.GetWinOrg(DDD.GetDDDWin());
      END;

      dsc:=DDD.GetStObjScale(obj);

      IF winnum<>dddwin THEN
        dsc.scx:=dsc.scx*sc;
        dsc.scy:=dsc.scy*sc;
        dsc.scz:=dsc.scz*sc;
      END;

      org.x:=DDD.ROUND(FLOAT(worg.x (* +wul.x *) )+FLOAT(org.x-worg.x)*sc);
      org.y:=DDD.ROUND(FLOAT(worg.y (* +wul.y *) )+FLOAT(org.y-worg.y)*sc);

      IF DDD.IsStObjDrawable(obj) THEN
        flag:=FALSE;
        FOR i:=1 TO DDD.GetStObjSize(obj) DO

          dpoi:=DDD.GetStObjPoint(obj,i);
          IF winnum=xywin THEN
            x:=(FLOAT(dpoi.x)*dsc.scx+FLOAT(org.x))*xr;
            y:=(FLOAT(dpoi.y)*dsc.scy+FLOAT(org.y))*yr;
          END;
          IF winnum=xzwin THEN
            x:=(FLOAT(dpoi.x)*dsc.scx+FLOAT(org.x))*xr;
            y:=(FLOAT(dpoi.z)*dsc.scz+FLOAT(org.y))*yr;
          END;
          IF winnum=yzwin THEN
            x:=(FLOAT(dpoi.y)*dsc.scy+FLOAT(org.x))*xr;
            y:=(FLOAT(dpoi.z)*dsc.scz+FLOAT(org.y))*yr;
          END;
          IF winnum=dddwin THEN
            pda.x:=DDD.ROUND(FLOAT(dpoi.x)*dsc.scx)+orgxy.x-crorgxy.x;
            pda.y:=DDD.ROUND(FLOAT(dpoi.y)*dsc.scy)+orgxy.y-crorgxy.y;
            pda.z:=DDD.ROUND(FLOAT(dpoi.z)*dsc.scz)+orgyz.y-crorgyz.y;
            pp:=DDD.Project(pda);
            x:=(FLOAT(pp.x)*sc+FLOAT(org.x))*xr;
            y:=(FLOAT(pp.y)*sc+FLOAT(org.y))*yr;
          END;

          IF flag AND dpoi.drawline THEN

            InOut.WriteString("\emline{");
            InOut.WriteInt(INTEGER(ax),1);
            InOut.WriteString(".");
            InOut.WriteInt(ABS(INTEGER((ax-REAL(INTEGER(ax)))*1.0E3)),1);
            InOut.WriteString("}{");

            InOut.WriteInt(INTEGER(ay),1);
            InOut.WriteString(".");
            InOut.WriteInt(ABS(INTEGER((ay-REAL(INTEGER(ay)))*1.0E3)),1);
            InOut.WriteString("}{");

            INC(count);

            InOut.WriteInt(count,1);
            InOut.WriteString("}{");

            InOut.WriteInt(INTEGER(x),1);
            InOut.WriteString(".");
            InOut.WriteInt(ABS(INTEGER((x-REAL(INTEGER(x)))*1.0E3)),1);
            InOut.WriteString("}{");

            InOut.WriteInt(INTEGER(y),1);
            InOut.WriteString(".");
            InOut.WriteInt(ABS(INTEGER((y-REAL(INTEGER(y)))*1.0E3)),1);
            InOut.WriteString("}{");

            INC(count);
            InOut.WriteInt(count,1);
            InOut.WriteString("}");
            InOut.WriteLn;

          END;

          ax:=x;
          ay:=y;
          flag:=TRUE;
        END;
      END;
    END;
  END;

  InOut.WriteString("\end{picture}");
  InOut.CloseOutput;

END TexOutput;

PROCEDURE ReadColor(VAR rgb : Grawin.RGB);
BEGIN
  InOut.ReadCard(rgb.r);
  InOut.ReadCard(rgb.g);
  InOut.ReadCard(rgb.b);
END ReadColor;

PROCEDURE WriteColor(rgb : Grawin.RGB);
BEGIN
  InOut.WriteCard(rgb.r,1);
  InOut.WriteLn;
  InOut.WriteCard(rgb.g,1);
  InOut.WriteLn;
  InOut.WriteCard(rgb.b,1);
  InOut.WriteLn;
END WriteColor;

PROCEDURE Write2DCoord(p : Grawin.Coord);
BEGIN
  InOut.WriteInt(p.x,1);
  InOut.WriteLn;
  InOut.WriteInt(p.y,1);
  InOut.WriteLn;
END Write2DCoord;

PROCEDURE Read2DCoord(VAR p : Grawin.Coord);
BEGIN
  InOut.ReadInt(p.x);
  InOut.ReadInt(p.y);
END Read2DCoord;

PROCEDURE Write3DCoord(p : DDD.DCoord);
BEGIN
  InOut.WriteInt(p.x,1);
  InOut.WriteLn;
  InOut.WriteInt(p.y,1);
  InOut.WriteLn;
  InOut.WriteInt(p.z,1);
  InOut.WriteLn;
END Write3DCoord;

PROCEDURE Read3DCoord(VAR p : DDD.DCoord);
BEGIN
  InOut.ReadInt(p.x);
  InOut.ReadInt(p.y);
  InOut.ReadInt(p.z);
END Read3DCoord;

PROCEDURE WriteBOOL(flag : BOOLEAN);
BEGIN
  IF flag THEN
    InOut.WriteInt(1,1);
  ELSE
    InOut.WriteInt(0,1);
  END;
  InOut.WriteLn;
END WriteBOOL;

PROCEDURE ReadBOOL(VAR flag : BOOLEAN);
VAR i : INTEGER;
BEGIN
  InOut.ReadInt(i);
  IF i=0 THEN
    flag:=FALSE;
  ELSE
    flag:=TRUE;
  END;
END ReadBOOL;

PROCEDURE WriteDiskString(string : ARRAY OF CHAR);
VAR i : CARDINAL;
BEGIN
  FOR i:=0 TO 9 DO
    InOut.Write(string[i]);
  END;
END WriteDiskString;

PROCEDURE ReadDiskString(VAR string :ARRAY OF CHAR);
VAR i : CARDINAL;
    c : CHAR;
BEGIN
  FOR i:=0 TO 9 DO
    InOut.Read(c);
    string[i]:=c;
  END;
END ReadDiskString;

PROCEDURE SaveStObject(obj : CARDINAL; fn, ext : ARRAY OF CHAR);
VAR name : Grawin.LString;
    ii, n, max : CARDINAL;
    dsc : DDD.DScale;
    p : Grawin.Coord;
    pd : DDD.DPoint;
    pp : DDD.DCoord;

BEGIN

  InOut.OpenNamedOutput(fn,ext);
  InOut.WriteString("PoorWorld"); InOut.WriteLn;
  IF DDD.DoesObjExists(obj) THEN
    DDD.GetObjName(name,obj);
    WriteDiskString(name);
    dsc:=DDD.GetStObjScale(obj);

    InOut.WriteInt(DDD.ROUND(dsc.scx*1000.0),1);
    InOut.WriteLn;
    InOut.WriteInt(DDD.ROUND(dsc.scy*1000.0),1);
    InOut.WriteLn;
    InOut.WriteInt(DDD.ROUND(dsc.scz*1000.0),1);
    InOut.WriteLn;

    p:=DDD.GetStObjXYOrg(obj);
    Write2DCoord(p);

    p:=DDD.GetStObjXZOrg(obj);
    Write2DCoord(p);

    p:=DDD.GetStObjYZOrg(obj);
    Write2DCoord(p);

    InOut.WriteInt(DDD.GetStObjSize(obj),1);
    InOut.WriteLn;

    FOR n:=1 TO DDD.GetStObjSize(obj) DO
      pd:=DDD.GetStObjPoint(obj,n);
      pp.x:=pd.x; pp.y:=pd.y; pp.z:=pd.z;
      Write3DCoord(pp);
      WriteColor(pd.col);
      WriteBOOL(pd.drawline);
    END;
  END;
END SaveStObject;

PROCEDURE SaveStObjects(fn, ext : ARRAY OF CHAR);
VAR ii, n, max, obj : CARDINAL;
    name : Grawin.LString;
    dsc : DDD.DScale;
    p : Grawin.Coord;
    pd : DDD.DPoint;
    pp : DDD.DCoord;

BEGIN

  max:=0;
  FOR obj:=DDD.GetFirstObjnum() TO DDD.GetLastObjnum() DO
    IF DDD.DoesObjExists(obj) THEN
      INC(max);
    END;
  END;
  InOut.OpenNamedOutput(fn,ext);
  InOut.WriteString("PoorWorld"); InOut.WriteLn;
  Write3DCoord(DDD.GetEyePos());
  InOut.WriteInt(DDD.GetPlaneDist(),1);
  InOut.WriteLn;
  InOut.WriteInt(max,1);
  InOut.WriteLn;
  FOR obj:=DDD.GetFirstObjnum() TO DDD.GetLastObjnum() DO
    IF DDD.DoesObjExists(obj) THEN
      InOut.WriteCard(obj,1); InOut.WriteLn;
      DDD.GetObjName(name,obj);
      WriteDiskString(name);

      dsc:=DDD.GetStObjScale(obj);
      InOut.WriteInt(DDD.ROUND(dsc.scx*1000.0),1);
      InOut.WriteLn;
      InOut.WriteInt(DDD.ROUND(dsc.scy*1000.0),1);
      InOut.WriteLn;
      InOut.WriteInt(DDD.ROUND(dsc.scz*1000.0),1);
      InOut.WriteLn;

      p:=DDD.GetStObjXYOrg(obj);
      Write2DCoord(p);

      p:=DDD.GetStObjXZOrg(obj);
      Write2DCoord(p);

      p:=DDD.GetStObjYZOrg(obj);
      Write2DCoord(p);

      InOut.WriteInt(DDD.GetStObjSize(obj),1);
      InOut.WriteLn;

      FOR n:=1 TO DDD.GetStObjSize(obj) DO
        pd:=DDD.GetStObjPoint(obj,n);
        pp.x:=pd.x; pp.y:=pd.y; pp.z:=pd.z;
        Write3DCoord(pp);
        WriteColor(pd.col);
        WriteBOOL(pd.drawline);
      END;
    END;
  END;
END SaveStObjects;

PROCEDURE LoadStObject(obj : CARDINAL; fn, ext : ARRAY OF CHAR):BOOLEAN;
VAR ii, n : CARDINAL;
    dsc : DDD.DScale;
    maxpoints, max, a : INTEGER;
    sc : DDD.DCoord;
    c: CHAR;
    orgxy, orgxz, orgyz, p : Grawin.Coord;
    pd : DDD.DPoint;
    pp : DDD.DCoord;
    name : Grawin.LString;

BEGIN

  IF Grawin.InErrorState() THEN IntMen.Error; RETURN(FALSE); END;

  InOut.OpenNamedInput(fn,ext);
  InOut.ReadString(name);
  IF Match("PoorWorld",name) THEN
    DDD.DestroyXYZObj(obj);
    DDD.DestroyDDDObj(obj);
    ReadDiskString(name);
    DDD.NameObj(name,obj);

    Read3DCoord(sc);
    Read2DCoord(orgxy);
    Read2DCoord(orgxz);
    Read2DCoord(orgyz);

    dsc.scx:=FLOAT(sc.x)/1000.0;
    dsc.scy:=FLOAT(sc.y)/1000.0;
    dsc.scz:=FLOAT(sc.z)/1000.0;

    DDD.CreateXYZObj(obj);
    pp.x:=orgxy.x;
    pp.y:=orgxy.y;
    pp.z:=orgyz.y;
    DDD.SetXYZObjOrg(obj,pp);
    DDD.SetXYZObjScale(obj,dsc);

    InOut.ReadInt(maxpoints);

    FOR ii:=1 TO maxpoints DO
      Read3DCoord(pp);
      pd.x:=pp.x; pd.y:=pp.y; pd.z:=pp.z;
      ReadColor(pd.col);
      ReadBOOL(pd.drawline);
      DDD.AddXYZObjPoint(obj,pd);
    END;
    DDD.DestroyStObj(obj);
    DDD.StoreObj(obj);
    RETURN(TRUE);
  ELSE
    RETURN(FALSE);
  END;
  (* Else error-message *)
END LoadStObject;

PROCEDURE LoadStObjects(fn, ext : ARRAY OF CHAR):BOOLEAN;
VAR ii, n, obj : CARDINAL;
    dsc : DDD.DScale;
    fz, maxpoints, max, a : INTEGER;
    sc : DDD.DCoord;
    c: CHAR;
    orgxy, orgxz, orgyz, p : Grawin.Coord;
    pd : DDD.DPoint;
    pp : DDD.DCoord;
    name : Grawin.LString;

BEGIN

  IF Grawin.InErrorState() THEN IntMen.Error; RETURN(FALSE); END;

  InOut.OpenNamedInput(fn,ext);
  InOut.ReadString(name);

  IF Match("PoorWorld",name) THEN
    Read3DCoord(pp);
    DDD.SetEyePos(pp);

    InOut.ReadInt(fz);
    DDD.SetPlaneDist(fz);

    InOut.ReadInt(max);
    FOR n:=1 TO max DO
      InOut.ReadCard(obj);
      IF DDD.DoesObjExists(obj) THEN
        DDD.DestroyStObj(obj);
      END;

      ReadDiskString(name);
      DDD.NameObj(name,obj);

      Read3DCoord(sc);
      Read2DCoord(orgxy);
      Read2DCoord(orgxz);
      Read2DCoord(orgyz);

      dsc.scx:=FLOAT(sc.x)/1000.0;
      dsc.scy:=FLOAT(sc.y)/1000.0;
      dsc.scz:=FLOAT(sc.z)/1000.0;

      DDD.CreateStObj(obj,dsc,orgxy,orgxz,orgyz);
      InOut.ReadInt(maxpoints);

      FOR ii:=1 TO maxpoints DO
        Read3DCoord(pp);
        pd.x:=pp.x; pd.y:=pp.y; pd.z:=pp.z;
        ReadColor(pd.col);
        ReadBOOL(pd.drawline);
        DDD.AddStObjPoint(obj,pd);
      END;
    END;
    RETURN(TRUE);
  ELSE
    RETURN(FALSE);
  END;
  (* Else error-message *)
END LoadStObjects;

BEGIN
END Disk.
