IMPLEMENTATION MODULE Grawin;

IMPORT Lib;

FROM Mouse    IMPORT SetMousePos, InitMouse, WaitForEvents, ConfPosChanged,
                     GetMouseState, RightButtonPressed, PosChanged, ConfRightButton,
                     StoreMousePos, RestoreMousePos, ConfLeftButton, DisableWaitProc;

FROM AsmLib   IMPORT Delay;

FROM Strings  IMPORT Concat, Length;

FROM Str IMPORT Match;

FROM Keyboard IMPORT BusyScan, SHIFTS;

FROM KeyConst IMPORT CurUp, CurDown, CurLeft, CurRight,
                     AltCurUp, AltCurDown, AltCurLeft, AltCurRight, Home,
                     Esc, Enter, Tab, FunKey1, FunKey2, FunKey3, FunKey4, FunKey5, FunKey6, FunKey7, Space;

FROM NewTerm IMPORT Scan, GotoXY, SetFGColor, SetBGColor, Plot, Line,
                    GetMaxWindow, SetWindow, SetMaxWindow, Scroll, xormode;

FROM NewIO   IMPORT WriteString, WriteInt;

FROM NewIO   IMPORT Read, Write, WriteCard, WriteLn, ReadInt;

FROM Storage IMPORT ALLOCATE, DEALLOCATE, Available;

CONST objsize = 100;
      numofwinfunctions = 10;

TYPE winfunctions = (nil, cyclewin, movemenu, exitmenu, movewin, sizewin,
                          refresh, cleanup, zoomwin, scrollwin, resetwin, closewin);

TYPE object = ARRAY[0..objsize] OF Point;

TYPE PtoObjList = POINTER TO ObjList;
     PtoCluList = POINTER TO ClusterList;
     PtoWin     = POINTER TO Window;

TYPE ClusterList = RECORD
                   size : CARDINAL;
                   actpoint : CARDINAL;
                   poicluster  : object;
                   nextcluster : PtoCluList;
                 END;

TYPE Menu = RECORD
              menx, meny : CARDINAL;
            END;

TYPE ObjList = RECORD
                 obj     : PtoCluList;
                 drawit  : BOOLEAN;
                 maxpoint : CARDINAL;
                 appointer : PtoCluList;
                 objnum  : CARDINAL;
                 scale  : Scale;
                 orgx, orgy : INTEGER;
                 nextobj : PtoObjList;
                 prevobj : PtoObjList;
               END;

TYPE Window = RECORD

                winnum       : CARDINAL;
                winname      : String;
                refreshflag  : BOOLEAN;
                frozen       : BOOLEAN; (* if TRUE Windows position and size is not changeabel *)
                destroyabel  : BOOLEAN; (* if TRUE Window can be destroyed *)

                winsizeproc  : Winproc;
                winmoveproc  : Winproc;
                refreshproc  : Winproc;
                winzoomproc  : Winproc;
                winscrollproc : Winproc;
                winresetproc : Winproc;

                orfx, orfy   : CARDINAL;
                ortx, orty   : CARDINAL;
                fromx, fromy : CARDINAL;
                tox, toy     : CARDINAL;
                curx, cury   : INTEGER;

                worgx, worgy : INTEGER;
                xareamin, xareamax : INTEGER;
                yareamin, yareamax : INTEGER;
                zoomfac      : REAL;

                curflag      : BOOLEAN;
                marflag1     : BOOLEAN;
                marx1, mary1 : CARDINAL;
                marcol1      : RGB;
                marflag2     : BOOLEAN;
                marx2, mary2 : CARDINAL;
                marcol2      : RGB;

                borcol       : RGB;
                backcol      : RGB;
                titlecol     : RGB;

                nextwin      : PtoWin;
                prevwin      : PtoWin;
                objects      : PtoObjList;
                menx, meny     : CARDINAL;
                ormenx, ormeny : CARDINAL;

                funmenu    : ARRAY[1..menitems] OF String;
                funbindkeyscan : ARRAY[1..menitems] OF CHAR;
                funbindkeywrite : ARRAY[1..menitems] OF CHAR;

                activated  : ARRAY[1..menitems] OF BOOLEAN;
                function   : ARRAY[1..menitems] OF Winproc;
              END;

VAR errproc : PROC;
    errorstate : BOOLEAN;
    isrefreshed : BOOLEAN;
    snapmode : BOOLEAN;
    fixed : BOOLEAN;

    win : Window;
    mouseoffx, mouseoffy : INTEGER;
    mouseorgx, mouseorgy : INTEGER;
    mickx, micky : CARDINAL;
    cursorstep, obnum  : CARDINAL;
    lastwin, lastobj : CARDINAL;
    ptolastwin : PtoWin;
    ptolastobj : PtoObjList;
    winbase: PtoWin;

    winmenu : ARRAY[1..menitems] OF String;
    winbindkeywrite : ARRAY[1..menitems] OF String;
    winbindkeyscan  : ARRAY[1..menitems] OF CHAR;

    key : INTEGER;
    scmaxx, scmaxy : CARDINAL;

    menborcol1, menborcol2, menitemcol, menhiitemcol,  menbackcol, mentitlecol : RGB;
    winhicol : RGB;
    screenbackcol : RGB;
    black, white : RGB;
    infotextcol, hiinfotextcol, infoborcol1, infoborcol2, infobackcol : RGB;
    string : String;
    text5 : ARRAY[1..5] OF CTLine;

(* NOP-Prozedur *)

PROCEDURE SetErrProc(proc : PROC);
BEGIN
  errproc:=proc;
END SetErrProc;

PROCEDURE NoMoreMemory();
BEGIN
  errorstate:=TRUE;
  errproc();
END NoMoreMemory;

PROCEDURE InErrorState():BOOLEAN;
BEGIN
  RETURN(errorstate);
END InErrorState;

PROCEDURE NilProc(VAR actwin, objnum: CARDINAL);
BEGIN
END NilProc;

PROCEDURE WaitForKey(time : CARDINAL):CHAR;
VAR key : CHAR;
    s : SHIFTS;
    fu : INTEGER;
BEGIN
  Delay(time);
  BusyScan(key,s,fu);
  RETURN(key);
END WaitForKey;

PROCEDURE ReadKey(VAR c : CHAR; VAR ctrl : BOOLEAN);
BEGIN
  Read(c);
  IF c='' THEN ctrl:=TRUE; Read(c); ELSE ctrl:=FALSE; END;
END ReadKey;

PROCEDURE Min(a, b : CARDINAL): CARDINAL;
BEGIN
  IF a<b THEN RETURN(a); ELSE RETURN(b); END;
END Min;

PROCEDURE Max(a, b : CARDINAL): CARDINAL;
BEGIN
  IF a<b THEN RETURN(b); ELSE RETURN(a); END;
END Max;

PROCEDURE Beep();
BEGIN
  Write(CHR(7));
END Beep;

PROCEDURE Tick(freq : CARDINAL);
BEGIN
  Lib.Sound(freq);
  Lib.Delay(3);
  Lib.NoSound();
END Tick;

PROCEDURE ErrorTick();
BEGIN
  Tick(1600);
  Tick(1600);
END ErrorTick;

PROCEDURE NormalTick1();
BEGIN
  Tick(200);
END NormalTick1;

PROCEDURE NormalTick2();
BEGIN
  Tick(800);
END NormalTick2;

PROCEDURE ROUND(x : REAL):INTEGER;
BEGIN
  IF x>0.0 THEN
    RETURN(TRUNC(x+0.5));
  ELSE
    RETURN(TRUNC(x-0.5));
  END;
END ROUND;

PROCEDURE GiveAlt(key : CHAR):CHAR;
BEGIN
  CASE key OF
    'a' : RETURN(CHR(30)); |
    'b' : RETURN(CHR(48)); |
    'c' : RETURN(CHR(46)); |
    'd' : RETURN(CHR(32)); |
    'e' : RETURN(CHR(18)); |
    'f' : RETURN(CHR(33)); |
    'g' : RETURN(CHR(34)); |
    'h' : RETURN(CHR(35)); |
    'i' : RETURN(CHR(23)); |
    'j' : RETURN(CHR(36)); |
    'k' : RETURN(CHR(37)); |
    'l' : RETURN(CHR(38)); |
    'm' : RETURN(CHR(50)); |
    'n' : RETURN(CHR(49)); |
    'o' : RETURN(CHR(24)); |
    'p' : RETURN(CHR(25)); |
    'q' : RETURN(CHR(16)); |
    'r' : RETURN(CHR(19)); |
    's' : RETURN(CHR(31)); |
    't' : RETURN(CHR(20)); |
    'u' : RETURN(CHR(22)); |
    'v' : RETURN(CHR(47)); |
    'w' : RETURN(CHR(17)); |
    'x' : RETURN(CHR(45)); |
    'y' : RETURN(CHR(21)); |
    'z' : RETURN(CHR(44)); |
    '1' .. '9' : RETURN(CHR(120+ORD(key)-49)); |
    '0' : RETURN(CHR(129)); |
    ''  : RETURN('');
  END;
END GiveAlt;

PROCEDURE DecodeAlt(key : CHAR):CHAR;
BEGIN
  CASE key OF
    CHR(30) : RETURN('a'); |
    CHR(48) : RETURN('b'); |
    CHR(46) : RETURN('c'); |
    CHR(32) : RETURN('d'); |
    CHR(18) : RETURN('e'); |
    CHR(33) : RETURN('f'); |
    CHR(34) : RETURN('g'); |
    CHR(35) : RETURN('h'); |
    CHR(23) : RETURN('i'); |
    CHR(36) : RETURN('j'); |
    CHR(37) : RETURN('k'); |
    CHR(38) : RETURN('l'); |
    CHR(50) : RETURN('m'); |
    CHR(49) : RETURN('n'); |
    CHR(24) : RETURN('o'); |
    CHR(25) : RETURN('p'); |
    CHR(16) : RETURN('q'); |
    CHR(19) : RETURN('r'); |
    CHR(31) : RETURN('s'); |
    CHR(20) : RETURN('t'); |
    CHR(22) : RETURN('u'); |
    CHR(47) : RETURN('v'); |
    CHR(17) : RETURN('w'); |
    CHR(45) : RETURN('x'); |
    CHR(21) : RETURN('y'); |
    CHR(44) : RETURN('z'); |
    CHR(120) .. CHR(128) : RETURN(CHR(ORD(key)-120+49)); |
    CHR(129) : RETURN(CHR(0)); |
  ELSE
    RETURN(key);
  END;
END DecodeAlt;

PROCEDURE SelectObj(objnum : CARDINAL);
BEGIN
  obnum:=objnum;
END SelectObj;

PROCEDURE FixAllWins();
BEGIN
  fixed:=TRUE;
END FixAllWins;

PROCEDURE ReleaseAllWins();
BEGIN
  fixed:=FALSE;
END ReleaseAllWins;

PROCEDURE AreWinsFixed():BOOLEAN;
BEGIN
  RETURN(fixed);
END AreWinsFixed;

PROCEDURE GetActiveWin():CARDINAL;
VAR thelastwin, lastwin : PtoWin;
BEGIN
  lastwin:=winbase;
  WHILE lastwin<>NIL DO
    thelastwin:=lastwin;
    lastwin:=lastwin^.nextwin;
  END;
  RETURN(thelastwin^.winnum);
END GetActiveWin;

PROCEDURE Calc(ri, gi, bi : CARDINAL; VAR ro, go, bo : CARDINAL);
BEGIN
  ro:=8191+ri*8192;
  go:=8191+gi*8192;
  bo:=16383+bi*16384;
END Calc;

PROCEDURE XorRGBs(col1, col2 : RGB):RGB;

  PROCEDURE Xor(a, b : CARDINAL):CARDINAL;
  BEGIN
    RETURN(CARDINAL((BITSET(a) + BITSET(b) -
                     (BITSET(a)*BITSET(b)))));
  END Xor;

BEGIN
  col1.r:=Xor(col1.r,col2.r);
  col1.g:=Xor(col1.g,col2.g);
  col1.b:=Xor(col1.b,col2.b);
  RETURN(col1);
END XorRGBs;

PROCEDURE SetMaxWin();
VAR minx, miny, maxx, maxy : INTEGER;
BEGIN
  GetMaxWindow(minx,miny,maxx,maxy);
  SetWindow(minx,miny,maxx, maxy);
  scmaxx:=CARDINAL(maxx);
  scmaxy:=CARDINAL(maxy);
END SetMaxWin;

PROCEDURE SnapCursorOn();
BEGIN
  snapmode:=TRUE;
END SnapCursorOn;

PROCEDURE SnapCursorOff();
BEGIN
  snapmode:=FALSE;
END SnapCursorOff;

PROCEDURE ToggleSnap();
BEGIN
  snapmode:=NOT(snapmode);
END ToggleSnap;

PROCEDURE InSnapMode():BOOLEAN;
BEGIN
  RETURN(snapmode);
END InSnapMode;

(* Zeichne ein Rechteck, bei DOUBLE=TRUE doppelt zeichnen *)

PROCEDURE DrawBox(x1, y1, x2, y2 : CARDINAL; borcol : RGB; double : BOOLEAN);

BEGIN
  SetMaxWin();
  SetFGColor(borcol.r,borcol.g,borcol.b);
  Line(x1,y1,x2,y1);
  Line(x2,y1,x2,y2);
  Line(x2,y2,x1,y2);
  Line(x1,y2,x1,y1);
  IF double THEN
    x1:=x1+3; x2:=x2-3;
    y1:=y1+3; y2:=y2-3;
    Line(x1,y1,x2,y1);
    Line(x2,y1,x2,y2);
    Line(x2,y2,x1,y2);
    Line(x1,y2,x1,y1);
 END;
END DrawBox;

(* Lschen den Bereich im angegebenen Rechteck *)

PROCEDURE ClearBox(x1, y1, x2, y2 : CARDINAL; col : RGB);
VAR i : CARDINAL;
BEGIN
  xormode:=FALSE;
  SetMaxWin();
  SetFGColor(col.r,col.g,col.b);
  FOR i:=y1 TO y2 DO
    Line(x1,i,x2,i);
  END;
END ClearBox;

PROCEDURE SolidBox(x1, y1, width, height : CARDINAL;
                   backcol, borcol1, borcol2 : RGB);
VAR ii : CARDINAL;

BEGIN
  xormode:=FALSE;
  ClearBox(x1*8,y1*16+8,(x1+1+width)*8,(y1+height+3)*16-8,backcol);
  FOR ii:=0 TO 3 DO
    DrawBox(x1*8+ii,y1*16+8+ii,(x1+width+1)*8-ii ,(y1+height+2)*16+8-ii,borcol2,FALSE);
  END;
  DrawBox(x1*8,y1*16+8,(x1+width+1)*8,(y1+height+2)*16+8,borcol1,TRUE);
END SolidBox;

(* Info-Box anzeigen *)

PROCEDURE ShowInfoBox(x1, y1, heigth : CARDINAL; VAR infotext : ARRAY OF CTLine);
VAR ii, i, length : CARDINAL;
    col : RGB;
    s : LString;
BEGIN
  INC(x1);
  FOR i:=0 TO heigth-1 DO
    s:=infotext[i].t;
    ii:=1;
    REPEAT
      INC(ii);
    UNTIL s[ii]=CHR(0);
    IF ii>length THEN length:=ii; END;
  END;

  SolidBox(x1,y1,length,i,infobackcol,infoborcol1,infoborcol2);
  SetBGColor(infobackcol.r,infobackcol.g,infobackcol.b);

  FOR i:=0 TO heigth-1 DO
    col:=infotext[i].c;
    SetFGColor(col.r,col.g,col.b);
    GotoXY(x1*8+8,(y1+i+1)*16);
    WriteString(infotext[i].t);
  END;

END ShowInfoBox;

PROCEDURE ColFromTo(VAR text : ARRAY OF CTLine; col : RGB; from, to : CARDINAL);
VAR i : CARDINAL;
BEGIN
  DEC(from);
  DEC(to);
  FOR i:=from TO to DO
    text[i].c:=col;
  END;
END ColFromTo;

PROCEDURE MakeLine(VAR text : CTLine; col : RGB);
VAR i : CARDINAL;
BEGIN
  FOR i:=0 TO HIGH(text.t) DO
    text.t[i]:="_";
  END;
  text.c:=col;
END MakeLine;

(* Info-Box lschen *)

PROCEDURE ClearInfoBox(x1, y1, height : CARDINAL; VAR infotext : ARRAY OF CTLine);
VAR i, ii, length : CARDINAL;
    s : LString;
BEGIN
  INC(x1);
  FOR i:=0 TO height-1 DO
    s:=infotext[i].t;
    ii:=1;
    REPEAT
      INC(ii);
    UNTIL s[ii]=CHR(0);
    IF ii>length THEN length:=ii; END;
  END;

  SolidBox(x1,y1,length,i,screenbackcol,screenbackcol,screenbackcol);

END ClearInfoBox;

PROCEDURE ShowChooseBox(x1, y1, height : CARDINAL;
                        VAR infotext : ARRAY OF CTLine;
                        VAR keys : ARRAY OF CHAR;
                        VAR selectabel : ARRAY OF BOOLEAN;
                        firstitem : CARDINAL):CARDINAL;


VAR lasti, i, ii, length, mousex, mousey : CARDINAL;
    s : LString;
    key: CHAR;
    col : RGB;
    left, right, keyflag, strg, pos : BOOLEAN;

PROCEDURE DrawMenItem(fgcol, bgcol : RGB; first : BOOLEAN; pos : CARDINAL);
VAR ix, iy : CARDINAL;
BEGIN
  GotoXY((x1+1)*8,(y1+pos+1)*16);
  SetBGColor(infobackcol.r,infobackcol.g,infobackcol.b);
  SetFGColor(fgcol.r,fgcol.g,fgcol.b);
  IF first THEN
    Write(CHR(62));
  ELSE
    col:=infotext[pos].c;
    WriteString(" ");
  END;

  WriteString(infotext[pos].t);
  SetBGColor(fgcol.r,fgcol.g,fgcol.b);
  SetFGColor(bgcol.r,bgcol.g,bgcol.b);

  IF keys[pos]<>"" THEN
    GotoXY((x1+length-1)*8,(y1+pos+1)*16);
    Write(CHR(keys[pos]));
  END;

  IF NOT(selectabel[pos]) THEN

    FOR ix:=(x1+1)*8 TO (x1+length)*8 DO
      FOR iy:=(y1+pos+1)*16 TO (y1+pos+2)*16 BY 2 DO
        Plot(ix,iy+CARDINAL((ix MOD 2)=0));
      END;
    END;
  END;
END DrawMenItem;

BEGIN

  StoreMousePos;
  DEC(firstitem);
  DEC(height);
  INC(x1);

  length:=0;
  FOR i:=0 TO height DO
    s:=infotext[i].t;
    ii:=1;
    REPEAT
      INC(ii);
    UNTIL s[ii]=CHR(0);
    IF ii+2>length THEN length:=ii+2; END;
  END;

  SolidBox(x1,y1,length,i,infobackcol,infoborcol1,infoborcol2);

  FOR i:=0 TO height DO
    IF i=firstitem THEN DrawMenItem(hiinfotextcol,infobackcol,TRUE,i);
    ELSE
      DrawMenItem(infotext[i].c,infobackcol,FALSE,i);
    END;
  END;

  i:=firstitem;
  lasti:=firstitem;

  InitMouse(0,0,1,height*32+31);
  SetMousePos(0,firstitem*32+16);
  ConfPosChanged();

  LOOP
    WaitForEvents(left,right,pos,keyflag,strg,key);

    IF ((key=Enter) OR left) THEN
      IF selectabel[i] THEN
        NormalTick1();
        RestoreMousePos;
        RETURN(i+1);
        EXIT;
      ELSE
        ErrorTick;
      END;
    END;
    col:=infotext[i].c;

    IF pos THEN
      GetMouseState(mousex,mousey,left,right);
      i:=(mousey DIV 32);
      IF lasti<>i THEN
        SetMousePos(0,i*32+16);
        ConfPosChanged();
      END;
    ELSIF keyflag AND strg THEN
      CASE key OF
        CurUp   : IF i>0 THEN DEC(i); END; |
        CurDown : IF i<height THEN INC(i); END;
      END;
      SetMousePos(0,i*32+16);
      ConfPosChanged();
    END;

    IF (key=Esc) OR right THEN
      NormalTick2();
      RestoreMousePos;
      RETURN(0);
      EXIT;
    ELSIF keyflag THEN
      FOR ii:=0 TO height DO
        IF key=keys[ii] THEN
          i:=ii;
          SetMousePos(0,i*32+16);
          ConfPosChanged();
        END;
      END;
    END;

    IF (lasti<>i) THEN
      DrawMenItem(col,infobackcol,FALSE,lasti);
      DrawMenItem(hiinfotextcol,infobackcol,TRUE,i);
    END;
    lasti:=i;

  END;
END ShowChooseBox;

(* Finde das Fenster mit der Nummer "winnum", PWin zeigt darauf *)

PROCEDURE FindWin(winnum: CARDINAL):PtoWin;
VAR PWin : PtoWin;
BEGIN
  IF (winnum=0) THEN RETURN(NIL); END;
  IF winnum=lastwin THEN
    RETURN(ptolastwin);
  ELSE
    PWin:=winbase;
    REPEAT
      IF PWin^.winnum=winnum THEN
        lastwin:=winnum;
        lastobj:=0;
        ptolastwin:=PWin;
        RETURN(PWin);
      END;
      PWin:=PWin^.nextwin;
    UNTIL PWin=NIL;
    lastwin:=0;
    RETURN(NIL);
  END;
END FindWin;

PROCEDURE FindWinObj(winnum, objnum: CARDINAL):PtoObjList;
VAR PWin : PtoWin;
    pt : PtoObjList;

BEGIN
  IF (winnum=0) OR (objnum=0) THEN RETURN(NIL); END;

  IF (winnum=lastwin) AND (objnum=lastobj) THEN
    RETURN(ptolastobj);
  ELSE
    PWin:=winbase;
    LOOP
      IF PWin=NIL THEN
        lastwin:=0;
        ptolastwin:=NIL;
        EXIT;
      ELSE
        IF PWin^.winnum=winnum THEN
          lastwin:=winnum;
          ptolastwin:=PWin;
          pt:=PWin^.objects;
          LOOP
            IF pt=NIL THEN
              lastobj:=0;
              RETURN(NIL);
              EXIT;
            ELSE
              IF pt^.objnum=objnum THEN
                lastobj:=objnum;
                ptolastobj:=pt;
                RETURN(pt);
                EXIT;
              END;
            END;
            pt:=pt^.nextobj;
          END;
        END;
      END;
      PWin:=PWin^.nextwin;
    END;
  END;
END FindWinObj;

PROCEDURE ClipWithWin(winnum : CARDINAL);
VAR PWin : PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      SetWindow(fromx*8,fromy*16,tox*8-1,toy*16-1);
    END;
  END;
END ClipWithWin;

PROCEDURE ResetAllWins();
VAR PWin : PtoWin;
BEGIN
  PWin:=winbase^.nextwin;
  REPEAT
    WITH PWin^ DO
      fromx:=orfx;
      fromy:=orfy;
      tox:=ortx;
      toy:=orty;
      menx:=fromx;
      meny:=fromy;
    END;
    PWin:=PWin^.nextwin;
  UNTIL PWin=NIL;
END ResetAllWins;

PROCEDURE BringWinToFront(winnum : CARDINAL);
VAR PWin : PtoWin;
    thelastwin, lastwin : PtoWin;
BEGIN

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    IF PWin^.nextwin=NIL THEN RETURN; END;

    lastwin:=winbase;
    WHILE lastwin<>NIL DO
      thelastwin:=lastwin;
      lastwin:=lastwin^.nextwin;
    END;

    PWin^.prevwin^.nextwin:=PWin^.nextwin;
    PWin^.nextwin^.prevwin:=PWin^.prevwin;

    thelastwin^.nextwin:=PWin;

    PWin^.nextwin:=NIL;
    PWin^.prevwin:=thelastwin;
  END;
END BringWinToFront;


(* Zeiger des nchsten Fenster zurckgeben *)

PROCEDURE GetNextVWinPointer(PWin: PtoWin):PtoWin;
BEGIN
  IF PWin<>NIL THEN
    LOOP
      PWin:=PWin^.nextwin;
      IF PWin=NIL THEN
        PWin:=winbase;
      ELSE
        IF PWin^.refreshflag THEN RETURN(PWin); EXIT; END;
      END;
    END;
  END;
END GetNextVWinPointer;

PROCEDURE GetNextVWinNumber(winnum : CARDINAL):CARDINAL;
VAR PWin : PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    LOOP
      PWin:=PWin^.nextwin;
      IF PWin=NIL THEN
        PWin:=winbase;
      ELSE
        IF PWin^.refreshflag THEN RETURN(PWin^.winnum); EXIT; END;
      END;
    END;
  END;
END GetNextVWinNumber;

(* Nummer des nchsten Fensters zurckgeben *)

PROCEDURE GetNextWinNumber(winnum: CARDINAL):CARDINAL;
VAR PWin : PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin:=PWin^.nextwin;
    IF PWin=NIL THEN
      RETURN(winbase^.nextwin^.winnum);
    ELSE
      RETURN(PWin^.winnum);
    END;
  END;
END GetNextWinNumber;

PROCEDURE GetNextWinPointer(PWin: PtoWin):PtoWin;
BEGIN
  IF PWin<>NIL THEN
    PWin:=PWin^.nextwin;
    IF PWin=NIL THEN
      RETURN(winbase^.nextwin);
    ELSE
      RETURN(PWin);
    END;
  END;
END GetNextWinPointer;

(* Fenster-Nummer zurckgeben, auf das PWin zeigt *)

PROCEDURE GetWinNumber(PWin: PtoWin):CARDINAL;
BEGIN
  RETURN(PWin^.winnum);
END GetWinNumber;

(* Ausdehnung des Fensters winnum zurckgeben *)

PROCEDURE GetWinSize(winnum: CARDINAL):Coord;
VAR size: Coord;
    PWin: PtoWin;
BEGIN
  size.x:=0;
  size.y:=0;
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      size.x:=(tox-fromx);
      size.y:=(toy-fromy);
    END;
  END;
  RETURN(size);
END GetWinSize;

PROCEDURE GetWinBackCol(winnum: CARDINAL):RGB;
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    RETURN(PWin^.backcol);
  END;
END GetWinBackCol;

(* Position des Fenster winnum zurckgeben *)

PROCEDURE GetWinPos(winnum: CARDINAL):Coord;
VAR pos: Coord;
    PWin: PtoWin;
BEGIN
  pos.x:=nocoord;
  pos.y:=nocoord;

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      pos.x:=fromx;
      pos.y:=fromy;
    END;
  END;
  RETURN(pos);
END GetWinPos;

(* Gib Cursor-Position zurck des Windows winnum *)

PROCEDURE GetCurPos(winnum: CARDINAL):Coord;
VAR PWin: PtoWin;
    pos: Coord;
BEGIN
  pos.x:=nocoord;
  pos.y:=nocoord;
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      pos.x:=curx;
      pos.y:=cury;
    END;
  END;
  RETURN(pos);
END GetCurPos;

PROCEDURE GetWinOrg(winnum: CARDINAL):Coord;
VAR PWin: PtoWin;
    org: Coord;
BEGIN
  org.x:=nocoord;
  org.y:=nocoord;
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      org.x:=worgx;
      org.y:=worgy;
    END;
  END;
  RETURN(org);
END GetWinOrg;

PROCEDURE AllWinsOrg():BOOLEAN;
VAR PWin, pt: PtoWin;
    flag : BOOLEAN;
BEGIN
  flag:=TRUE;

  PWin:=winbase;

  REPEAT
    PWin:=PWin^.nextwin;
    IF PWin<>NIL THEN
      WITH PWin^ DO
        IF refreshflag THEN
          flag:=flag AND
          (orfx=fromx) AND (orfy=fromy) AND
          (ortx=tox)   AND (orty=toy);
        END;
      END;
    END;
  UNTIL PWin=NIL;
  RETURN(flag);
END AllWinsOrg;

PROCEDURE SetWinSizeProc(winnum: CARDINAL; sizepro: Winproc);
VAR PWin: PtoWin;

BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin^.winsizeproc:=sizepro;
  END;
END SetWinSizeProc;

PROCEDURE SetWinMoveProc(winnum: CARDINAL; movepro: Winproc);
VAR PWin: PtoWin;

BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin^.winmoveproc:=movepro;
  END;
END SetWinMoveProc;

PROCEDURE SetWinRefreshProc(winnum: CARDINAL; refproc: Winproc);
VAR PWin: PtoWin;

BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin^.refreshproc:=refproc;
  END;
END SetWinRefreshProc;

PROCEDURE SetWinScrollProc(winnum: CARDINAL; scrollproc: Winproc);
VAR PWin: PtoWin;

BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin^.winscrollproc:=scrollproc;
  END;
END SetWinScrollProc;

PROCEDURE SetWinZoomProc(winnum: CARDINAL; zoomproc: Winproc);
VAR PWin: PtoWin;

BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin^.winzoomproc:=zoomproc;
  END;
END SetWinZoomProc;

PROCEDURE SetWinResetProc(winnum: CARDINAL; resetproc: Winproc);
VAR PWin: PtoWin;

BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin^.winresetproc:=resetproc;
  END;
END SetWinResetProc;

(* Erzeuge ein Grafik-Object Nr. "objnum" fr Window "winnum" *)

PROCEDURE CreateObj(winnum, num: CARDINAL; scalex, scaley : REAL; originx, originy : INTEGER);
VAR pt, pt2, apt : PtoObjList;
    PWin: PtoWin;
BEGIN

  IF errorstate THEN RETURN; END;

  PWin:=FindWin(winnum);

  IF PWin<>NIL THEN
    pt:=PWin^.objects;
    IF pt=NIL THEN
      IF NOT(Available(SIZE(ObjList))) THEN
        NoMoreMemory();
        RETURN;
      ELSE
        ALLOCATE(pt2,SIZE(ObjList));
      END;
      PWin^.objects:=pt2;

      WITH pt2^ DO
        nextobj:=NIL;
        prevobj:=NIL;
        appointer:=NIL;
        objnum:=num;
        maxpoint:=0;
        scale.scx:=scalex;
        scale.scy:=scaley;
        orgx:=originx;
        orgy:=originy;
        obj:=NIL;
        drawit:=TRUE;
      END;
    ELSE
      REPEAT
        apt:=pt;
        pt:=pt^.nextobj;
      UNTIL pt=NIL;

      IF NOT(Available(SIZE(ObjList))) THEN
        NoMoreMemory();
        RETURN;
      ELSE
        ALLOCATE(pt2,SIZE(ObjList));
      END;
      apt^.nextobj:=pt2;

      WITH pt2^ DO
        nextobj:=NIL;
        prevobj:=apt;
        appointer:=NIL;
        objnum:=num;
        maxpoint:=0;
        scale.scx:=scalex;
        scale.scy:=scaley;
        orgx:=originx;
        orgy:=originy;
        obj:=NIL;
      END;
    END;
  END;
END CreateObj;

(* Lsche ein Grafik-Objekt m. der Nummer "objnum" im Fenster "winnum" *)

PROCEDURE DeleteObj(winnum, objnum : CARDINAL);
VAR pt1 : PtoObjList;
    pt2, pt3 : PtoCluList;
    PWin: PtoWin;
BEGIN

  IF errorstate THEN RETURN; END;

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    pt1:=PWin^.objects;

    WHILE pt1^.objnum#objnum DO
      pt1:=pt1^.nextobj;
      IF pt1=NIL THEN RETURN; END;
    END;

    IF pt1^.prevobj=NIL THEN
      IF pt1^.nextobj#NIL THEN
        pt1^.nextobj^.prevobj:=NIL;
        PWin^.objects:=pt1^.nextobj;
      ELSE
        pt1^.prevobj^.nextobj:=NIL;
      END;
    ELSE
      IF pt1^.nextobj#NIL THEN
        pt1^.prevobj^.nextobj:=pt1^.nextobj;
        pt1^.nextobj^.prevobj:=pt1^.prevobj;
      ELSE
        IF (pt1^.nextobj=NIL) AND (pt1^.prevobj#NIL) THEN
          pt1^.prevobj^.nextobj:=NIL;
        END;
      END;
    END;

    pt2:=pt1^.obj;
    DEALLOCATE(pt1,SIZE(ObjList));
    IF pt2<>NIL THEN
    REPEAT
      pt3:=pt2;
      DEALLOCATE(pt3,SIZE(ClusterList));
      pt2:=pt2^.nextcluster;
    UNTIL pt2=NIL;
    END;
  END;
END DeleteObj;

(* Setzte die internen Dontdraw-Number *)

PROCEDURE DontDrawObj(winnum, objnum : CARDINAL);

VAR pt : PtoObjList;

BEGIN
  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    pt^.drawit:=FALSE;
  END;
END DontDrawObj;

PROCEDURE AllowDrawObj(winnum, objnum : CARDINAL);

VAR pt : PtoObjList;

BEGIN
  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    pt^.drawit:=TRUE;
  END;
END AllowDrawObj;

PROCEDURE DontRefreshWin(winnum: CARDINAL);
VAR PWin: PtoWin;

BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin^.refreshflag:=FALSE;
  END;
END DontRefreshWin;

PROCEDURE AllowRefreshWin(winnum: CARDINAL);
VAR PWin: PtoWin;

BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin^.refreshflag:=TRUE;
  END;
END AllowRefreshWin;

PROCEDURE IsObjDrawable(winnum, objnum : CARDINAL): BOOLEAN;

VAR pt : PtoObjList;
    pt2, apt : PtoCluList;
    PWin: PtoWin;
BEGIN
  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    RETURN(pt^.drawit);
  ELSE
    RETURN(FALSE);
  END;
END IsObjDrawable;


PROCEDURE Reset;

VAR
    pt : PtoObjList;
    apt, pt2 : PtoCluList;
    PWin: PtoWin;

BEGIN

  PWin:=winbase;

  REPEAT
    PWin:=PWin^.nextwin;
    IF PWin<>NIL THEN
      pt:=PWin^.objects;
    IF pt<>NIL THEN
    REPEAT
      pt2:=pt^.obj;
      IF pt2<>NIL THEN
        REPEAT
          apt:=pt2;
          pt2:=pt2^.nextcluster;
        UNTIL pt2=NIL;
        pt^.appointer:=apt;
        apt^.actpoint:=apt^.size;
      END;
      pt:=pt^.nextobj;
    UNTIL pt=NIL;
    END;
    END;
  UNTIL PWin=NIL;
END Reset;

(* Erzeuge einen Punkt im Grafik-Objekt "objnum" des Fensters "winnum" *)

PROCEDURE AddObjPoint(winnum, objnum : CARDINAL; px, py : INTEGER;
                                c : RGB; drawline : BOOLEAN);
VAR pt : PtoObjList;
    pt2, apt : PtoCluList;

BEGIN
  IF errorstate THEN RETURN; END;

  pt:=FindWinObj(winnum,objnum);

  IF pt<>NIL THEN
    INC(pt^.maxpoint);

    IF (pt^.appointer=NIL) THEN
      IF NOT(Available(SIZE(ClusterList))) THEN
        NoMoreMemory();
        RETURN;
      ELSE
        ALLOCATE(pt2,SIZE(ClusterList));
      END;
      pt^.appointer:=pt2;
      pt^.obj:=pt2;
      pt2^.nextcluster:=NIL;

      WITH pt2^ DO
        size:=1;
        actpoint:=1;
        poicluster[1].x:=px;
        poicluster[1].y:=py;
        poicluster[1].col:=c;
        poicluster[1].drawline:=drawline;
        poicluster[0]:=nopoint;
      END;
    ELSE
      pt2:=pt^.appointer;

      IF pt2^.size=objsize THEN
        apt:=pt2;
        IF NOT(Available(SIZE(ClusterList))) THEN
          NoMoreMemory();
          RETURN;
        ELSE
          ALLOCATE(pt2,SIZE(ClusterList));
        END;
        apt^.nextcluster:=pt2;
        pt^.appointer:=pt2;
        pt2^.nextcluster:=NIL;
        WITH pt2^ DO
          size:=1;
          actpoint:=1;
          poicluster[1].x:=px;
          poicluster[1].y:=py;
          poicluster[1].col:=c;
          poicluster[1].drawline:=drawline;
        END;
      ELSE
        WITH pt2^ DO
          INC(size);
          INC(actpoint);
          poicluster[size].x:=px;
          poicluster[size].y:=py;
          poicluster[size].col:=c;
          poicluster[size].drawline:=drawline;
        END;
      END;
    END;
  END;
END AddObjPoint;


PROCEDURE SetObjScale(winnum, objnum : CARDINAL; scalex, scaley : REAL);
VAR pt : PtoObjList;

BEGIN
  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    pt^.scale.scx:=scalex;
    pt^.scale.scy:=scaley;
  END;
END SetObjScale;


PROCEDURE GetObjScale(winnum, objnum : CARDINAL):Scale;
VAR pt : PtoObjList;
    sc : Scale;
BEGIN
  sc.scx:=0.0;
  sc.scy:=0.0;
  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    RETURN(pt^.scale);
  ELSE
    RETURN(sc);
  END;
END GetObjScale;

PROCEDURE SetObjOrg(winnum, objnum : CARDINAL; originx, originy: INTEGER);
VAR pt : PtoObjList;

BEGIN
  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    pt^.orgx:=originx;
    pt^.orgy:=originy;
  END;
END SetObjOrg;

PROCEDURE GetObjOrg(winnum, objnum : CARDINAL):Coord;
VAR pt : PtoObjList;
    org : Coord;
BEGIN
  org.x:=nocoord;
  org.y:=nocoord;
  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    org.x:=pt^.orgx;
    org.y:=pt^.orgy;
  END;
  RETURN(org);
END GetObjOrg;

(* Zeichne die Grafik-Objektliste des Fensters "winnum" *)

PROCEDURE DrawWinObjlist(winnum : CARDINAL; considerate : BOOLEAN);
VAR xmin, ymin, xmax, ymax : INTEGER;
    x, y, ax, ay, i, ii : INTEGER;
    worgx, worgy, orx, ory : INTEGER;
    ofx, ofy : REAL;
    pt : PtoObjList;
    pt2: PtoCluList;
    PWin: PtoWin;
    flag : BOOLEAN;
    pn : Point; c: CHAR;
    sc, sx, sy : REAL;


BEGIN

  xormode:=FALSE;

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN

    pt:=PWin^.objects;
    xmin:=PWin^.fromx*8+4;
    ymin:=PWin^.fromy*16+33;
    xmax:=PWin^.tox*8-4;
    ymax:=PWin^.toy*16-4;
    worgx:=PWin^.worgx;
    worgy:=PWin^.worgy;
    sc:=PWin^.zoomfac;

    SetWindow(xmin+1,ymin+1,xmax-1,ymax-1);

    REPEAT
      pt2:=pt^.obj;
      sx:=pt^.scale.scx;
      sy:=pt^.scale.scy;
      orx:=pt^.orgx;
      ory:=pt^.orgy;

      IF considerate THEN
        ofx:=FLOAT(orx-worgx)*sc;
        ofy:=FLOAT(ory-worgy)*sc;
      ELSE
        ofx:=FLOAT(xmin+worgx)+FLOAT(orx-worgx)*sc;
        ofy:=FLOAT(ymin+worgy)+FLOAT(ory-worgy)*sc;
      END;

      sx:=pt^.scale.scx*sc;
      sy:=pt^.scale.scy*sc;

      IF (pt2#NIL) AND (pt^.drawit) THEN
        i:=1;
        REPEAT

          FOR ii:=1 TO pt2^.size DO
            pn:=pt2^.poicluster[ii];
            x:=ROUND(FLOAT(pn.x)*sx+ofx);
            y:=ROUND(FLOAT(pn.y)*sy+ofy);

            IF (i>1) AND (pn.drawline) THEN
              IF considerate THEN
                DrawConsiderate(winnum,ax,ay,x,y,pn.col);
              ELSE
                SetFGColor(pn.col.r,pn.col.g,pn.col.b);
                Line(ax,ay,x,y);
              END;
            END;
            ax:=x;
            ay:=y;
            INC(i);
          END;
          pt2:=pt2^.nextcluster;
        UNTIL pt2=NIL;
      END;
      pt:=pt^.nextobj;

    UNTIL pt=NIL;
  END;

  isrefreshed:=TRUE;

END DrawWinObjlist;

(* Lsche die Grafik-Objektliste vom Fenster "winnum" *)

PROCEDURE UndrawWinObjlist(winnum : CARDINAL; considerate : BOOLEAN);
VAR xmin, ymin, xmax, ymax : INTEGER;
    x, y, ax, ay, i, ii : INTEGER;
    worgx, worgy, orx, ory : INTEGER;
    ofx, ofy : REAL;
    pt : PtoObjList;
    pt2: PtoCluList;
    PWin: PtoWin;
    flag : BOOLEAN;
    pn : Point; c: CHAR;
    sc, sx, sy : REAL;

BEGIN

  xormode:=FALSE;

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN

    pt:=PWin^.objects;
    xmin:=PWin^.fromx*8+4;
    ymin:=PWin^.fromy*16+33;
    xmax:=PWin^.tox*8-4;
    ymax:=PWin^.toy*16-4;
    worgx:=PWin^.worgx;
    worgy:=PWin^.worgy;
    sc:=PWin^.zoomfac;

    SetWindow(xmin+1,ymin+1,xmax-1,ymax-1);
    SetFGColor(PWin^.backcol.r,PWin^.backcol.g,PWin^.backcol.b);

    REPEAT
      pt2:=pt^.obj;
      sx:=pt^.scale.scx;
      sy:=pt^.scale.scy;
      orx:=pt^.orgx;
      ory:=pt^.orgy;

      IF considerate THEN
        ofx:=FLOAT(orx-worgx)*sc;
        ofy:=FLOAT(ory-worgy)*sc;
      ELSE
        ofx:=FLOAT(xmin+worgx)+FLOAT(orx-worgx)*sc;
        ofy:=FLOAT(ymin+worgy)+FLOAT(ory-worgy)*sc;
      END;

      sx:=pt^.scale.scx*sc;
      sy:=pt^.scale.scy*sc;

      IF (pt2#NIL) AND (pt^.drawit) THEN
        i:=1;
        REPEAT

          FOR ii:=1 TO pt2^.size DO
            pn:=pt2^.poicluster[ii];
            x:=ROUND(FLOAT(pn.x)*sx+ofx);
            y:=ROUND(FLOAT(pn.y)*sy+ofy);

            IF (i>1) AND (pn.drawline) THEN
              IF considerate THEN
                DrawConsiderate(winnum,ax,ay,x,y,PWin^.backcol);
              ELSE
                Line(ax,ay,x,y);
              END;
            END;
            ax:=x;
            ay:=y;
            INC(i);
          END;
          pt2:=pt2^.nextcluster;
        UNTIL pt2=NIL;
      END;
      pt:=pt^.nextobj;

    UNTIL pt=NIL;
  END;

  isrefreshed:=TRUE;

END UndrawWinObjlist;

PROCEDURE IsPointVisible(winnum : CARDINAL; x, y : INTEGER):BOOLEAN;
VAR PWin : PtoWin;
    flag: BOOLEAN;
    xmi, ymi, xma, yma : INTEGER;

BEGIN
  PWin:=FindWin(winnum);
  IF PWin=NIL THEN
    RETURN(FALSE);
  ELSE
    WITH PWin^ DO
    xmi:=fromx*8+4;
    ymi:=fromy*16+33;

    x:=ROUND(FLOAT(xmi)+FLOAT(worgx)+FLOAT(x)*zoomfac);
    y:=ROUND(FLOAT(ymi)+FLOAT(worgy)+FLOAT(y)*zoomfac);

    xma:=tox*8-4;
    yma:=toy*16-4;
    END;
    IF (x<xmi) OR (x>xma) OR (y<ymi) OR (y>yma) THEN RETURN(FALSE); END;
    PWin:=PWin^.nextwin;
    flag:=TRUE;

    WHILE PWin<>NIL DO
      WITH PWin^ DO
        flag:=flag AND NOT((INTEGER(fromx*8)<=x) AND (x<=INTEGER(tox*8)) AND (INTEGER(fromy*16)<=y) AND (y<=INTEGER(toy*16)));
      END;
      PWin:=PWin^.nextwin;
    END;
    RETURN(flag);
  END;
END IsPointVisible;

PROCEDURE IsCPointVisible(PWin: PtoWin; x, y : INTEGER):BOOLEAN;
VAR flag: BOOLEAN;
BEGIN

  IF PWin=NIL THEN
    RETURN(FALSE);
  ELSE

    flag:=TRUE;
    PWin:=PWin^.nextwin;
    WHILE (PWin<>NIL) AND flag DO
      WITH PWin^ DO
        flag:=flag AND NOT((INTEGER(fromx*8 )<=x) AND (x<=INTEGER(tox*8))
                       AND (INTEGER(fromy*16)<=y) AND (y<=INTEGER(toy*16)));
      END;
      PWin:=PWin^.nextwin;
    END;
    RETURN(flag);
  END;
END IsCPointVisible;

PROCEDURE IsRefreshed():BOOLEAN;
BEGIN
  RETURN(isrefreshed);
END IsRefreshed;

PROCEDURE TextToWinTitle(winnum : CARDINAL; text : CTLine);
VAR PWin : PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      xormode:=FALSE;
      SetWindow(fromx*8,fromy*16,tox*8-1,(fromy+2)*16);
      ClearBox(fromx*8+6,(fromy+1)*16,tox*8-6,(fromy+2)*16-1,backcol);
      SetFGColor(text.c.r,text.c.g,text.c.b);
      SetBGColor(backcol.r,backcol.g,backcol.b);
      GotoXY((fromx+1)*8,(fromy+1)*16);
      WriteString(text.t);
    END;
  END;
END TextToWinTitle;

PROCEDURE ConTextToWinTitle(winnum : CARDINAL; text : CTLine);
VAR PWin : PtoWin;
    i, x, y : CARDINAL;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      xormode:=FALSE;
      SetWindow(fromx*8,fromy*16,tox*8-1,(fromy+2)*16);
      SetFGColor(text.c.r,text.c.g,text.c.b);
      SetBGColor(backcol.r,backcol.g,backcol.b);
      i:=1;
      WHILE text.t[i]<>CHR(0) DO
        x:=(fromx+i)*8;
        y:=(fromy+1)*16;
        IF IsCPointVisible(PWin,x,y) THEN
          GotoXY(x,y);
          Write(text.t[i]);
        END;
        INC(i);
      END;
    END;
  END;
END ConTextToWinTitle;

PROCEDURE TextToWin(winnum : CARDINAL; text : CTLine; x, y : CARDINAL);
VAR PWin : PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      xormode:=FALSE;
      SetWindow(fromx*8,fromy*16,tox*8-1,(fromy+2)*16);
      SetFGColor(text.c.r,text.c.g,text.c.b);
      SetBGColor(backcol.r,backcol.g,backcol.b);
      GotoXY((fromx+1+x)*8,(fromy+1+y)*16);
      WriteString(text.t);
    END;
  END;
END TextToWin;

PROCEDURE GetWinUpperLeft(winnum : CARDINAL):Coord;
VAR  PWin: PtoWin;
     p : Coord;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    p.x:=PWin^.fromx*8+4;
    p.y:=PWin^.fromy*16+33;
    RETURN(p);
  END;
END GetWinUpperLeft;

PROCEDURE GetWinBottomRight(winnum : CARDINAL):Coord;
VAR  PWin: PtoWin;
     p : Coord;
BEGIN

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    p.x:=PWin^.tox*8-4;
    p.y:=PWin^.toy*16-4;
    RETURN(p);
  END;
END GetWinBottomRight;

PROCEDURE InitVirtualMouse(x, y : CARDINAL);
BEGIN
  mickx:=x;
  micky:=y;
  InitMouse(0,0,x,y);
END InitVirtualMouse;

PROCEDURE SetMouseAtWinOrg(winnum : CARDINAL);
VAR PWin : PtoWin;
 BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      mouseorgx:=mickx DIV 2 -1;
      mouseorgy:=micky DIV 2 -1;
      SetMousePos(mouseorgx,mouseorgy);
      ConfPosChanged();
      IF snapmode THEN
        mouseoffx:=ROUND(REAL(mouseorgx)/zoomfac) DIV INTEGER(cursorstep) * INTEGER(cursorstep);
        mouseoffy:=ROUND(REAL(mouseorgy)/zoomfac) DIV INTEGER(cursorstep) * INTEGER(cursorstep);
      ELSE
        mouseoffx:=ROUND(REAL(mouseorgx)/zoomfac);
        mouseoffy:=ROUND(REAL(mouseorgy)/zoomfac);
      END;
    END;
  END;
END SetMouseAtWinOrg;

PROCEDURE SetMouseAtWinPos(winnum : CARDINAL; x, y : INTEGER);
VAR PWin : PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
      mouseorgx:=mickx DIV 2 -1;
      mouseorgy:=micky DIV 2 -1;
      SetMousePos(mouseorgx,mouseorgy);
      ConfPosChanged();
      IF snapmode THEN
        mouseoffx:=ROUND(REAL(mouseorgx)/PWin^.zoomfac) DIV INTEGER(cursorstep) * INTEGER(cursorstep)-x;
        mouseoffy:=ROUND(REAL(mouseorgy)/PWin^.zoomfac) DIV INTEGER(cursorstep) * INTEGER(cursorstep)-y;
      ELSE
        mouseoffx:=ROUND(REAL(mouseorgx)/PWin^.zoomfac)-x;
        mouseoffy:=ROUND(REAL(mouseorgy)/PWin^.zoomfac)-y;
      END;
      PWin^.curx:=x;
      PWin^.cury:=y;
  END;
END SetMouseAtWinPos;

(* Zeichne ins Fenster winnum ohne Speicherung der Linie *)

PROCEDURE DrawRegardless(winnum : CARDINAL; x1, y1, x2, y2 : INTEGER; col : RGB);
VAR xmin, ymin, xmax, ymax : INTEGER;
    PWin: PtoWin;
BEGIN

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    xmin:=PWin^.fromx*8+4;
    ymin:=PWin^.fromy*16+33;
    xmax:=PWin^.tox*8-4;
    ymax:=PWin^.toy*16-4;
    SetWindow(xmin+1,ymin+1,xmax-1,ymax-1);
    x1:=x1+PWin^.worgx;
    y1:=y1+PWin^.worgy;
    x2:=x2+PWin^.worgx;
    y2:=y2+PWin^.worgy;
    SetFGColor(col.r,col.g,col.b);
    Line(x1+xmin,y1+ymin,x2+xmin,y2+ymin);
  END;
END DrawRegardless;

PROCEDURE IsPixelVisible(winnum : CARDINAL; x, y : INTEGER):BOOLEAN;
VAR PWin : PtoWin;
    flag: BOOLEAN;
    xmi, ymi, xma, yma : INTEGER;

BEGIN
  PWin:=FindWin(winnum);
  IF PWin=NIL THEN
    RETURN(FALSE);
  ELSE

    WITH PWin^ DO
      xmi:=fromx*8+4;
      ymi:=fromy*16+33;
      xma:=tox*8-4;
      yma:=toy*16-4;
    END;

    IF (x<xmi) OR (x>xma) OR (y<ymi) OR (y>yma) THEN RETURN(FALSE); END;
    PWin:=PWin^.nextwin;
    flag:=TRUE;

    WHILE PWin<>NIL DO
      WITH PWin^ DO
        flag:=flag AND NOT((INTEGER(fromx*8)<=x) AND (x<=INTEGER(tox*8)) AND (INTEGER(fromy*16)<=y) AND (y<=INTEGER(toy*16)));
      END;
      PWin:=PWin^.nextwin;
    END;
    RETURN(flag);
  END;
END IsPixelVisible;

PROCEDURE PlotConsiderate(winnum : CARDINAL; x, y : INTEGER; col : RGB);
VAR xmin, ymin, xmax, ymax : INTEGER;
    PWin: PtoWin;
BEGIN

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    xmin:=PWin^.fromx*8+4;
    ymin:=PWin^.fromy*16+33;
    xmax:=PWin^.tox*8-4;
    ymax:=PWin^.toy*16-4;
    SetWindow(xmin+1,ymin+1,xmax-1,ymax-1);
    x:=x+PWin^.worgx+xmin;
    y:=y+PWin^.worgy+ymin;
    SetFGColor(col.r,col.g,col.b);
    IF IsPixelVisible(winnum,x,y) THEN
      Plot(x,y);
    END;
  END;
END PlotConsiderate;

PROCEDURE DotConsiderate(winnum : CARDINAL; x, y : INTEGER; col : RGB);
VAR xmin, ymin, xmax, ymax : INTEGER;
    PWin: PtoWin;
BEGIN

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    xmin:=PWin^.fromx*8+4;
    ymin:=PWin^.fromy*16+33;
    xmax:=PWin^.tox*8-4;
    ymax:=PWin^.toy*16-4;
    SetWindow(xmin+1,ymin+1,xmax-1,ymax-1);
    x:=x+PWin^.worgx+xmin;
    y:=y+PWin^.worgy+ymin;
    SetFGColor(col.r,col.g,col.b);
    IF IsPixelVisible(winnum,x,y) THEN
      Plot(x-1,y);
      Plot(x+1,y);
      Plot(x,y-1);
      Plot(x,y+1);
    END;
  END;
END DotConsiderate;

(* Zeichne ins Fenster winnum ohne Speicherung der Linie *)

PROCEDURE DrawConsiderate(winnum : CARDINAL; x1, y1, x2, y2 : INTEGER; col : RGB);

VAR xmin, ymin, xmax, ymax : INTEGER;
    dx,dy,e,tmp : INTEGER;
    PWin: PtoWin;
BEGIN

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    xmin:=PWin^.fromx*8+4;
    ymin:=PWin^.fromy*16+33;
    xmax:=PWin^.tox*8-4;
    ymax:=PWin^.toy*16-4;
    SetWindow(xmin+1,ymin+1,xmax-1,ymax-1);
    x1:=x1+PWin^.worgx+xmin;
    y1:=y1+PWin^.worgy+ymin;
    x2:=x2+PWin^.worgx+xmin;
    y2:=y2+PWin^.worgy+ymin;
    SetFGColor(col.r,col.g,col.b);

    IF x1 > x2 THEN (* ensure that x2 >= x1 *)
      tmp := x1; x1 := x2; x2 := tmp;
      tmp := y1; y1 := y2; y2 := tmp;
    END;

    dx := x2-x1;
    e  := 0;
    IF y1 <= y2 THEN (* case where y increases *)
      dy := (y2-y1);
      IF dx >= dy THEN
        LOOP
          IF IsPixelVisible(winnum,x1,y1) THEN Plot( x1,y1); END;
          IF x1 = x2 THEN EXIT END;
          INC(x1);
          INC(e,dy);
          INC(e,dy);
          IF e > dx THEN
            DEC(e,dx);
            DEC(e,dx);
            INC(y1);
          END;
        END;
      ELSE
        LOOP
    
          IF IsPixelVisible(winnum,x1,y1) THEN Plot( x1,y1); END;
          IF y1 = y2 THEN EXIT END;
          INC(y1);

          INC(e,dx);
          INC(e,dx);
          IF e > dy THEN
            DEC(e,dy);
            DEC(e,dy);
            INC(x1);
          END;
        END;
      END;
    ELSE
      (* case where y decreases *)
      dy := (y1-y2);
      IF dx >= dy THEN
        LOOP
          IF IsPixelVisible(winnum,x1,y1) THEN Plot( x1,y1); END;
    
          IF x1 = x2 THEN EXIT END;
          INC(x1);
          INC(e,dy);
          INC(e,dy);
          IF e > dx THEN
            DEC(e,dx);
            DEC(e,dx);
            DEC(y1);
          END;
        END;
      ELSE
        LOOP
          IF IsPixelVisible(winnum,x1,y1) THEN Plot( x1,y1); END;

          IF y1 = y2 THEN EXIT END;
          DEC(y1);
          INC(e,dx);
          INC(e,dx);
          IF e > dy THEN
            DEC(e,dy);
            DEC(e,dy);
            INC(x1);
          END;
        END;
      END;
    END;
  END;

END DrawConsiderate;

(* Gebe einen Punkt des Objektes zurck *)

PROCEDURE GetObjPoint(winnum, objnum: CARDINAL):Point;
VAR p : Point;
    pt : PtoObjList;
    pt2: PtoCluList;
BEGIN
  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    IF pt^.appointer<>NIL THEN
      pt2:=pt^.appointer;
      IF pt2=NIL THEN RETURN(nopoint); END;
      p:=pt2^.poicluster[pt2^.actpoint];

      IF pt2^.actpoint=pt2^.size THEN
        pt2:=pt2^.nextcluster;
        IF pt2<>NIL THEN
          pt^.appointer:=pt2;
          pt2^.actpoint:=1;
        END;
      ELSE
        INC(pt2^.actpoint);
      END;
      RETURN(p);
    END;
  END;
  RETURN(nopoint);
END GetObjPoint;

PROCEDURE ReadObjPoint(winnum, objnum: CARDINAL):Point;
VAR p : Point;
    pt : PtoObjList;
    pt2: PtoCluList;
BEGIN

  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    IF pt^.appointer<>NIL THEN
      pt2:=pt^.appointer;
      RETURN(pt2^.poicluster[pt2^.actpoint]);
    END;
  ELSE
    RETURN(nopoint);
  END;
END ReadObjPoint;

(* Pointer des Punktes der nchsten Operation setzen *)

PROCEDURE SetObjPointNumber(winnum, objnum, pointnum: CARDINAL);
VAR pt: PtoObjList;
    pt2 : PtoCluList;
    i : CARDINAL;
BEGIN

  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    pt2:=pt^.obj;
    IF pt2<>NIL THEN
      FOR i:=1 TO ((pointnum-1) DIV objsize) DO
        pt2:=pt2^.nextcluster;
      END;
      pt^.appointer:=pt2;
      pt2^.actpoint:=((pointnum-1) MOD objsize)+1;
    END;
  END;
END SetObjPointNumber;

(* Pointer des Punktes der nchsten Operation zurckgeben *)

PROCEDURE GetObjPointNumber(winnum, objnum: CARDINAL):CARDINAL;
VAR pt: PtoObjList;
    apt, pt2 : PtoCluList;
    i : CARDINAL;
BEGIN

  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    pt2:=pt^.obj;
    apt:=pt^.appointer;
    IF pt2<>NIL THEN
      i:=0;
      WHILE pt2<>apt DO
        INC(i);
        pt2:=pt2^.nextcluster;
      END;
      RETURN(i*objsize+pt2^.size);
    END;
  END;
  RETURN(0);
END GetObjPointNumber;

(* Pointer des Punktes der nchsten Operation zurckgeben *)

PROCEDURE GetObjMaxPointNumber(winnum, objnum: CARDINAL):CARDINAL;
VAR pt: PtoObjList;
BEGIN

  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    RETURN(pt^.maxpoint);
  ELSE
    RETURN(0);
  END;
END GetObjMaxPointNumber;

(* ndere den Punkt, auf den PointNumber des Objektes zeigt *)

PROCEDURE ChangeObjPoint(winnum, objnum : CARDINAL; nx, ny: INTEGER;
                                   ncol : RGB);
VAR pointnum, i : CARDINAL;
    p : Point;
    pt : PtoObjList;
    apt, pt2: PtoCluList;

BEGIN
  IF errorstate THEN RETURN; END;
  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    apt:=pt^.appointer;
    i:=apt^.actpoint;
    IF i=objsize THEN
      apt^.poicluster[objsize].x:=nx;
      apt^.poicluster[objsize].y:=ny;
      apt^.poicluster[objsize].col:=ncol;
      apt:=apt^.nextcluster;
      IF apt<>NIL THEN
        apt^.actpoint:=1;
        pt^.appointer:=apt;
      END;
    ELSE
      apt^.poicluster[i].x:=nx;
      apt^.poicluster[i].y:=ny;
      apt^.poicluster[i].col:=ncol;
      INC(apt^.actpoint);
    END;
  END;
END ChangeObjPoint;

(* Lsche den Punkt, auf den PointNumber des Objektes zeigt *)

PROCEDURE DeleteObjPoint(winnum, objnum : CARDINAL);
VAR pointnum, i : CARDINAL;
    p : Point; c:CHAR;
    pt : PtoObjList;
    apt, pt3, pt2: PtoCluList;

BEGIN

  IF errorstate THEN RETURN; END;
  pt:=FindWinObj(winnum,objnum);
  IF pt<>NIL THEN
    apt:=pt^.appointer;
    IF apt=NIL THEN RETURN; END;
    IF apt^.actpoint=1 THEN
      pt2:=pt^.obj;
      pt3:=NIL;
      WHILE pt2<>apt DO
        pt3:=pt2;
        pt2:=pt2^.nextcluster;
      END;
      IF pt3<>NIL THEN
        DEALLOCATE(apt,SIZE(ClusterList));
        pt^.appointer:=pt3;
        DEC(pt^.maxpoint);
        pt3^.nextcluster:=NIL;
        pt3^.actpoint:=pt3^.size;
      ELSE
        pt^.maxpoint:=0;
        apt^.actpoint:=0;
        apt^.size:=0;
      END;
    ELSE
      IF apt^.actpoint>1 THEN
        DEC(apt^.actpoint);
        DEC(apt^.size);
        DEC(pt^.maxpoint);
      END;
    END;
  END;
END DeleteObjPoint;

(* Lsche Fenster "winnum" m. Farbe "col" *)

PROCEDURE ClearWin(winnum: CARDINAL; col : RGB);
VAR x, i, y : CARDINAL;
    PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    IF PWin=NIL THEN RETURN; END;
    WITH PWin^ DO
      curflag:=FALSE;
      marflag1:=FALSE;
      marflag2:=FALSE;
      ClearBox(fromx*8,fromy*16,tox*8,toy*16,col);
    END;
  END;
END ClearWin;

(* Zeichne das Fenster "winnum" und bringe es in den Vordergrund *)

PROCEDURE DrawWin(winnum : CARDINAL; hilight, title : BOOLEAN);
VAR PWin: PtoWin;
    i : CARDINAL;
BEGIN
  BringWinToFront(winnum);
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      IF refreshflag THEN

        ClearWin(winnum,backcol);
        DrawBox(fromx*8,fromy*16,tox*8-1,toy*16-1,borcol,TRUE);
        IF hilight THEN
          FOR i:=0 TO 2 DO
            DrawBox(fromx*8+i,fromy*16+i,tox*8-i-1,toy*16-i-1,winhicol,FALSE);
          END;
        END;

        IF title THEN
          SetFGColor(titlecol.r,titlecol.g,titlecol.b);
          SetBGColor(backcol.r,backcol.g,backcol.b);

          GotoXY((fromx+1)*8,(fromy+1)*16);
          WriteCard(winnum,1);
          GotoXY((fromx+3)*8,(fromy+1)*16);
          WriteString(winname);
        END;
        SetFGColor(borcol.r,borcol.g,borcol.b);
        Line(fromx*8+3,(fromy+2)*16,tox*8-4,(fromy+2)*16);
        refreshproc(winnum,obnum);
      END;
    END;
  END;
END DrawWin;

(* Setzte die Window-Gre von "winnum" *)

PROCEDURE SetWinPos(winnum, x, y : CARDINAL; call : BOOLEAN);
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      tox:=(tox-fromx)+x;
      toy:=(toy-fromy)+y;
      fromx:=x;
      fromy:=y;
      IF call THEN winmoveproc(winnum,obnum); END;
    END;
  END;
END SetWinPos;


PROCEDURE SetWinSize(winnum, x, y : CARDINAL; call : BOOLEAN);
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      tox:=fromx+x;
      toy:=fromy+y;
      IF call THEN winsizeproc(winnum,obnum); END;
    END;
  END;
END SetWinSize;

(* Hintergrundfarbe des Schirmes *)

PROCEDURE SetScreenBackCol(col : RGB);
BEGIN
  screenbackcol:=col;
END SetScreenBackCol;

PROCEDURE GetScreenBackCol():RGB;
BEGIN
  RETURN(screenbackcol);
END GetScreenBackCol;

(* Setze Border-Color des Fensters "winnum" *)

PROCEDURE SetWinBorCol(winnum : CARDINAL; borcol : RGB);
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin^.borcol:=borcol;
  END;
END SetWinBorCol;

(* Setze Hintergrundfarbe des Fensters winnum *)

PROCEDURE SetWinBackCol(winnum : CARDINAL; col : RGB);
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin^.backcol:=col;
  END;
END SetWinBackCol;

(* Setze die Farbe des Fensterstitels "winnum" *)

PROCEDURE SetWinTitleCol(winnum: CARDINAL; col : RGB);
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin^.titlecol:=col;
  END;
END SetWinTitleCol;

(* Set Farbe der Menuitems *)

PROCEDURE SetMenuTitleCol(col: RGB);
BEGIN
  mentitlecol:=col;
END SetMenuTitleCol;

PROCEDURE GetMenuTitleCol():RGB;
BEGIN
  RETURN(mentitlecol);
END GetMenuTitleCol;

PROCEDURE SetMenuBackCol(col: RGB);
BEGIN
  menbackcol:=col;
END SetMenuBackCol;

PROCEDURE GetMenuBackCol():RGB;
BEGIN
  RETURN(menbackcol);
END GetMenuBackCol;

PROCEDURE SetMenuItemCol(col: RGB);
BEGIN
  menitemcol:=col;
END SetMenuItemCol;

PROCEDURE GetMenuItemCol():RGB;
BEGIN
  RETURN(menitemcol);
END GetMenuItemCol;

(* Ausgewhlte Menuitems *)

PROCEDURE SetMenuActItemCol(col : RGB);
BEGIN
  menhiitemcol:=col;
END SetMenuActItemCol;

PROCEDURE GetMenuActItemCol():RGB;
BEGIN
  RETURN(menhiitemcol);
END GetMenuActItemCol;

PROCEDURE SetMenuBorCol1(col : RGB);
BEGIN
  menborcol1:=col;
END SetMenuBorCol1;

PROCEDURE GetMenuBorCol1():RGB;
BEGIN
  RETURN(menborcol1);
END GetMenuBorCol1;

PROCEDURE SetMenuBorCol2(col : RGB);
BEGIN
  menborcol2:=col;
END SetMenuBorCol2;

PROCEDURE GetMenuBorCol2():RGB;
BEGIN
  RETURN(menborcol2);
END GetMenuBorCol2;

(* actives Fenster *)

PROCEDURE SetWinActCol(col : RGB);
BEGIN
  winhicol:=col;
END SetWinActCol;

PROCEDURE GetWinActCol():RGB;
BEGIN
  RETURN(winhicol);
END GetWinActCol;

(* Farbe der Info - Chosseboxtexte *)

PROCEDURE SetInfoCol(col : RGB);
BEGIN
  infotextcol:=col;
END SetInfoCol;

PROCEDURE GetInfoCol():RGB;
BEGIN
  RETURN(infotextcol);
END GetInfoCol;

(* ausgewhlt bei Choosebox *)

PROCEDURE SetInfoActCol(col : RGB);
BEGIN
  hiinfotextcol:=col;
END SetInfoActCol;

PROCEDURE GetInfoActCol():RGB;
BEGIN
  RETURN(hiinfotextcol);
END GetInfoActCol;

(* Hintergrund der Info + Choose-Boxen *)

PROCEDURE SetInfoBackCol(col : RGB);
BEGIN
  infobackcol:=col;
END SetInfoBackCol;

PROCEDURE GetInfoBackCol():RGB;
BEGIN
  RETURN(infobackcol);
END GetInfoBackCol;

PROCEDURE SetInfoBorCol1(col : RGB);
BEGIN
  infoborcol1:=col;
END SetInfoBorCol1;

PROCEDURE GetInfoBorCol1():RGB;
BEGIN
  RETURN(infoborcol1);
END GetInfoBorCol1;

PROCEDURE SetInfoBorCol2(col : RGB);
BEGIN
  infoborcol2:=col;
END SetInfoBorCol2;

PROCEDURE GetInfoBorCol2():RGB;
BEGIN
  RETURN(infoborcol2);
END GetInfoBorCol2;

(* Setzte Ursprung fr die Graphicoperationen auf dem Fenster *)

PROCEDURE SetWinOrg(winnum : CARDINAL; originx, originy : INTEGER);
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin^.worgx:=originx;
    PWin^.worgy:=originy;
  END;
END SetWinOrg;

PROCEDURE AllignAllObjs(winnum : CARDINAL; originx, originy : INTEGER);
VAR PWin: PtoWin;
    pt : PtoObjList;
    dx, dy : INTEGER;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    dx:=PWin^.worgx-originx;
    dy:=PWin^.worgy-originy;
    pt:=PWin^.objects;
    IF pt<>NIL THEN
      REPEAT
        pt^.orgx:=pt^.orgx-dx;
        pt^.orgy:=pt^.orgy-dy;
        pt:=pt^.nextobj;
      UNTIL pt=NIL;
    END;
  END;
END AllignAllObjs;

PROCEDURE SetWinZoom(winnum : CARDINAL; zoomfac : REAL);
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    PWin^.zoomfac:=zoomfac;
  END;
END SetWinZoom;

PROCEDURE GetWinZoom(winnum : CARDINAL):REAL;
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    RETURN(PWin^.zoomfac);
  END;
END GetWinZoom;

(* alle Fenster neu zeichnen, "last" ist im Vordergrund! *)

PROCEDURE RefreshAllWins(clearfirst : BOOLEAN);
VAR PWin: PtoWin;
    i : CARDINAL;

BEGIN
  IF clearfirst THEN
    SetMaxWindow();
    SetBGColor(screenbackcol.r,screenbackcol.g,screenbackcol.b);
    Scroll(0);
  END;
  PWin:=winbase^.nextwin;
  IF PWin=NIL THEN RETURN; END;
  REPEAT

    IF PWin<>NIL THEN
    WITH PWin^ DO
      IF refreshflag THEN

        ClearWin(winnum,backcol);
        DrawBox(fromx*8,fromy*16,tox*8-1,toy*16-1,borcol,TRUE);
        IF PWin^.nextwin=NIL THEN
          FOR i:=0 TO 2 DO
            DrawBox(fromx*8+i,fromy*16+i,tox*8-i-1,toy*16-i-1,winhicol,FALSE);
          END;
        END;

        SetFGColor(titlecol.r,titlecol.g,titlecol.b);
        SetBGColor(backcol.r,backcol.g,backcol.b);

        GotoXY((fromx+1)*8,(fromy+1)*16);
        WriteCard(winnum,1);
        GotoXY((fromx+3)*8,(fromy+1)*16);
        WriteString(winname);
        SetFGColor(borcol.r,borcol.g,borcol.b);
        Line(fromx*8+3,(fromy+2)*16,tox*8-4,(fromy+2)*16);
        refreshproc(winnum,obnum);
      END;
    END;
    END;
    PWin:=PWin^.nextwin;
  UNTIL PWin=NIL;
END RefreshAllWins;

(* Erzeuge Fenster m. Name, Nummer, Koordinaten, Farben *)

PROCEDURE CreateWin(wname: String; wnum, fx,fy,tx,ty : CARDINAL;
                    bor, back, title : RGB; froz, destr : BOOLEAN);
VAR pt, pt2,  apt : PtoWin;
    i : CARDINAL;

BEGIN
  pt:=winbase;
  IF errorstate THEN RETURN; END;

  REPEAT
    apt:=pt;
    pt:=pt^.nextwin;
  UNTIL pt=NIL;

  IF NOT(Available(SIZE(Window))) THEN
    NoMoreMemory();
    RETURN;
  ELSE
    ALLOCATE(pt2,SIZE(Window));
  END;
  apt^.nextwin:=pt2;

  WITH pt2^ DO
    objects:=NIL;
    winname:=wname;
    winnum:=wnum;
    fromx:=fx; fromy:=fy;
    tox:=tx; toy:=ty;
    orfx:=fx; orfy:=fy;
    ortx:=tx; orty:=ty;
    curx:=0;
    cury:=0;
    worgx:=0;
    worgy:=0;
    zoomfac:=1.0;
    curflag:=FALSE;
    marflag1:=FALSE;
    marflag2:=FALSE;
    refreshflag:=TRUE;

    xareamin:=-10000;
    xareamax:=10000;
    yareamin:=-10000;
    yareamax:=10000;

    winsizeproc:=NilProc;
    winmoveproc:=NilProc;
    refreshproc:=NilProc;
    winscrollproc:=NilProc;
    winzoomproc:=NilProc;

    borcol:=bor;
    backcol:=back;
    titlecol:=title;
    prevwin:=apt;
    nextwin:=NIL;
    frozen:=froz;
    destroyabel:=destr;
    FOR i:=1 TO menitems DO
      funmenu[i]:='          ';
      funbindkeyscan[i]:='';
      funbindkeywrite[i]:='';
      function[i]:=NilProc;
      activated[i]:=FALSE;
    END;
    menx:=fx;
    meny:=fy;
    ormenx:=fx;
    ormeny:=fy;
  END;
END CreateWin;

PROCEDURE SetWinArea(winnum : CARDINAL; xmin, xmax, ymin, ymax : INTEGER);
VAR PWin : PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      xareamin:=xmin;
      xareamax:=xmax;
      yareamin:=ymin;
      yareamax:=ymax;
    END;
  END;
END SetWinArea;

PROCEDURE GetWinAreaMin(winnum : CARDINAL):Coord;
VAR PWin : PtoWin;
    p : Coord;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      p.x:=xareamin;
      p.y:=yareamin;
    END;
  END;
  RETURN(p);
END GetWinAreaMin;

PROCEDURE GetWinAreaMax(winnum : CARDINAL):Coord;
VAR PWin : PtoWin;
    p : Coord;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      p.x:=xareamax;
      p.y:=yareamax;
    END;
  END;
  RETURN(p);
END GetWinAreaMax;
                 
PROCEDURE GetWinGraphicSize(winnum : CARDINAL):Coord;
VAR PWin: PtoWin;
    p : Coord;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      p.x:=tox*8-4- (fromx*8+4);
      p.y:=toy*16-4-(fromy*16+33);
      RETURN(p);
    END;
  END;
END GetWinGraphicSize;

(* Zerstre Fenster "winnum", gib Speicher frei! *)

PROCEDURE DestroyWin(winnum : CARDINAL);
VAR PWin: PtoWin;
    pt1, pt5, pt4 : PtoObjList;
    pt2, pt3 : PtoCluList;
BEGIN

  PWin:=FindWin(winnum);

  IF PWin<>NIL THEN

    IF PWin^.prevwin=winbase THEN
      IF PWin^.nextwin=NIL THEN
        winbase^.nextwin:=NIL
      ELSE
        PWin^.nextwin^.prevwin:=winbase;
        winbase^.nextwin:=PWin^.nextwin;
      END;
    END;

    IF (PWin^.nextwin=NIL) AND (PWin^.prevwin#winbase) THEN
      PWin^.prevwin^.nextwin:=NIL;
    END;

    IF (PWin^.prevwin#winbase) AND (PWin^.nextwin#NIL) THEN
      PWin^.prevwin^.nextwin:=PWin^.nextwin;
      PWin^.nextwin^.prevwin:=PWin^.prevwin;
    END;

    pt1:=PWin^.objects;

    WHILE pt1<>NIL DO
      pt2:=pt1^.obj;
      IF pt2#NIL THEN
        REPEAT
          pt3:=pt2;
          pt2:=pt2^.nextcluster;

          DEALLOCATE(pt3,SIZE(ClusterList));
        UNTIL pt2=NIL;
      END;

      pt4:=pt1;
      pt1:=pt1^.nextobj;

      DEALLOCATE(pt4,SIZE(ObjList));

    END;

    IF PWin^.objects<>NIL THEN
      PWin^.objects^.nextobj:=NIL;
      PWin^.objects:=NIL;
    END;
    DEALLOCATE(PWin,SIZE(Window));
  END;
END DestroyWin;

(* Hnge eine Prozedur in's Func-Men des Fensters "winnum", m. Name + Nummer *)

PROCEDURE SetWinMenItem(winnum, funnum: CARDINAL; name: String; fun: Winproc);
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      funmenu[funnum]:=name;
      function[funnum]:=fun;
      activated[funnum]:=TRUE;
    END;
  END;
END SetWinMenItem;

PROCEDURE SetWinMenBindkey(winnum, funnum: CARDINAL; key : CHAR);
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      funbindkeyscan[funnum]:=GiveAlt(key);
      funbindkeywrite[funnum]:=key;
    END;
  END;
END SetWinMenBindkey;

PROCEDURE ActivateWinMenItem(winnum, funnum: CARDINAL);
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      activated[funnum]:=TRUE;
    END;
  END;
END ActivateWinMenItem;

PROCEDURE IsWinMenItemActivated(winnum, funnum: CARDINAL):BOOLEAN;
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    RETURN(PWin^.activated[funnum]);
  END;
END IsWinMenItemActivated;

PROCEDURE DeactivateWinMenItem(winnum, funnum: CARDINAL);
VAR PWin: PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      activated[funnum]:=FALSE;
    END;
  END;
END DeactivateWinMenItem;

(* Wandernde Box (Cursor-Tasten) *)

PROCEDURE MoveBox(VAR x1, y1 : CARDINAL; VAR x2, y2 : CARDINAL; winnum : CARDINAL; stat : BOOLEAN);

VAR i, ii, ax, ay, x, y, mousex, mousey : CARDINAL;
   dx, dy,  amousex, amousey : CARDINAL;
   key : CHAR;
   left, right, keyflag, pos, strg : BOOLEAN;
   
   PWin : PtoWin;

BEGIN

  SetMaxWin();
  StoreMousePos;
  ConfLeftButton;
  ConfRightButton;

  IF stat THEN
    ax:=x1;
    ay:=y1;
    x1:=x1*8;
    x2:=x2*8+16;
    y1:=y1*16+8;
    y2:=y2*16+8;
  ELSE
    ax:=x1;
    ay:=y1;
    x1:=x1*8;
    x2:=x2*8-1;
    y1:=y1*16;
    y2:=y2*16-1;
  END;

  SetFGColor(winhicol.r,winhicol.g,winhicol.b);
  xormode:=FALSE;
  FOR i:=x1 TO x2 BY 4 DO
    FOR ii:=y1 TO y2 BY 4 DO
      Plot(i,ii);
    END;
  END;

  dx:=x2-x1;
  dy:=y2-y1;

  InitMouse(0,0,scmaxx,scmaxy);
  SetMousePos(x1,y1);
  ConfPosChanged();

  PWin:=FindWin(winnum);

  text5[1].t:="Move-Box:";
  text5[2].t:="Use CURSORKEYS or MOUSE,";
  text5[3].t:="ENTER or LEFT MOUSEBUTTON";
  text5[4].t:="to confirm, SPACE or RIGHT";
  text5[5].t:="MOUSEBUTTON to fit in.";

  ShowInfoBox(x1 DIV 8, y1 DIV 16,5,text5);
  xormode:=TRUE;

  DrawBox(x1,y1,x2,y2,white,FALSE);

  LOOP

    WaitForEvents(left,right,pos,keyflag,strg,key);
    DrawBox(x1,y1,x2,y2,white,FALSE);

    IF pos THEN
      amousex:=mousex;
      amousey:=mousey;
      GetMouseState(mousex,mousey,left,right);
      x1:=(mousex DIV 8)*8;
      x2:=dx+x1;
      y1:=(mousey DIV 16)*16;
      IF stat THEN
        INC(y1,8);
      END;
      y2:=dy+y1;

      IF (x2>scmaxx) OR (y2>scmaxy) THEN
        IF x2>scmaxx THEN
          x1:=((scmaxx+1) DIV 8)*8-dx-1;
          x2:=dx+x1;
          mousex:=amousex;
        END;
        IF y2>scmaxy THEN
          y1:=((scmaxy+1) DIV 16)*16-dy-1;
          y2:=dy+y1;
          mousey:=amousey;
        END;
        SetMousePos(mousex,mousey);
        ConfPosChanged();
      END;
    ELSIF keyflag THEN
      GetMouseState(mousex,mousey,left,right);
      CASE key OF
        CurDown  : IF (y2<(scmaxy-15)) THEN y1:=y1+16; y2:=y2+16;
                                            INC(mousey,16); END; |
        CurUp    : IF (y1>15)          THEN y1:=y1-16; y2:=y2-16;
                                            DEC(mousey,16); END; |
        CurRight : IF (x2<scmaxx-7)    THEN x1:=x1+8;  x2:=x2+8;
                                            INC(mousex,8); END; |
        CurLeft  : IF (x1>7)           THEN x1:=x1-8;  x2:=x2-8;
                                            DEC(mousex,8); END;
      END;
      SetMousePos(mousex,mousey);
      ConfPosChanged();
    END;

    IF (key=Enter) OR left THEN
      NormalTick2();
      IF stat THEN
        IF x1<8 THEN
          x1:=0;
          x2:=x2 DIV 8 -1;
        ELSE
          x1:=x1 DIV 8 -1;
          x2:=x2 DIV 8 -2;
        END;
        y1:=y1 DIV 16;
        y2:=y2 DIV 16;
      ELSE
        x1:=x1 DIV 8;    y1:=y1 DIV 16;
        x2:=(x2+1) DIV 8;
        y2:=(y2+1) DIV 16;
      END;
      ClearInfoBox(ax,ay,5,text5);
      RestoreMousePos;
      ConfLeftButton;
      ConfRightButton;
      ConfPosChanged;
      RETURN;
    END;

    IF (key=Space) OR right THEN
      NormalTick1();
      WITH PWin^ DO
        IF stat THEN
          x1:=ormenx*8+8;    y1:=ormeny*16+8;
          x2:=(ormenx+21)*8; y2:=(ormeny+4+menitems)*16+8;
        ELSE
          x1:=orfx*8; y1:=orfy*16;
          x2:=ortx*8-1; y2:=orty*16-1;
        END;
      END;

      InitMouse(0,0,scmaxx,scmaxy);
      SetMousePos(0,0);
      ConfPosChanged();

    END;
    DrawBox(x1,y1,x2,y2,white,FALSE);
  END;
  RestoreMousePos;
  ConfLeftButton;
  ConfRightButton;
  ConfPosChanged;
END MoveBox;

(* Grenvernderungs-Box (Cursor-Tasten) *)

PROCEDURE SizeBox(winnum : CARDINAL; VAR x1, y1, x2, y2 : CARDINAL):BOOLEAN;

VAR PWin: PtoWin;
   i, ii, ax, ay, bx, by, x, y : CARDINAL;
   mousex, mousey, amousex, amousey : CARDINAL;
   key : CHAR;
   pos, strg, keyflag, left, right : BOOLEAN;

BEGIN

  SetMaxWin();
  ax:=x1;
  ay:=y1;
  bx:=x2;
  by:=y2;
  x1:=x1*8;
  x2:=x2*8-1;
  y1:=y1*16;
  y2:=y2*16-1;

  xormode:=FALSE;
  SetFGColor(winhicol.r,winhicol.g,winhicol.b);
  xormode:=FALSE;
  FOR i:=x1 TO x2 BY 4 DO
    FOR ii:=y1 TO y2 BY 4 DO
      Plot(i,ii);
    END;
  END;

  text5[1].t:="Size-Box:";
  text5[2].t:="Use CURSORKEYS or MOUSE,";
  text5[3].t:="ENTER or LEFT MOUSEBUTTON";
  text5[4].t:="to confirm, SPACE or RIGHT";
  text5[5].t:="MOUSEBUTTON to toggle.";

  ShowInfoBox(x1 DIV 8, y1 DIV 16,5,text5);
  xormode:=TRUE;
  PWin:=FindWin(winnum);
  DrawBox(x1,y1,x2,y2,white,FALSE);

  StoreMousePos;
  ConfLeftButton;
  ConfRightButton;

  InitMouse(0,0,scmaxx,scmaxy);
  SetMousePos(x2+1,y2+1);
  ConfPosChanged();

  LOOP

    WaitForEvents(left,right,pos,keyflag,strg,key);
    DrawBox(x1,y1,x2,y2,white,FALSE);

    IF pos THEN
      amousex:=mousex;
      amousey:=mousey;
      GetMouseState(mousex,mousey,left,right);
      x2:=(mousex DIV 8)*8;
      y2:=(mousey DIV 16)*16;
      IF (INTEGER(y2)-INTEGER(y1))<INTEGER((PWin^.orty)*16-1-PWin^.orfy*16) THEN
        y2:=y1+((PWin^.orty)*16-1-PWin^.orfy*16);
        mousey:=y2;
        SetMousePos(mousex,mousey);
        ConfPosChanged();
      END;
      IF (INTEGER(x2)-INTEGER(x1))<INTEGER((PWin^.ortx)*8-1-PWin^.orfx*8) THEN
        x2:=x1+((PWin^.ortx)*8-1-PWin^.orfx*8);
        mousex:=x2;
        SetMousePos(mousex,mousey);
        ConfPosChanged();
      END;
    ELSIF keyflag THEN
      GetMouseState(mousex,mousey,left,right);
      CASE key OF
        CurDown  : IF (y2<scmaxy-15) THEN
                     INC(y2,16);
                     INC(mousey,16);
                   END; |
        CurUp    : IF (y2-y1)>((PWin^.orty)*16-1-PWin^.orfy*16) THEN
                     DEC(y2,16);
                     DEC(mousey,16);
                   END; |
        CurRight : IF (x2<scmaxx-7) THEN
                     INC(x2,8);
                     INC(mousex,8);
                   END; |
        CurLeft  : IF (x2-x1)>((PWin^.ortx)*8-1-PWin^.orfx*8) THEN
                     DEC(x2,8);
                     DEC(mousex,8);
                   END;
      END;
      SetMousePos(mousex,mousey);
      ConfPosChanged();
    END;

    IF (key=Enter) OR left THEN
      NormalTick2();
      x1:=x1     DIV 8; y1:=y1     DIV 16;
      x2:=(x2+1) DIV 8; y2:=(y2+1) DIV 16;
      ClearInfoBox(ax,ay,5,text5);
      RestoreMousePos;
      ConfLeftButton;
      ConfRightButton;
      ConfPosChanged;

      IF (x1=ax) AND (x2=bx) AND (y1=ay) AND (y2=by) THEN
        RETURN(FALSE);
        EXIT;
      ELSE
        RETURN(TRUE);
        EXIT;
      END;
    END;

    IF (key=Space) OR right THEN
      NormalTick1();
      IF (x2=PWin^.ortx*8-1) AND (y2=PWin^.orty*16-1) THEN
        x1:=0;
        y1:=0;
        x2:=8 *(scmaxx DIV 8  );
        y2:=16*(scmaxy DIV 16 );
      ELSE
        WITH PWin^ DO
          x1:=orfx*8;   y1:=orfy*16;
          x2:=ortx*8-1; y2:=orty*16-1;
        END;
      END;
      SetMousePos(x2,y2);
      ConfPosChanged();
      mousex:=x2;
      mousey:=y2;
    END;

    DrawBox(x1,y1,x2,y2,white,FALSE);

  END;
END SizeBox;


PROCEDURE SizeWinHandler(winnum : CARDINAL);

VAR PWin : PtoWin;

BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    IF NOT(PWin^.frozen) THEN
      ClearWin(winnum,screenbackcol);
      WITH PWin^ DO
        IF SizeBox(winnum,fromx,fromy,tox,toy) THEN
          winsizeproc(winnum,obnum);
        ELSE
          RefreshAllWins(TRUE);
        END;
      END;
    END;
  END;
END SizeWinHandler;

PROCEDURE MoveWinHandler(winnum : CARDINAL);

VAR PWin : PtoWin;

BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    IF NOT(PWin^.frozen) THEN
      ClearWin(winnum,screenbackcol);
      WITH PWin^ DO
        MoveBox(fromx,fromy,tox,toy,winnum,FALSE);
        winsizeproc(winnum,obnum);
        (* RefreshAllWins(TRUE); *)
      END;
    END;
  END;
END MoveWinHandler;

PROCEDURE DrawMenItem(VAR name : ARRAY OF CHAR; bindkey : ARRAY OF CHAR;
                      active : BOOLEAN;
                      x, y, i : CARDINAL; itemcol, backcol : RGB);

VAR ix, iy : CARDINAL;

BEGIN
  SetFGColor(itemcol.r,itemcol.g,itemcol.b);
  GotoXY((x+1)*8,(y+2+i)*16);
  Write(" ");
  WriteString(name);
  Write(" ");
  IF bindkey[0]<>'' THEN
    SetBGColor(itemcol.r,itemcol.g,itemcol.b);
    SetFGColor(backcol.r,backcol.g,backcol.b);
    WriteString(bindkey);
  END;
  SetBGColor(backcol.r,backcol.g,backcol.b);
  IF NOT(active) THEN
    SetFGColor(backcol.r,backcol.g,backcol.b);
    FOR ix:=(x+2)*8 TO (x+HIGH(winmenu[1])+3)*8 DO
      FOR iy:=(y+2+i)*16 TO (y+2+i+1)*16 BY 2 DO
        Plot(ix,iy+CARDINAL((ix MOD 2)=0));
      END;
    END;
  END;
  SetFGColor(itemcol.r,itemcol.g,itemcol.b);
  GotoXY((x+1)*8,(y+i+2)*16);
END DrawMenItem;

(* Zeige das Func- oder Window-Men des Fensters, auf das "PWin" zeigt *)

PROCEDURE ShowMenu(PWin: PtoWin; x, y : CARDINAL; mode: BOOLEAN);
VAR i, ii :CARDINAL;
    ix, iy : CARDINAL;
BEGIN
   SetMaxWin();
   WITH PWin^ DO
     SolidBox(x,y,HIGH(winmenu[1])+4,2+menitems,menbackcol,menborcol1,menborcol2);
     GotoXY((x+2)*8,(y+1)*16);
     SetFGColor(mentitlecol.r,mentitlecol.g,mentitlecol.b);
     SetBGColor(menbackcol.r,menbackcol.g,menbackcol.b);
     IF mode THEN WriteString('Window menu '); ELSE WriteString('Functions '); END;
     WriteCard(winnum,1);
     IF NOT(mode) THEN
       GotoXY((x+HIGH(winmenu[1])+1)*8,(y+1)*16);
       SetFGColor(menbackcol.r,menbackcol.g,menbackcol.b);
       SetBGColor(menitemcol.r,menitemcol.g,menitemcol.b);
       WriteString("ALT");
       SetBGColor(menbackcol.r,menbackcol.g,menbackcol.b);
     END;
     SetFGColor(mentitlecol.r,mentitlecol.g,mentitlecol.b);
     Line(x*8+3,(y+2)*16,(x+HIGH(winmenu[1])+5)*8-4,(y+2)*16);

     FOR i:=1 TO menitems DO
       IF mode THEN
         IF (i=ORD(sizewin)) OR (i=ORD(movewin)) THEN
           DrawMenItem(winmenu[i],winbindkeywrite[i],NOT(frozen),x,y,i,menitemcol,menbackcol);
         ELSIF (i=ORD(closewin)) THEN
           DrawMenItem(winmenu[i],winbindkeywrite[i], destroyabel,x,y,i,menitemcol,menbackcol);
         ELSE
           DrawMenItem(winmenu[i],winbindkeywrite[i],TRUE,x,y,i,menitemcol,menbackcol);
         END;
       ELSE
         DrawMenItem(funmenu[i],funbindkeywrite[i],activated[i],x,y,i,menitemcol,menbackcol);
       END;
     END;
   END;
END ShowMenu;

PROCEDURE OpenMenu(winnum : CARDINAL);
VAR fx, fy, tx, ty :CARDINAL;
    PWin : PtoWin;
BEGIN
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      fx:=menx; fy:=meny;
      tx:=fx+13; ty:=fy+4+menitems;
      INC(fx);
      INC(tx);
      ShowMenu(PWin,fx,fy,TRUE);
      SetFGColor(menhiitemcol.r,menhiitemcol.g,menhiitemcol.b);
      DrawMenItem(winmenu[1],winbindkeywrite[1],TRUE,fx,fy,1,menhiitemcol,menbackcol);
      WriteString(">");
    END;
  END;
END OpenMenu;

(* Handler fr Window-Men (Size, Move, etc.) und Func-Men, eingehngte Prozeduren *)

PROCEDURE ProcessMenu(wnum : CARDINAL):CARDINAL;


  (*    func_1  , func_2,   func_3               .............    func_7 *)

VAR x,y, fx, fy, tx, ty,a, b, c, d, max, mwin : CARDINAL;
    ix, iy : CARDINAL;
    PWin: PtoWin;
    key : CHAR;
    left, right, keyflag, pos, strg, mode, flag, l, r, up, down : BOOLEAN;
    i, ii, ai, n : CARDINAL;
    mousex, mousey : CARDINAL;

 BEGIN

  PWin:=FindWin(wnum);
  mode:=FALSE;

  IF PWin<>NIL THEN
    StoreMousePos;
    SetMaxWin;
    SetBGColor(menbackcol.r,menbackcol.g,menbackcol.b);
    WITH PWin^ DO
      fx:=menx; fy:=meny;
      tx:=fx+18; ty:=fy+4+menitems;
      INC(fx);
      INC(tx);
      ShowMenu(PWin,fx,fy,mode);

      DrawMenItem(funmenu[1],funbindkeywrite[1],activated[1],fx,fy,1,menhiitemcol,menbackcol);
      WriteString(">");

      i:=ORD(cyclewin); ii:=ORD(cyclewin);

      InitMouse(0,32,1,menitems*32+31);
      SetMousePos(0,32+16);
      ConfPosChanged();

      LOOP
        WaitForEvents(left,right,pos,keyflag,strg,key);

        IF pos THEN
          ai:=i;
          GetMouseState(mousex,mousey,left,right);
          i:=mousey DIV 32;

          IF i<>ai THEN
            SetMousePos(0,i*32+16);
            ConfPosChanged();
          END;
        ELSE
          IF strg THEN
            ai:=i;
            CASE key OF
              CurUp   : IF i>1        THEN DEC(i); END; |
              CurDown : IF i<menitems THEN INC(i); END;
            END;

            IF (function[i]=NilProc) OR (i<1) OR (i>menitems) THEN
              i:=ai;
            END;

            FOR n:=1 TO menitems DO
              IF key=funbindkeyscan[n] THEN
                i:=n;
               END;
            END;

            SetMousePos(0,i*32+16);
            ConfPosChanged();

          END;
        END;

        IF i<>ii THEN
          IF mode THEN
            IF (ii=ORD(movewin)) OR (ii=ORD(sizewin)) THEN
              DrawMenItem(winmenu[ii],winbindkeywrite[ii],NOT(frozen),fx,fy,ii,menitemcol,menbackcol);
            ELSIF (ii=ORD(closewin)) THEN
              DrawMenItem(winmenu[ii],winbindkeywrite[ii],destroyabel,fx,fy,ii,menitemcol,menbackcol);
            ELSIF (ii=ORD(cyclewin)) THEN
              DrawMenItem(winmenu[ii],winbindkeywrite[ii], NOT(fixed),fx,fy,ii,menitemcol,menbackcol);
            ELSE
              DrawMenItem(winmenu[ii],winbindkeywrite[ii],TRUE,fx,fy,ii,menitemcol,menbackcol);
            END;
          ELSE
            DrawMenItem(funmenu[ii],funbindkeywrite[ii],activated[ii],fx,fy,ii,menitemcol,menbackcol);
          END;
        END;

        IF (key=winbindkeyscan[ORD(exitmenu)]) THEN
          NormalTick2();
          RefreshAllWins(TRUE);
          RestoreMousePos;
          RETURN(wnum);
          EXIT;
        END;

        IF ((key=Space) AND NOT(strg)) OR right THEN
          NormalTick2();
          mode:=NOT(mode);
          ii:=0;
          ShowMenu(PWin,fx,fy,mode);
        END;

        IF (key=Enter) OR left THEN
          NormalTick1();
          ConfLeftButton;
          xormode:=FALSE;
          IF mode THEN
            CASE i OF
              ORD(movemenu) :
                ClearBox(fx*8,fy*16+8,tx*8+16,ty*16+8,screenbackcol);
                MoveBox(fx,fy,tx,ty,wnum,TRUE);
                RefreshAllWins(TRUE);
                ShowMenu(PWin,fx+1,fy,mode);
                menx:=fx; meny:=fy;
                INC(fx); ii:=0; |
              ORD(exitmenu) :
                RefreshAllWins(TRUE);
                RestoreMousePos;
                RETURN(wnum); EXIT; |
              ORD(movewin) :
                IF NOT(frozen) THEN
                  ClearWin(wnum,screenbackcol);
                  a:=fromx; b:=fromy;
                  c:=tox; d:=toy;
                  MoveBox(fromx,fromy,tox,toy,wnum,FALSE);
                  RestoreMousePos;
                  IF (fromx<>a) OR (fromy<>b) OR (tox<>c) OR (toy<>d) THEN
                    winmoveproc(wnum,obnum);
                  ELSE
                    RefreshAllWins(TRUE);
                  END;
                  RETURN(wnum);
                  EXIT;
                END; |
              ORD(sizewin) :
                IF NOT(frozen) THEN
                  ClearWin(wnum,screenbackcol);
                  RestoreMousePos;
                  IF SizeBox(wnum,fromx,fromy,tox,toy) THEN
                    winsizeproc(wnum,obnum);
                  ELSE
                    RefreshAllWins(TRUE);
                  END;
                  RETURN(wnum);
                  EXIT;
                END; |
              ORD(zoomwin) : RestoreMousePos;
                             winzoomproc(wnum,obnum);
                             RETURN(wnum); EXIT; |
              ORD(scrollwin) : RestoreMousePos;
                               winscrollproc(wnum,obnum);
                               RETURN(wnum); EXIT; |
              ORD(resetwin) : RestoreMousePos;
                              winresetproc(wnum,obnum);
                              RETURN(wnum); EXIT; |
              ORD(closewin) :
                IF destroyabel THEN
                  mwin:=GetNextWinNumber(wnum);
                  DestroyWin(wnum);
                  RefreshAllWins(TRUE);
                  RestoreMousePos;
                  RETURN(mwin);
                  EXIT;
                END; |
              ORD(cyclewin) :
                IF NOT(fixed) THEN
                  mwin:=GetNextVWinNumber(wnum);
                  BringWinToFront(mwin);
                  RefreshAllWins(TRUE);
                  RestoreMousePos;
                  wnum:=ProcessMenu(mwin);
                  RETURN(wnum);
                  EXIT;
                END; |
              ORD(refresh) :
                RefreshAllWins(TRUE);
                ShowMenu(PWin,fx,fy,mode); |
              ORD(cleanup) :
                ResetAllWins();
                RefreshAllWins(TRUE);
                RestoreMousePos;
                RETURN(wnum); |
            END;
          ELSE
            IF (activated[i]) AND (function[i]<>NilProc) THEN
              RestoreMousePos;
              function[i](wnum,obnum);
              RETURN(wnum);
              EXIT;
            END;
          END;
        END;

        IF i<>ii THEN
          IF mode THEN
            IF (i=ORD(movewin)) OR (i=ORD(sizewin)) THEN
              DrawMenItem(winmenu[i],winbindkeywrite[i],NOT(frozen),fx,fy,i,menhiitemcol,menbackcol);
            ELSIF (i=ORD(closewin)) THEN
              DrawMenItem(winmenu[i],winbindkeywrite[i],destroyabel,fx,fy,i,menhiitemcol,menbackcol);
            ELSIF (i=ORD(cyclewin)) THEN
              DrawMenItem(winmenu[i],winbindkeywrite[i],NOT(fixed),fx,fy,i,menhiitemcol,menbackcol);
            ELSE
              DrawMenItem(winmenu[i],winbindkeywrite[i],TRUE,fx,fy,i,menhiitemcol,menbackcol);
            END;
          ELSE
            DrawMenItem(funmenu[i],funbindkeywrite[i],activated[i],fx,fy,i,menhiitemcol,menbackcol);
          END;

          WriteString(">");
        END;

        ii:=i;

      END;
    END;
  ELSE
    RETURN(0);
  END;
END ProcessMenu;

(* Handelt Fenster-Aktionen wie TAB, Enter, Window-Nummer 1..5 *)

PROCEDURE WindowHandler(VAR left, right : BOOLEAN;
          VAR key : CHAR; ctrl : BOOLEAN; VAR wnum : CARDINAL);
VAR PWin : PtoWin;
    confirm : BOOLEAN;
    flage : BOOLEAN;
    i, awnum : CARDINAL;

BEGIN

  isrefreshed:=FALSE;

  SetMaxWin();
  IF NOT(fixed) THEN
    IF key=winbindkeyscan[ORD(cyclewin)] THEN
      NormalTick1();
      PWin:=FindWin(wnum);
      PWin^.curflag:=FALSE;
      PWin^.marflag1:=FALSE;
      PWin^.marflag2:=FALSE;
      DrawWin(wnum,FALSE,TRUE);

      PWin:=GetNextVWinPointer(PWin);
      IF PWin<>NIL THEN
        wnum:=PWin^.winnum;
        DrawWin(wnum,TRUE,TRUE);
      END;
    ELSIF (key>'0') AND (key<'9') THEN
      NormalTick1();
      awnum:=wnum;
      wnum:=ORD(key)-48;
      PWin:=FindWin(wnum);
      IF PWin<>NIL THEN
        IF PWin^.refreshflag THEN
          DrawWin(awnum,FALSE,TRUE);
          DrawWin(wnum,TRUE,TRUE);
        ELSE
          wnum:=awnum;
        END;
      ELSE
        wnum:=awnum;
      END;
    END;
  END;

  IF (key=Enter) OR right THEN
    NormalTick2();
    DisableWaitProc;
    right:=FALSE;
    ConfRightButton;
    DrawWin(wnum,TRUE,TRUE);
    wnum:=ProcessMenu(wnum);
  ELSIF (key=winbindkeyscan[ORD(movewin)]) AND ctrl THEN
    NormalTick1();
    DisableWaitProc;
    MoveWinHandler(wnum);
  ELSIF (key=winbindkeyscan[ORD(sizewin)]) AND ctrl THEN
    NormalTick1();
    DisableWaitProc;
    SizeWinHandler(wnum);
  ELSIF (key=winbindkeyscan[ORD(refresh)]) AND ctrl THEN
    NormalTick1();
    RefreshAllWins(TRUE);
  ELSIF (key=winbindkeyscan[ORD(cleanup)]) AND ctrl THEN
    NormalTick1();
    ResetAllWins();
    RefreshAllWins(TRUE);
  ELSIF (key=winbindkeyscan[ORD(zoomwin)]) AND ctrl THEN
    NormalTick1();
    PWin:=FindWin(wnum);
    IF PWin<>NIL THEN
      PWin^.winzoomproc(wnum,obnum);
      (* RefreshAllWins(TRUE); *)
    END;
  ELSIF (key=winbindkeyscan[ORD(scrollwin)]) AND ctrl THEN
    NormalTick1();
    PWin:=FindWin(wnum);
    IF PWin<>NIL THEN
      PWin^.winscrollproc(wnum,obnum);
      (* RefreshAllWins(TRUE); *)
    END;
  ELSIF (key=winbindkeyscan[ORD(resetwin)]) AND ctrl THEN
    NormalTick1();
    PWin:=FindWin(wnum);
    IF PWin<>NIL THEN
      PWin^.winresetproc(wnum,obnum);
      (* RefreshAllWins(TRUE); *)
    END;
  ELSIF ctrl THEN
    DisableWaitProc;
    PWin:=FindWin(wnum);
    IF PWin<>NIL THEN
      WITH PWin^ DO
        FOR i:=1 TO menitems DO
          IF (funbindkeyscan[i]=key) AND (activated[i]) THEN
            NormalTick1();
            function[i](wnum,obnum);
          END;
        END;
      END;
    END;
  END;
END WindowHandler;

PROCEDURE SetCursorstep(step : CARDINAL);
BEGIN
  cursorstep:=step;
END SetCursorstep;

PROCEDURE GetCursorstep():CARDINAL;
BEGIN
  RETURN(cursorstep);
END GetCursorstep;

(* Zeichne ein Cursor-Cross und behandle Tasten-Events *)

PROCEDURE CursorHandler(key : CHAR; winnum : CARDINAL; col : RGB; type : BOOLEAN);
VAR xamin, xamax, yamin, yamax, xma, yma, xmi, ymi : INTEGER;
    inc1, inc2 : INTEGER;
    x, y : INTEGER;
    flag : BOOLEAN;
    aPWin, PWin: PtoWin;
    left, right, up, down  : BOOLEAN;
    xmouse, ymouse : CARDINAL;

BEGIN
  xormode:=TRUE;

  PWin:=FindWin(winnum);

  WITH PWin^ DO

    xamin:=xareamin;
    xamax:=xareamax;

    yamin:=yareamin;
    yamax:=yareamax;

    xmi:=fromx*8+4;
    ymi:=fromy*16+33;

    xma:=tox*8-4;
    yma:=toy*16-4;
    SetWindow(xmi+1,ymi+1,xma-1,yma-1);
    SetFGColor(col.r,col.g,col.b);

    aPWin:=PWin;
    flag:=TRUE;

    IF curflag THEN
      REPEAT
        aPWin:=aPWin^.nextwin;
        IF aPWin<>NIL THEN
          WITH aPWin^ DO
            flag:=flag AND NOT((INTEGER(fromx*8)<=x) AND (x<=INTEGER(tox*8)) AND (INTEGER(fromy*16)<=y) AND (y<=INTEGER(toy*16)));
          END;
        END;
      UNTIL aPWin=NIL;
    END;

    IF curflag AND flag THEN

      x:=ROUND(FLOAT(xmi)+FLOAT(worgx)+FLOAT(curx)*zoomfac);
      y:=ROUND(FLOAT(ymi)+FLOAT(worgy)+FLOAT(cury)*zoomfac);

      IF type THEN
        Plot(x,y-2);
        Plot(x,y+2);
        Plot(x-2,y);
        Plot(x+2,y);

        Plot(x,y-4);
        Plot(x,y+4);
        Plot(x-4,y);
        Plot(x+4,y);

        Plot(x,y-6);
        Plot(x,y+6);
        Plot(x-6,y);
        Plot(x+6,y);
      ELSE
        Plot(x-2,y-2);
        Plot(x,y-2);
        Plot(x+2,y-2);

        Plot(x-2,y);
        Plot(x+2,y);

        Plot(x-2,y+2);
        Plot(x,y+2);
        Plot(x+2,y+2);
      END;
    END;

    inc1:=1;
    inc2:=cursorstep;

    GetMouseState(xmouse,ymouse,left,right);

    IF snapmode THEN
      xmouse:=ROUND(REAL(xmouse)/zoomfac) DIV INTEGER(cursorstep) * INTEGER(cursorstep);
      ymouse:=ROUND(REAL(ymouse)/zoomfac) DIV INTEGER(cursorstep) * INTEGER(cursorstep);
    ELSE
      xmouse:=ROUND(REAL(xmouse)/zoomfac);
      ymouse:=ROUND(REAL(ymouse)/zoomfac);
    END;

    IF NOT(PosChanged()) THEN
      CASE key OF
        CurDown     : INC(cury,inc2); |
        CurUp       : DEC(cury,inc2); |
        CurRight    : INC(curx,inc2); |
        CurLeft     : DEC(curx,inc2); |
        AltCurDown  : INC(cury,inc1); |
        AltCurUp    : DEC(cury,inc1); |
        AltCurRight : INC(curx,inc1); |
        AltCurLeft  : DEC(curx,inc1);
      END;

      mouseorgx:=mickx DIV 2 -1;
      mouseorgy:=micky DIV 2 -1;
      SetMousePos(mouseorgx,mouseorgy);
      ConfPosChanged();
      IF snapmode THEN
        mouseoffx:=ROUND(REAL(mouseorgx)/zoomfac) DIV INTEGER(cursorstep) * INTEGER(cursorstep)-curx;
        mouseoffy:=ROUND(REAL(mouseorgy)/zoomfac) DIV INTEGER(cursorstep) * INTEGER(cursorstep)-cury;
      ELSE
        mouseoffx:=ROUND(REAL(mouseorgx)/zoomfac)-curx;
        mouseoffy:=ROUND(REAL(mouseorgy)/zoomfac)-cury;
      END;
    ELSE
      curx:=INTEGER(xmouse)-INTEGER(mouseoffx);
      cury:=INTEGER(ymouse)-INTEGER(mouseoffy);
    END;
    ConfPosChanged;

    flag:=FALSE;
    IF curx<xamin THEN flag:=TRUE; curx:=xamin; END;
    IF curx>xamax THEN flag:=TRUE; curx:=xamax; END;
    IF cury<yamin THEN flag:=TRUE; cury:=yamin; END;
    IF cury>yamax THEN flag:=TRUE; cury:=yamax; END;

    IF flag THEN
      SetMousePos(mouseorgx,mouseorgy);
      ConfPosChanged();
      IF snapmode THEN
        mouseoffx:=ROUND(REAL(mouseorgx)/zoomfac) DIV INTEGER(cursorstep) * INTEGER(cursorstep)-curx;
        mouseoffy:=ROUND(REAL(mouseorgy)/zoomfac) DIV INTEGER(cursorstep) * INTEGER(cursorstep)-cury;
      ELSE
        mouseoffx:=ROUND(REAL(mouseorgx)/zoomfac)-curx;
        mouseoffy:=ROUND(REAL(mouseorgy)/zoomfac)-cury;
      END;
    END;

    x:=ROUND(FLOAT(xmi)+FLOAT(worgx)+FLOAT(curx)*zoomfac);
    y:=ROUND(FLOAT(ymi)+FLOAT(worgy)+FLOAT(cury)*zoomfac);

    aPWin:=PWin;
    flag:=TRUE;

    REPEAT
      aPWin:=aPWin^.nextwin;
      IF aPWin<>NIL THEN
        WITH aPWin^ DO
          flag:=flag AND NOT((INTEGER(fromx*8)<=x) AND (x<=INTEGER(tox*8)) AND (INTEGER(fromy*16)<=y) AND (y<=INTEGER(toy*16)));
        END;
      END;
    UNTIL aPWin=NIL;

    IF flag THEN

      IF type THEN
        Plot(x,y-2);
        Plot(x,y+2);
        Plot(x-2,y);
        Plot(x+2,y);

        Plot(x,y-4);
        Plot(x,y+4);
        Plot(x-4,y);
        Plot(x+4,y);

        Plot(x,y-6);
        Plot(x,y+6);
        Plot(x-6,y);
        Plot(x+6,y);
      ELSE
        Plot(x-2,y-2);
        Plot(x,y-2);
        Plot(x+2,y-2);

        Plot(x-2,y);
        Plot(x+2,y);

        Plot(x-2,y+2);
        Plot(x,y+2);
        Plot(x+2,y+2);
      END;

    END;
    curflag:=flag;
  END;
END CursorHandler;

(* Zeige den Cursor an Position posx, posy des Fenster winnum *)

PROCEDURE SetCursor(winnum : CARDINAL; posx, posy : INTEGER; col : RGB; type : BOOLEAN);

VAR xamin, xamax, yamin, yamax, xma, yma, xmi, ymi : INTEGER;
    x, y : INTEGER;
    flag : BOOLEAN;
    aPWin, PWin: PtoWin;

BEGIN
  xormode:=TRUE;
  PWin:=FindWin(winnum);

  IF PWin<>NIL THEN

    WITH PWin^ DO
      IF ((curx=posx) AND (cury=posy)) THEN
        RETURN;
      END;

      xmi:=fromx*8+4;
      ymi:=fromy*16+33;

      xamin:=xareamin;
      xamax:=xareamax;

      yamin:=yareamin;
      yamax:=yareamax;

      x:=ROUND(FLOAT(xmi)+FLOAT(worgx)+FLOAT(curx)*zoomfac);
      y:=ROUND(FLOAT(ymi)+FLOAT(worgy)+FLOAT(cury)*zoomfac);

      xma:=tox*8-4;
      yma:=toy*16-4;

      SetWindow(xmi+1,ymi+1,xma-1,yma-1);
      SetFGColor(col.r,col.g,col.b);

      aPWin:=PWin;
      flag:=TRUE;

      IF curflag THEN
        REPEAT
          aPWin:=aPWin^.nextwin;
          IF aPWin<>NIL THEN
            WITH aPWin^ DO
              flag:=flag AND NOT((INTEGER(fromx*8)<=x) AND (x<=INTEGER(tox*8)) AND (INTEGER(fromy*16)<=y) AND (y<=INTEGER(toy*16)));
            END;
          END;
        UNTIL aPWin=NIL;
      END;

      IF curflag AND flag THEN

     IF NOT((x<xmi) OR (x>xma) OR (y<ymi) OR (y>yma)) THEN

      IF type THEN

        Plot(x,y-2);
        Plot(x,y+2);
        Plot(x-2,y);
        Plot(x+2,y);

        Plot(x,y-4);
        Plot(x,y+4);
        Plot(x-4,y);
        Plot(x+4,y);

        Plot(x,y-6);
        Plot(x,y+6);
        Plot(x-6,y);
        Plot(x+6,y);
      ELSE
        Plot(x-2,y-2);
        Plot(x,y-2);
        Plot(x+2,y-2);

        Plot(x-2,y);
        Plot(x+2,y);

        Plot(x-2,y+2);
        Plot(x,y+2);
        Plot(x+2,y+2);
      END;
     END;

      END;

      IF posx<xamin THEN posx:=xamin; END;
      IF posx>xamax THEN posx:=xamax; END;
      IF posy<yamin THEN posy:=yamin; END;
      IF posy>yamax THEN posy:=yamax; END;

      x:=ROUND(FLOAT(xmi)+FLOAT(worgx)+FLOAT(posx)*zoomfac);
      y:=ROUND(FLOAT(ymi)+FLOAT(worgy)+FLOAT(posy)*zoomfac);

      aPWin:=PWin;
      flag:=TRUE;

      REPEAT
        aPWin:=aPWin^.nextwin;
        IF aPWin<>NIL THEN
          WITH aPWin^ DO
            flag:=flag AND NOT((INTEGER(fromx*8)<=x) AND (x<=INTEGER(tox*8)) AND (INTEGER(fromy*16)<=y) AND (y<=INTEGER(toy*16)));
          END;
        END;
      UNTIL aPWin=NIL;

      IF flag THEN
        IF NOT((x<xmi) OR (x>xma) OR (y<ymi) OR (y>yma)) THEN

      IF type THEN

        Plot(x,y-2);
        Plot(x,y+2);
        Plot(x-2,y);
        Plot(x+2,y);

        Plot(x,y-4);
        Plot(x,y+4);
        Plot(x-4,y);
        Plot(x+4,y);

        Plot(x,y-6);
        Plot(x,y+6);
        Plot(x-6,y);
        Plot(x+6,y);
      ELSE
        Plot(x-2,y-2);
        Plot(x,y-2);
        Plot(x+2,y-2);

        Plot(x-2,y);
        Plot(x+2,y);

        Plot(x-2,y+2);
        Plot(x,y+2);
        Plot(x+2,y+2);
      END;
      END;
      END;

      curx:=posx;
      cury:=posy;
      curflag:=flag;
    END;
  END;
END SetCursor;

(* Zeige den Cursor des Fensters winnum *)

PROCEDURE ShowCursor(winnum : CARDINAL; col : RGB; type : BOOLEAN);
VAR xmi, ymi, xma, yma : INTEGER;
    x, y : INTEGER;
    aPWin, PWin: PtoWin;
    flag : BOOLEAN;

BEGIN
  xormode:=TRUE;
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN

    WITH PWin^ DO

      xmi:=fromx*8+4;
      ymi:=fromy*16+33;

      x:=ROUND(FLOAT(xmi)+FLOAT(worgx)+FLOAT(curx)*zoomfac);
      y:=ROUND(FLOAT(ymi)+FLOAT(worgy)+FLOAT(cury)*zoomfac);

      xma:=tox*8-4;
      yma:=toy*16-4;

      IF (x<xmi) OR (x>xma) OR (y<ymi) OR (y>yma) THEN RETURN; END;

      SetWindow(xmi+1,ymi+1,xma-1,yma-1);
      SetFGColor(col.r,col.g,col.b);

      aPWin:=PWin;
      flag:=TRUE;

      REPEAT
        aPWin:=aPWin^.nextwin;
        IF aPWin<>NIL THEN
          WITH aPWin^ DO
            flag:=flag AND NOT((INTEGER(fromx*8)<=x) AND (x<=INTEGER(tox*8)) AND (INTEGER(fromy*16)<=y) AND (y<=INTEGER(toy*16)));
          END;
        END;
      UNTIL aPWin=NIL;

      IF flag THEN

      IF type THEN
        Plot(x,y-2);
        Plot(x,y+2);
        Plot(x-2,y);
        Plot(x+2,y);

        Plot(x,y-4);
        Plot(x,y+4);
        Plot(x-4,y);
        Plot(x+4,y);

        Plot(x,y-6);
        Plot(x,y+6);
        Plot(x-6,y);
        Plot(x+6,y);
      ELSE
        Plot(x-2,y-2);
        Plot(x,y-2);
        Plot(x+2,y-2);

        Plot(x-2,y);
        Plot(x+2,y);

        Plot(x-2,y+2);
        Plot(x,y+2);
        Plot(x+2,y+2);
      END;

      curflag:=flag AND NOT(curflag);
    END;
    END;
  END;
END ShowCursor;

(* Setzte eine Markierung ins Fenster winnum an Stelle posx, posy *)

PROCEDURE SetMarker1(winnum : CARDINAL; posx, posy : INTEGER; col : RGB);
VAR x, y, xmi, ymi, xma, yma : INTEGER;
    PWin: PtoWin;
BEGIN

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN

    WITH PWin^ DO

      xmi:=fromx*8+4;
      ymi:=fromy*16+33;
      x:=ROUND(FLOAT(xmi)+FLOAT(worgx)+FLOAT(posx)*zoomfac);
      y:=ROUND(FLOAT(ymi)+FLOAT(worgy)+FLOAT(posy)*zoomfac);
      marcol1:=col;
      xma:=tox*8-4;
      yma:=toy*16-4;

      IF (x<xmi) OR (x>xma) OR (y<ymi) OR (y>yma) THEN RETURN; END;

      SetWindow(xmi+1,ymi+1,xma-1,yma-1);

      IF NOT(IsPointVisible(winnum,posx,posy)) THEN RETURN; END;

      SetFGColor(col.r,col.g,col.b);

      Line(x-3,y,x,y+3);
      Line(x,y+3,x+3,y);
      Line(x+3,y,x,y-3);
      Line(x,y-3,x-3,y);

      marflag1:=TRUE;
      marx1:=x;
      mary1:=y;
    END;
  END;
END SetMarker1;

(* Lsche die Markierung, wenn notwendig *)

PROCEDURE UnsetMarker1(winnum : CARDINAL);
VAR PWin: PtoWin;
BEGIN

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      IF marflag1 THEN
        SetWindow(fromx*8+5,fromy*16+34,tox*8-5,toy*16-5);
        SetFGColor(marcol1.r,marcol1.g,marcol1.b);
        Line(marx1-3,mary1,marx1,mary1+3);
        Line(marx1,mary1+3,marx1+3,mary1);
        Line(marx1+3,mary1,marx1,mary1-3);
        Line(marx1,mary1-3,marx1-3,mary1);
        PWin^.marflag1:=FALSE;
      END;
    END;
  END;
END UnsetMarker1;

PROCEDURE SetMarker2(winnum : CARDINAL; posx, posy : INTEGER; col : RGB);
VAR x, y, xmi, ymi, xma, yma : INTEGER;
    PWin: PtoWin;
BEGIN

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN

    WITH PWin^ DO

      xmi:=fromx*8+4;
      ymi:=fromy*16+33;
      x:=ROUND(FLOAT(xmi)+FLOAT(worgx)+FLOAT(posx)*zoomfac);
      y:=ROUND(FLOAT(ymi)+FLOAT(worgy)+FLOAT(posy)*zoomfac);
      marcol2:=col;
      xma:=tox*8-4;
      yma:=toy*16-4;

      IF (x<xmi) OR (x>xma) OR (y<ymi) OR (y>yma) THEN RETURN; END;

      SetWindow(xmi+1,ymi+1,xma+1,yma+1);
      SetFGColor(col.r,col.g,col.b);

      IF NOT(IsPointVisible(winnum,posx,posy)) THEN RETURN; END;

      Line(x-3,y-3,x-3,y+3);
      Line(x-3,y+3,x+3,y+3);
      Line(x+3,y+3,x+3,y-3);
      Line(x+3,y-3,x-3,y-3);

      marflag2:=TRUE;
      marx2:=x;
      mary2:=y;
    END;
  END;
END SetMarker2;

(* Lsche die Markierung, wenn notwendig *)

PROCEDURE UnsetMarker2(winnum : CARDINAL);
VAR PWin: PtoWin;
BEGIN

  SetMaxWin();
  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      IF marflag2 THEN
        SetWindow(fromx*8+5,fromy*16+34,tox*8-5,toy*16-5);
        SetFGColor(marcol2.r,marcol2.g,marcol2.b);
        Line(marx2-3,mary2-3,marx2-3,mary2+3);
        Line(marx2-3,mary2+3,marx2+3,mary2+3);
        Line(marx2+3,mary2+3,marx2+3,mary2-3);
        Line(marx2+3,mary2-3,marx2-3,mary2-3);
        PWin^.marflag2:=FALSE;
      END;
    END;
  END;
END UnsetMarker2;

(* Lege ein Gitter auf Fenster winnum; stepx, stepy : Gitterabstnde *)

PROCEDURE LayGrid(winnum, stepx, stepy, offx, offy : CARDINAL; col : RGB);
VAR PWin: PtoWin;
    x, y : CARDINAL;
BEGIN

  PWin:=FindWin(winnum);
  IF PWin<>NIL THEN
    WITH PWin^ DO
      x:=fromx*8+4+offx;
      SetFGColor(col.r,col.g,col.b);
      REPEAT
        y:=fromy*16+33+offy;
        REPEAT
          Plot(x,y);
          y:=y+stepy;
        UNTIL y>=toy*16-4;
        x:=x+stepx;
      UNTIL x>=tox*8-4;
    END;
  END;
END LayGrid;

(* Initialisierung der Datenstrukturen, Anker legen *)

BEGIN

  white.r:=65535;
  white.g:=65535;
  white.b:=65535;
  black.r:=0;
  black.g:=0;
  black.b:=0;

  winbase:=ADR(win);
  win.nextwin:=NIL;
  win.prevwin:=NIL;
  win.winnum:=0;

  obnum:=0;
  lastobj:=0;
  lastwin:=0;
  ptolastwin:=NIL;
  ptolastobj:=NIL;


  nopoint.x:=nocoord;
  nopoint.y:=nocoord;
  nopoint.col:=black;

  winmenu[ORD(cyclewin) ]:="Next Window  ";
  winmenu[ORD(movemenu) ]:="Move Menu    ";
  winmenu[ORD(exitmenu) ]:="Exit Menu    ";
  winmenu[ORD(movewin)  ]:="Move Window  ";
  winmenu[ORD(sizewin)  ]:="Size Window  ";
  winmenu[ORD(zoomwin)  ]:="Zoom In/Out  ";
  winmenu[ORD(scrollwin)]:="Scroll Around";
  winmenu[ORD(resetwin) ]:="Reset Window ";
  winmenu[ORD(cleanup)  ]:="Clean Up     ";
  winmenu[ORD(closewin) ]:="Close Window ";
  winmenu[ORD(refresh)  ]:="Refresh All  ";

  winbindkeywrite[ORD(cyclewin)]:="TAB";
  winbindkeyscan [ORD(cyclewin)]:=Tab;
  winbindkeywrite[ORD(exitmenu)]:="ESC";
  winbindkeyscan [ORD(exitmenu)]:=Esc;
  winbindkeywrite[ORD(movewin)]:="F1";
  winbindkeyscan [ORD(movewin)]:=FunKey1;
  winbindkeywrite[ORD(sizewin)]:="F2";
  winbindkeyscan [ORD(sizewin)]:=FunKey2;
  winbindkeywrite[ORD(zoomwin)]:="F5";
  winbindkeyscan [ORD(zoomwin)]:=FunKey5;
  winbindkeywrite[ORD(scrollwin)]:="F6";
  winbindkeyscan [ORD(scrollwin)]:=FunKey6;
  winbindkeywrite[ORD(cleanup)]:="F4";
  winbindkeyscan [ORD(cleanup)]:=FunKey4;
  winbindkeywrite[ORD(refresh)]:="F3";
  winbindkeyscan [ORD(refresh)]:=FunKey3;
  winbindkeywrite[ORD(resetwin)]:="HOM";
  winbindkeyscan [ORD(resetwin)]:=Home;


  white.r:=65535;
  white.g:=65535;
  white.b:=65535;
  black.r:=0;
  black.g:=0;
  black.b:=0;

  menborcol1 := white;
  menborcol2:= white;
  menitemcol := white;
  menhiitemcol := white;
  menbackcol := black;
  mentitlecol := white;
  winhicol := white;
  infotextcol := white;
  hiinfotextcol:= white;
  infoborcol1:= white;
  infoborcol2:= white;
  infobackcol:= black;
  screenbackcol:=black;

  errorstate:=FALSE;
  snapmode:=TRUE;

END Grawin.


