IMPLEMENTATION MODULE Guitool;

IMPORT Str;
IMPORT Strings;
IMPORT KeyConst;
IMPORT Colors;
IMPORT NewIO;
IMPORT NewTerm;
IMPORT Mouse;
IMPORT Grawin;
IMPORT FIO;

TYPE tfilelist = ARRAY[0..20] OF Grawin.CTLine;

VAR hiinfotextcol, infobackcol, infoborcol1, infoborcol2, infotextcol : Grawin.RGB;

    mintval, mintfrom, mintto : INTEGER;
    mintfineness, mintgranu : CARDINAL;
    text2 : ARRAY[1..2] OF Grawin.CTLine;
    list : ARRAY[0..5] OF tfilelist;

PROCEDURE Min(a, b : CARDINAL):CARDINAL;
BEGIN
  IF a>b THEN RETURN(b) ELSE RETURN(a); END;
END Min;

PROCEDURE ColorPicker(posx, posy, state : CARDINAL; proc : ColPickproc);
VAR x, y, i, ii : CARDINAL;
    r, g, b : CARDINAL;
    ro, go, bo : CARDINAL;
    mousex, mousey : CARDINAL;
    lc, key: CHAR;
    col : Grawin.RGB;
    left, right, pos, strg, keyflag, flag : BOOLEAN;

BEGIN

  Mouse.StoreMousePos;
  NewTerm.xormode:=FALSE;

  infobackcol:=Grawin.GetInfoBackCol();
  infotextcol:=Grawin.GetInfoCol();
  infoborcol1:=Grawin.GetInfoBorCol1();
  infoborcol2:=Grawin.GetInfoBorCol2();

  Grawin.SolidBox(posx,posy,17,16,infobackcol,infoborcol1,infoborcol2);
  NewTerm.GotoXY((posx+1)*8,(posy+1)*16);
  NewTerm.SetFGColor(infotextcol.r,infotextcol.g,infotextcol.b);
  NewTerm.SetBGColor(infobackcol.r,infobackcol.g,infobackcol.b);
  NewIO.WriteString(" Choose a color ");
  r:=0;
  g:=0;
  b:=0;
  flag:=FALSE;

  FOR x:=1 TO 16 DO
    FOR y:=1 TO 16 DO
      IF flag THEN
        r:=(r+1) MOD 8;
        IF (r=0) THEN
          g:=(g+1) MOD 8;
          IF (g=0) THEN
            b:=(b+1) MOD 4;
          END;
        END;
      END;
      flag:=TRUE;
      Grawin.Calc(r,g,b,ro,go,bo);
      NewTerm.SetFGColor(ro,go,bo);
      NewTerm.GotoXY((posx+x)*8,(posy+y+1)*16);
      NewIO.Write(CHR(219));
    END;
  END;

  x:=1; y:=1;
  Mouse.InitMouse(8,16,16*8,16*16);
  Mouse.SetMousePos(8+4,16+8);

  LOOP
    r:=0;
    g:=0;
    b:=0;
    flag:=FALSE;
    FOR i:=1 TO 16 DO
      FOR ii:=1 TO 16 DO
        IF flag THEN
          r:=(r+1) MOD 8;
          IF (r=0) THEN
            g:=(g+1) MOD 8;
            IF (g=0) THEN
              b:=(b+1) MOD 4;
            END;
          END;
        END;
        IF (i=x) AND (ii=y) THEN
          Grawin.Calc(r,g,b,ro,go,bo);
          NewTerm.SetBGColor(ro,go,bo);
          col.r:=ro;
          col.g:=go;
          col.b:=bo;
        END;
        flag:=TRUE;
      END;
    END;

    NewTerm.SetFGColor(infobackcol.r,infobackcol.g,infobackcol.b);
    NewTerm.GotoXY((x+posx)*8,(y+posy+1)*16);
    NewIO.Write('X');
    Grawin.SolidBox(posx+18,posy,4,4,col,infoborcol1,infoborcol2);

    Mouse.WaitForEvents(left,right,pos,keyflag,strg,key);

    NewTerm.SetFGColor(col.r,col.g,col.b);
    NewTerm.GotoXY((x+posx)*8,(y+posy+1)*16);
    NewIO.Write(CHR(219));

    IF keyflag THEN
      CASE key OF
        KeyConst.CurDown  : IF y<16 THEN INC(y); END; |
        KeyConst.CurUp    : IF y>1  THEN DEC(y); END; |
        KeyConst.CurRight : IF x<16 THEN INC(x); END; |
        KeyConst.CurLeft  : IF x>1  THEN DEC(x); END;
      END;
      Mouse.SetMousePos(x*8+4,y*16+8);
    ELSIF pos THEN
      Mouse.GetMouseState(mousex,mousey,left,right);
      x:=(mousex DIV 8);
      y:=(mousey DIV 16);
    END;
    IF (key=KeyConst.Esc) OR right THEN
      Grawin.NormalTick2();
      Mouse.RestoreMousePos;
      RETURN;
    END;
    IF (key=KeyConst.Enter) OR left THEN
      Grawin.NormalTick1();
      proc(col,state);
      NewTerm.SetMaxWindow;
    END;
  END;
END ColorPicker;


PROCEDURE Dir(VAR ext : ARRAY OF CHAR):PathTail;

VAR
    i, ii, n : CARDINAL;
    xmouse, ymouse : CARDINAL;
    dirname : ARRAY[0..30] OF CHAR;
    name : PathTail;
    fileattr : FIO.FileAttr;
    direntry : FIO.DirEntry;
    nextdir, printflag, flag, again, notatend : BOOLEAN;
    left, right, strg, pos, keyflag : BOOLEAN;
    key : CHAR;
    ax, ay, x, y : CARDINAL;

BEGIN

  LOOP
    nextdir:=FALSE;
    Grawin.RefreshAllWins(TRUE);

    FIO.GetDir(0,dirname);

    Strings.Concat("*.",ext,name);
    fileattr:=FIO.FileAttr{FIO.directory};
    flag:=FIO.ReadFirstEntry(name,fileattr,direntry);

    again:=FALSE;

    REPEAT
      text2[1].t:="Current directory is: ";
      text2[1].c:=infotextcol;
      text2[2].c:=hiinfotextcol;

      FOR i:=0 TO HIGH(dirname) DO
        text2[2].t[i+1]:=dirname[i];
      END;

      Grawin.ShowInfoBox(1,2,2,text2);
      notatend:=FALSE;

      i:=1;
      n:=0;

      LOOP

        INC(i);

        IF i=2 THEN
          list[n,0].t:="Directory: ";
          list[n,0].c:=infotextcol;
          list[n,1].t:="-------------";
          list[n,1].c:=hiinfotextcol;
        END;

        IF NOT(flag) THEN EXIT; END;

        IF ((i<HIGH(list[n])+1) AND (n<>HIGH(list))) OR
           ((i<HIGH(list[n])) AND (n=HIGH(list))) THEN
          FOR ii:=0 TO HIGH(direntry.Name) DO
            list[n,i].t[ii+2]:=direntry.Name[ii];
          END;
          list[n,i].t[1]:=" ";

          IF FIO.directory IN direntry.attr THEN
            list[n,i].c:=infoborcol1;
          ELSE
            list[n,i].c:=infotextcol;
          END;
          flag:=flag AND FIO.ReadNextEntry(direntry);
          printflag:=FALSE;
        END;

        IF i=HIGH(list[n])+1 THEN (* Box ausgeben, evt. *MORE* eintragen *)
          Grawin.ShowInfoBox(1+n*14,5,HIGH(list[n])+1,list[n]);
          printflag:=TRUE;
          INC(n);
          i:=1;
        END;

        IF (i=HIGH(list[n])) AND (n=HIGH(list)) THEN
          IF flag THEN
            list[n,i].t:=" More --->!";
            list[n,i].c:=infoborcol1;
            notatend:=TRUE;
          END;
          Grawin.ShowInfoBox(1+n*14,5,HIGH(list[n])+1,list[n]);
          printflag:=TRUE;
          EXIT;
        END;
      END;

      IF NOT(printflag) THEN
        IF NOT(notatend) AND again THEN
          IF i=HIGH(list[n])+1 THEN
            Grawin.ShowInfoBox(1+n*14,5,HIGH(list[n])+1,list[n]);
            INC(n);
            i:=2;
          END;
          list[n,i].c:=infoborcol1;
          list[n,i].t:=" Back <---!";
        END;
        Grawin.ShowInfoBox(1+n*14,5,HIGH(list[n])+1,list[n]);
      END;

      y:=2;
      x:=0;
      again:=FALSE;

      (* auswhlen *)

      Mouse.InitMouse(0,2*16,n*160,HIGH(list[n])*16);
      Mouse.SetMousePos(80,2*16+8);

      REPEAT
        NewTerm.GotoXY((3+x*14)*8,(6+y)*16);
        NewTerm.SetFGColor(hiinfotextcol.r,hiinfotextcol.g,hiinfotextcol.b);
        NewIO.WriteString(list[x,y].t);
        NewTerm.GotoXY((3+x*14)*8,(6+y)*16);
        NewIO.Write(">");

        Mouse.ConfPosChanged;
        Mouse.WaitForEvents(left,right,pos,keyflag,strg,key);

        NewTerm.GotoXY((3+x*14)*8,(6+y)*16);
        NewTerm.SetFGColor(list[x,y].c.r,list[x,y].c.g,list[x,y].c.b);
        NewIO.WriteString(list[x,y].t);
        NewTerm.GotoXY((3+x*14)*8,(6+y)*16);
        NewIO.Write(" ");

        IF keyflag AND strg THEN
          CASE key OF
            KeyConst.CurUp    : IF y>2                 THEN DEC(y); END; |
            KeyConst.CurDown  : IF y<HIGH(list[x])     THEN INC(y); END; |
            KeyConst.CurLeft  : IF x>0                 THEN DEC(x); END; |
            KeyConst.CurRight : IF x<Min(n,HIGH(list)) THEN INC(x); END; |
          END;
          Mouse.SetMousePos(x*160,y*16+8);
        ELSIF pos THEN
          Mouse.GetMouseState(xmouse,ymouse,left,right);
          x:=(xmouse DIV 160);
          y:=(ymouse DIV 16);
        END;
        IF (key=KeyConst.Enter) OR left THEN
          Grawin.NormalTick1();
          FOR ii:=0 TO 12 DO
            name[ii]:=list[x,y].t[ii+2];
          END;
          IF list[x,y].c=infoborcol1 THEN
            FOR i:=0 TO HIGH(list) DO
              FOR ii:=0 TO HIGH(list[i]) DO
                list[i,ii].t:="";
              END;
            END;
            IF Str.Match(name,"More --->!") THEN
              Grawin.RefreshAllWins(TRUE);
              again:=TRUE;
              flag:=TRUE;
            ELSE
              FIO.ChDir(name);
              nextdir:=TRUE;
            END;
          ELSE
            nextdir:=FALSE;
            EXIT;
          END;
        END;
        IF (key=KeyConst.Esc) OR right THEN
          Grawin.NormalTick2();
          name:="";
          nextdir:=FALSE;
          EXIT;
        END;
      UNTIL (key=KeyConst.Esc) OR right OR again OR nextdir;
    UNTIL NOT(again) OR nextdir;
  END;
  RETURN(name);
END Dir;

PROCEDURE DirLocal(VAR ext : ARRAY OF CHAR):PathTail;

BEGIN

  infobackcol:=Grawin.GetInfoBackCol();
  infotextcol:=Grawin.GetInfoCol();
  hiinfotextcol:=Grawin.GetInfoActCol();
  infoborcol1:=Grawin.GetInfoBorCol1();
  infoborcol2:=Grawin.GetInfoBorCol2();

  RETURN(Dir(ext));

END DirLocal;

PROCEDURE ShowDir(ext : ARRAY OF CHAR);

VAR c : CHAR;
    dummy : PathTail;

BEGIN
  Mouse.StoreMousePos;
  dummy:=DirLocal(ext);
  Mouse.RestoreMousePos;
  Grawin.RefreshAllWins(TRUE);
END ShowDir;

PROCEDURE PickFile(ext : ARRAY OF CHAR):PathTail;

VAR name : PathTail;

BEGIN
  Mouse.StoreMousePos;
  name:=DirLocal(ext);
  Mouse.RestoreMousePos;
  Grawin.RefreshAllWins(TRUE);
  RETURN(name);
END PickFile;

PROCEDURE InitMouseIntervall(from, to : INTEGER; granu, fineness : CARDINAL);
VAR mousex, mousey : CARDINAL;
    left, right : BOOLEAN;
BEGIN
  Mouse.StoreMousePos;
  Mouse.InitMouse(0,0,2*fineness*granu-1,1);
  Mouse.SetMousePos(0,0);
  mintfineness:=fineness*2;
  mintfrom:=from;
  mintto:=to;
  mintgranu:=granu;
  Mouse.GetMouseState(mousex,mousey,left,right);
  mintval:=INTEGER(mousex DIV mintfineness)*((mintto-mintfrom) DIV INTEGER(mintgranu-1))+mintfrom;
END InitMouseIntervall;

PROCEDURE EndMouseIntervall();
BEGIN
  Mouse.RestoreMousePos;
END EndMouseIntervall;

PROCEDURE MouseIntervall(VAR left, right : BOOLEAN; VAR key : CHAR):INTEGER;
VAR pos, keyflag, strg : BOOLEAN;
    mousex, mousey : CARDINAL;
    val : INTEGER;
BEGIN
  REPEAT
    Mouse.ConfLeftButton;
    Mouse.ConfRightButton;
    Mouse.ConfPosChanged;
    Mouse.WaitForEvents(left,right,pos,keyflag,strg,key);
    Mouse.GetMouseState(mousex,mousey,left,right);
    IF strg AND keyflag THEN
      IF key=KeyConst.CurRight THEN
        Mouse.SetMousePos(mousex+mintfineness,0);
        Mouse.GetMouseState(mousex,mousey,left,right);
      END;
      IF key=KeyConst.CurLeft THEN
        IF mousex>mintfineness THEN
          Mouse.SetMousePos(mousex-mintfineness,0);
        ELSE
          Mouse.SetMousePos(mintfineness DIV 2,0);
        END;
        Mouse.GetMouseState(mousex,mousey,left,right);
      END;
    END;
    val:=INTEGER(mousex DIV mintfineness)*((mintto-mintfrom) DIV INTEGER(mintgranu-1))+mintfrom;
  UNTIL (pos AND (val<>mintval)) OR left OR right OR keyflag;
  Grawin.NormalTick2();
  mintval:=val;
  RETURN(val);
END MouseIntervall;

BEGIN
END Guitool.

