IMPLEMENTATION MODULE Handler;

FROM KeyConst IMPORT CurRight, CurLeft, CurUp, CurDown,
                     AltCurRight, AltCurLeft, AltCurUp, AltCurDown,
                     StrgCurRight, StrgCurLeft, StrgCurUp, StrgCurDown,
                     PgUp, PgDown, AltPgUp, AltPgDown,
                     Tab, Enter, Esc, Space, Home, FunKey1, FunKey2;

FROM Mouse    IMPORT WaitForAnything, StoreMousePos, WaitForEvents, InitMouse, StoreMousePos,
                     GetMouseState, StoreMousePos, SetMousePos, LeftAndMove, RestoreMousePos,
                     LeftButtonPressed, RightButtonPressed, ConfLeftButton, ConfRightButton,
                     ConfPosChanged;

IMPORT IntMen;
IMPORT Guitool;
IMPORT Str;
IMPORT NewIO;
IMPORT Colors;
IMPORT DDD;
IMPORT Grawin;
IMPORT SceneEd;
IMPORT WorldEd;
IMPORT NewTerm;
IMPORT IntMen;

FROM DDD IMPORT ROUND, Min, Max;

VAR screenwidth, screenheight : CARDINAL;
    Orgorg, Org, Einsorg : ARRAY[1..4] OF Grawin.Coord;
    Areamin : ARRAY[1..4] OF Grawin.Coord;
    Areamax : ARRAY[1..4] OF Grawin.Coord;
    Orgsc, Sc : ARRAY[1..4] OF Grawin.Scale;
    Omin, Omax : DDD.DCoord;
    Dontwriteinfo, Snapmode, Absdisp, Dispflag, Quitflag : BOOLEAN;
    i, Granu, Xywin, Xzwin, Yzwin, Dddwin, Objnum, Tempobj1 : CARDINAL;
    Tcol, Wherecol : Grawin.RGB;

    selab : ARRAY[1..4],[1..Grawin.menitems] OF BOOLEAN;

    text : ARRAY[1..27] OF Grawin.CTLine;
    itext : Grawin.CTLine;
    nokeys : ARRAY[1..3] OF CHAR;
    alltrue : ARRAY[1..3] OF BOOLEAN;

PROCEDURE InitLocalMouse();
BEGIN
  InitMouse(0,0,2*screenwidth,2*screenheight);
  SetMousePos(screenwidth,screenheight);
  ConfLeftButton;
  ConfRightButton;
  ConfPosChanged;
END InitLocalMouse;

PROCEDURE DrawIt;
BEGIN
  DDD.CalcNewDCoords(Tempobj1);
  Grawin.RefreshAllWins(FALSE);
  Omin:=DDD.GiveObjMin(Tempobj1);
  Omax:=DDD.GiveObjMax(Tempobj1);
END DrawIt;

PROCEDURE WinInfoLine(actwin, objnum : CARDINAL);
VAR pp, ppp : Grawin.Coord;
    poi : Grawin.Point;
    winbackcol : Grawin.RGB;
BEGIN
  NewTerm.xormode:=FALSE;
  Grawin.ClipWithWin(actwin);
  winbackcol:=Grawin.GetWinBackCol(actwin);
  NewTerm.SetFGColor(Colors.swintitlecol.r,Colors.swintitlecol.g,Colors.swintitlecol.b);
  NewTerm.SetBGColor(winbackcol.r,winbackcol.g,winbackcol.b);
  pp:=Grawin.GetWinPos(actwin);
  NewTerm.GotoXY((pp.x+1)*8,(pp.y+1)*16);
  IF Dispflag AND (actwin<>Dddwin) THEN
    NewIO.Write(" ");
    IF DDD.IsWhereOn() THEN NewIO.Write("F"); ELSE NewIO.Write("-"); END;
    NewIO.Write(" ");
    IF Snapmode THEN
      NewIO.Write("#");
    ELSE
      NewIO.Write("~");
    END;
    NewIO.Write(" ");

    NewIO.WriteInt(Org[1].x-Einsorg[1].x,5);
    NewIO.Write(",");
    NewIO.WriteInt(Org[1].y-Einsorg[1].y,5);
    NewIO.Write(",");
    NewIO.WriteInt(Org[2].y-Einsorg[2].y,5);

  END;
  NewTerm.xormode:=TRUE;
END WinInfoLine;

PROCEDURE OverTake();
VAR winnum : CARDINAL;
BEGIN
  DDD.DestroyXYZObj(Objnum);
  DDD.DestroyDDDObj(Objnum);
  DDD.CreateDDDObj(Objnum);
  DDD.CopyObjFromTo(Tempobj1,Objnum);
  DDD.CalcNewDCoords(Objnum);
  FOR winnum:=Xywin TO Dddwin DO
    Grawin.DontDrawObj(winnum,Objnum);
  END;
END OverTake;

PROCEDURE Adjust;
BEGIN

  Grawin.SetObjOrg(Xywin,Tempobj1,Org[1].x,Org[1].y);
  Grawin.SetObjOrg(Xzwin,Tempobj1,Org[2].x,Org[2].y);
  Grawin.SetObjOrg(Yzwin,Tempobj1,Org[3].x,Org[3].y);

  Grawin.SetObjScale(Xywin,Tempobj1,Sc[1].scx,Sc[1].scy);
  Grawin.SetObjScale(Xzwin,Tempobj1,Sc[2].scx,Sc[2].scy);
  Grawin.SetObjScale(Yzwin,Tempobj1,Sc[3].scx,Sc[3].scy);

END Adjust;

PROCEDURE ResetWinForHandler(VAR actwin, objnum : CARDINAL);
VAR winnum : CARDINAL;
BEGIN

  IntMen.ResetWin(actwin,Tempobj1);
  Einsorg[actwin-Xywin+1]:=Grawin.GetWinOrg(actwin);
  Org[actwin-Xywin+1]:=Grawin.GetObjOrg(actwin,Tempobj1);
  Adjust;
  DrawIt;

END ResetWinForHandler;

PROCEDURE ScrollWin(VAR actwin, objnum : CARDINAL);
VAR
    key : CHAR;
    dx, dy : INTEGER;
    keyflag, strg, bleft, bright, pos, flag : BOOLEAN;
    mousex, mousey : CARDINAL;
    pp : Grawin.Coord;

BEGIN

  Grawin.DrawWin(actwin,TRUE,FALSE);
  itext.t:=' Scroll: cur.keys, mouse';
  IF DDD.InWorldMode() THEN
    itext.c:=Colors.wwintitlecol;
  ELSE
    itext.c:=Colors.swintitlecol;
  END;
  Grawin.TextToWinTitle(actwin,itext);

  StoreMousePos;

  pp:=Grawin.GetWinOrg(actwin);
  dx:=0; dy:=0;
  REPEAT
    ConfPosChanged;
    WaitForEvents(bleft,bright,pos,keyflag,strg,key);
    IF keyflag AND strg THEN
      CASE key OF
        CurLeft  : DEC(dx); |
        CurRight : INC(dx); |
        CurUp    : DEC(dy); |
        CurDown  : INC(dy);
      END;
      SetMousePos(INTEGER(screenwidth)+dx*10,INTEGER(screenheight)+dy*10);
    ELSIF pos THEN
      GetMouseState(mousex,mousey,bleft,bright);
      dx:=(INTEGER(mousex)-INTEGER(screenwidth)) DIV 10;
      dy:=(INTEGER(mousey)-INTEGER(screenheight)) DIV 10;
    END;
    IntMen.ScrollInt(actwin,pp,dx,dy);
    Einsorg[actwin-Xywin+1]:=Grawin.GetWinOrg(actwin);
    Org[actwin-Xywin+1]:=Grawin.GetObjOrg(actwin,Tempobj1);
  UNTIL (key=Enter) OR bleft;

  Adjust;
  RestoreMousePos;

END ScrollWin;

PROCEDURE ZoomWin(VAR actwin, objnum : CARDINAL);
VAR key : CHAR;
    pp : Grawin.Coord;
    keyflag, strg, bleft, bright, up, down, pos, flag : BOOLEAN;
    mousex, mousey : CARDINAL;
    dy : INTEGER;
    zoom : REAL;

BEGIN

  Grawin.DrawWin(actwin,TRUE,FALSE);
  itext.t:=' Zoom: cur.keys, mouse';
  IF DDD.InWorldMode() THEN
    itext.c:=Colors.wwintitlecol;
  ELSE
    itext.c:=Colors.swintitlecol;
  END;
  Grawin.TextToWinTitle(actwin,itext);

  StoreMousePos();
  InitMouse(0,0,1,510);
  zoom:=Grawin.GetWinZoom(actwin);
  SetMousePos(0,ROUND(zoom*50.0));
  dy:=0;
  REPEAT
    ConfPosChanged;
    WaitForEvents(bleft,bright,pos,keyflag,strg,key);
    IF keyflag AND strg THEN
      CASE key OF
        CurUp    : DEC(dy); |
        CurDown  : INC(dy);
      END;
      IF key=CurUp   THEN mousey:=CARDINAL(Min(510,INTEGER(ROUND(zoom*50.0))+dy*10)); END;
      IF key=CurDown THEN mousey:=CARDINAL(Max(0,INTEGER(ROUND(zoom*50.0))+dy*10));   END;
      SetMousePos(0,mousey);
      GetMouseState(mousex,mousey,bleft,bright);
      dy:=((INTEGER(mousey)-ROUND(zoom*50.0)) DIV 10);
    ELSIF pos THEN
      GetMouseState(mousex,mousey,bleft,bright);
      dy:=((INTEGER(mousey)-ROUND(zoom*50.0)) DIV 10);
    END;
    IntMen.ZoomInt(actwin,zoom,dy);
  UNTIL (key=Enter) OR bleft;

  Einsorg[actwin-Xywin+1]:=Grawin.GetWinOrg(actwin);
  Org[actwin-Xywin+1]:=Grawin.GetObjOrg(actwin,Tempobj1);

  Adjust;
  RestoreMousePos;

END ZoomWin;

PROCEDURE FrameReset(VAR actwin, objnum : CARDINAL);
VAR i : CARDINAL;
BEGIN
  FOR i:=1 TO 3 DO
    Sc[i]:=Orgsc[i];
    Org[i]:=Orgorg[i];
  END;
  DrawIt;
END FrameReset;

PROCEDURE FrameHome(VAR actwin, objnum : CARDINAL);
VAR i : CARDINAL;
BEGIN
  FOR i:=1 TO 3 DO
    Org[i]:=Einsorg[i];
  END;
  DrawIt;
END FrameHome;


PROCEDURE RotForHandler(actwin, rottype : CARDINAL);
VAR left, right, ok : BOOLEAN;
    val : INTEGER;
    orgobj : CARDINAL;
    key : CHAR;

BEGIN

  Guitool.InitMouseIntervall(0,359,Granu,10);
  itext.c:=Tcol;
  itext.t:="";
  Grawin.DrawWin(actwin,TRUE,FALSE);
  REPEAT
    REPEAT
      Str.IntToStr(LONGINT(val),itext.t,10,ok);

      CASE rottype OF
        1 : Str.Concat(itext.t," X-Rotate: ",itext.t); |
        2 : Str.Concat(itext.t," Y-Rotate: ",itext.t); |
        3 : Str.Concat(itext.t," Z-Rotate: ",itext.t);
      END;

      Grawin.TextToWinTitle(actwin,itext);
      val:=Guitool.MouseIntervall(left,right,key);
    UNTIL left OR right OR (key=' ') OR (key=Enter);

    DDD.DestroyXYZObj(Tempobj1);
    DDD.CopyObjFromTo(Objnum,Tempobj1);

    CASE rottype OF
      1 : DDD.XRot(REAL(val),Tempobj1); |
      2 : DDD.YRot(REAL(val),Tempobj1); |
      3 : DDD.ZRot(REAL(val),Tempobj1);
    END;

    Adjust;
    Grawin.AllowDrawObj(actwin,Tempobj1);
    Grawin.SelectObj(Tempobj1);
    DrawIt;
    Grawin.SelectObj(Objnum);
  UNTIL right OR (key=Enter);
  Guitool.EndMouseIntervall;

  CASE rottype OF
    1 : itext.t:=" X-rotated!"; |
    2 : itext.t:=" Y-rotated!"; |
    3 : itext.t:=" Z-rotated!";
  END;

  Grawin.TextToWinTitle(actwin,itext);
  Dontwriteinfo:=TRUE;
  InitLocalMouse;
  OverTake;
  Grawin.SelectObj(Tempobj1);

END RotForHandler;

PROCEDURE XRotForHandler(VAR actwin, objnum : CARDINAL);
BEGIN
  RotForHandler(actwin,1);
END XRotForHandler;

PROCEDURE YRotForHandler(VAR actwin, objnum : CARDINAL);
BEGIN
  RotForHandler(actwin,2);
END YRotForHandler;

PROCEDURE ZRotForHandler(VAR actwin, objnum : CARDINAL);
BEGIN
  RotForHandler(actwin,3);
END ZRotForHandler;

PROCEDURE RotStep(VAR actwin, objnum : CARDINAL);

BEGIN
  NewIO.UseDefault;
  text[1].t:="Change Rot-Step.";
  text[2].t:="Enter step for ";
  text[3].t:="rotations: ";
  text[1].c:=Colors.ititlecol;
  text[2].c:=Colors.ientercol;
  text[3].c:=Colors.ientercol;
  REPEAT
     Grawin.ShowInfoBox(31,14,3,text);
     NewIO.ReadCard(Granu);
     Granu:=Granu MOD 360;
  UNTIL NewIO.Done;
  DrawIt;
  itext.c:=Tcol;
  itext.t:=" Rot-step changed!";
  Grawin.TextToWinTitle(actwin,itext);
  Dontwriteinfo:=TRUE;
END RotStep;

PROCEDURE QuitForHandler(VAR actwin, objnum : CARDINAL);
BEGIN
  Quitflag:=TRUE;
END QuitForHandler;

PROCEDURE Helppages(VAR actwin, scenenum : CARDINAL);
VAR
    c : CHAR;
    selected, i : CARDINAL;

BEGIN

  selected:=1;
  REPEAT
    
    text[1].t:="Helppages for HANDLER";
    text[2].t:="Please choose:";
    text[1].c:=Colors.ititlecol;
    text[2].c:=Colors.ipromptcol;
    Grawin.ShowInfoBox(10,10,2,text);

    text[1].t:="Mouse- or keyboard-handling";
    text[2].t:="Menus & bindkeys";
    text[3].t:="Windowhandling";
    text[1].c:=Colors.itextcol;
    text[2].c:=Colors.itextcol;
    text[3].c:=Colors.itextcol;

    selected:=Grawin.ShowChooseBox(12,14,3,text,nokeys,alltrue,selected);

    CASE selected OF
      1 :  Grawin.ColFromTo(text,Colors.ipromptcol,3,20);
           text[1].t:=" How to use the handler with the mouse or keyboard _______________________ ";
           text[1].c:=Colors.ititlecol;
           text[2].t:=" _____________________________________________________________________________ ";
           text[2].c:=Colors.ialacol;
           text[3].t:=" CURSORKEYS (+/- ALT) | MOUSE             = Move the cursor!";
           text[4].t:=" PageUp, PageDown (+/- ALT)               = Change third coordinate";
           text[5].t:=" SPACE | LEFT MOUSEBUTTON, pressed short  = Move object to frame-position";
           text[6].t:=" MOUSE + LEFT MOUSEBUTTON, held down      = Change frame/object-scale";
           text[7].t:=" _____________________________________________________________________________ ";
           text[7].c:=Colors.ialacol;
           text[8].t:=" x y z = Increment frame/object-scale ";
           text[9].t:=" X Y Z = Decrement frame/object-scale ";
           text[10].t:=" r     = Reset position and size";
           text[11].t:=" o     = Move frame to window-origin ";
           text[12].t:=" #     = Turn Snap-mode on/off ";
           text[13].t:=" +     = Turn cursorposition-display on/off";
           text[14].t:=" ALT q = Quit handler";
           text[15].t:=" ____________________________________________________________________________ ";
           text[16].t:=" The handler provides a ROTATE-MODE. You can activate it by ALT X, Y, Z, ";
           text[17].t:=" to rotate object around X-, Y- or Z-Axis. You rotate with: ";
           text[18].t:=" MOUSE LEFT, RIGHT | CURSOR LEFT, RIGHT = Increment, decrement rot-angle";
           text[19].t:=" SPACE | LEFT MOUSEBUTTON               = Perform rotation around shown angle";
           text[20].t:=" ENTER | RIGHT MOUSEBUTTON              = Exit rotate-mode";

           Grawin.ShowInfoBox(1,2,20,text); |

       2 : Grawin.ColFromTo(text,Colors.ipromptcol,3,27);
           Grawin.ColFromTo(text,Colors.itextcol,10,23);
           text[1].t:=" How to use handler's menus and bindkeys ________________________ ";
           text[1].c:=Colors.ititlecol;
           text[2].t:=" _________________________________________________________________ ";
           text[2].c:=Colors.ialacol;
           text[3].t:=" ENTER | RIGHT MOUSEBUTTON = Window's menu pops up";
           text[4].t:=" ALT <key>, <key>...       = Call menu-item directly";
           text[5].t:=" When the window's menu poped up, you can use:";
           text[5].c:=Colors.itextcol;
           text[6].t:=" SPACE      | RIGHT MOUSEBUTTON    = Toggle between menu-pages";
           text[7].t:=" CURSORKEYS | MOUSE UP, MOUSE DOWN = Choose one menu-items";
           text[8].t:=" ENTER      | LEFT MOUSEBUTTON     = Activate menu-item!";
           text[9].t:=" ESC                               = Quit window's menu";
           text[10].t:="__________________________________________________________________ ";
           text[10].c:=Colors.ialacol;
           text[11].t:=" Menuitems can be activated as described above, but there is also";
           text[12].t:=" a faster method: use the bindkeys!  Each bindkeys lets you acti-";
           text[13].t:=" vate the item directly without opening the menu-pages.  You have";
           text[14].t:=" to press ALT and the listed bindkey. For example, if you want to";
           text[15].t:=" create a new object, you first press ALT f, then (quickly) n.";
           text[16].t:=" If you wait to long for the second key, a choosebox will pop up;";
           text[17].t:=" bindkeys are also listed.  ATTENTION: choosebox-bindkeys are NOT";
           text[18].t:=" activated with ALT and key, press simply the key that is listed.";
           text[19].t:=" If choosebox has poped-up,  you also have to confirm with ENTER.";
           text[20].t:=" You need not press ENTER if you press the  second key BEFORE the";
           text[21].t:=" box pops up.  Other example: press ALT u to undo last operation.";
           text[22].t:="__________________________________________________________________ ";
           text[22].c:=Colors.ialacol;
           text[23].t:=" When a choose-box pops up, you can use:";
           text[23].c:=Colors.itextcol;
           text[24].t:=" ESC | RIGHT MOUSEBUTTON           = Quit choose-box";
           text[25].t:=" CURSORKEYS | MOUSE UP, MOUSE DOWN = Choose one choose-box-item";
           text[26].t:=" ENTER      | LEFT MOUSEBUTTON     = Activate choose-box-item!";
           text[27].t:=" <listed bindkey>                  = Choose item with that bindkey";
           Grawin.ShowInfoBox(4,1,27,text); |

       3 : Grawin.ColFromTo(text,Colors.ipromptcol,3,19);
           text[1].t:=" How to manage the windows __________________________________________";
           text[1].c:=Colors.ititlecol;
           text[2].t:=" ____________________________________________________________________";
           text[2].c:=Colors.ialacol;
           text[3].t:=" ENTER | RIGHT MOUSEBUTTON, pressed longer = Window's menu pops up";
           text[4].t:=" ALT <key>, <key>...                     = Call menu-item directly";
           text[5].t:=" When the window's menu poped up, you can use:";
           text[5].c:=Colors.itextcol;
           text[6].t:=" SPACE      | RIGHT MOUSEBUTTON    = Toggle between menu-pages";
           text[7].t:=" CURSORKEYS | MOUSE UP, MOUSE DOWN = Choose on menu-items";
           text[8].t:=" ENTER      | LEFT MOUSEBUTTON     = Activate menu-item!";
           text[9].t:=" ESC                               = Quit window's menu";
           text[10].t:="_____________________________________________________________________";
           text[10].c:=Colors.ialacol;
           text[11].t:=" TAB  = Bring next window in window-list to front, cycling";
           text[12].t:=" 0..9 = Bring window with pressed number-key to front ";
           text[13].t:=" F1   = Move window with MOUSE | CURSORKEYS, SPACE, R. MB, ENTER";
           text[14].t:=" F2   = Size window with MOUSE | CURSORKEYS, SPACE, R. MB, ENTER";
           text[15].t:=" F3   = Refresh all windows";
           text[16].t:=" F4   = Clean up desktop, bring all windows to their inital-position";
           text[17].t:=" F5   = Zoom   window's contents with MOUSE | CURSORK., ENTER, R. MB";
           text[18].t:=" F6   = Scroll window's contents with MOUSE | CURSORK., ENTER, R. MB";
           text[19].t:=" HOM  = Reset current window";
           Grawin.ShowInfoBox(4,6,19,text);
    END;

    IF selected<>0 THEN
      WaitForAnything;
    END;
    Grawin.RefreshAllWins(TRUE);
  UNTIL selected=0;

END Helppages;

(* interactive object/scene-handler: supports rotating, scaling, moving, etc. *)

PROCEDURE ObjectHandlerInt(actwin, objnum : CARDINAL);

VAR c : CHAR;
    lastactwin, oactwin, i, winnum, maxpoints: CARDINAL;
    curstep : CARDINAL;
    mousex, mousey, lastmousex, lastmousey : CARDINAL;
    dx, dy : INTEGER;
    xso, yso, px, py, pz, zoom : REAL;
    p : Grawin.Coord;
    poi : Grawin.Point;
    minx, maxx, miny, maxy  : INTEGER;
    r, xst, yst, zst : REAL;
    pd, min, max : DDD.DCoord;
    strg, left, right, keyflag, pos, flag : BOOLEAN;
    rmin, rmax : RECORD x,y, z : REAL; END;

BEGIN

  IF Grawin.InErrorState() THEN IntMen.Error; RETURN; END;

  Objnum:=objnum;

  Xywin:=DDD.GetXYWin();
  Xzwin:=DDD.GetXZWin();
  Yzwin:=DDD.GetYZWin();
  Dddwin:=DDD.GetDDDWin();
  curstep:=Grawin.GetCursorstep();
  Snapmode:=Grawin.InSnapMode();

  Tempobj1:=DDD.GetLastObjnum()+1;
  Quitflag:=FALSE;

  IF NOT(DDD.InWorldMode()) THEN
    Wherecol:=Colors.swherecol;
    Tcol:=Colors.swintitlecol;
  ELSE
    Wherecol:=Colors.wwherecol;
    Tcol:=Colors.wwintitlecol;
  END;

  itext.c:=Tcol;

  StoreMousePos;
  InitLocalMouse;

  lastmousex:=screenwidth;
  lastmousey:=screenheight;

  Grawin.RefreshAllWins(TRUE);

  FOR winnum:=Xywin TO Dddwin DO
    FOR i:=1 TO Grawin.menitems DO
      selab[winnum-Xywin+1,i]:=Grawin.IsWinMenItemActivated(winnum,i);
      Grawin.SetWinMenItem(winnum,i,'',Grawin.NilProc);
      Grawin.SetWinMenBindkey(winnum,i,'');
    END;
    IF winnum<>Dddwin THEN
      Grawin.SetWinMenItem(winnum,1,'Rotate x       ',XRotForHandler);
      Grawin.SetWinMenItem(winnum,2,'Rotate y       ',YRotForHandler);
      Grawin.SetWinMenItem(winnum,3,'Rotate z       ',ZRotForHandler);
      Grawin.SetWinMenItem(winnum,4,'Rot-Step       ',RotStep);
      Grawin.SetWinMenItem(winnum,5,'Frame home     ',FrameHome);
      Grawin.SetWinMenItem(winnum,6,'Frame reset    ',FrameReset);
      Grawin.SetWinMenItem(winnum,7,'Help           ',Helppages);
      Grawin.SetWinMenItem(winnum,8,'Quit Handler   ',QuitForHandler);

      Grawin.SetWinMenBindkey(winnum,1,'x');
      Grawin.SetWinMenBindkey(winnum,2,'y');
      Grawin.SetWinMenBindkey(winnum,3,'z');
      Grawin.SetWinMenBindkey(winnum,4,'s');
      Grawin.SetWinMenBindkey(winnum,7,'h');
      Grawin.SetWinMenBindkey(winnum,8,'q');
    END;
  END;

  oactwin:=actwin;

  FOR winnum:=Xywin TO Yzwin DO
    Einsorg[winnum-Xywin+1]:=Grawin.GetWinOrg(winnum);
    Org[winnum-Xywin+1]:=Grawin.GetObjOrg(winnum,objnum);
    Sc[winnum-Xywin+1]:=Grawin.GetObjScale(winnum,objnum);
    Areamin[winnum-Xywin+1]:=Grawin.GetWinAreaMin(winnum);
    Areamax[winnum-Xywin+1]:=Grawin.GetWinAreaMax(winnum);
  END;

  xst:=0.05;
  yst:=0.05;
  zst:=0.05;

  Omin:=DDD.GiveObjMin(objnum);
  Omax:=DDD.GiveObjMax(objnum);

  DDD.CopyObjFromTo(objnum,Tempobj1);
  p:=Grawin.GetWinOrg(Dddwin);
  Grawin.CreateObj(Dddwin,Tempobj1,1.0,1.0,p.x,p.y);

  Grawin.SelectObj(Tempobj1);

  FOR i:=1 TO 3 DO
    Orgsc[i]:=Sc[i];
    Orgorg[i]:=Org[i];
  END;

  FOR winnum:=Xywin TO Dddwin DO
    Grawin.DontDrawObj(winnum,objnum);
    Grawin.SetWinScrollProc(winnum,ScrollWin);
    Grawin.SetWinZoomProc(winnum,ZoomWin);
    Grawin.SetWinResetProc(winnum,ResetWinForHandler);
  END;

  LOOP

    dx:=0;
    dy:=0;
    NewTerm.xormode:=TRUE;
    Adjust;

    FOR winnum:=1 TO 3 DO

      IF (Org[winnum].x-Einsorg[winnum].x)<Areamin[winnum].x THEN Org[winnum].x:=Einsorg[winnum].x+Areamin[winnum].x END;
      IF (Org[winnum].y-Einsorg[winnum].y)<Areamin[winnum].y THEN Org[winnum].y:=Einsorg[winnum].y+Areamin[winnum].y END;
      IF (Org[winnum].x-Einsorg[winnum].x)>Areamax[winnum].x THEN Org[winnum].x:=Einsorg[winnum].x+Areamax[winnum].x END;
      IF (Org[winnum].y-Einsorg[winnum].y)>Areamax[winnum].y THEN Org[winnum].y:=Einsorg[winnum].y+Areamax[winnum].y END;

      CASE winnum OF
        1 : i:=Xywin; minx:=Omin.x; miny:=Omin.y; maxx:=Omax.x; maxy:=Omax.y; |
        2 : i:=Xzwin; minx:=Omin.x; miny:=Omin.z; maxx:=Omax.x; maxy:=Omax.z; |
        3 : i:=Yzwin; minx:=Omin.y; miny:=Omin.z; maxx:=Omax.y; maxy:=Omax.z;
      END;

      r:=Grawin.GetWinZoom(i);
      rmin.x:=FLOAT(minx)*Sc[winnum].scx*r+(FLOAT(Org[winnum].x)-FLOAT(Einsorg[winnum].x))*r;
      rmax.x:=FLOAT(maxx)*Sc[winnum].scx*r+(FLOAT(Org[winnum].x)-FLOAT(Einsorg[winnum].x))*r;
      rmin.y:=FLOAT(miny)*Sc[winnum].scy*r+(FLOAT(Org[winnum].y)-FLOAT(Einsorg[winnum].y))*r;
      rmax.y:=FLOAT(maxy)*Sc[winnum].scy*r+(FLOAT(Org[winnum].y)-FLOAT(Einsorg[winnum].y))*r;

      min.x:=ROUND(rmin.x);
      min.y:=ROUND(rmin.y);
      max.x:=ROUND(rmax.x);
      max.y:=ROUND(rmax.y);

      Grawin.DrawConsiderate(i,min.x,min.y,max.x,min.y,Wherecol);
      Grawin.DrawConsiderate(i,max.x,min.y,max.x,max.y,Wherecol);
      Grawin.DrawConsiderate(i,max.x,max.y,min.x,max.y,Wherecol);
      Grawin.DrawConsiderate(i,min.x,max.y,min.x,min.y,Wherecol);

    END;

    IF NOT(Dontwriteinfo) THEN WinInfoLine(actwin,Tempobj1); END;
    Dontwriteinfo:=FALSE;
    WaitForEvents(left,right,pos,keyflag,strg,c);

    FOR winnum:=1 TO 3 DO
      CASE winnum OF
        1 : i:=Xywin; minx:=Omin.x; miny:=Omin.y; maxx:=Omax.x; maxy:=Omax.y; |
        2 : i:=Xzwin; minx:=Omin.x; miny:=Omin.z; maxx:=Omax.x; maxy:=Omax.z; |
        3 : i:=Yzwin; minx:=Omin.y; miny:=Omin.z; maxx:=Omax.y; maxy:=Omax.z;
      END;

      r:=Grawin.GetWinZoom(i);
      rmin.x:=FLOAT(minx)*Sc[winnum].scx*r+(FLOAT(Org[winnum].x)-FLOAT(Einsorg[winnum].x))*r;
      rmax.x:=FLOAT(maxx)*Sc[winnum].scx*r+(FLOAT(Org[winnum].x)-FLOAT(Einsorg[winnum].x))*r;
      rmin.y:=FLOAT(miny)*Sc[winnum].scy*r+(FLOAT(Org[winnum].y)-FLOAT(Einsorg[winnum].y))*r;
      rmax.y:=FLOAT(maxy)*Sc[winnum].scy*r+(FLOAT(Org[winnum].y)-FLOAT(Einsorg[winnum].y))*r;

      min.x:=ROUND(rmin.x);
      min.y:=ROUND(rmin.y);
      max.x:=ROUND(rmax.x);
      max.y:=ROUND(rmax.y);

      Grawin.DrawConsiderate(i,min.x,min.y,max.x,min.y,Wherecol);
      Grawin.DrawConsiderate(i,max.x,min.y,max.x,max.y,Wherecol);
      Grawin.DrawConsiderate(i,max.x,max.y,min.x,max.y,Wherecol);
      Grawin.DrawConsiderate(i,min.x,max.y,min.x,min.y,Wherecol);

    END;

    lastactwin:=actwin;
    Grawin.WindowHandler(left,right,c,strg,actwin);

    IF (actwin<>lastactwin) THEN
      Adjust;
      DrawIt;
    END;

    IF actwin<>Dddwin THEN
      IF keyflag AND NOT(strg) THEN
        CASE c OF
          'x' : Sc[1].scx:=Sc[1].scx+xst;
                Sc[2].scx:=Sc[2].scx+xst;
                itext.t:=" X-size incremented!";
                Grawin.TextToWinTitle(actwin,itext);
                Dontwriteinfo:=TRUE; |

          'X' : Sc[1].scx:=Sc[1].scx-xst;
                Sc[2].scx:=Sc[2].scx-xst;
                itext.t:=" X-size decremented!";
                Grawin.TextToWinTitle(actwin,itext);
                Dontwriteinfo:=TRUE; |

          'y' : Sc[1].scy:=Sc[1].scy+yst;
                Sc[3].scx:=Sc[3].scx+yst;
                itext.t:=" Y-size incremented!";
                Grawin.TextToWinTitle(actwin,itext);
                Dontwriteinfo:=TRUE; |

          'Y' : Sc[1].scy:=Sc[1].scy-yst;
                Sc[3].scx:=Sc[3].scx-yst;
                itext.t:=" Y-size decremented!";
                Grawin.TextToWinTitle(actwin,itext);
                Dontwriteinfo:=TRUE; |

          'z' : Sc[2].scy:=Sc[2].scy+zst;
                Sc[3].scy:=Sc[3].scy+zst;
                itext.t:=" Z-size incremented!";
                Grawin.TextToWinTitle(actwin,itext);
                Dontwriteinfo:=TRUE; |

          'Z' : Sc[2].scy:=Sc[2].scy-zst;
                Sc[3].scy:=Sc[3].scy-zst;
                itext.t:=" Z-size decremented!";
                Grawin.TextToWinTitle(actwin,itext);
                Dontwriteinfo:=TRUE; |

          'r' : FOR i:=1 TO 3 DO
                  Sc[i]:=Orgsc[i];
                  Org[i]:=Orgorg[i];
                END;
                itext.t:=" Frame reseted!";
                Grawin.TextToWinTitle(actwin,itext);
                Dontwriteinfo:=TRUE; |

          'o' : FOR i:=1 TO 3 DO
                  Org[i]:=Einsorg[i];
                END;
                itext.t:=" To window-origin!";
                Grawin.TextToWinTitle(actwin,itext);
                Dontwriteinfo:=TRUE; |

          '+' : Dispflag:=NOT(Dispflag);
                Grawin.DrawWin(actwin,TRUE,TRUE);
                WinInfoLine(actwin,Tempobj1);
                IF Dispflag THEN
                  itext.t:=" Coordinates on!";
                ELSE
                  itext.t:=" Coordinates off!";
                END;
                Grawin.TextToWinTitle(actwin,itext);
                Dontwriteinfo:=TRUE; |

          '#' : Snapmode:=NOT(Snapmode);
                IF Snapmode THEN
                  itext.t:=" Snapmode on!";
                ELSE
                  itext.t:=" Snapmode off!";
                END;
                Grawin.TextToWinTitle(actwin,itext);
                Dontwriteinfo:=TRUE;
        END;
      END;

      IF (c=' ') OR left THEN
        Adjust;
        DrawIt;
      END;

      IF Quitflag THEN

        Adjust;
        OverTake;

        Grawin.SelectObj(Objnum);

        FOR winnum:=Xywin TO Dddwin DO
          Grawin.AllowDrawObj(winnum,Objnum);
        END;

        actwin:=oactwin;
        DDD.DestroyXYZObj(Tempobj1);
        DDD.DestroyDDDObj(Tempobj1);

        DDD.ShowWhere(Objnum);
        Grawin.BringWinToFront(oactwin);
        FOR winnum:=Xywin TO Dddwin DO
          FOR i:=1 TO Grawin.menitems DO
            IF selab[winnum-Xywin+1,i] THEN
              Grawin.ActivateWinMenItem(winnum,i);
            END;
          END;
        END;
        RestoreMousePos;
        RETURN;
        EXIT;
      END;

      IF pos THEN
        GetMouseState(mousex,mousey,left,right);
        zoom:=Grawin.GetWinZoom(actwin);
        IF Snapmode THEN
          dx:=ROUND((REAL(mousex)-REAL(lastmousex))/zoom) DIV INTEGER(curstep) *INTEGER(curstep);
          dy:=ROUND((REAL(mousey)-REAL(lastmousey))/zoom) DIV INTEGER(curstep) *INTEGER(curstep);
          IF dx<>0 THEN lastmousex:=mousex; END;
          IF dy<>0 THEN lastmousey:=mousey; END;
          IF (dx<>0) OR (dy<>0) THEN
            lastmousex:=screenwidth;
            lastmousey:=screenheight;
            SetMousePos(screenwidth,screenheight);
          END;
        ELSE
          dx:=ROUND((REAL(mousex)-REAL(lastmousex))/zoom);
          dy:=ROUND((REAL(mousey)-REAL(lastmousey))/zoom);
          lastmousex:=screenwidth;
          lastmousey:=screenheight;
          SetMousePos(screenwidth,screenheight);
        END;
        xso:=REAL(dx)*xst*0.1;
        yso:=REAL(dy)*yst*0.1;

        IF LeftAndMove() THEN

          IF actwin=Xywin THEN Sc[1].scx:=Sc[1].scx+xso; Sc[1].scy:=Sc[1].scy+yso;
                               Sc[2].scx:=Sc[2].scx+xso;
                               Sc[3].scx:=Sc[3].scx+yso; END;
          IF actwin=Xzwin THEN Sc[2].scx:=Sc[2].scx+xso; Sc[2].scy:=Sc[2].scy+yso;
                               Sc[1].scx:=Sc[1].scx+xso;
                               Sc[3].scy:=Sc[3].scy+yso; END;
          IF actwin=Yzwin THEN Sc[3].scx:=Sc[3].scx+xso; Sc[3].scy:=Sc[3].scy+yso;
                               Sc[1].scy:=Sc[1].scy+xso;
                               Sc[2].scy:=Sc[2].scy+yso; END;

        ELSE

          IF actwin=Xywin THEN INC(Org[1].x,dx); INC(Org[1].y,dy);
                               INC(Org[2].x,dx);
                               INC(Org[3].x,dy); END;
          IF actwin=Xzwin THEN INC(Org[2].x,dx); INC(Org[2].y,dy);
                               INC(Org[1].x,dx);
                               INC(Org[3].y,dy); END;
          IF actwin=Yzwin THEN INC(Org[3].x,dx); INC(Org[3].y,dy);
                               INC(Org[1].y,dx);
                               INC(Org[2].y,dy); END;
        END;
      END;

      IF keyflag AND strg THEN
        CASE c OF
          AltCurRight : IF actwin<>Yzwin THEN INC(Org[1].x); INC(Org[2].x); END;
                        IF actwin=Yzwin  THEN INC(Org[3].x); INC(Org[1].y); END; |

          AltCurLeft  : IF actwin<>Yzwin THEN DEC(Org[1].x); DEC(Org[2].x); END;
                        IF actwin=Yzwin  THEN DEC(Org[3].x); DEC(Org[1].y); END; |

          AltCurUp    : IF actwin<>Xywin THEN DEC(Org[2].y); DEC(Org[3].y); END;
                        IF actwin=Xywin  THEN DEC(Org[1].y); DEC(Org[3].x); END; |

          AltCurDown  : IF actwin<>Xywin THEN INC(Org[2].y); INC(Org[3].y); END;
                        IF actwin=Xywin  THEN INC(Org[1].y); INC(Org[3].x); END; |

          CurRight : IF actwin<>Yzwin THEN INC(Org[1].x,8);
                                           INC(Org[2].x,8); END;
                     IF actwin=Yzwin  THEN INC(Org[3].x,8);
                                           INC(Org[1].y,8); END; |
          CurLeft  : IF actwin<>Yzwin THEN DEC(Org[1].x,8);
                                           DEC(Org[2].x,8); END;
                     IF actwin=Yzwin  THEN DEC(Org[3].x,8);
                                           DEC(Org[1].y,8); END; |
          CurUp    : IF actwin<>Xywin THEN DEC(Org[2].y,8);
                                           DEC(Org[3].y,8); END;
                     IF actwin=Xywin  THEN DEC(Org[1].y,8);
                                           DEC(Org[3].x,8); END; |
          CurDown  : IF actwin<>Xywin THEN INC(Org[2].y,8);
                                           INC(Org[3].y,8); END;
                     IF actwin=Xywin  THEN INC(Org[1].y,8);
                                           INC(Org[3].x,8); END; |


          AltPgUp :   IF actwin=Xywin THEN DEC(Org[2].y); DEC(Org[3].y); END;
                      IF actwin=Xzwin THEN DEC(Org[1].y); DEC(Org[3].x); END;
                      IF actwin=Yzwin THEN DEC(Org[1].x); DEC(Org[2].x); END; |

          AltPgDown : IF actwin=Xywin THEN INC(Org[2].y); INC(Org[3].y); END;
                      IF actwin=Xzwin THEN INC(Org[1].y); INC(Org[3].x); END;
                      IF actwin=Yzwin THEN INC(Org[1].x); INC(Org[2].x); END; |

          PgUp :   IF actwin=Xywin THEN DEC(Org[2].y,8);
                                        DEC(Org[3].y,8); END;
                   IF actwin=Xzwin THEN DEC(Org[1].y,8);
                                        DEC(Org[3].x,8); END;
                   IF actwin=Yzwin THEN DEC(Org[1].x,8);
                                        DEC(Org[2].x,8); END; |
          PgDown : IF actwin=Xywin THEN INC(Org[2].y,8);
                                        INC(Org[3].y,8); END;
                   IF actwin=Xzwin THEN INC(Org[1].y,8);
                                        INC(Org[3].x,8); END;
                   IF actwin=Yzwin THEN INC(Org[1].x,8);
                                        INC(Org[2].x,8); END; |
        END;

      END;
    END;
  END;
END ObjectHandlerInt;

BEGIN
  Granu:=36;
  Dispflag:=TRUE;
  Snapmode:=FALSE;
  Dontwriteinfo:=FALSE;
  screenwidth:=800;
  screenheight:=600;
  FOR i:=1 TO HIGH(alltrue) DO
    alltrue[i]:=TRUE;
  END;
END Handler.
