IMPLEMENTATION MODULE NewIO;

IMPORT Str;
IMPORT NewTerm;

VAR defaultflag : BOOLEAN;
    boxlength : CARDINAL;

PROCEDURE Empty(string : ARRAY OF CHAR):BOOLEAN;
VAR i : CARDINAL;
    flag : BOOLEAN;
BEGIN
  i:=0;
  flag:=TRUE;
  WHILE (i<=HIGH(string)) AND (string[i]<>CHR(0)) DO
    flag:=flag AND (string[i]=' ');
    INC(i);
  END;
  RETURN(flag);
END Empty;

PROCEDURE SetBoxlength(x : CARDINAL);
BEGIN
  boxlength:=x;
END SetBoxlength;

PROCEDURE UseDefault();
BEGIN
  defaultflag:=TRUE;
 END UseDefault;

PROCEDURE DontUseDefault();
BEGIN
  defaultflag:=FALSE;
END DontUseDefault;

PROCEDURE ReadString(VAR string : ARRAY OF CHAR);
BEGIN
  IF NOT(defaultflag) THEN string[0]:=''; END;
  NewTerm.ReadString(string,termch,boxlength);
  Done:=NOT(Empty(string));
END ReadString;

PROCEDURE Read(VAR c : CHAR);
BEGIN
  NewTerm.Read(c);
  Done:=TRUE;
END Read;

PROCEDURE ReadInt(VAR x : INTEGER);
VAR intstring : ARRAY[0..40] OF CHAR;
    ok : BOOLEAN;
    pos, base : CARDINAL;
BEGIN
  IF NOT(defaultflag) THEN
    intstring:="";
  ELSE
    Str.IntToStr(LONGINT(x),intstring,10,ok);
  END;
  NewTerm.ReadString(intstring,termch,boxlength);
  Str.Caps(intstring);
  pos:=Str.Pos(intstring,'H');
  base:=10;
  IF pos<>65535 THEN
    base:=16;
  ELSE
    pos:=Str.Pos(intstring,'X');
    IF pos<>65535 THEN
      base:=2;
    END;
  END;
  IF (base<>10) THEN
    intstring[pos]:="";
  END;
  x:=INTEGER(Str.StrToInt(intstring,base,Done));
  IF NOT(Done) THEN x:=0; END;
END ReadInt;

PROCEDURE ReadCard(VAR x : CARDINAL);
VAR cardstring : ARRAY[0..40] OF CHAR;
    ok : BOOLEAN;
    pos, base : CARDINAL;
BEGIN
  IF NOT(defaultflag) THEN
    cardstring:="";
  ELSE
    Str.CardToStr(LONGCARD(x),cardstring,10,ok);
  END;
  NewTerm.ReadString(cardstring,termch,boxlength);
  Str.Caps(cardstring);
  pos:=Str.Pos(cardstring,'H');
  base:=10;
  IF pos<>65535 THEN
    base:=16;
  ELSE
    pos:=Str.Pos(cardstring,'X');
    IF pos<>65535 THEN
      base:=2;
    END;
  END;
  IF (base<>10) THEN
    cardstring[pos]:="";
  END;
  x:=CARDINAL(Str.StrToCard(cardstring,base,Done));
  IF NOT(Done) THEN x:=0; END;
END ReadCard;

PROCEDURE ReadReal(VAR x : REAL; defstring : ARRAY OF CHAR);
VAR realstring : ARRAY[0..60] OF CHAR;
    ok : BOOLEAN;
    pos, base : CARDINAL;
BEGIN
  IF NOT(defaultflag) OR Empty(defstring) THEN
    realstring[0]:="";
  ELSE
    Str.Copy(realstring,defstring);
  END;

  NewTerm.ReadString(realstring,termch,boxlength);
  IF Empty(realstring) THEN
    Done:=FALSE;
    x:=0.0;
    RETURN;
  END;
  x:=REAL(Str.StrToReal(realstring,Done));
  IF NOT(Done) THEN x:=0.0; Write(CHR(7)); END;
END ReadReal;
                       (*
PROCEDURE ReadLongReal(VAR x : LONGREAL);
VAR realstring : ARRAY[0..60] OF CHAR;
    ok : BOOLEAN;
    pos, base : CARDINAL;
BEGIN
  IF NOT(defaultflag) THEN
    realstring:="";
  ELSE
    Str.RealToStr(x,20,FALSE,realstring,ok);
  END;
  NewTerm.ReadString(realstring,termch,boxlength);
  IF realstring[0]=CHR(0) THEN
    Done:=FALSE;
    x:=0.0;
    RETURN;
  END;
  x:=Str.StrToReal(realstring,Done);
  IF NOT(Done) THEN x:=0.0; END;
END ReadLongReal;
                         *)
PROCEDURE Write(c : CHAR);
BEGIN
  NewTerm.Write(c);
END Write;

PROCEDURE WriteLn();
BEGIN
  Write(CHR(13));
  Write(CHR(10));
END WriteLn;

PROCEDURE WriteString(string : ARRAY OF CHAR);
BEGIN
  NewTerm.WriteString(string);
END WriteString;

PROCEDURE WriteInt(x : INTEGER; width : CARDINAL);
VAR intstring : ARRAY[0..20] OF CHAR;
    ok : BOOLEAN;
    l,i : CARDINAL;
BEGIN
  Str.IntToStr(LONGINT(x),intstring,10,ok);
  l:=Str.Length(intstring);
  FOR i:=1 TO width-l DO
    Write(' ');
  END;
  WriteString(intstring);
END WriteInt;

PROCEDURE WriteCard(x : CARDINAL; width : CARDINAL);
VAR cardstring : ARRAY[0..20] OF CHAR;
    ok : BOOLEAN;
    i, l : CARDINAL;
BEGIN
  Str.CardToStr(LONGCARD(x),cardstring,10,ok);
  l:=Str.Length(cardstring);
  FOR i:=1 TO width-l DO
    Write(' ');
  END;
  WriteString(cardstring);
END WriteCard;

PROCEDURE WriteLongCard(x : LONGCARD; width : CARDINAL);
VAR cardstring : ARRAY[0..20] OF CHAR;
    ok : BOOLEAN;
    i, l : CARDINAL;
BEGIN
  Str.CardToStr(x,cardstring,10,ok);
  l:=Str.Length(cardstring);
  FOR i:=1 TO width-l DO
    Write(' ');
  END;
  WriteString(cardstring);
END WriteLongCard;

PROCEDURE WriteReal(x : REAL; width, prec : CARDINAL; eng : BOOLEAN);
VAR realstring : ARRAY[0..50] OF CHAR;
    ok : BOOLEAN;
    l, i : CARDINAL;
BEGIN
  Str.RealToStr(LONGREAL(x),prec,eng,realstring,ok);
  l:=Str.Length(realstring);
  IF width>l THEN
    FOR i:=1 TO width-l DO
      Write(' ');
    END;
  END;
  WriteString(realstring);
END WriteReal;

PROCEDURE WriteLongReal(x : LONGREAL; width, prec : CARDINAL; eng : BOOLEAN);
VAR realstring : ARRAY[0..50] OF CHAR;
    ok : BOOLEAN;
    l, i : CARDINAL;
BEGIN
  Str.RealToStr(x,prec,eng,realstring,ok);
  l:=Str.Length(realstring);
  IF width>l THEN
    FOR i:=1 TO ABS(width-l) DO
      Write(' ');
    END;
  END;
  WriteString(realstring);
END WriteLongReal;

END NewIO.

