IMPLEMENTATION MODULE ObjView;

IMPORT Colors;
IMPORT Grawin;
IMPORT DDD;
IMPORT NewIO;
IMPORT NewTerm;
IMPORT InOut;
IMPORT Mouse;
IMPORT IntMen;

FROM KeyConst IMPORT Esc, Enter,
                     CurUp, CurDown, CurRight, CurLeft,
                     AltCurLeft, AltCurRight, AltCurUp, AltCurDown,
                     PgUp, PgDown, AltPgUp, AltPgDown,
                     StrgCurUp, StrgCurDown;

FROM AsmLib   IMPORT Concat;
FROM Str IMPORT CardToStr;
FROM Storage  IMPORT ALLOCATE, DEALLOCATE, Available;
FROM MathLib0 IMPORT sin, cos;
FROM DDD      IMPORT ROUND,PI;

CONST maxpoints=100;

TYPE cors = (x,y,z);
     vector = RECORD
                coord : ARRAY[x..z] OF REAL;
                col : Grawin.RGB;
                drawline : BOOLEAN;
              END;
     object = ARRAY[1..maxpoints] OF vector;
     arrpointer = POINTER TO arrlist;
     arrlist = RECORD
                 obj : object;
                 size : CARDINAL;
                 nextobj : arrpointer;
               END;

VAR orgzsc, azsc, zsc, orgeyedist, eyedist, aeyedist, orgfz, afz, fz : REAL;
    eyestep, sizestep : REAL;
    orgeyes, aeyes, eyes : vector;
    crossobj, xywin, xzwin, yzwin, dddwin : CARDINAL;
    screenmaxx, screenmaxy : INTEGER;
    screenoffx, screenoffy : REAL;

    nokeys : ARRAY[1..17] OF CHAR;
    alltrue : ARRAY[1..17] OF BOOLEAN;

    text : ARRAY[1..17] OF Grawin.CTLine;
    keys : ARRAY[1..17] OF CHAR;

PROCEDURE TexOutput(fn : ARRAY OF CHAR; xsize, ysize : CARDINAL;
                       basepointer : arrpointer);

VAR p, pos : vector;
    i, co : CARDINAL;
    ii : cors;
    xr, yr, x1, y1, x2, y2 : REAL;
    pt : arrpointer;
    cardstr, str : Grawin.LString;
    ok : BOOLEAN;

BEGIN

  xr:=REAL(xsize)/REAL(screenmaxx+1);
  yr:=REAL(ysize)/REAL(screenmaxy+1);

  InOut.OpenNamedOutput(fn,'pic');
  InOut.WriteString("\unitlength=1.0mm");
  InOut.WriteLn;
  InOut.WriteString("\special{em:linewidth 0.4pt}");
  InOut.WriteLn;
  InOut.WriteString("\linethickness{0.4pt}");
  InOut.WriteLn;

  CardToStr(LONGCARD(xsize),cardstr,10,ok);
  Concat(str,"\begin{picture}(",cardstr);
  Concat(str,str," , ");
  CardToStr(LONGCARD(ysize),cardstr,10,ok);
  Concat(str,str,cardstr);
  Concat(str,str,")");

  InOut.WriteString(str);
  InOut.WriteLn;

  (* InOut.WriteString("\beginpicture");
  InOut.WriteLn;

  CardToStr(LONGCARD(xsize),cardstr,10,ok);
  Concat(str,"\setplotarea x from 0 to ",cardstr);
  Concat(str,str," , y from 0 to ");
  CardToStr(LONGCARD(ysize),cardstr,10,ok);
  Concat(str,str,cardstr);

  InOut.WriteString("\setplotarea x from 0 to 200, y from 0 to 200");
  InOut.WriteString(str);
  InOut.WriteLn;
  InOut.WriteString("\inboundscheckon");
  InOut.WriteLn; *)

  x1:=0.0; y1:=0.0;
  pt:=basepointer;
  co:=0;

  REPEAT
    WITH pt^ DO
      FOR i:=1 TO size DO
        pos:=obj[i];

        p.coord[x]:=pos.coord[x]+(fz-pos.coord[z])*
                       (eyes.coord[x]-pos.coord[x])/(eyes.coord[z]-pos.coord[z]);

        p.coord[y]:=pos.coord[y]+(fz-pos.coord[z])*
                       (eyes.coord[y]-pos.coord[y])/(eyes.coord[z]-pos.coord[z]);

        x2:=(screenoffx+p.coord[x]*zsc)*xr;
        y2:=(screenoffy-p.coord[y]*zsc)*yr;

        IF pos.drawline THEN

          InOut.WriteString("\emline{");
          InOut.WriteInt(INTEGER(x1),1);
          InOut.Write(".");
          InOut.WriteInt(ABS(INTEGER((x1-REAL(INTEGER(x1)))*1.0E3)),1);
          InOut.WriteString("}{");

          InOut.WriteInt(INTEGER(y1),1);
          InOut.Write(".");
          InOut.WriteInt(ABS(INTEGER((y1-REAL(INTEGER(y1)))*1.0E3)),1);
          InOut.WriteString("}{");

          INC(co);

          InOut.WriteInt(co,1);
          InOut.WriteString("}{");

          InOut.WriteInt(INTEGER(x2),1);
          InOut.Write(".");
          InOut.WriteInt(ABS(INTEGER((x2-REAL(INTEGER(x2)))*1.0E3)),1);
          InOut.WriteString("}{");

          InOut.WriteInt(INTEGER(y2),1);
          InOut.Write(".");
          InOut.WriteInt(ABS(INTEGER((y2-REAL(INTEGER(y2)))*1.0E3)),1);
          InOut.WriteString("}{");

          INC(co);
          InOut.WriteInt(co,1);
          InOut.WriteString("}");
          InOut.WriteLn;

        END;

        x1:=x2;
        y1:=y2;
      END;
    END;

    pt:=pt^.nextobj;

  UNTIL pt=NIL;

  InOut.WriteString("\end{picture}");
  InOut.CloseOutput;

END TexOutput;

PROCEDURE Project(pt : arrpointer);
VAR p, pos : vector;
    i, count:  CARDINAL;
    ii : cors;
    ax,ay  : REAL;
    col : Grawin.RGB;

BEGIN

  count:=0;
  ax:=0.0; ay:=0.0;

  WHILE pt<>NIL DO
    WITH pt^ DO
      FOR i:=1 TO size DO

        pos:=obj[i];

        p.coord[x]:=pos.coord[x]+(fz-pos.coord[z])*
                       (eyes.coord[x]-pos.coord[x])/(eyes.coord[z]-pos.coord[z]);

        p.coord[y]:=pos.coord[y]+(fz-pos.coord[z])*
                       (eyes.coord[y]-pos.coord[y])/(eyes.coord[z]-pos.coord[z]);


        IF pos.drawline THEN
          NewTerm.SetFGColor(pos.col.r,
                             pos.col.g,
                             pos.col.b);

          NewTerm.Line(ROUND(ax*zsc+screenoffx),
                       ROUND(screenoffy+ay*zsc),
                       ROUND(p.coord[x]*zsc+screenoffx),
                       ROUND(screenoffy+p.coord[y]*zsc));
        END;
        ax:=p.coord[x];
        ay:=p.coord[y];
      END;
    END;
    pt:=pt^.nextobj;

  END;

END Project;

PROCEDURE DDDProject(basepointer : arrpointer);
VAR p, pos : vector;
    i : CARDINAL;
    ii : cors;
    ax1, ay1, ax2, ay2 : REAL;
    pt : arrpointer;

BEGIN
  ax1:=0.0; ay1:=0.0;
  ax2:=0.0; ay2:=0.0;
  pt:=basepointer;
  WHILE pt<>NIL DO
    WITH pt^ DO
      FOR i:=1 TO size DO
        pos:=obj[i];

        p.coord[x]:=pos.coord[x]+(fz-pos.coord[z])*
                       (eyes.coord[x]-pos.coord[x])/(eyes.coord[z]-pos.coord[z]);

        p.coord[y]:=pos.coord[y]+(fz-pos.coord[z])*
                       (eyes.coord[y]-pos.coord[y])/(eyes.coord[z]-pos.coord[z]);

        IF pos.drawline THEN
          NewTerm.SetFGColor(Colors.stereogreen.r,
                             Colors.stereogreen.g,
                             Colors.stereogreen.b);
          NewTerm.Line(ROUND(ax1*zsc+screenoffx),
                       ROUND(screenoffy+ay1*zsc),
                       ROUND(p.coord[x]*zsc+screenoffx),
                       ROUND(screenoffy+p.coord[y]*zsc));
        END;

        ax1:=p.coord[x];
        ay1:=p.coord[y];

        p.coord[x]:=pos.coord[x]+(fz-pos.coord[z])*
                       (eyes.coord[x]-eyedist-pos.coord[x])/(eyes.coord[z]-pos.coord[z]);

        p.coord[y]:=pos.coord[y]+(fz-pos.coord[z])*
                       (eyes.coord[y]-pos.coord[y])/(eyes.coord[z]-pos.coord[z]);

        IF pos.drawline THEN
          NewTerm.SetFGColor(Colors.stereored.r,
                             Colors.stereored.g,
                             Colors.stereored.b);

          NewTerm.Line(ROUND(ax2*zsc+screenoffx),
                       ROUND(screenoffy+ay2*zsc),
                       ROUND(p.coord[x]*zsc+screenoffx),
                       ROUND(screenoffy+p.coord[y]*zsc));
        END;

        ax2:=p.coord[x];
        ay2:=p.coord[y];
      END;
    END;
    pt:=pt^.nextobj;

  END;

END DDDProject;

PROCEDURE ClearScreen(info : BOOLEAN);
BEGIN
  NewTerm.SetMaxWindow();
  NewTerm.SetBGColor(Colors.viewscreencol.r,
                       Colors.viewscreencol.g,
                       Colors.viewscreencol.b);
  NewTerm.Scroll(0);

  IF info THEN
    NewTerm.GotoXY(0,0);
    NewTerm.SetFGColor(Colors.viewinfocol.r,
                       Colors.viewinfocol.g,
                       Colors.viewinfocol.b);

  NewTerm.WriteString("Objviewer ready.");
  END;
END ClearScreen;

PROCEDURE Helppages();
VAR
    c : CHAR;
    selected, i : CARDINAL;

BEGIN

  FOR i:=1 TO HIGH(nokeys) DO
    nokeys[i]:="";
    alltrue[i]:=TRUE;
  END;

  selected:=1;
  REPEAT

    text[1].t:="Helppages.";
    text[2].t:="Please choose:";
    text[1].c:=Colors.ititlecol;
    text[2].c:=Colors.ipromptcol;
    Grawin.ShowInfoBox(10,10,2,text);

    text[1].t:="Mouse- & keyboard-handling";
    text[2].t:="Menus & bindkeys";
    text[1].c:=Colors.itextcol;
    text[2].c:=Colors.itextcol;
    selected:=Grawin.ShowChooseBox(12,14,2,text,nokeys,alltrue,selected);

    CASE selected OF
      1 : Grawin.ColFromTo(text,Colors.ipromptcol,3,17);
          Grawin.ColFromTo(text,Colors.itextcol,4,6);

          text[1].t:=" How to use the object-viewer with the mouse or keyboard __________________";
          text[1].c:=Colors.ititlecol;
          text[2].t:=" __________________________________________________________________________";
          text[2].c:=Colors.ialacol;
          text[3].t:=" CURSORKEYS | MOUSE = Change values for current mode";
          text[4].t:=" The object-viewer provides 4 different MODES, in wich mouse- and ";
          text[5].t:=" cursor-movements have different meanings. The current mode may be";
          text[6].t:=" shown in the info-line (if info-line is turned on). The modes are:";
          text[7].t:=" MOVING-EYE-Mode:__________________________________________________________";
          text[7].c:=Colors.itextcol;
          text[8].t:=" MOUSE                    | CURSORKEYS    = Change viewer's XY-eye-position";
          text[9].t:=" MOUSE UP, DOWN + LEFT MB | PAGE UP, DOWN = Change viewer's Z-eye-Postion";
          text[10].t:=" ZOOM-MODE:________________________________________________________________";
          text[10].c:=Colors.itextcol;
          text[11].t:=" MOUSE UP, DOWN | CURSOR UP, DOWN = Change viewer's zoom-factor";
          text[12].t:=" ROTATE-X,Y,Z-MODE:________________________________________________________";
          text[12].c:=Colors.itextcol;
          text[13].t:=" MOUSE LEFT, RIGHT | CURSOR LEFT, RIGHT = Rotate arround X-, Y- or Z-Axis";
          text[14].t:=" PLANE-DISTANCE-MODE:______________________________________________________";
          text[14].c:=Colors.itextcol;
          text[15].t:=" MOUSE UP, DOWN | CURSOR UP, DOWN = Change projection-plane-distance";
          text[16].t:=" EYE-DISTANCE-MODE (only when stereo-view):________________________________";
          text[16].c:=Colors.itextcol;
          text[17].t:=" MOUSE LEFT, RIGHT | CURSOR LEFT, RIGHT = Change intensity of stereo-effect";
          Grawin.ShowInfoBox(4,2,17,text); |

      2 : Grawin.ColFromTo(text,Colors.ipromptcol,3,8);
          text[1].t:=" How to use object-viewer's menu and bindkeys ____________________ ";
          text[1].c:=Colors.ititlecol;
          text[2].t:=" _________________________________________________________________ ";
          text[2].c:=Colors.ialacol;
          text[3].t:=" ENTER | RIGHT MOUSEBUTTON         = choose-box pops up";
          text[4].t:=" When the choose-box pops up, you can use:";
          text[4].c:=Colors.itextcol;
          text[5].t:=" ESC | RIGHT MOUSEBUTTON           = Quit choose-box";
          text[6].t:=" CURSORKEYS | MOUSE UP, MOUSE DOWN = Choose one choose-box-item";
          text[7].t:=" ENTER      | LEFT MOUSEBUTTON     = Activate choose-box-item!";
          text[8].t:=" <listed bindkey>                  = Choose item with that bindkey";
          Grawin.ShowInfoBox(10,10,8,text);
    END;

    IF selected<>0 THEN
      Mouse.WaitForAnything;
      ClearScreen(FALSE);
    END;

  UNTIL selected=0;

END Helppages;

PROCEDURE View(objnum : CARDINAL; ddd : BOOLEAN);

  PROCEDURE WReal(x : REAL);
  BEGIN
    NewIO.WriteReal(x,8,3,FALSE);
  END WReal;

  PROCEDURE ShowEyes(info : BOOLEAN);
  BEGIN
    ClearScreen(FALSE);
    IF NOT(info) THEN RETURN; END;

    NewTerm.SetFGColor(Colors.viewinfocol.r,
                       Colors.viewinfocol.g,
                       Colors.viewinfocol.b);

    NewTerm.GotoXY(0,0);

    NewIO.WriteString("MOVING-EYE-MODE. Eye: ");
    WReal(eyes.coord[x]);
    NewIO.WriteString(" , ");
    WReal(eyes.coord[y]);
    NewIO.WriteString(" , ");
    WReal(eyes.coord[z]);
    NewIO.WriteLn;
    NewIO.WriteString("Step: ");
    WReal(eyestep);

  END ShowEyes;

  PROCEDURE ShowDist(info : BOOLEAN);
  BEGIN
    ClearScreen(FALSE);
    IF NOT(info) OR NOT(ddd) THEN RETURN; END;

    NewTerm.SetFGColor(Colors.viewinfocol.r,
                       Colors.viewinfocol.g,
                       Colors.viewinfocol.b);
    NewTerm.GotoXY(0,0);

    NewIO.WriteString("EYE-DISTANCE-MODE. Eyedistance: ");
    WReal(eyedist);
  END ShowDist;

  PROCEDURE ShowZoom(info : BOOLEAN);
  BEGIN
    ClearScreen(FALSE);
    IF NOT(info) THEN RETURN; END;
    NewTerm.SetFGColor(Colors.viewinfocol.r,
                       Colors.viewinfocol.g,
                       Colors.viewinfocol.b);

    NewTerm.GotoXY(0,0);
    NewIO.WriteString("ZOOM-MODE. Zoom: ");
    WReal(zsc);
    NewIO.WriteLn;
    NewIO.WriteString("Step: ");
    WReal(sizestep);
  END ShowZoom;

  PROCEDURE ShowPlane(info : BOOLEAN);
  BEGIN
    ClearScreen(FALSE);
    IF NOT(info) THEN RETURN; END;
    NewTerm.SetFGColor(Colors.viewinfocol.r,
                       Colors.viewinfocol.g,
                       Colors.viewinfocol.b);

    NewTerm.GotoXY(0,0);
    NewIO.WriteString("PLANE-DISTANCE-MODE. Plane: ");
    WReal(fz);
    NewIO.WriteLn;
    NewIO.WriteString("Step: ");
    WReal(eyestep);
  END ShowPlane;

TYPE modetype = (eyemode, zoommode, xrotmode, yrotmode, zrotmode, planemode, distmode);

VAR

  fn : ARRAY[1..14] OF CHAR;
  p1, p2 : vector;
  r11, r12, gamma : REAL;
  dx, dy : INTEGER;
  viewwin, xsize, ysize, i, max, obj, co, crossobj : CARDINAL;
  dummyx, dummyy : INTEGER;
  amousex, amousey, mousex, mousey : CARDINAL;
  w : INTEGER;
  key,   c : CHAR;
  dsc : DDD.DScale;
  eyepos : DDD.DCoord;
  info : BOOLEAN;
  mode : modetype;
  porg1, porg2, org1, org2 : Grawin.Coord;
  pd : DDD.DPoint;
  pos, left, right, strg, keyflag : BOOLEAN;
  mleft, mright, mup, mdown, lmflag : BOOLEAN;

  basepointer, pt, npt : arrpointer;

  PROCEDURE ShowXRot(info : BOOLEAN);
  BEGIN
    ClearScreen(FALSE);
    IF info THEN
      NewTerm.SetFGColor(Colors.viewinfocol.r,
                         Colors.viewinfocol.g,
                         Colors.viewinfocol.b);
      NewTerm.GotoXY(0,0);
      NewIO.WriteString("X-ROTATE-MODE.");
      NewIO.WriteLn;
      NewIO.WriteString("Step: ");
      NewIO.WriteInt(w,3);
    END;
  END ShowXRot;

  PROCEDURE XRot(dirflag : BOOLEAN);
  BEGIN
    ShowXRot(info);
    pt:=basepointer;
    REPEAT
      WITH pt^ DO
        FOR i:=1 TO size DO
          p1:=obj[i];
          p2.col:=p1.col;
          p2.drawline:=p1.drawline;
          IF dirflag THEN
            p2.coord[x]:=p1.coord[x];
            p2.coord[y]:=p1.coord[y]*r11-p1.coord[z]*r12;
            p2.coord[z]:=p1.coord[y]*r12+p1.coord[z]*r11;
          ELSE
            p2.coord[x]:=p1.coord[x];
            p2.coord[y]:=p1.coord[y]*r11+p1.coord[z]*r12;
            p2.coord[z]:=-p1.coord[y]*r12+p1.coord[z]*r11;
          END;
          obj[i]:=p2;
        END;
      END;
      pt:=pt^.nextobj;
    UNTIL pt=NIL;
  END XRot;

  PROCEDURE ShowYRot(info : BOOLEAN);
  BEGIN
    ClearScreen(FALSE);
    IF info THEN
      NewTerm.SetFGColor(Colors.viewinfocol.r,
                         Colors.viewinfocol.g,
                         Colors.viewinfocol.b);
      NewTerm.GotoXY(0,0);
      NewIO.WriteString("Y-ROTATE-MODE.");
      NewIO.WriteLn;
      NewIO.WriteString("Step: ");
      NewIO.WriteInt(w,3);
    END;
  END ShowYRot;

  PROCEDURE YRot(dirflag : BOOLEAN);
  BEGIN
    ShowYRot(info);
    pt:=basepointer;
    REPEAT
      WITH pt^ DO
        FOR i:=1 TO size DO
          p1:=obj[i];
          p2.col:=p1.col;
          p2.drawline:=p1.drawline;
          IF dirflag THEN
            p2.coord[x]:=p1.coord[z]*r12+p1.coord[x]*r11;
            p2.coord[y]:=p1.coord[y];
            p2.coord[z]:=p1.coord[z]*r11-p1.coord[x]*r12;
          ELSE
            p2.coord[x]:=-p1.coord[z]*r12+p1.coord[x]*r11;
            p2.coord[y]:=p1.coord[y];
            p2.coord[z]:=p1.coord[z]*r11+p1.coord[x]*r12;
          END;
          obj[i]:=p2;
        END;
      END;
      pt:=pt^.nextobj;
    UNTIL pt=NIL;
  END YRot;

  PROCEDURE ShowZRot(info : BOOLEAN);
  BEGIN
    ClearScreen(FALSE);
    IF info THEN
      NewTerm.SetFGColor(Colors.viewinfocol.r,
                         Colors.viewinfocol.g,
                         Colors.viewinfocol.b);
      NewTerm.GotoXY(0,0);
      NewIO.WriteString("Z-ROTATE-MODE.");
      NewIO.WriteLn;
      NewIO.WriteString("Step: ");
      NewIO.WriteInt(w,3);
    END;
  END ShowZRot;

  PROCEDURE ZRot(dirflag : BOOLEAN);
  BEGIN
    ShowZRot(info);
    pt:=basepointer;
    REPEAT
      WITH pt^ DO
        FOR i:=1 TO size DO
          p1:=obj[i];
          p2.col:=p1.col;
          p2.drawline:=p1.drawline;
          IF dirflag THEN
            p2.coord[x]:=p1.coord[x]*r11-p1.coord[y]*r12;
            p2.coord[y]:=p1.coord[x]*r12+p1.coord[y]*r11;
            p2.coord[z]:=p1.coord[z];
          ELSE
            p2.coord[x]:=p1.coord[x]*r11+p1.coord[y]*r12;
            p2.coord[y]:=-p1.coord[x]*r12+p1.coord[y]*r11;
            p2.coord[z]:=p1.coord[z];
          END;
          obj[i]:=p2;
        END;
      END;
      pt:=pt^.nextobj;
    UNTIL pt=NIL;
  END ZRot;

BEGIN

  info:=TRUE;
  mode:=eyemode;
  Mouse.StoreMousePos;
  NewTerm.GetMaxWindow(dummyx,dummyy,screenmaxx,screenmaxy);
  Mouse.InitMouse(0,0,screenmaxx*2,screenmaxy*2);
  Mouse.SetMousePos(screenmaxx,screenmaxy);

  screenoffx:=REAL(screenmaxx+1)/2.0;
  screenoffy:=REAL(screenmaxy+1)/2.0;

  ClearScreen(info);

  NewIO.UseDefault;

  DDD.StoreObj(objnum);

  FOR i:=1 TO HIGH(text) DO
    alltrue[i]:=TRUE;
  END;
  IF NOT(ddd) THEN
    alltrue[7]:=FALSE;
  END;

  keys[1]:="e";
  keys[2]:="m";
  keys[3]:="x";
  keys[4]:="y";
  keys[5]:="z";

  keys[6]:="p";
  keys[7]:="d";

  keys[9]:="o";
  keys[10]:="t";
  keys[11]:="h";
  keys[12]:="a";
  keys[13]:="1";
  keys[14]:="2";
  keys[15]:="f";
  keys[16]:="i";
  keys[17]:="q";

  NewTerm.xormode:=FALSE;
  co:=0;
  sizestep:=0.100;
  eyestep:=10.0;

  fz:=FLOAT(DDD.GetPlaneDist());
  afz:=fz;
  orgfz:=fz;

  eyepos:=DDD.GetEyePos();

  xywin:=DDD.GetXYWin();
  xzwin:=DDD.GetXZWin();
  yzwin:=DDD.GetYZWin();
  dddwin:=DDD.GetDDDWin();

  IF NOT(Available(SIZE(arrlist))) THEN
    IntMen.Error();
    RETURN;
  ELSE
    ALLOCATE(basepointer,SIZE(arrlist));
  END;
  pt:=basepointer;
  pt^.size:=0;
  pt^.nextobj:=NIL;

  FOR obj:=DDD.GetFirstObjnum() TO DDD.GetLastObjnum() DO
    IF DDD.DoesObjExists(obj) AND DDD.IsStObjDrawable(obj) THEN

      dsc:=DDD.GetStObjScale(obj);
      max:=DDD.GetStObjSize(obj);

      org1:=DDD.GetStObjXYOrg(obj);
      org2:=DDD.GetStObjYZOrg(obj);
      crossobj:=DDD.GetCrossObj();
      porg1:=Grawin.GetObjOrg(xywin,crossobj);
      porg2:=Grawin.GetObjOrg(yzwin,crossobj);

      FOR i:=1 TO max DO
        INC(co);
        pd:=DDD.GetStObjPoint(obj,i);

        WITH pt^ DO
          obj[co].coord[x]:=FLOAT(pd.x)*dsc.scx+FLOAT(org1.x)-FLOAT(porg1.x);
          obj[co].coord[y]:=FLOAT(pd.y)*dsc.scy+FLOAT(org1.y)-FLOAT(porg1.y);
          obj[co].coord[z]:=FLOAT(pd.z)*dsc.scz+FLOAT(org2.y)-FLOAT(porg2.y);
          obj[co].col:=pd.col;
          IF i=1 THEN
            obj[co].drawline:=FALSE;
          ELSE
            obj[co].drawline:=pd.drawline;
          END;
        END;
        IF co=maxpoints THEN
          IF NOT(Available(SIZE(arrlist))) THEN
            IntMen.Error();
            RETURN;
          ELSE
            ALLOCATE(npt,SIZE(arrlist));
          END;
          pt^.nextobj:=npt;
          pt^.size:=maxpoints;
          pt:=npt;
          pt^.nextobj:=NIL;
          co:=0;
        END;
      END;

      pt^.size:=co;
    END;
  END;

  eyes.coord[x]:=FLOAT(eyepos.x);
  eyes.coord[y]:=FLOAT(eyepos.y);
  eyes.coord[z]:=FLOAT(eyepos.z);
  aeyes:=eyes;
  orgeyes:=eyes;

  aeyes.coord[x]:=FLOAT(eyepos.x);
  aeyes.coord[y]:=FLOAT(eyepos.y);
  aeyes.coord[z]:=FLOAT(eyepos.z);

  w:=10;

  zsc:=1.0;
  azsc:=zsc;
  orgzsc:=zsc;

  gamma:=FLOAT(w)/180.0*PI;
  eyedist:=3.0;
  aeyedist:=eyedist;
  orgeyedist:=eyedist;

  r11:=cos(gamma);
  r12:=sin(gamma);

  IF ddd THEN
    DDDProject(basepointer);
  ELSE
    Project(basepointer);
  END;

  LOOP
    Mouse.ConfLeftButton;
    Mouse.ConfRightButton;
    Mouse.ConfPosChanged;
    Mouse.WaitForEvents(left,right,pos,keyflag,strg,c);
    Mouse.ConfPosChanged;

    key:="";

    IF keyflag THEN
      Mouse.SetMousePos(screenmaxx,screenmaxy);

      aeyes:=eyes;
      aeyedist:=eyedist;
      afz:=fz;
      azsc:=zsc;

      IF strg THEN
        key:=c;
      ELSE
        FOR i:=1 TO HIGH(keys) DO
          IF keys[i]=c THEN
            key:=c;
          END;
        END;
      END;
    END;

    IF strg THEN
      CASE mode OF
        eyemode :
          CASE c OF
            CurLeft     : eyes.coord[x]:=eyes.coord[x]-eyestep; |
            CurRight    : eyes.coord[x]:=eyes.coord[x]+eyestep; |
            CurUp       : eyes.coord[y]:=eyes.coord[y]-eyestep; |
            CurDown     : eyes.coord[y]:=eyes.coord[y]+eyestep; |
            PgDown      : eyes.coord[z]:=eyes.coord[z]+eyestep; |
            PgUp        : eyes.coord[z]:=eyes.coord[z]-eyestep;
          END;
          aeyes:=eyes;
          ShowEyes(info); |
        distmode :
          CASE c OF
            CurLeft  : eyedist:=eyedist-sizestep; |
            CurRight : eyedist:=eyedist+sizestep; |
          END;
          aeyedist:=eyedist;
          ShowDist(info); |
        zoommode :
          CASE c OF
            CurUp     : zsc:=zsc-sizestep; |
            CurDown   : zsc:=zsc+sizestep; |
          END;
          azsc:=zsc;
          ShowZoom(info); |
        planemode :
          CASE c OF
            CurUp   : fz:=fz+eyestep; |
            CurDown : fz:=fz-eyestep; |
          END;
          afz:=fz;
          ShowPlane(info); |
        xrotmode :
          CASE c OF
            CurLeft : XRot(TRUE); |
            CurRight : XRot(FALSE); |
          END; |
        yrotmode :
          CASE c OF
            CurLeft : YRot(TRUE); |
            CurRight : YRot(FALSE); |
          END; |
        zrotmode :
          CASE c OF
            CurLeft : ZRot(TRUE); |
            CurRight : ZRot(FALSE); |
          END; |
      END;

    END;

    IF right OR (c=Enter) THEN
      text[1].t:='Viewer-Functions.';
      text[2].t:='Please choose: ';
      text[1].c:=Colors.ititlecol;
      text[2].c:=Colors.ipromptcol;

      Grawin.ShowInfoBox(10,6,2,text);
      Grawin.ColFromTo(text,Colors.itextcol,1,HIGH(text));

      text[1].t:='Moving-Eye-Mode...........';
      text[2].t:='Zoom-Mode.................';
      text[3].t:='X-Rotate-Mode.............';
      text[4].t:='Y-Rotate-Mode.............';
      text[5].t:='Z-Rotate-Mode.............';
      text[6].t:='Plane-Distance-Mode.......';
      text[7].t:='Eye-Distance-Mode.........';
      text[8].t:="__________________________";
      text[9].t:="Reset perspective.........";
      text[10].t:="Save screen as TeX-file...";
      text[11].t:="Helppages.................";
      text[12].t:="Change rot-Angle..........";
      text[13].t:="Change steP-size..........";
      text[14].t:="Change Eye-step-size......";
      text[15].t:="Enter zoom-factor.........";
      text[16].t:="Info-line on/off..........";
      text[17].t:="Exit viewer...............";

      i:=Grawin.ShowChooseBox(12,10,17,text,keys,alltrue,1);
      IF i>0 THEN
        key:=keys[i];
      END;
      ClearScreen(info);
    END;

    IF pos THEN
      Mouse.ConfPosChanged;
      IF Mouse.LeftAndMove() THEN
        IF NOT(lmflag) THEN
          Mouse.SetMousePos(screenmaxx,screenmaxy);
          lmflag:=TRUE;
        END;
      ELSE
        lmflag:=FALSE;
      END;

      Mouse.GetMouseState(mousex,mousey,left,right);

      IF (INTEGER(mousex)=0) OR (INTEGER(mousey)=0) OR
         (INTEGER(mousex)=screenmaxx*2-2) OR (INTEGER(mousey)=screenmaxy*2) THEN
        Mouse.SetMousePos(screenmaxx,screenmaxy);
        Mouse.GetMouseState(mousex,mousey,left,right);
        CASE mode OF
          eyemode   : aeyes:=eyes; |
          distmode  : aeyedist:=eyedist; |
          zoommode  : azsc:=zsc; |
          planemode : afz:=fz;
        END;

      ELSE

        dx:=(INTEGER(mousex)-screenmaxx) DIV 4;
        dy:=(INTEGER(mousey)-screenmaxy) DIV 4;

        IF Mouse.LeftAndMove() THEN
          CASE mode OF
            eyemode : eyes.coord[z]:=aeyes.coord[z]+eyestep*REAL(dy);
                      aeyes.coord[x]:=eyes.coord[x];
                      aeyes.coord[y]:=eyes.coord[y];
                      ShowEyes(info); |
          END;
        ELSE
          CASE mode OF
             eyemode  : eyes.coord[x]:=aeyes.coord[x]+eyestep*REAL(dx);
                        eyes.coord[y]:=aeyes.coord[y]+eyestep*REAL(dy);
                        ShowEyes(info); |
             distmode : eyedist:=aeyedist+sizestep*REAL(dx);
                        ShowDist(info); |
             zoommode  : zsc:=azsc+sizestep*REAL(dy);
                         ShowZoom(info); |
             planemode : fz:=afz+eyestep*REAL(dy);
                         ShowPlane(info); |
             xrotmode : IF dx<>0 THEN
                          XRot(dx<0);
                          Mouse.SetMousePos(screenmaxx,screenmaxy);
                          Mouse.ConfPosChanged;
                        END; |
             yrotmode : IF dx<>0 THEN
                          YRot(dx<0);
                          Mouse.SetMousePos(screenmaxx,screenmaxy);
                          Mouse.ConfPosChanged;
                        END; |
             zrotmode : IF dx<>0 THEN
                          ZRot(dx<0);
                          Mouse.SetMousePos(screenmaxx,screenmaxy);
                          Mouse.ConfPosChanged;
                        END;
          END;
        END;
      END;
    END;

    IF key<>"" THEN
      CASE key OF
        'o' : aeyes:=orgeyes;
              eyes:=orgeyes;
              afz:=orgfz;
              fz:=orgfz;
              zsc:=orgzsc;
              azsc:=orgzsc;
              eyedist:=orgeyedist;
              aeyedist:=orgeyedist;
              ClearScreen(info); |
        'e' : mode:=eyemode; ShowEyes(info); |
        'm' : mode:=zoommode; ShowZoom(info); |
        'x' : mode:=xrotmode; ShowXRot(info); |
        'y' : mode:=yrotmode; ShowYRot(info); |
        'z' : mode:=zrotmode; ShowZRot(info); |
        'p' : mode:=planemode; ShowPlane(info); |
        'd' : IF ddd THEN mode:=distmode; ShowDist(info); END; |
        'a' : text[1].t:="Change rot-angle.";
              text[2].t:="Please enter";
              text[3].t:="new angle:";
              text[4].t:="";
              text[1].c:=Colors.ititlecol;
              text[2].c:=Colors.ipromptcol;
              text[3].c:=Colors.ipromptcol;
              text[4].c:=Colors.ientercol;
              REPEAT
                Grawin.ShowInfoBox(10,10,4,text);
                NewIO.ReadReal(gamma,"10.0");
              UNTIL NewIO.Done;
              w:=ROUND(gamma);
              gamma:=gamma/180.0*PI;
              r11:=cos(gamma);
              r12:=sin(gamma);
              ClearScreen(info); |

        '1' : text[1].t:="Change size-step.";
              text[2].t:="Please enter";
              text[3].t:="new step:";
              text[4].t:="";
              text[1].c:=Colors.ititlecol;
              text[2].c:=Colors.ipromptcol;
              text[3].c:=Colors.ipromptcol;
              text[4].c:=Colors.ientercol;
              REPEAT
                Grawin.ShowInfoBox(10,10,4,text);
                NewIO.ReadReal(sizestep,"0.1");
              UNTIL NewIO.Done;
              ClearScreen(info); |

        '2' : text[1].t:="Change eye-step.";
              text[2].t:="Please enter";
              text[3].t:="new step:";
              text[4].t:="";
              text[1].c:=Colors.ititlecol;
              text[2].c:=Colors.ipromptcol;
              text[3].c:=Colors.ipromptcol;
              text[4].c:=Colors.ientercol;

              REPEAT
                Grawin.ShowInfoBox(10,10,4,text);
                NewIO.ReadReal(eyestep,"10.0");
              UNTIL NewIO.Done;
              ClearScreen(info); |

        'i' : info:=NOT(info);
              ClearScreen(FALSE);
              NewTerm.GotoXY(0,0);

              NewTerm.SetFGColor(Colors.viewinfocol.r,
                                 Colors.viewinfocol.g,
                                 Colors.viewinfocol.b);

              IF info THEN
                NewIO.WriteString("Infoline on.")
              ELSE
                NewIO.WriteString("Infoline off.");
              END; |

       't' :  text[1].t:="Save TeX-file.";
              text[2].t:="Please enter TeX-";
              text[3].t:="filename:";
              text[4].t:="";
              text[1].c:=Colors.ititlecol;
              text[2].c:=Colors.ipromptcol;
              text[3].c:=Colors.ipromptcol;
              text[4].c:=Colors.ientercol;

              Grawin.ShowInfoBox(10,10,4,text);
              NewIO.ReadString(fn);
              IF fn[1]<>'' THEN

                text[3].t:="x-picture-size: ";
                REPEAT
                  Grawin.ShowInfoBox(10,10,4,text);
                  xsize:=100;
                  NewIO.ReadCard(xsize);
                UNTIL NewIO.Done AND (xsize>0);

                text[3].t:="y-picture-size: ";
                REPEAT
                  Grawin.ShowInfoBox(10,10,4,text);
                  ysize:=80;
                  NewIO.ReadCard(ysize);
                UNTIL NewIO.Done AND (ysize>0);

                TexOutput(fn,xsize,ysize,basepointer);
              END;
              ClearScreen(info); |

        'f' : text[1].t:="Zoom-factor.";
              text[2].t:="Please enter";
              text[3].t:="new factor:";
              text[4].t:="";
              text[1].c:=Colors.ititlecol;
              text[2].c:=Colors.ipromptcol;
              text[3].c:=Colors.ipromptcol;
              text[4].c:=Colors.ientercol;
              REPEAT
                Grawin.ShowInfoBox(10,10,4,text);
                NewIO.ReadReal(zsc,"1.0");
              UNTIL NewIO.Done;
              ClearScreen(info); |

        'h' : Helppages;
              ClearScreen(info); |

        'q' : pt:=basepointer;
              REPEAT
                npt:=pt;
                DEALLOCATE(pt,SIZE(arrlist));
                pt:=npt^.nextobj;
              UNTIL pt=NIL;
              DDD.RestoreStObj(objnum);
              Grawin.Reset;
              Mouse.RestoreMousePos;
              EXIT; |
      END;
    END;
    IF ddd THEN
      DDDProject(basepointer);
    ELSE
      Project(basepointer);
    END;
  END;
END View;

BEGIN
END ObjView.

