IMPLEMENTATION MODULE SceneEd;

IMPORT Guitool;
IMPORT Handler;
IMPORT Info;
IMPORT ObjView;
IMPORT Grawin;
IMPORT DDD;
IMPORT Colors;
IMPORT InOut;
IMPORT Disk;
IMPORT IntMen;

FROM Mouse    IMPORT SetMousePos, WaitForEvents, WaitForAnything, StoreMousePos,
                     RestoreMousePos, InitMouse, GetMouseState, ConfRightButton,
                     ConfLeftButton, ConfPosChanged, SetWaitProc, EnableWaitProcEvery,
                     LeftAndMove, RightAndMove;

FROM FIO      IMPORT PathTail;
FROM Str      IMPORT Length, Concat, IntToStr;
FROM KeyConst IMPORT Enter, PgUp, PgDown, CurLeft, CurRight, CurUp, CurDown, StrgCurUp, StrgCurDown, StrgCurLeft, StrgCurRight;
FROM NewTerm  IMPORT GotoXY, SetFGColor, SetBGColor, SetMaxWindow, xormode, Scroll;
FROM NewIO    IMPORT Done, WriteLn, Read, Write, ReadReal, WriteReal, UseDefault;
FROM NewIO    IMPORT ReadString, WriteString, ReadInt, WriteInt, ReadCard, WriteCard;
FROM MathLib0 IMPORT sin, cos, arctan;
FROM DDD      IMPORT Max, Min, ROUND, PI (*, WriteColor, ReadColor, Write2DCoord, Read2DCoord; *);

CONST rotbuffobj = lastobj+4;
      tubebuffobj = lastobj+4;
      shapebuffobj = lastobj+5;
      temprotshape = lastobj+6;
      splinebuffobj = lastobj+5;
      tempobj1 = lastobj+5;
      tempobj2 = lastobj+6;


TYPE
     objfuntions = (nil, hideshow, create, destroy, rename, copy,
                           move, whereis, select, objhandler, yanktogether);

TYPE tstate = (inactive, defpoints, defshape);
     trotobj = (asradius, ascenter);
     functions = (nil2, objlib3d, objlib2d, operations, objmisc, handler,
                       helppage, colorpicker, planeeye, laygrid, disk, preferences,
                       undo, done);
     funtions2 = (nil3, view, stereoview);

VAR c : CHAR;
    cur : Grawin.Coord;
    p : DDD.DCoord;
    rotstate, tubestate : tstate;
    rotobjtype : trotobj;
    lastpoints, actwin, shapewin, rotwin : CARDINAL;
    cursorstep, gridstep : CARDINAL;
    lobj, obj : CARDINAL;
    actcol : Grawin.RGB;
    a, b, pointselcoords : ARRAY[xywin..dddwin] OF Grawin.Coord;

    dontwriteinfo, dispflag, absdisp, handleract, gridflag, scenedone : BOOLEAN;


    objflags : ARRAY[firstobj..lastobj] OF BOOLEAN;
    showallpoints, pointselected, addpointsmode, crossflag : BOOLEAN;
    i : CARDINAL;

    setscenemenus : PROC;

    itext : Grawin.CTLine;
    text : ARRAY[1..27] OF Grawin.CTLine;
    keys : ARRAY[1..20] OF CHAR;
    nokeys  : ARRAY[1..20] OF CHAR;
    alltrue : ARRAY[1..20] OF BOOLEAN;

    selab : ARRAY[1..10] OF BOOLEAN;

PROCEDURE SetGridstep(step : CARDINAL);
BEGIN
  gridstep:=step;
END SetGridstep;

PROCEDURE GetGridstep():CARDINAL;
BEGIN
  RETURN(gridstep);
END GetGridstep;

PROCEDURE SetCursorstep(step : CARDINAL);
BEGIN
  cursorstep:=step;
END SetCursorstep;

PROCEDURE GetCursorstep():CARDINAL;
BEGIN
  RETURN(cursorstep);
END GetCursorstep;

PROCEDURE SetActCol(col : Grawin.RGB);
BEGIN
  actcol:=col;
END SetActCol;

PROCEDURE GetActCol():Grawin.RGB;
BEGIN
  RETURN(actcol);
END GetActCol;

PROCEDURE Inform(objnum : CARDINAL);
VAR winbackcol : Grawin.RGB;
    string : Grawin.LString;
    ok : BOOLEAN;
    ttext : Grawin.CTLine;

BEGIN

  xormode:=FALSE;
  winbackcol:=Grawin.GetWinBackCol(dddwin);
  SetFGColor(Colors.swintitlecol.r,Colors.swintitlecol.g,Colors.swintitlecol.b);
  SetBGColor(winbackcol.r,winbackcol.g,winbackcol.b);
  ttext.c:=itext.c;

  IF objnum<=lastobj THEN
    Concat(ttext.t,"8 Scene-3D  Name: ",objnames[objnum]);
  ELSE
    ttext.t:="8 Scene-3D  Name: -----";
  END;

  IntToStr(LONGINT(Grawin.GetObjMaxPointNumber(dddwin,objnum)),
           string,10,ok);
  Concat(string," Points: ",string);
  Concat(ttext.t,ttext.t,string);

  IntToStr(LONGINT(Info.GetFreeKB()),string,10,ok);
  Concat(string," Mem: ",string);
  Concat(ttext.t,ttext.t,string);

  Grawin.ClipWithWin(dddwin);
  Grawin.ConTextToWinTitle(dddwin,ttext);

END Inform;

PROCEDURE WinInfoLine(actwin : CARDINAL);
VAR pp, ppp : Grawin.Coord;
    poi : Grawin.Point;
    winbackcol : Grawin.RGB;
BEGIN
  xormode:=FALSE;
  Grawin.ClipWithWin(actwin);
  winbackcol:=Grawin.GetWinBackCol(actwin);
  SetFGColor(actcol.r,actcol.g,actcol.b);
  SetBGColor(winbackcol.r,winbackcol.g,winbackcol.b);
  pp:=Grawin.GetWinPos(actwin);
  GotoXY((pp.x+1)*8,(pp.y+1)*16);
  IF dispflag AND (actwin<>dddwin) THEN
    Write(" ");
    IF DDD.IsWhereOn() THEN Write("F"); ELSE Write("-"); END;
    Write(" ");
    IF addpointsmode THEN
      Write("A");
    ELSE
      IF pointselected THEN Write("!"); ELSE Write("?"); END;
    END;
    Write(" ");
    IF Grawin.InSnapMode() THEN
      Write("#");
    ELSE
      Write("~");
    END;
    Write(" ");
    IF absdisp THEN
      WriteInt(p.x,5);
      Write(",");
      WriteInt(p.y,5);
      Write(",");
      WriteInt(p.z,5);
    ELSE
      ppp:=Grawin.GetObjOrg(xywin,obj);
      pp:=Grawin.GetWinOrg(xywin);
      WriteInt(p.x+pp.x-ppp.x,5);
      Write("|");
      WriteInt(p.y+pp.y-ppp.y,5);
      Write("|");
      ppp:=Grawin.GetObjOrg(yzwin,obj);
      pp:=Grawin.GetWinOrg(yzwin);
      WriteInt(p.z+pp.y-ppp.y,5);
    END;
  END;
END WinInfoLine;

(* Procedure called by module GRAWIN, if size of window has changed *)

PROCEDURE AdjustSize(VAR actwin, objnum: CARDINAL);
VAR pp : Grawin.Coord;

BEGIN
  Grawin.RefreshAllWins(TRUE);
END AdjustSize;

(* Procedure called by module GRAWIN, if window has been updated *)

PROCEDURE Refresh(VAR actwin, objnum : CARDINAL);
VAR p : Grawin.Point;
    sc : Grawin.Scale;
    r : REAL;
    pp, ppp : Grawin.Coord;
    dotcol : Grawin.RGB;
    i : CARDINAL;
    fx, fy : INTEGER;

BEGIN

  xormode:=FALSE;
  IF ((rotstate=defpoints) AND (actwin<>rotwin))
     OR ((rotstate=defshape) AND (actwin<>shapewin))
     OR ((actwin<>shapewin) AND (tubestate=defshape))
     OR ((tubestate=defpoints) AND (actwin=dddwin)) THEN
    Grawin.LayGrid(actwin,16,16,0,0,Colors.sgridcol);
  END;

  IF gridflag AND (actwin<>dddwin) THEN
    pp:=Grawin.GetWinOrg(actwin);
    r:=Grawin.GetWinZoom(actwin);
    fx:=ROUND(REAL(gridstep)*r);
    fy:=ROUND(REAL(gridstep)*r);
    Grawin.LayGrid(actwin,fx,fy,ABS(pp.x) MOD fx,ABS(pp.y) MOD fy,Colors.sgridcol);
  END;

  DDD.ShowPlane(actwin);
  DDD.ShowEye(actwin);
  DDD.ShowOrg(actwin,objnum);

  DDD.DrawStObjsToWin(actwin);
  Grawin.DrawWinObjlist(actwin,FALSE);

  IF Grawin.IsObjDrawable(actwin,objnum) THEN

    IF addpointsmode THEN
      p:=Grawin.GetObjPoint(actwin,objnum);
    ELSE
      IF pointselected THEN
        p.x:=pointselcoords[actwin].x;
        p.y:=pointselcoords[actwin].y;
      ELSE
        p.x:=0;
        p.y:=0;
      END;
    END;

    sc:=Grawin.GetObjScale(actwin,objnum);

    pp:=Grawin.GetObjOrg(actwin,objnum);
    ppp:=Grawin.GetWinOrg(actwin);

    p.x:=ROUND(FLOAT(p.x)*sc.scx+ FLOAT(pp.x-ppp.x));
    p.y:=ROUND(FLOAT(p.y)*sc.scy+ FLOAT(pp.y-ppp.y));

    IF Grawin.GetObjPointNumber(actwin,objnum)>1 THEN

      xormode:=TRUE;
      Grawin.SetMarker1(actwin,p.x,p.y,Colors.smarcol);
      xormode:=FALSE;
      dotcol:=Grawin.XorRGBs(Colors.smarcol,Colors.swinbackcol);

      IF showallpoints THEN
        Grawin.SetObjPointNumber(actwin,objnum,1);
        r:=Grawin.GetWinZoom(actwin);
        FOR i:=1 TO Grawin.GetObjMaxPointNumber(actwin,objnum)-1 DO
          p:=Grawin.GetObjPoint(actwin,objnum);
          p.x:=ROUND((FLOAT(p.x)*sc.scx+ FLOAT(pp.x-ppp.x))*r);
          p.y:=ROUND((FLOAT(p.y)*sc.scy+ FLOAT(pp.y-ppp.y))*r);
          IF (p.x>-10000) AND (p.x<10000) AND (p.y>-10000) AND (p.y<10000) THEN
            Grawin.DotConsiderate(actwin,p.x,p.y,dotcol);
          END;
        END;
      END;
    END;

  END;

  IF (actwin=dddwin) THEN
    Inform(objnum);
    pp:=Grawin.GetWinPos(dddwin);
    Grawin.ColFromTo(text,Colors.ipromptcol,1,3);

    IF rotstate=defpoints THEN
      text[1].t:="Rot-Body. Define points";
      text[2].t:="for it and confirm with";
      text[3].t:="'ALT o a' or menu 'Rot-Body'.";
      Grawin.ShowInfoBox(pp.x+3,pp.y+3,3,text);
    END;
    IF rotstate=defshape THEN
      text[1].t:="Rot-Body. Define points";
      text[2].t:="of shape and confirm with";
      text[3].t:="'ALT o a' or menu 'Rot-Body'.";
      Grawin.ShowInfoBox(pp.x+3,pp.y+3,3,text);
    END;

    IF tubestate=defpoints THEN
      text[1].t:="Tube-Body. Define points";
      text[2].t:="for it and confirm with";
      text[3].t:="'ALT o b' or menu 'Tube-Body'.";
      Grawin.ShowInfoBox(pp.x+3,pp.y+3,3,text);
    END;
    IF tubestate=defshape THEN
      text[1].t:="Tube-Body. Define points";
      text[2].t:="of shape and confirm with";
      text[3].t:="'ALT o b' or menu 'Tube-Body'.";
      Grawin.ShowInfoBox(pp.x+3,pp.y+3,3,text);
    END;
  END;
  Grawin.ShowCursor(actwin,Colors.scurcol,addpointsmode);
END Refresh;

PROCEDURE ParUpdateCon(VAR actwin, objnum : CARDINAL);
VAR p : ARRAY[1..3] OF Grawin.Point;
    sc : Grawin.Scale;
    r : REAL;
    poi : Grawin.Point;
    pp, ppp : Grawin.Coord;
    dotcol : Grawin.RGB;
    i, num : CARDINAL;
    fx, fy : INTEGER;

BEGIN

  IF Grawin.IsObjDrawable(actwin,objnum) THEN

    IF addpointsmode THEN
      p[3]:=Grawin.GetObjPoint(actwin,objnum);
    ELSE
      IF pointselected THEN
        p[3].x:=pointselcoords[actwin].x;
        p[3].y:=pointselcoords[actwin].y;
      ELSE
        p[3].x:=0;
        p[3].y:=0;
      END;
    END;

    num:=Grawin.GetObjPointNumber(actwin,objnum);
    IF num>1 THEN
      Grawin.SetObjPointNumber(actwin,objnum,num-1);
      p[1]:=Grawin.GetObjPoint(actwin,objnum);
      p[2]:=Grawin.GetObjPoint(actwin,objnum);
    END;

    sc:=Grawin.GetObjScale(actwin,objnum);
    pp:=Grawin.GetObjOrg(actwin,objnum);
    ppp:=Grawin.GetWinOrg(actwin);

    FOR i:=1 TO 3 DO
      p[i].x:=ROUND(FLOAT(p[i].x)*sc.scx+ FLOAT(pp.x-ppp.x));
      p[i].y:=ROUND(FLOAT(p[i].y)*sc.scy+ FLOAT(pp.y-ppp.y));
    END;

    IF num>1 THEN

      IF p[2].drawline THEN
        xormode:=FALSE;
        Grawin.DrawConsiderate(actwin,p[1].x,p[1].y,p[2].x,p[2].y,actcol);
      END;

    pp:=Grawin.GetObjOrg(actwin,objnum);
    ppp:=Grawin.GetWinOrg(actwin);


      xormode:=TRUE;
      Grawin.SetMarker1(actwin,p[3].x,p[3].y,Colors.smarcol);
      xormode:=FALSE;
      dotcol:=Grawin.XorRGBs(Colors.smarcol,Colors.swinbackcol);

      IF showallpoints THEN
      (* r:=Grawin.GetWinZoom(actwin);
        Grawin.DotConsiderate(actwin,p[1].x,p[1].y,dotcol);
      END; *)
        Grawin.SetObjPointNumber(actwin,objnum,1);
        r:=Grawin.GetWinZoom(actwin);
        FOR i:=1 TO Grawin.GetObjMaxPointNumber(actwin,objnum)-1 DO
          poi:=Grawin.GetObjPoint(actwin,objnum);
          poi.x:=ROUND((FLOAT(poi.x)*sc.scx+ FLOAT(pp.x-ppp.x))*r);
          poi.y:=ROUND((FLOAT(poi.y)*sc.scy+ FLOAT(pp.y-ppp.y))*r);
          IF (poi.x>-10000) AND (poi.x<10000) AND (poi.y>-10000) AND (poi.y<10000) THEN
            Grawin.DotConsiderate(actwin,poi.x,poi.y,dotcol);
          END;
        END;
      END;

    END;

  END;

  IF actwin=dddwin THEN Inform(objnum); END;

  Grawin.ShowCursor(actwin,Colors.scurcol,addpointsmode);

END ParUpdateCon;

PROCEDURE AllWinsParUpdateCon(actwin, objnum : CARDINAL);
VAR winnum : CARDINAL;
BEGIN
  FOR winnum:=xywin TO dddwin DO
    IF winnum<>actwin THEN
      ParUpdateCon(winnum,objnum); (* Grawin.RefreshAllWins would overpaint it all! *)
    END;
  END;
  Grawin.DrawWin(actwin,TRUE,TRUE);
END AllWinsParUpdateCon;
      (*
PROCEDURE AllWinsTotUpdateCon(actwin, objnum : CARDINAL);
VAR winnum : CARDINAL;
BEGIN
  FOR winnum:=xywin TO dddwin DO
    IF winnum<>actwin THEN
      TotUpdateCon(winnum,objnum); (* Grawin.RefreshAllWins would overpaint it all! *)
    END;
  END;
  Grawin.DrawWin(actwin,TRUE,TRUE);
END AllWinsTotUpdateCon;
        *)
PROCEDURE Error();
BEGIN
  IntMen.Error;
END Error;

PROCEDURE HideAllObjects(actwin: CARDINAL);
VAR i : CARDINAL;

BEGIN
  FOR i:=firstobj TO lastobj DO
    IF i=obj THEN
      objflags[i]:=Grawin.IsObjDrawable(actwin,i);
      Grawin.DontDrawObj(actwin,i);
    ELSE
      objflags[i]:=DDD.IsStObjDrawable(i);
      DDD.DontDrawStObj(i);
    END;
  END;
END HideAllObjects;

PROCEDURE ShowAllObjects(actwin: CARDINAL);
VAR i : CARDINAL;

BEGIN
  FOR i:=firstobj TO lastobj DO
    IF objflags[i] THEN
      IF i=obj THEN
        Grawin.AllowDrawObj(actwin,i);
      ELSE
        DDD.AllowDrawStObj(i);
      END;
    END;
  END;
  (* IF crossflag THEN Grawin.AllowDrawObj(actwin,crossobj); END; *)
END ShowAllObjects;

(* Now following: menu-procedures called by Grawin.WindowHandler or
   directy via bindkey from keyboard *)

(* Option ZOOM was selected *)

PROCEDURE Scale(VAR actwin, objnum : CARDINAL);
BEGIN
  (* IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END; *)
  DDD.MakeObjBackup(objnum);
  IntMen.ScaleInt(objnum);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Object scaled!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END Scale;

(* Option ROTATE was selected *)

PROCEDURE Rotate(VAR actwin, objnum : CARDINAL);
BEGIN
  (* IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END; *)
  DDD.MakeObjBackup(objnum);
  IntMen.RotateInt(objnum);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Object rotated!";
    dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END Rotate;

(* Option CREATE OBJECT was selected *)

PROCEDURE CreateObj(VAR actwin, objnum : CARDINAL);
BEGIN
  IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END;
  DDD.CopyToLocalNames(objnames);
  obj:=IntMen.CreateObjInt(objnum,TRUE);
  DDD.CopyFromLocalNames(objnames);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Object created!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END CreateObj;

(* Option MIRROR was selected *)

PROCEDURE Mirror(VAR actwin, objnum : CARDINAL);


  (* mirror object at plane xy *)
  
  PROCEDURE XYMirror(objnum : CARDINAL);
  VAR p : Grawin.Coord;
      poi: Grawin.Point;
      winnum, i, max : CARDINAL;
  
  BEGIN
  
    max:=Grawin.GetObjMaxPointNumber(xywin,objnum);
    DDD.CreateXYZObj(tempobj1);
    FOR winnum:=xywin TO yzwin DO
      Grawin.SetObjPointNumber(winnum,objnum,1);
      FOR i:=1 TO max DO
        poi:=Grawin.GetObjPoint(winnum,objnum);
        IF (winnum=xzwin) OR (winnum=yzwin) THEN
          poi.y:=-poi.y;
        END;
        Grawin.AddObjPoint(winnum,tempobj1,poi.x,poi.y,poi.col,poi.drawline);
      END;
    END;
    FOR winnum:=xywin TO yzwin DO
      Grawin.SetObjPointNumber(winnum,tempobj1,1);
      FOR i:=1 TO max DO
        poi:=Grawin.GetObjPoint(winnum,tempobj1);
        Grawin.AddObjPoint(winnum,objnum,poi.x,poi.y,poi.col,poi.drawline);
      END;
    END;
    DDD.ClearDDDObj(objnum);
    DDD.AddNewDCoords(objnum);
    DDD.DestroyXYZObj(tempobj1);
    DDD.ShowWhere(objnum);
  END XYMirror;

  (* mirror object at plane xz *)

  PROCEDURE XZMirror(objnum : CARDINAL);
  VAR p : Grawin.Coord;
      poi: Grawin.Point;
      winnum, i, max : CARDINAL;

  BEGIN
    max:=Grawin.GetObjMaxPointNumber(xywin,objnum);
    DDD.CreateXYZObj(tempobj1);
    FOR winnum:=xywin TO yzwin DO
      Grawin.SetObjPointNumber(winnum,objnum,1);
      FOR i:=1 TO max DO
        poi:=Grawin.GetObjPoint(winnum,objnum);
        IF (winnum=xywin) THEN
          poi.y:=-poi.y;
        END;
        IF (winnum=yzwin) THEN
          poi.x:=-poi.x;
        END;
        Grawin.AddObjPoint(winnum,tempobj1,poi.x,poi.y,poi.col,poi.drawline);
      END;
    END;
    FOR winnum:=xywin TO yzwin DO
      Grawin.SetObjPointNumber(winnum,tempobj1,1);
      FOR i:=1 TO max DO
        poi:=Grawin.GetObjPoint(winnum,tempobj1);
        Grawin.AddObjPoint(winnum,objnum,poi.x,poi.y,poi.col,poi.drawline);
      END;
    END;
    DDD.ClearDDDObj(objnum);
    DDD.AddNewDCoords(objnum);
    DDD.DestroyXYZObj(tempobj1);
    DDD.ShowWhere(objnum);
  END XZMirror;

  (* mirror object at plane yz *)

  PROCEDURE YZMirror(objnum : CARDINAL);
  VAR p : Grawin.Coord;
      poi: Grawin.Point;
      winnum, i, max : CARDINAL;

  BEGIN
    max:=Grawin.GetObjMaxPointNumber(xywin,objnum);
    DDD.CreateXYZObj(tempobj1);
    FOR winnum:=xywin TO yzwin DO
      Grawin.SetObjPointNumber(winnum,objnum,1);
      FOR i:=1 TO max DO
        poi:=Grawin.GetObjPoint(winnum,objnum);
        IF (winnum=xywin) OR (winnum=xzwin) THEN
          poi.x:=-poi.x;
        END;
        Grawin.AddObjPoint(winnum,tempobj1,poi.x,poi.y,poi.col,poi.drawline);
      END;
    END;
    FOR winnum:=xywin TO yzwin DO
      Grawin.SetObjPointNumber(winnum,tempobj1,1);
      FOR i:=1 TO max DO
        poi:=Grawin.GetObjPoint(winnum,tempobj1);
        Grawin.AddObjPoint(winnum,objnum,poi.x,poi.y,poi.col,poi.drawline);
      END;
    END;
    DDD.ClearDDDObj(objnum);
    DDD.AddNewDCoords(objnum);
    DDD.DestroyXYZObj(tempobj1);
    DDD.ShowWhere(objnum);
  END YZMirror;

VAR
    selected, i : CARDINAL;

BEGIN
  IF Grawin.InErrorState() THEN Error; RETURN; END;
  (* IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END; *)
  DDD.MakeObjBackup(objnum);
  text[1].t:="Mirror-Object.";
  text[2].t:="Please choose:";
  text[1].c:=Colors.ititlecol;
  text[2].c:=Colors.ipromptcol;
  Grawin.ShowInfoBox(31,14,2,text);

  Grawin.ColFromTo(text,Colors.itextcol,1,3);
  text[1].t:="XY-Mirror...";
  text[2].t:="XZ-Mirror...";
  text[3].t:="YZ-Mirror...";

  selected:=Grawin.ShowChooseBox(33,18,3,text,nokeys,alltrue,1);

  CASE selected OF
    1 : XYMirror(objnum); |
    2 : XZMirror(objnum); |
    3 : YZMirror(objnum);
  END;

  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Object mirrored!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END Mirror;

(* Create a 3D-B-Spline outoff the points of the actual object *)

PROCEDURE BSpline3D(m, n : CARDINAL);
VAR  pd, p : Grawin.Point;
     org, pp : Grawin.Coord;
     pdd : DDD.DPoint;
     m1, j, i, winnum, first : CARDINAL;
     nowcol : Grawin.RGB;
     scale : Grawin.Scale;
     x, y, z, t, xa, xb, xc, xd, ya, yb, yc, yd, za, zb, zc, zd : REAL;
     a0, a1, a2, a3, b0, b1, b2, b3, c0, c1, c2, c3 : REAL;

BEGIN
  first:=0;

  DDD.CopyObjFromTo(obj,splinebuffobj);
  DDD.ClearXYZObj(obj);

  FOR i:=2 TO m-2 DO
    DDD.SetXYZObjPointNumber(splinebuffobj,i-1);
    pdd:=DDD.GetXYZObjPoint(splinebuffobj);

    WITH pdd DO
      xa:=FLOAT(x); ya:=FLOAT(y);
      za:=FLOAT(z);
      nowcol:=col;
    END;

    pdd:=DDD.GetXYZObjPoint(splinebuffobj);
    WITH pdd DO
      xb:=FLOAT(x); yb:=FLOAT(y);
      zb:=FLOAT(z);
    END;

    pdd:=DDD.GetXYZObjPoint(splinebuffobj);
    WITH pdd DO
      xc:=FLOAT(x); yc:=FLOAT(y);
      zc:=FLOAT(z);
    END;

    pdd:=DDD.GetXYZObjPoint(splinebuffobj);
    WITH pdd DO
      xd:=FLOAT(x); yd:=FLOAT(y);
      zd:=FLOAT(z);
    END;

    a3:=(-xa+3.0*(xb-xc)+xd)/6.0;
    a2:=(xa-2.0*xb+xc)/2.0;
    a1:=(xc-xa)/2.0;
    a0:=(xa+4.0*xb+xc)/6.0;
    b3:=(-ya+3.0*(yb-yc)+yd)/6.0;
    b2:=(ya-2.0*yb+yc)/2.0;
    b1:=(yc-ya)/2.0;
    b0:=(ya+4.0*yb+yc)/6.0;
    c3:=(-za+3.0*(zb-zc)+zd)/6.0;
    c2:=(za-2.0*zb+zc)/2.0;
    c1:=(zc-za)/2.0;
    c0:=(za+4.0*zb+zc)/6.0;

    j:=first;
    REPEAT
      t:=FLOAT(j)/FLOAT(n);
      pdd.x:=ROUND(((a3*t+a2)*t+a1)*t+a0);
      pdd.y:=ROUND(((b3*t+b2)*t+b1)*t+b0);
      pdd.z:=ROUND(((c3*t+c2)*t+c1)*t+c0);
      pdd.col:=nowcol;
      INC(j);
      DDD.AddXYZObjPoint(obj,pdd);
    UNTIL j=n;

    first:=1;
  END;
  DDD.DestroyXYZObj(splinebuffobj);
  DDD.ClearDDDObj(obj);
  DDD.AddNewDCoords(obj);

  lastpoints:=Grawin.GetObjMaxPointNumber(xywin,obj);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" 3D-Spline created!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);

END BSpline3D;

(* Create a 2D-B-Spline outoff the points of the actual object *)

PROCEDURE BSpline2D(m, n : CARDINAL);
  PROCEDURE Give(p : DDD.DPoint; VAR xo, yo : REAL);
  BEGIN
    CASE actwin OF
      xywin : xo:=FLOAT(p.x); yo:=FLOAT(p.y); |
      xzwin : xo:=FLOAT(p.x); yo:=FLOAT(p.z); |
      yzwin : xo:=FLOAT(p.y); yo:=FLOAT(p.z);
    END;
  END Give;

VAR pd, p : Grawin.Point;
    org, pp : Grawin.Coord;
    pdd : DDD.DPoint;
    m1, winnum, j, i, first : CARDINAL;
    nowcol : Grawin.RGB;
    scale : Grawin.Scale;
    xo, yo : INTEGER;
    x, y, t, xa, xb, xc, xd, ya, yb, yc, yd : REAL;
    a0, a1, a2, a3, b0, b1, b2, b3 : REAL;

BEGIN
  first:=0;

  DDD.CopyObjFromTo(obj,splinebuffobj);
  DDD.ClearXYZObj(obj);

  FOR i:=2 TO m-2 DO
    DDD.SetXYZObjPointNumber(splinebuffobj,i-1);
    pdd:=DDD.GetXYZObjPoint(splinebuffobj);

    nowcol:=pdd.col;
    Give(pdd,xa,ya);

    pdd:=DDD.GetXYZObjPoint(splinebuffobj);
    Give(pdd,xb,yb);

    pdd:=DDD.GetXYZObjPoint(splinebuffobj);
    Give(pdd,xc,yc);

    pdd:=DDD.GetXYZObjPoint(splinebuffobj);
    Give(pdd,xd,yd);

    a3:=(-xa+3.0*(xb-xc)+xd)/6.0;
    a2:=(xa-2.0*xb+xc)/2.0;
    a1:=(xc-xa)/2.0;
    a0:=(xa+4.0*xb+xc)/6.0;
    b3:=(-ya+3.0*(yb-yc)+yd)/6.0;
    b2:=(ya-2.0*yb+yc)/2.0;
    b1:=(yc-ya)/2.0;
    b0:=(ya+4.0*yb+yc)/6.0;
    j:=first;

    REPEAT
      t:=FLOAT(j)/FLOAT(n);
      xo:=ROUND(((a3*t+a2)*t+a1)*t+a0);
      yo:=ROUND(((b3*t+b2)*t+b1)*t+b0);
      CASE actwin OF
        xywin : pdd.x:=xo; pdd.y:=yo; |
        xzwin : pdd.x:=xo; pdd.z:=yo; |
        yzwin : pdd.y:=xo; pdd.z:=yo;
      END;
      pdd.col:=nowcol;

      INC(j);
      DDD.AddXYZObjPoint(obj,pdd);
    UNTIL j=n;

    first:=1;
  END;
  DDD.DestroyXYZObj(splinebuffobj);
  DDD.ClearDDDObj(obj);
  DDD.AddNewDCoords(obj);

  lastpoints:=Grawin.GetObjMaxPointNumber(xywin,obj);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" 2D-Spline created!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);

END BSpline2D;

(* Calculate angle between vectors (0,x) (y,0) *)

PROCEDURE CalcAbsAngle(x, y : REAL):REAL;
VAR i : REAL;
    z : INTEGER;

BEGIN
  IF (x=0.0) OR (y=0.0) THEN
    IF y<0.0 THEN i:=270.0; END;
    IF y>0.0 THEN i:=90.0; END;
    IF (x>0.0) OR ((x=0.0) AND (y=0.0)) THEN i:=0.0; END;
    IF x<0.0 THEN i:=180.0; END;
  ELSE
    i:=ABS(arctan(y/x)/PI*180.0);
    IF (x<0.0)  AND (y>0.0) THEN i:=180.0-i; END;
    IF (x<0.0)  AND (y<0.0)  THEN i:=i+180.0; END;
    IF (x>0.0) AND (y<0.0)  THEN i:=360.0-i; END;
  END;
  RETURN(i);
END CalcAbsAngle;

(* Menu-Option select object choosen *)

PROCEDURE SelectObj(VAR actwin, objnum : CARDINAL);

BEGIN
  IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END;
  DDD.CopyToLocalNames(objnames);
  obj:=IntMen.SelectObjInt(objnum);
  DDD.CopyFromLocalNames(objnames);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Object selected!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END SelectObj;

PROCEDURE DestroyObj(VAR actwin, objnum : CARDINAL);

BEGIN
  IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END;
  DDD.CopyToLocalNames(objnames);
  obj:=IntMen.DestroyObjInt(objnum);
  DDD.DestroyStObjBackup;
  DDD.CopyFromLocalNames(objnames);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Object destroyed!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END DestroyObj;

PROCEDURE MoveObj(VAR actwin, objnum : CARDINAL);

BEGIN
  (* IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END; *)
  DDD.MakeObjBackup(objnum);
  IntMen.MoveObj(objnum,a);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Object moved!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END MoveObj;

PROCEDURE ScrollWin(VAR actwin, objnum : CARDINAL);
VAR keyflag, strg, bleft, bright, pos, flag : BOOLEAN;
    mousex, mousey : CARDINAL;
    dx, dy : INTEGER;
    key : CHAR;
    pp : Grawin.Coord;

BEGIN
  flag:=dispflag;
  dispflag:=FALSE;
  Grawin.DrawWin(actwin,TRUE,FALSE);
  itext.t:=' Scroll: cur.keys, mouse';
  itext.c:=Colors.swintitlecol;
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
  StoreMousePos;
  InitMouse(0,0,2*800,2*600);
  SetMousePos(800,600);
  pp:=Grawin.GetWinOrg(actwin);
  dx:=0;
  dy:=0;
  REPEAT
    ConfPosChanged;
    WaitForEvents(bleft,bright,pos,keyflag,strg,key);
    IF keyflag AND strg THEN
      CASE key OF
        CurLeft  : DEC(dx); |
        CurRight : INC(dx); |
        CurUp    : DEC(dy); |
        CurDown  : INC(dy);
      END;
      SetMousePos(800+dx*10,600+dy*10);
    ELSIF pos THEN
      GetMouseState(mousex,mousey,bleft,bright);
      dx:=(INTEGER(mousex)-800) DIV 10;
      dy:=(INTEGER(mousey)-600) DIV 10;
    END;
    IntMen.ScrollInt(actwin,pp,dx,dy);
  UNTIL (key=Enter) OR bleft;
  Grawin.NormalTick2();
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Window scrolled!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
  dispflag:=flag;
  RestoreMousePos;
END ScrollWin;

PROCEDURE ZoomWin(VAR actwin, objnum : CARDINAL);
VAR pp : Grawin.Coord;
    keyflag, strg, bleft, bright, pos, flag : BOOLEAN;
    mousex, mousey : CARDINAL;
    key : CHAR;
    zoom : REAL;
    dy : INTEGER;

BEGIN
  flag:=dispflag;
  dispflag:=FALSE;
  Grawin.DrawWin(actwin,TRUE,FALSE);
  itext.t:=' Zoom: cur.keys, mouse';
  itext.c:=Colors.swintitlecol;
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
  StoreMousePos;
  InitMouse(0,0,1,510);

  zoom:=Grawin.GetWinZoom(actwin);
  SetMousePos(0,ROUND(zoom*50.0));

  dy:=0;
  REPEAT
    WaitForEvents(bleft,bright,pos,keyflag,strg,key);
    IF keyflag AND strg THEN
      IF key=CurUp THEN
        DEC(dy);
        mousey:=CARDINAL(Min(510,INTEGER(ROUND(zoom*50.0))+dy*10));
        SetMousePos(0,mousey);
      END;
      IF key=CurDown THEN
        INC(dy);
        mousey:=CARDINAL(Max(0,INTEGER(ROUND(zoom*50.0))+dy*10));
        SetMousePos(0,mousey);
      END;
      GetMouseState(mousex,mousey,bleft,bright);
      dy:=((INTEGER(mousey)-ROUND(zoom*50.0)) DIV 10);
    ELSIF pos THEN
      GetMouseState(mousex,mousey,bleft,bright);
      dy:=((INTEGER(mousey)-ROUND(zoom*50.0)) DIV 10);
    END;
    IntMen.ZoomInt(actwin,zoom,dy);
  UNTIL (key=Enter) OR bleft;
  Grawin.NormalTick2;
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Window zoomed!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
  dispflag:=flag;
  pp:=Grawin.GetCurPos(actwin);
  RestoreMousePos;
  Grawin.SetMouseAtWinPos(actwin,pp.x,pp.y);

END ZoomWin;

PROCEDURE ResetWin(VAR actwin, objnum : CARDINAL);
BEGIN
  IntMen.ResetWin(actwin,objnum);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Window reseted!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END ResetWin;

PROCEDURE ObjectHandler(VAR actwin, objnum : CARDINAL);
VAR winnum : CARDINAL;

BEGIN
  (* IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END; *)
  IF Grawin.GetObjMaxPointNumber(actwin,objnum)<2 THEN
    Grawin.RefreshAllWins(TRUE);
    Grawin.ErrorTick();
    itext.t:=" !?! No points!";
    dontwriteinfo:=TRUE;
    Grawin.TextToWinTitle(actwin,itext);
    RETURN;
  END;

  DDD.MakeObjBackup(objnum);
  handleract:=TRUE;
  Handler.ObjectHandlerInt(actwin,objnum);
  FOR winnum:=xywin TO dddwin DO
     Grawin.SetWinScrollProc(winnum,ScrollWin);
     Grawin.SetWinZoomProc(winnum,ZoomWin);
  END;
  handleract:=FALSE;

  Grawin.RefreshAllWins(TRUE);
  (* Grawin.DrawWin(dddwin,actwin=dddwin); *)
  itext.t:=" Object handled!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
  setscenemenus; (* tricky *)
END ObjectHandler;

PROCEDURE Object(VAR actwin, objnum : CARDINAL);
VAR
    winnum, i : CARDINAL;
    key : CHAR;

BEGIN
  IF (rotstate<>inactive) OR (tubestate<>inactive) THEN
    FOR i:=1 TO 10 DO
      selab[i]:=FALSE;
    END;
    selab[ORD(move)]:=TRUE;
    selab[ORD(whereis)]:=TRUE;
    selab[ORD(objhandler)]:=TRUE;
  ELSE
    FOR i:=1 TO 10 DO
      selab[i]:=TRUE;
    END;
  END;

  keys[1]:="i";
  keys[2]:="n";
  keys[3]:="x";
  keys[4]:="r";
  keys[5]:="c";
  keys[6]:="m";
  keys[7]:="w";
  keys[8]:="a";
  keys[9]:="z";
  keys[10]:="y";

  DDD.CopyToLocalNames(objnames);
  key:=Grawin.WaitForKey(500);

  IF key='' THEN

    text[1].t:='Object-Function.';
    text[2].t:='Please choose: ';
    text[1].c:=Colors.ititlecol;
    text[2].c:=Colors.ipromptcol;

    Grawin.ShowInfoBox(10,10,2,text);

    Grawin.ColFromTo(text,Colors.itextcol,1,10);
    text[1].t:='Hide/show some objects......';
    text[2].t:='Create new object...........';
    text[3].t:='Destroy existing object.....';
    text[4].t:='Rename existing object......';
    text[5].t:='Copy actual object..........';
    text[6].t:='Move actual object..........';
    text[7].t:='Where is actual object......';
    text[8].t:='Select actual object........';
    text[9].t:='Interactiv object-handler...';
    text[10].t:='Yank objects together.......';

    i:=Grawin.ShowChooseBox(12,14,10,text,keys,selab,1);
    IF i>0 THEN key:=keys[i]; ELSE key:=''; END;
  END;

  CASE key OF
    'i' : IntMen.HideShowObjInt(obj);
          Grawin.RefreshAllWins(TRUE);
          itext.t:=" Hide/show done!";
          dontwriteinfo:=TRUE;
          Grawin.TextToWinTitle(actwin,itext);|
    'n' : CreateObj(actwin,obj); |
    'a' : SelectObj(actwin,obj); |
    'r' : IntMen.RenameObjInt(obj);
          DDD.CopyFromLocalNames(objnames);
          Grawin.RefreshAllWins(TRUE);
          itext.t:=" Object renamed!";
          dontwriteinfo:=TRUE;
          Grawin.TextToWinTitle(actwin,itext); |
    'x' : DestroyObj(actwin,obj); |
    'w' : DDD.ToggleWhere;
          DDD.ShowWhere(obj);
          Grawin.RefreshAllWins(TRUE);
          IF DDD.IsWhereOn() THEN
            itext.t:=" Whereframe on!";
          ELSE
            itext.t:=" Whereframe off!";
          END;
          dontwriteinfo:=TRUE;
          Grawin.TextToWinTitle(actwin,itext);|
    'm' : MoveObj(actwin,obj); |
    'z' : ObjectHandler(actwin,obj); |
    'y' : obj:=IntMen.YankObjsTogetherInt(obj);
          DDD.CopyFromLocalNames(objnames);
          Grawin.RefreshAllWins(TRUE);
          itext.t:=" Objects yanked!";
          dontwriteinfo:=TRUE;
          Grawin.TextToWinTitle(actwin,itext); |
    'c' : obj:=IntMen.CopyObjInt(obj);
          DDD.CopyFromLocalNames(objnames);
          Grawin.RefreshAllWins(TRUE);
          itext.t:=" Objects copied!";
          dontwriteinfo:=TRUE;
          Grawin.TextToWinTitle(actwin,itext); |
    ''  : Grawin.RefreshAllWins(TRUE);
  END;
END Object;

(* Define a rotation-body *)

PROCEDURE Rotdef(VAR actwin, objnum : CARDINAL);
VAR winnum : CARDINAL;
    c : CHAR;
    selected, i, max, ii : CARDINAL;
    col, nowcol : Grawin.RGB;
    x, y, xx, yy : INTEGER;
    poi: Grawin.Point;
    org : DDD.DCoord;
    pd : DDD.DPoint;
    pp : Grawin.Coord;
    angle, ymax, xmax : REAL;
    drawline : BOOLEAN;

BEGIN
  IF Grawin.InErrorState() THEN Error; RETURN; END;
  IF tubestate<>inactive THEN RETURN; END;
  IF rotstate=inactive THEN
    rotwin:=actwin;
    rotstate:=defpoints;

    lobj:=objnum;
    DDD.StoreObj(objnum);

    obj:=rotbuffobj;
    Grawin.SelectObj(rotbuffobj);
    HideAllObjects(actwin);

    DDD.CreateXYZObj(rotbuffobj);
    DDD.CreateDDDObj(rotbuffobj);
    Grawin.RefreshAllWins(TRUE);
    Grawin.FixAllWins;
    FOR winnum:=xywin TO yzwin DO
      Grawin.DeactivateWinMenItem(winnum,ORD(objlib3d));
(*      Grawin.DeactivateWinMenItem(winnum,ORD(tubebody)); *)
      Grawin.DeactivateWinMenItem(winnum,ORD(planeeye));
      Grawin.DeactivateWinMenItem(winnum,ORD(disk));
      Grawin.DeactivateWinMenItem(winnum,ORD(undo));
      Grawin.DeactivateWinMenItem(winnum,ORD(done));
    END;
    Grawin.DeactivateWinMenItem(dddwin,ORD(view));
    Grawin.DeactivateWinMenItem(dddwin,ORD(stereoview));
    RETURN;
  END;

  IF rotstate=defpoints THEN

    ShowAllObjects(rotwin);

    IF Grawin.GetObjPointNumber(rotwin,rotbuffobj)=0 THEN
      DDD.DestroyXYZObj(rotbuffobj);
      DDD.DestroyDDDObj(rotbuffobj);
      obj:=lobj;
      DDD.RestoreStObj(obj);
      Grawin.SelectObj(obj);
      rotstate:=inactive;
      Grawin.RefreshAllWins(TRUE);
      FOR winnum:=xywin TO dddwin DO
        FOR i:=1 TO Grawin.menitems DO
          Grawin.ActivateWinMenItem(winnum,i);
        END;
      END;
      Grawin.ReleaseAllWins;
      RETURN;
    END;

    angle:=0.0;

    text[1].t:="Rot-Body.";
    text[2].t:="Please choose:";
    text[1].c:=Colors.ititlecol;
    text[2].c:=Colors.ipromptcol;
    Grawin.ShowInfoBox(10,10,2,text);

    text[1].t:="Take as Radius...";
    text[2].t:="Take as Center...";
    Grawin.ColFromTo(text,Colors.itextcol,1,2);

    selected:=Grawin.ShowChooseBox(12,14,2,text,nokeys,alltrue,1);
    rotstate:=defshape;

    CASE selected OF
      1 : rotobjtype:=asradius; |
      2 : rotobjtype:=ascenter; |
    END;

    CASE actwin OF
      xywin : shapewin:=yzwin; |
      xzwin : shapewin:=yzwin; |
      yzwin : shapewin:=xzwin;
    END;

    actwin:=shapewin;

    obj:=shapebuffobj;
    HideAllObjects(actwin);
    Grawin.SelectObj(shapebuffobj);

    DDD.CreateXYZObj(shapebuffobj);
    DDD.CreateDDDObj(shapebuffobj);
    DDD.DontDrawXYZObj(rotbuffobj);
    Grawin.DontDrawObj(dddwin,rotbuffobj);

    FOR winnum:=xywin TO yzwin DO
      Grawin.DeactivateWinMenItem(winnum,ORD(colorpicker));
    END;

    Grawin.BringWinToFront(actwin);
    Grawin.RefreshAllWins(TRUE);

    RETURN;
  END;

  IF rotstate=defshape THEN
    org:=DDD.GiveObjMax(shapebuffobj);
    CASE shapewin OF
      xywin : xmax:=FLOAT(org.x); ymax:=FLOAT(org.y); |
      xzwin : xmax:=FLOAT(org.x); ymax:=FLOAT(org.z); |
      yzwin : xmax:=FLOAT(org.y); ymax:=FLOAT(org.z);
    END;

      obj:=IntMen.CreateObjInt(objnum,FALSE);
      DDD.CopyFromLocalNames(objnames);
      Grawin.SetObjPointNumber(rotwin,rotbuffobj,1);

      max:=Grawin.GetObjMaxPointNumber(shapewin,shapebuffobj);
      FOR i:=1 TO Grawin.GetObjMaxPointNumber(rotwin,rotbuffobj) DO
        poi:=Grawin.GetObjPoint(rotwin,rotbuffobj);
        x:=poi.x;
        y:=poi.y;
        col:=poi.col;
        drawline:=poi.drawline;
        Grawin.SetObjPointNumber(shapewin,shapebuffobj,1);

        FOR ii:=1 TO max DO
          poi:=Grawin.GetObjPoint(shapewin,shapebuffobj);
          xx:=poi.x;
          yy:=poi.y;
          pd.col:=col;
          pd.drawline:=(ii<>1);

          CASE rotobjtype OF
            asradius : CASE rotwin OF
                         xywin : pd.x:=x;
                                 pd.y:=ROUND(FLOAT(xx*y)/xmax);
                                 pd.z:=ROUND(FLOAT(yy*y)/ymax); |
                         xzwin : pd.x:=x;
                                 pd.y:=ROUND(FLOAT(xx*y)/xmax);
                                 pd.z:=ROUND(FLOAT(yy*y)/ymax); |
                         yzwin : pd.x:=ROUND(FLOAT(xx*y)/xmax);
                                 pd.y:=x;
                                 pd.z:=ROUND(FLOAT(yy*y)/ymax);
                        END; |
            ascenter : CASE rotwin OF
                         xywin : pd.x:=x;
                                 pd.y:=ROUND(FLOAT(xx)/xmax*10.0)+y;
                                 pd.z:=ROUND(FLOAT(yy)/ymax*10.0); |
                         xzwin : pd.x:=x;
                                 pd.y:=ROUND(FLOAT(xx)/xmax*10.0);
                                 pd.z:=ROUND(FLOAT(yy)/ymax*10.0)+y; |
                         yzwin : pd.x:=ROUND(FLOAT(xx)/xmax*10.0);
                                 pd.y:=x;
                                 pd.z:=ROUND(FLOAT(yy)/ymax*10.0)+y;
                       END;
          END;

          DDD.AddXYZObjPoint(obj,pd);
        END;
      END;

      Grawin.SetObjPointNumber(shapewin,shapebuffobj,1);
      max:=Grawin.GetObjMaxPointNumber(rotwin,rotbuffobj);

      FOR ii:=1 TO Grawin.GetObjMaxPointNumber(shapewin,shapebuffobj) DO
        poi:=Grawin.GetObjPoint(shapewin,shapebuffobj);
        xx:=poi.x;
        yy:=poi.y;

        Grawin.SetObjPointNumber(rotwin,rotbuffobj,1);

        FOR i:=1 TO max DO
          poi:=Grawin.GetObjPoint(rotwin,rotbuffobj);
          x:=poi.x;
          y:=poi.y;
          pd.col:=poi.col;
          pd.drawline:=poi.drawline AND (i<>1);

          CASE rotobjtype OF
            asradius : CASE rotwin OF
                         xywin : pd.x:=x;
                                 pd.y:=ROUND(FLOAT(xx*y)/xmax);
                                 pd.z:=ROUND(FLOAT(yy*y)/ymax); |
                         xzwin : pd.x:=x;
                                 pd.y:=ROUND(FLOAT(xx*y)/xmax);
                                 pd.z:=ROUND(FLOAT(yy*y)/ymax); |
                         yzwin : pd.x:=ROUND(FLOAT(xx*y)/xmax);
                                 pd.y:=x;
                                 pd.z:=ROUND(FLOAT(yy*y)/ymax);
                       END; |
            ascenter : CASE rotwin OF
                         xywin : pd.x:=x;
                                 pd.y:=ROUND(FLOAT(xx)/xmax*10.0)+y;
                                 pd.z:=ROUND(FLOAT(yy)/ymax*10.0); |
                         xzwin : pd.x:=x;
                                 pd.y:=ROUND(FLOAT(xx)/xmax*10.0);
                                 pd.z:=ROUND(FLOAT(yy)/ymax*10.0)+y; |
                         yzwin : pd.x:=ROUND(FLOAT(xx)/xmax*10.0);
                                 pd.y:=x;
                                 pd.z:=ROUND(FLOAT(yy)/ymax*10.0)+y;
                       END;
          END;

          DDD.AddXYZObjPoint(obj,pd);

        END;
      END;

      lastpoints:=Grawin.GetObjMaxPointNumber(rotwin,obj);
      rotstate:=inactive;
      DDD.ShowWhere(obj);
      ShowAllObjects(shapewin);
      DDD.DestroyXYZObj(rotbuffobj);
      DDD.DestroyDDDObj(rotbuffobj);
      DDD.DestroyXYZObj(shapebuffobj);
      DDD.DestroyDDDObj(shapebuffobj);
      DDD.AddNewDCoords(obj);
      Grawin.RefreshAllWins(TRUE);
      Grawin.ReleaseAllWins;
      FOR winnum:=xywin TO dddwin DO
        pp:=Grawin.GetWinOrg(winnum);
        Grawin.SetObjOrg(winnum,obj,pp.x,pp.y);
        FOR i:=1 TO Grawin.menitems DO
          Grawin.ActivateWinMenItem(winnum,i);
        END;
      END;

     itext.t:=" Rot-Body created!";
     dontwriteinfo:=TRUE;
     Grawin.TextToWinTitle(actwin,itext);


  END;
END Rotdef;

(* Define a tube-body (cable) *)

PROCEDURE Tubedef(VAR actwin, objnum : CARDINAL);
VAR n, j, winnum, m, s, i, ii : CARDINAL;
    col, nowcol : Grawin.RGB;
    poi, poi1, poi2 : Grawin.Point;
    apd, pd2, pd : ARRAY[5..7] OF Grawin.Coord;
    horwin, verwin : REAL;
    z, x, y, ymax, xmax : REAL;

BEGIN
  IF Grawin.InErrorState() THEN Error; RETURN; END;
  IF rotstate<>inactive THEN RETURN; END;
  IF tubestate=inactive THEN
    tubestate:=defpoints;

    lobj:=objnum;
    DDD.StoreObj(objnum);

    obj:=tubebuffobj;
    Grawin.SelectObj(tubebuffobj);

    HideAllObjects(actwin);

    DDD.CreateXYZObj(tubebuffobj);
    DDD.CreateDDDObj(tubebuffobj);
    Grawin.RefreshAllWins(TRUE);

    FOR winnum:=xywin TO yzwin DO
      Grawin.DeactivateWinMenItem(winnum,ORD(objlib3d));
      Grawin.DeactivateWinMenItem(winnum,ORD(planeeye));
      Grawin.DeactivateWinMenItem(winnum,ORD(disk));
      Grawin.DeactivateWinMenItem(winnum,ORD(undo));
      Grawin.DeactivateWinMenItem(winnum,ORD(done));
    END;
    Grawin.DeactivateWinMenItem(dddwin,ORD(view));
    Grawin.DeactivateWinMenItem(dddwin,ORD(stereoview));

    RETURN;
  END;

  IF tubestate=defpoints THEN
    IF Grawin.GetObjPointNumber(actwin,tubebuffobj)=0 THEN
      DDD.DestroyXYZObj(tubebuffobj);
      DDD.DestroyDDDObj(tubebuffobj);

      obj:=lobj;
      DDD.RestoreStObj(obj);
      Grawin.SelectObj(obj);
      tubestate:=inactive;

      FOR winnum:=xywin TO dddwin DO
        FOR i:=1 TO Grawin.menitems DO
          Grawin.ActivateWinMenItem(winnum,i);
        END;
        ShowAllObjects(winnum);
      END;
      Grawin.RefreshAllWins(TRUE);

      RETURN;
    END;
    tubestate:=defshape;
    actwin:=xywin;
    Grawin.BringWinToFront(actwin);
    Grawin.FixAllWins;
    obj:=shapebuffobj;

    shapewin:=xywin;

    Grawin.SelectObj(shapebuffobj);
    DDD.CreateXYZObj(shapebuffobj);
    DDD.CreateDDDObj(shapebuffobj);
    DDD.DontDrawXYZObj(tubebuffobj);
    Grawin.DontDrawObj(dddwin,tubebuffobj);
    Grawin.RefreshAllWins(TRUE);

    FOR winnum:=xywin TO yzwin DO
      Grawin.DeactivateWinMenItem(winnum,ORD(colorpicker));
    END;

    RETURN;
  END;

  IF tubestate=defshape THEN
    IF Grawin.GetObjPointNumber(shapewin,shapebuffobj)=0 THEN
      DDD.DestroyXYZObj(tubebuffobj);
      DDD.DestroyDDDObj(tubebuffobj);
      DDD.DestroyXYZObj(shapebuffobj);
      DDD.DestroyDDDObj(shapebuffobj);
      FOR winnum:=xywin TO dddwin DO
        FOR i:=1 TO Grawin.menitems DO
          Grawin.ActivateWinMenItem(winnum,i);
        END;
        ShowAllObjects(winnum);
      END;

      obj:=lobj;
      DDD.RestoreStObj(obj);
      Grawin.SelectObj(obj);
      tubestate:=inactive;
      Grawin.RefreshAllWins(TRUE);
      Grawin.ReleaseAllWins;
      RETURN;
    END;

    obj:=IntMen.CreateObjInt(objnum,FALSE);
    DDD.CopyFromLocalNames(objnames);

    FOR winnum:=xywin TO yzwin DO
      apd[winnum].x:=0;
      apd[winnum].y:=0;
    END;

    m:=Grawin.GetObjMaxPointNumber(xywin,tubebuffobj)+1;
    FOR i:=1 TO m DO
      IF i<>m THEN
        FOR winnum:=xywin TO yzwin DO
          Grawin.SetObjPointNumber(winnum,tubebuffobj,i);
          poi:=Grawin.GetObjPoint(winnum,tubebuffobj);
          pd2[winnum].x:=poi.x;
          pd2[winnum].y:=poi.y;
          pd[winnum].x:=poi.x-apd[winnum].x;
          pd[winnum].y:=poi.y-apd[winnum].y;
        END;
      END;

      DDD.CopyObjFromTo(shapebuffobj,temprotshape);

      horwin:=CalcAbsAngle(FLOAT(-pd[xywin].y),FLOAT(pd[xywin].x));
      verwin:=CalcAbsAngle(FLOAT(pd[yzwin].y),FLOAT(pd[xywin].x)*sin(horwin)/180.0*PI
                                            - FLOAT(pd[xywin].y)*cos(horwin)/180.0*PI);

      IF i>1 THEN

        DDD.XRot(verwin,temprotshape);
        DDD.ZRot(horwin,temprotshape);

        DDD.SetXYZObjPointNumber(temprotshape,1);

        FOR winnum:=xywin TO yzwin DO
          Grawin.SetObjPointNumber(winnum,temprotshape,1);
          FOR j:=1 TO Grawin.GetObjMaxPointNumber(shapewin,temprotshape) DO
            poi:=Grawin.GetObjPoint(winnum,temprotshape);
            nowcol:=poi.col;
            Grawin.AddObjPoint(winnum,obj,poi.x+apd[winnum].x,poi.y+apd[winnum].y,nowcol,poi.drawline);
          END;
        END;
      END;
      apd:=pd2;
      DDD.DestroyXYZObj(temprotshape);
    END;

    n:=Grawin.GetObjMaxPointNumber(xywin,shapebuffobj);
    m:=Grawin.GetObjMaxPointNumber(xywin,tubebuffobj);

    FOR winnum:=xywin TO yzwin DO
      i:=0;
      REPEAT
        INC(i);
        j:=0;
        REPEAT
          INC(j);
          Grawin.SetObjPointNumber(winnum,obj,j+(i-1)*n);
          poi1:=Grawin.GetObjPoint(winnum,obj);
          Grawin.SetObjPointNumber(winnum,obj,j+i*n);
          poi2:=Grawin.GetObjPoint(winnum,obj);
          Grawin.Reset;
          Grawin.AddObjPoint(winnum,obj,poi1.x,poi1.y,Colors.black,FALSE);
          Grawin.AddObjPoint(winnum,obj,poi2.x,poi2.y,poi2.col,poi2.drawline);
        UNTIL j=n;
      UNTIL i=m-1;
    END;

    lastpoints:=Grawin.GetObjMaxPointNumber(actwin,obj);
    tubestate:=inactive;

    DDD.ShowWhere(obj);
    DDD.AddNewDCoords(obj);
    ShowAllObjects(shapewin);

    DDD.DestroyXYZObj(tubebuffobj);
    DDD.DestroyDDDObj(tubebuffobj);
    DDD.DestroyXYZObj(shapebuffobj);
    DDD.DestroyDDDObj(shapebuffobj);
    Grawin.RefreshAllWins(TRUE);
    Grawin.ReleaseAllWins;

    FOR winnum:=xywin TO dddwin DO
      FOR i:=1 TO Grawin.menitems DO
        Grawin.ActivateWinMenItem(winnum,i);
      END;
    END;
  END;
  itext.t:=" Tube-Body created!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END Tubedef;


(* make a 3d-object outof a 2d-object, 3rd-thickness from 0 to depth *)

PROCEDURE Dimen(actwin, objnum, depth : CARDINAL);
VAR p : Grawin.Coord;
    poi: Grawin.Point;
    winnum, i, max : CARDINAL;

BEGIN
  max:=Grawin.GetObjMaxPointNumber(xywin,objnum);
  DDD.CreateXYZObj(tempobj1);
  DDD.CreateXYZObj(tempobj2);
  FOR winnum:=xywin TO yzwin DO
    Grawin.SetObjPointNumber(winnum,objnum,1);
    FOR i:=1 TO max DO
      poi:=Grawin.GetObjPoint(winnum,objnum);
      Grawin.AddObjPoint(winnum,tempobj2,poi.x,poi.y,poi.col,FALSE);
      IF (actwin=xywin) THEN
        IF (winnum=xzwin) OR (winnum=yzwin) THEN
          poi.y:=poi.y+INTEGER(depth);
        END;
      END;
      IF (actwin=xzwin) THEN
        IF (winnum=xywin) THEN
          poi.y:=poi.y+INTEGER(depth);
        END;
        IF (winnum=yzwin) THEN
          poi.x:=poi.x+INTEGER(depth);
        END;
      END;
      IF (actwin=yzwin) THEN
        IF (winnum=xywin) OR (winnum=xzwin) THEN
          poi.x:=poi.x+INTEGER(depth);
        END;
      END;
      Grawin.AddObjPoint(winnum,tempobj1,poi.x,poi.y,poi.col,poi.drawline);
      Grawin.AddObjPoint(winnum,tempobj2,poi.x,poi.y,poi.col,poi.drawline);
    END;
  END;

  FOR winnum:=xywin TO yzwin DO
    Grawin.SetObjPointNumber(winnum,tempobj1,1);
    FOR i:=1 TO max DO
      poi:=Grawin.GetObjPoint(winnum,tempobj1);
      IF i=1 THEN poi.drawline:=FALSE; END;
      Grawin.AddObjPoint(winnum,objnum,poi.x,poi.y,poi.col,poi.drawline);
     END;
   END;
  FOR winnum:=xywin TO yzwin DO
    Grawin.SetObjPointNumber(winnum,tempobj2,1);
    FOR i:=1 TO 2*max DO
      poi:=Grawin.GetObjPoint(winnum,tempobj2);
      IF i=1 THEN poi.drawline:=FALSE; END;
      Grawin.AddObjPoint(winnum,objnum,poi.x,poi.y,poi.col,poi.drawline);
     END;
  END;

  DDD.DestroyXYZObj(tempobj1);
  DDD.DestroyXYZObj(tempobj2);
  DDD.ClearDDDObj(objnum);
  DDD.AddNewDCoords(objnum);
  DDD.ShowWhere(objnum);
END Dimen;

(* Menu-option OPERATIONS was selected *)

PROCEDURE Operate(VAR actwin, objnum : CARDINAL);
VAR
    max, i, selected : CARDINAL;
    key : CHAR;

BEGIN
  IF Grawin.InErrorState() THEN Error; RETURN; END;
  UseDefault;

  FOR i:=1 TO 8 DO
    selab[i]:=TRUE;
  END;
  IF (rotstate<>inactive) THEN
    selab[8]:=FALSE;
  END;
  IF (tubestate<>inactive) THEN
    selab[7]:=FALSE;
  END;

  keys[1]:="s";
  keys[2]:="r";
  keys[3]:="m";
  keys[4]:="d";
  keys[5]:="3";
  keys[6]:="2";
  keys[7]:="a";
  keys[8]:="b";

  key:=Grawin.WaitForKey(500);

  CASE key OF
    's' : selected:=1; |
    'r' : selected:=2; |
    'm' : selected:=3; |
    'd' : selected:=4; |
    '3' : selected:=5; |
    '2' : selected:=6; |
    'a' : selected:=7; |
    'b' : selected:=8;
  ELSE
    text[1].t:="Operations.";
    text[2].t:="Please choose:";
    text[1].c:=Colors.ititlecol;
    text[2].c:=Colors.ipromptcol;
    Grawin.ShowInfoBox(10,10,2,text);

    text[1].t:="Scale.........";
    text[2].t:="Rotate........";
    text[3].t:="Mirror........";
    text[4].t:="3delize.......";
    text[5].t:="3D-B-Spline...";
    text[6].t:="2D-B-Spline...";
    text[7].t:="Rot-body......";
    text[8].t:="Tube-body.....";
    Grawin.ColFromTo(text,Colors.itextcol,1,8);

    selected:=Grawin.ShowChooseBox(12,14,8,text,keys,selab,1);
  END;

  CASE selected OF
    1 : Scale(actwin,objnum); |
    2 : Rotate(actwin,objnum); |
    3 : Mirror(actwin,objnum); |
    4 : DDD.MakeObjBackup(objnum);
        text[1].t:="3delize Object.";
        text[2].t:="Please enter:";
        text[1].c:=Colors.ititlecol;
        text[2].c:=Colors.ipromptcol;
        Grawin.ShowInfoBox(31,14,2,text);

        text[1].t:="Enter DEPTH of ";
        text[2].t:="body: ";
        text[3].t:="";
        text[1].c:=Colors.ipromptcol;
        text[2].c:=Colors.ipromptcol;
        text[3].c:=Colors.ientercol;
        REPEAT
          i:=20;
          Grawin.ShowInfoBox(33,18,3,text);
          ReadCard(i);
        UNTIL Done;
        Dimen(actwin,objnum,i);
        Grawin.RefreshAllWins(TRUE);
        itext.t:=" Object 3delized!";
        dontwriteinfo:=TRUE;
        Grawin.TextToWinTitle(actwin,itext); |
    5 : max:=Grawin.GetObjMaxPointNumber(actwin,objnum);
        IF max>3 THEN
          DDD.MakeObjBackup(objnum);
          text[1].t:="Create 3D-B-Spline.";
          text[2].t:="Please enter:";
          text[1].c:=Colors.ititlecol;
          text[2].c:=Colors.ipromptcol;
          Grawin.ShowInfoBox(31,14,2,text);

          text[1].t:="Enter granularity of ";
          text[2].t:="3D-B-Spline: ";
          text[3].t:="";
          text[1].c:=Colors.ipromptcol;
          text[2].c:=Colors.ipromptcol;
          text[3].c:=Colors.ientercol;
          REPEAT
            i:=4;
            Grawin.ShowInfoBox(33,18,3,text);
            ReadCard(i);
          UNTIL Done;
          BSpline3D(max,i);
        ELSE
          Grawin.RefreshAllWins(TRUE);
          Grawin.ErrorTick();
          itext.t:=" !?! Not enough points!";
          dontwriteinfo:=TRUE;
          Grawin.TextToWinTitle(actwin,itext);
        END; |
    6 : max:=Grawin.GetObjMaxPointNumber(actwin,objnum);
        IF max>3 THEN
          DDD.MakeObjBackup(objnum);
          text[1].t:="Create 2D-B-Spline.";
          text[2].t:="Please enter:";
          text[1].c:=Colors.ititlecol;
          text[2].c:=Colors.ipromptcol;
          Grawin.ShowInfoBox(31,14,2,text);

          text[1].t:="Enter granularity of ";
          text[2].t:="2D-B-Spline: ";
          text[3].t:="";
          text[1].c:=Colors.ipromptcol;
          text[2].c:=Colors.ipromptcol;
          text[3].c:=Colors.ientercol;
          REPEAT
            i:=4;
            Grawin.ShowInfoBox(33,18,3,text);
            ReadCard(i);
          UNTIL Done;
          BSpline2D(max,i);
        ELSE
          Grawin.RefreshAllWins(TRUE);
          Grawin.ErrorTick();
          itext.t:=" !?! Not enough points!";
          dontwriteinfo:=TRUE;
          Grawin.TextToWinTitle(actwin,itext);
        END; |
    7 : Rotdef(actwin,objnum); |
    8 : Tubedef(actwin,objnum);
  ELSE
    Grawin.RefreshAllWins(TRUE);
  END;
END Operate;

(* Object-viewer choosen *)

PROCEDURE View(VAR actwin, objnum : CARDINAL);

BEGIN
  IF Grawin.InErrorState() THEN Error; RETURN; END;
  IF (rotstate<>inactive) AND (tubestate<>inactive) THEN RETURN; END;
  ObjView.View(objnum,FALSE);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Viewer done!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END View;

(* 3D-stereo-object-viewer choosen *)

PROCEDURE View3D(VAR actwin, objnum : CARDINAL);
BEGIN
  IF Grawin.InErrorState() THEN Error; RETURN; END;
  IF (rotstate<>inactive) AND (tubestate<>inactive) THEN RETURN; END;
  ObjView.View(objnum,TRUE);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Viewer done!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END View3D;

(* Show the helppage *)

PROCEDURE Helppages(VAR actwin, objnum : CARDINAL);
VAR
   c : CHAR;
   selected, i : CARDINAL;

BEGIN

  selected:=1;
  REPEAT

    text[1].t:="Helppages.";
    text[2].t:="Please choose:";
    text[1].c:=Colors.ititlecol;
    text[2].c:=Colors.ipromptcol;
    Grawin.ShowInfoBox(10,10,2,text);

    text[1].t:="Mouse- or keyboard-handling";
    text[2].t:="Menus & bindkeys";
    text[3].t:="Windowhandling";

    Grawin.ColFromTo(text,Colors.itextcol,1,3);
    selected:=Grawin.ShowChooseBox(12,14,3,text,nokeys,alltrue,selected);

    CASE selected OF
      1 : Grawin.ColFromTo(text,Colors.ipromptcol,3,25);
          text[1].t:=" How to use the scene-editor with the mouse or keyboard _____________ ";
          text[1].c:=Colors.ititlecol;
          text[2].t:=" ____________________________________________________________________ ";
          text[2].c:=Colors.ialacol;
          text[3].t:=" CURSORKEYS (+/- ALT) | MOUSE             = Move the cursor!";
          text[4].t:=" SPACE | LEFT MOUSEBUTTON, pressed short  = Set point in actual color";
          text[5].t:=" s     | LEFT MOUSEBUTTON, pressed longer = Set invisible point";
          text[6].t:=" d     | RIGHT MOUSEBUTTON, pressed short = Delete last point(s)";
            
          text[7].t:=" Following functions can only be selected by keyboard: ________________ ";
          text[7].c:=Colors.ialacol;
            
          text[8].t:=" . = Show all points of current object ";
          text[9].t:=" o = Set cursor to window-origin";
          text[10].t:=" O = Set cursor to object-origin";
          text[11].t:=" + = Turn cursor-position-display on/off";
          text[12].t:=" * = Toggel between relative and absolute cursor-cordinates";
          text[13].t:=" # = Turn snap-mode on/off";
          text[14].t:=" n = Select next object and show frame-box";
          text[15].t:=" p = Select previous object and show frame-box";
          text[16].t:=" m = Toggel between add-cursor and change-cursor";
            
          text[17].t:=" ____________________________________________________________________ ";
          text[17].c:=Colors.ialacol;
            
          text[18].t:=" Add-cursor (little cross) lets you add new points, the change-cursor";
          text[19].c:=Colors.itextcol;
          text[19].t:=" (little box) lets you change a point, that you've selected first. ";
          text[19].c:=Colors.itextcol;
          text[20].t:=" If the change-point-cursor is activated, the following keys have ";
          text[20].c:=Colors.itextcol;
          text[21].t:=" other functions:";
          text[21].c:=Colors.itextcol;
          text[22].t:=" SPACE | LEFT MOUSEBUTTON, pressed short  = Select a point";
          text[23].t:=" SPACE | LEFT MOUSEBUTTON, pressed short  = Change a selected point";
          text[24].t:=" s     | LEFT MOUSEBUTTON, pressed longer =          ''";
          text[25].t:=" d     | RIGHT MOUSEBUTTON, pressed short = Delete selected point";

          Grawin.ShowInfoBox(4,2,25,text); |

      2 : Grawin.ColFromTo(text,Colors.ipromptcol,1,9);
          Grawin.ColFromTo(text,Colors.ipromptcol,24,27);
          Grawin.ColFromTo(text,Colors.itextcol,10,23);

          text[1].t:=" How to use scene-editor's menus and bindkeys ____________________ ";
          text[1].c:=Colors.ititlecol;
          text[2].t:=" _________________________________________________________________ ";
          text[2].c:=Colors.ialacol;
          text[3].t:=" ENTER | RIGHT MOUSEBUTTON = Window's menu pops up";
          text[4].t:=" ALT <key>, <key>...       = Call menu-item directly";
          text[5].t:=" When the window's menu poped up, you can use:";
          text[5].c:=Colors.itextcol;
          text[6].t:=" SPACE      | RIGHT MOUSEBUTTON    = Toggle between menu-pages";
          text[7].t:=" CURSORKEYS | MOUSE UP, MOUSE DOWN = Choose one menu-items";
          text[8].t:=" ENTER      | LEFT MOUSEBUTTON     = Activate menu-item!";
          text[9].t:=" ESC                               = Quit window's menu";
          text[10].t:="__________________________________________________________________ ";
          text[10].c:=Colors.ialacol;
          text[11].t:=" Menuitems can be activated as described above, but there is also";
          text[12].t:=" a faster method: use the bindkeys!  Each bindkeys lets you acti-";
          text[13].t:=" vate the item directly without opening the menu-pages.  You have";
          text[14].t:=" to press ALT and the listed bindkey. For example, if you want to";
          text[15].t:=" create a new object, you first press ALT f, then (quickly) n.";
          text[16].t:=" If you wait to long for the second key, a choosebox will pop up;";
          text[17].t:=" bindkeys are also listed.  ATTENTION: choosebox-bindkeys are NOT";
          text[18].t:=" activated with ALT and key, press simply the key that is listed.";
          text[19].t:=" If choosebox has poped-up,  you also have to confirm with ENTER.";
          text[20].t:=" You need not press ENTER if you press the  second key BEFORE the";
          text[21].t:=" box pops up.  Other example: press ALT u to undo last operation.";
          text[22].t:="__________________________________________________________________ ";
          text[22].c:=Colors.ialacol;
          text[23].t:=" When a choose-box pops up, you can use:";
          text[23].c:=Colors.itextcol;
          text[24].t:=" ESC | RIGHT MOUSEBUTTON           = Quit choose-box";
          text[25].t:=" CURSORKEYS | MOUSE UP, MOUSE DOWN = Choose one choose-box-item";
          text[26].t:=" ENTER      | LEFT MOUSEBUTTON     = Activate choose-box-item!";
          text[27].t:=" <listed bindkey>                  = Choose item with that bindkey";
          Grawin.ShowInfoBox(4,1,27,text); |

      3 : Grawin.ColFromTo(text,Colors.ipromptcol,3,19);
          text[1].t:=" How to manage the windows __________________________________________";
          text[1].c:=Colors.ititlecol;
          text[2].t:=" ____________________________________________________________________";
          text[2].c:=Colors.ialacol;
          text[3].t:=" ENTER | RIGHT MOUSEBUTTON, pressed longer = Window's menu pops up";
          text[4].t:=" ALT <key>, <key>...                     = Call menu-item directly";
          text[5].t:=" When the window's menu poped up, you can use:";
          text[5].c:=Colors.itextcol;
          text[6].t:=" SPACE      | RIGHT MOUSEBUTTON    = Toggle between menu-pages";
          text[7].t:=" CURSORKEYS | MOUSE UP, MOUSE DOWN = Choose on menu-items";
          text[8].t:=" ENTER      | LEFT MOUSEBUTTON     = Activate menu-item!";
          text[9].t:=" ESC                               = Quit window's menu";
          text[10].t:="_____________________________________________________________________";
          text[10].c:=Colors.ialacol;
          text[11].t:=" TAB  = Bring next window in window-list to front, cycling";
          text[12].t:=" 0..9 = Bring window with pressed number-key to front ";
          text[13].t:=" F1   = Move window with MOUSE | CURSORKEYS, SPACE, R. MB, ENTER";
          text[14].t:=" F2   = Size window with MOUSE | CURSORKEYS, SPACE, R. MB, ENTER";
          text[15].t:=" F3   = Refresh all windows";
          text[16].t:=" F4   = Clean up desktop, bring all windows to their inital-position";
          text[17].t:=" F5   = Zoom   window's contents with MOUSE | CURSORK., ENTER, R. MB";
          text[18].t:=" F6   = Scroll window's contents with MOUSE | CURSORK., ENTER, R. MB";
          text[19].t:=" HOM  = Reset current window";
          Grawin.ShowInfoBox(4,6,19,text);
    END;

    IF selected<>0 THEN
      WaitForAnything;
    END;
    Grawin.RefreshAllWins(TRUE);
  UNTIL selected=0;

  itext.t:=" Helppages shown!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);

END Helppages;

PROCEDURE Preferences(VAR actwin, objnum : CARDINAL);
VAR selected : CARDINAL;
BEGIN

  UseDefault;
  text[1].t:="Preferences.";
  text[2].t:="Please choose:";
  text[1].c:=Colors.ititlecol;
  text[2].c:=Colors.ipromptcol;

  Grawin.ShowInfoBox(10,10,2,text);

  text[1].t:="Change Colors.......";
  text[2].t:="Change Gridstep.....";
  text[3].t:="Change Cursorstep...";
  Grawin.ColFromTo(text,Colors.itextcol,1,3);

  selected:=Grawin.ShowChooseBox(12,14,3,text,nokeys,alltrue,1);
  text[1].c:=Colors.ititlecol;
  text[2].c:=Colors.ipromptcol;
  text[3].c:=Colors.ipromptcol;

  CASE selected OF
    1 : IntMen.ChangeColorsInt(actwin,objnum);
        Grawin.RefreshAllWins(TRUE);
        itext.t:=" Colors changed!";
        dontwriteinfo:=TRUE;
        Grawin.TextToWinTitle(actwin,itext); |
    2 : text[1].t:="Change Gridstep.";
        text[2].t:="Please enter new";
        text[3].t:="gridstep: ";
        REPEAT
          Grawin.ShowInfoBox(37,14,3,text);
          ReadCard(gridstep);
        UNTIL Done AND (gridstep>=5);
        Grawin.RefreshAllWins(TRUE);
        itext.t:=" Gridstep changed!";
        dontwriteinfo:=TRUE;
        Grawin.TextToWinTitle(actwin,itext);|
    3 : text[1].t:="Change Cursorstep.";
        text[2].t:="Please enter new";
        text[3].t:="cursorstep: ";
        REPEAT
          Grawin.ShowInfoBox(37,14,3,text);
          ReadCard(cursorstep);
        UNTIL Done AND (cursorstep>=5);
        Grawin.SetCursorstep(cursorstep);
        Grawin.RefreshAllWins(TRUE);
        itext.t:=" Cursorstep changed!";
        dontwriteinfo:=TRUE;
        Grawin.TextToWinTitle(actwin,itext);
  ELSE
    Grawin.RefreshAllWins(TRUE);
  END;
END Preferences;

(* Color-Box choosen *)

PROCEDURE TakeIt(col : Grawin.RGB; state : CARDINAL);
BEGIN
  actcol:=col;
END TakeIt;

PROCEDURE Color(VAR actwin, objnum : CARDINAL);

VAR pp : Grawin.Coord;

BEGIN
  pp:=Grawin.GetWinPos(actwin);
  Guitool.ColorPicker(pp.x+1,pp.y+1,0,TakeIt);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Color picked!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END Color;

(* Set eyeposition *)

PROCEDURE AdjustEye(VAR actwin, objnum : CARDINAL);
VAR i : CARDINAL;
    pd : DDD.DCoord;

BEGIN
  IF Grawin.InErrorState() THEN Error; RETURN; END;
  IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END;
  pd.x:=a[xywin].x;
  pd.y:=a[xywin].y;
  pd.z:=a[yzwin].y;
  DDD.SetEyePos(pd);

  FOR i:=firstobj TO lastobj DO
    IF DDD.IsAName(objnames[i]) THEN
      DDD.CalcNewDCoords(i);
    END;
  END;
  DDD.AdjustDCross(dddwin,crossobj,gridstep);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Eyeposition changed!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END AdjustEye;

(* Set projection-plane *)

PROCEDURE AdjustPlane(VAR actwin, objnum : CARDINAL);
VAR i : CARDINAL;

BEGIN
  IF Grawin.InErrorState() THEN Error; RETURN; END;
  IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END;
  DDD.SetPlaneDist(a[yzwin].y);
  FOR i:=firstobj TO lastobj DO
    IF DDD.IsAName(objnames[i]) THEN
      DDD.CalcNewDCoords(i);
    END;
  END;
  DDD.AdjustDCross(dddwin,crossobj,gridstep);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Planedistance changed!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END AdjustPlane;

(* Menu plane&eye *)

PROCEDURE PlaneEye(VAR actwin, objnum : CARDINAL);
VAR selected : CARDINAL;
    key  : CHAR;
BEGIN
  IF Grawin.InErrorState() THEN Error; RETURN; END;
  IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END;

  keys[1]:="e";
  keys[2]:="p";
  key:=Grawin.WaitForKey(500);
  CASE key OF
    'e' : selected:=1; |
    'p' : selected:=2;
  ELSE
    text[1].t:="Plane & Eye.";
    text[2].t:="Please choose:";
    text[1].c:=Colors.ititlecol;
    text[2].c:=Colors.ipromptcol;
    Grawin.ShowInfoBox(10,10,2,text);

    text[1].t:="Place eye at actual cursorposition....";
    text[2].t:="Place projection-plane at z-cur.pos...";
    text[1].c:=Colors.itextcol;
    text[2].c:=Colors.itextcol;
    selected:=Grawin.ShowChooseBox(12,14,2,text,keys,alltrue,1);
  END;

  CASE selected OF
    1 : AdjustEye(actwin,objnum); |
    2 : AdjustPlane(actwin,objnum);
  ELSE
    Grawin.RefreshAllWins(TRUE);
  END;
END PlaneEye;

(* Back to world-editor *)

PROCEDURE SceneDone(VAR actwin, objnum : CARDINAL);

BEGIN
  IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END;
  IF Grawin.InErrorState() THEN Error; RETURN; END;
  scenedone:=TRUE;
END SceneDone;

(* Lay grid *)

PROCEDURE Grid(VAR actwin, objnum : CARDINAL);
BEGIN
  gridflag:=NOT(gridflag);
  Grawin.RefreshAllWins(TRUE);
  IF gridflag THEN
    itext.t:=" Grid on!";
  ELSE
    itext.t:=" Grid off!";
  END;
  Grawin.TextToWinTitle(actwin,itext);
  dontwriteinfo:=TRUE;
END Grid;

(* Save and load to/from disk *)

PROCEDURE DiskFunc(VAR actwin, objnum : CARDINAL);

VAR name, name2 : Grawin.LString;
    a : INTEGER;
    p, pp : Grawin.Coord;
    winnum, i, ii, x, y, n : CARDINAL;
    r : REAL;
    fn : PathTail;
    key : CHAR;
    flag : BOOLEAN;

BEGIN

  IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END;

  DDD.CopyToLocalNames(objnames);

  keys[1]:="s";
  keys[2]:="l";
  keys[3]:="e";
  keys[4]:="o";
  keys[5]:="t";
  keys[6]:="d";

  key:=Grawin.WaitForKey(500);
  CASE key OF
    's' : i:=1; |
    'l' : i:=2; |
    'e' : i:=3; |
    'o' : i:=4; |
    't' : i:=5; |
    'd' : i:=6;
  ELSE
    text[1].t:='Disk-Function';
    text[2].t:='Please choose: ';
    text[1].c:=Colors.ititlecol;
    text[2].c:=Colors.ipromptcol;

    Grawin.ShowInfoBox(10,10,2,text);
    Grawin.ColFromTo(text,Colors.itextcol,1,6);

    text[1].t:='Save Scene.........';
    text[2].t:='Load Scene.........';
    text[3].t:='Save Object........';
    text[4].t:='Load Object........';
    text[5].t:='TeX-Output.........';
    text[6].t:='Show Directory.....';

    i:=Grawin.ShowChooseBox(12,14,6,text,keys,alltrue,1);
  END;

  IF i=0 THEN
    DDD.RestoreStObj(objnum);
    Grawin.RefreshAllWins(TRUE);
    RETURN;
  END;

  IF i=5 THEN
    text[1].t:='Save TeX-File.';
    text[2].t:='Please choose:';
    text[1].c:=Colors.ititlecol;
    text[1].c:=Colors.ipromptcol;
    Grawin.ShowInfoBox(10,10,2,text);

    Grawin.ColFromTo(text,Colors.itextcol,1,4);
    text[1].t:='XY-Window...';
    text[2].t:='XZ-Window...';
    text[3].t:='YZ-Window...';
    text[4].t:='3D-Window...';

    ii:=Grawin.ShowChooseBox(12,14,4,text,nokeys,alltrue,1);
    IF ii=0 THEN Grawin.RefreshAllWins(TRUE); RETURN; END;
  END;

  IF (i=1) OR (i=3) OR (i=5) THEN
    DDD.StoreObj(objnum);
    text[1].t:="Please enter file-  ";
    text[2].t:="name:               ";
    text[3].t:="";
    text[1].c:=Colors.ipromptcol;
    text[2].c:=Colors.ipromptcol;
    text[3].c:=Colors.ientercol;

    REPEAT
      Grawin.ShowInfoBox(12,14,3,text);
      ReadString(fn);
      IF fn[1]='' THEN DDD.RestoreStObj(objnum); Grawin.RefreshAllWins(TRUE); RETURN; END;
    UNTIL Done AND (Length(fn)<9);
  ELSE
    IF i=2 THEN fn:=Guitool.PickFile("sce"); END;
    IF i=4 THEN fn:=Guitool.PickFile("obj"); END;
    IF ((i=2) OR (i=4)) AND (fn[1]="") THEN
      DDD.RestoreStObj(objnum);
      Grawin.RefreshAllWins(TRUE); RETURN;
    END;
  END;

  CASE i OF
    1 : Disk.SaveStObjects(fn,'sce');
        FOR winnum:=xywin TO dddwin DO

          pp:=Grawin.GetWinPos(winnum);
          Disk.Write2DCoord(pp);

          pp:=Grawin.GetWinSize(winnum);
          Disk.Write2DCoord(pp);

          pp:=Grawin.GetWinOrg(winnum);
          Disk.Write2DCoord(pp);

          r:=Grawin.GetWinZoom(winnum);
          InOut.WriteInt(ROUND(r*1000.0),1); InOut.WriteLn;
        END;

        Grawin.Reset;
        InOut.CloseOutput;
        Grawin.RefreshAllWins(TRUE);
        itext.t:=" Scene saved!";
        Grawin.TextToWinTitle(actwin,itext);
        dontwriteinfo:=TRUE; |

    2 : IF Disk.LoadStObjects(fn,'sce') THEN
          FOR winnum:=xywin TO dddwin DO

            Disk.Read2DCoord(p);
            Disk.Read2DCoord(pp);

            Grawin.SetWinPos(winnum,p.x,p.y,FALSE);
            Grawin.SetWinSize(winnum,pp.x,pp.y,FALSE);

            Disk.Read2DCoord(pp);
            Grawin.SetWinOrg(winnum,pp.x,pp.y);

            InOut.ReadInt(a);
            Grawin.SetWinZoom(winnum,FLOAT(a)/1000.0);
          END;
        END;

        Grawin.Reset;
        InOut.CloseInput;
        DDD.CopyFromLocalNames(objnames);
        Grawin.RefreshAllWins(TRUE);
        itext.t:=" Scene loaded!";
        Grawin.TextToWinTitle(actwin,itext);
        dontwriteinfo:=TRUE;|

    3 : Disk.SaveStObject(objnum,fn,"obj");
        Grawin.RefreshAllWins(TRUE);
        itext.t:=" Object saved!";
        Grawin.TextToWinTitle(actwin,itext);
        dontwriteinfo:=TRUE;|

    4 : flag:=Disk.LoadStObject(objnum,fn,"obj");
        DDD.CopyFromLocalNames(objnames);
        Grawin.RefreshAllWins(TRUE);
        itext.t:=" Object loaded!";
        Grawin.TextToWinTitle(actwin,itext);
        dontwriteinfo:=TRUE;|

    5 : text[1].t:="Please enter";
        text[2].t:="TeX-x-picture-";
        text[3].t:="size: ";
        Grawin.ColFromTo(text,Colors.ipromptcol,1,3);
        REPEAT
          x:=100;
          Grawin.ShowInfoBox(12,14,3,text);
          ReadCard(x);
        UNTIL Done AND (x>0);
        text[2].t:="TeX-y-picture-";
        REPEAT
          y:=80;
          Grawin.ShowInfoBox(12,14,3,text);
          ReadCard(y);
        UNTIL Done AND (y>0);
        CASE ii OF
          1 : Disk.TexOutput(fn,'pic',x,y,xywin); |
          2 : Disk.TexOutput(fn,'pic',x,y,xzwin); |
          3 : Disk.TexOutput(fn,'pic',x,y,yzwin); |
          4 : Disk.TexOutput(fn,'pic',x,y,dddwin);
        END;
        Grawin.RefreshAllWins(TRUE);
        itext.t:=" TeX-file generated!";
        Grawin.TextToWinTitle(actwin,itext);
        dontwriteinfo:=TRUE;|

    6 : Guitool.ShowDir("*");
        Grawin.RefreshAllWins(TRUE);
        itext.t:=" Directory shown!";
        Grawin.TextToWinTitle(actwin,itext);
        dontwriteinfo:=TRUE;
  ELSE
    Grawin.RefreshAllWins(TRUE);
  END;

  IF i=2 THEN
    DDD.RestoreStObj(objnum);
    DDD.DestroyStObj(objnum);
  ELSE
    DDD.RestoreStObj(objnum);
  END;
  
END DiskFunc;

(* Object-libary for 3D-objects *)

PROCEDURE Obj3Dlib(VAR actwin, objnum : CARDINAL);

TYPE objects = (nil, ellipsoid, semiellipsoid, cylinder, pyramid, spindle,
                     toroid, quader);

VAR p : Grawin.Point;
    a, b : Grawin.Coord;
    step1, h, step2,  rcx, rcy, rcz, winnum, i, sections, sections1, sections2, teta, phi : CARDINAL;
    segment1, segment2, m1 : CARDINAL;
    curpos, p1, p2, p3, p4 : DDD.DCoord;
    r, tetasin, x,y,phisin, tetacos, phicos, rx, ry, rz, verwin, horwin, horwin2 : REAL;
    sc, rx1, ry1, rx2, ry2 : REAL;
    phisin2, phicos2 : REAL;
    key : CHAR;

BEGIN
  IF Grawin.InErrorState() THEN Error; RETURN; END;
  IF (rotstate<>inactive) OR (tubestate<>inactive) THEN RETURN; END;
  DDD.MakeObjBackup(objnum);
  UseDefault;
  itext.t:="";
  m1:=Grawin.GetObjMaxPointNumber(xywin,objnum);

  keys[ORD(ellipsoid)]:="e";
  keys[ORD(semiellipsoid)]:="i";
  keys[ORD(cylinder)]:="c";
  keys[ORD(pyramid)]:="p";
  keys[ORD(spindle)]:="c";
  keys[ORD(toroid)]:="t";
  keys[ORD(quader)]:="q";

  key:=Grawin.WaitForKey(500);
  CASE key OF
    'e' : i:=1; |
    'i' : i:=2; |
    'c' : i:=3; |
    'p' : i:=4; |
    's' : i:=5; |
    't' : i:=6; |
    'q' : i:=7;
  ELSE

    text[1].t:="3D-Object-Library.";
    text[2].t:="Please choose:    ";
    text[1].c:=Colors.ititlecol;
    text[2].c:=Colors.ipromptcol;
    Grawin.ShowInfoBox(10,10,2,text);

    Grawin.ColFromTo(text,Colors.itextcol,1,7);
    text[ORD(ellipsoid)    ].t:="Ellipsoid........";
    text[ORD(semiellipsoid)].t:="Semi-Ellipsoid...";
    text[ORD(cylinder)     ].t:="Cylinder.........";
    text[ORD(pyramid)      ].t:="Pyramid..........";
    text[ORD(spindle)      ].t:="Spindle..........";
    text[ORD(toroid)       ].t:="Toroid...........";
    text[ORD(quader)       ].t:="Quader...........";

    i:=Grawin.ShowChooseBox(12,14,7,text,keys,alltrue,1);
  END;

  Grawin.ColFromTo(text,Colors.ipromptcol,1,3);
  text[4].c:=Colors.ientercol;

  CASE i OF
    ORD(ellipsoid) :
    text[1].t:="Please enter";
    text[2].t:="x-radius of";
    text[3].t:="ellipsoid:";
    text[4].t:="";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(rx,"30.0");
    UNTIL Done;
    text[2].t:="y-radius of";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(ry,"30.0");
    UNTIL Done;
    text[2].t:="z-radius of";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(rz,"30.0");
    UNTIL Done;
    text[2].t:="1. granularity";

    REPEAT
      sections1:=6;
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(sections1);
    UNTIL Done AND ((180 MOD sections1) = 0);

    REPEAT
      sections2:=12;
      text[2].t:="2. granularity";
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(sections2);
    UNTIL Done AND ((360 MOD sections2) = 0);

    step1:=180 DIV sections1;
    step2:=360 DIV sections2;
    teta:=0;

    REPEAT

      tetasin:=sin((FLOAT(teta)-0.0)/360.0 * 2.0 * PI);
      tetacos:=cos((FLOAT(teta)-0.0)/360.0 * 2.0 * PI);
      phi:=0;
      REPEAT

        horwin:=FLOAT(phi)/360.0 * 2.0 * PI;

        FOR winnum:=xywin TO yzwin DO
          p1.x:=ROUND(cos(horwin)*tetasin*rx);
          p1.y:=ROUND(sin(horwin)*tetasin*ry);

          p1.z:=ROUND(tetacos*rz);
          a:=DDD.GiveXY(winnum,p1);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,phi<>0);
        END;
        phi:=phi+step2;
      UNTIL phi=360+step2;
      teta:=teta+step1;
    UNTIL teta=180;

    phi:=0;
    REPEAT

      phisin:=sin((FLOAT(phi)-0.0)/360.0 * 2.0 * PI);
      phicos:=cos((FLOAT(phi)-0.0)/360.0 * 2.0 * PI);
      teta:=0;
      REPEAT

        verwin:=FLOAT(teta)/360.0 * 2.0 * PI;

        FOR winnum:=xywin TO yzwin DO
          p1.x:=ROUND(sin(verwin)*phicos*rx);
          p1.y:=ROUND(sin(verwin)*phisin*ry);
          p1.z:=ROUND(cos(verwin)*rz);
          a:=DDD.GiveXY(winnum,p1);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,teta<>0);
        END;
        teta:=teta+step2;
      UNTIL teta=360+step2;
      phi:=phi+step1;
    UNTIL phi=180;
    DDD.CalcNewDCoords(objnum);
    itext.t:=" Ellipsoid created!";
    Grawin.RefreshAllWins(TRUE);
    Grawin.TextToWinTitle(actwin,itext);
    dontwriteinfo:=TRUE;|

    ORD(semiellipsoid) :
    text[1].t:="Please enter";
    text[2].t:="x-radius of";
    text[3].t:="semi-ellipsoid:";
    text[4].t:="";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(rx,"30.0");
    UNTIL Done;
    text[2].t:="y-radius of";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(ry,"30.0");
    UNTIL Done;
    text[2].t:="z-radius of";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(rz,"30.0");
    UNTIL Done;
    REPEAT
      sections1:=6;
      text[2].t:="1. granularity";
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(sections1);
    UNTIL Done AND ((360 MOD sections1) = 0);

    REPEAT
      sections2:=12;
      text[2].t:="2. granularity";
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(sections2);
    UNTIL Done AND ((180 MOD sections2) = 0);

    step1:=180 DIV sections1;
    step2:=360 DIV sections2;
    teta:=0;

    REPEAT

      tetasin:=sin((FLOAT(teta)-0.0)/360.0 * 2.0 * PI);
      tetacos:=cos((FLOAT(teta)-0.0)/360.0 * 2.0 * PI);
      phi:=0;
      REPEAT

        horwin:=FLOAT(phi)/360.0 * 2.0 * PI;

        FOR winnum:=xywin TO yzwin DO
          p1.x:=ROUND(cos(horwin)*tetasin*rx);
          p1.y:=ROUND(sin(horwin)*tetasin*ry);
          p1.z:=ROUND(tetacos*rz);
          a:=DDD.GiveXY(winnum,p1);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,phi<>0);
        END;
        phi:=phi+step2;
      UNTIL phi=180+step2;
      teta:=teta+step1;
    UNTIL teta=180;

    phi:=0;
    REPEAT

      phisin:=sin((FLOAT(phi)-0.0)/360.0 * 2.0 * PI);
      phicos:=cos((FLOAT(phi)-0.0)/360.0 * 2.0 * PI);
      teta:=0;
      REPEAT

        verwin:=FLOAT(teta)/360.0 * 2.0 * PI;

        FOR winnum:=xywin TO yzwin DO
          p1.x:=ROUND(sin(verwin)*phicos*rx);
          p1.y:=ROUND(sin(verwin)*phisin*ry);
          p1.z:=ROUND(cos(verwin)*rz);
          a:=DDD.GiveXY(winnum,p1);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,teta<>0);
        END;
        teta:=teta+step2;
      UNTIL teta=180+step2;
      phi:=phi+step1;
    UNTIL phi=180+step1;
    DDD.CalcNewDCoords(objnum);
    itext.t:=" Semiellipsoid created!";
    Grawin.RefreshAllWins(TRUE);
    Grawin.TextToWinTitle(actwin,itext);
    dontwriteinfo:=TRUE;|

    ORD(cylinder) :
    text[1].t:="Please enter";
    text[2].t:="height of";
    text[3].t:="cylinder:";
    text[4].t:="";
    REPEAT
      h:=50;
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(h);
    UNTIL Done;
    text[2].t:="x1-radius of";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(rx1,"10.0");
    UNTIL Done;
    text[2].t:="y1-radius of";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(ry1,"10.0");
    UNTIL Done;
    text[2].t:="x2-radius of";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(rx2,"10.0");
    UNTIL Done;
    text[2].t:="y2-radius of";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(ry2,"10.0");
    UNTIL Done;
    text[2].t:="granularity";
    REPEAT
      sections:=10;
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(sections);
    UNTIL Done AND ((360 MOD sections)=0);

    step2:=360 DIV sections;

    phi:=0;

    REPEAT

      horwin:=FLOAT(phi)/360.0 * 2.0 * PI;
      horwin2:=FLOAT(phi+step2)/360.0 * 2.0 * PI;

      FOR winnum:=xywin TO yzwin DO

        p1.x:=ROUND(cos(horwin2)*rx1);
        p1.y:=ROUND(sin(horwin2)*ry1);
        p1.z:=-1*INTEGER(h);

        p2.x:=ROUND(cos(horwin)*rx1);
        p2.y:=ROUND(sin(horwin)*ry1);
        p2.z:=p1.z;

        p3.x:=ROUND(cos(horwin)*rx2);
        p3.y:=ROUND(sin(horwin)*ry2);
        p3.z:=h;

        p4.x:=ROUND(cos(horwin2)*rx2);
        p4.y:=ROUND(sin(horwin2)*ry2);
        p4.z:=p3.z;

        IF phi>0 THEN
          a:=DDD.GiveXY(winnum,p1);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,FALSE);
          a:=DDD.GiveXY(winnum,p2);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
          a:=DDD.GiveXY(winnum,p3);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
          a:=DDD.GiveXY(winnum,p4);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
        END;
      END;
      phi:=phi+step2;
    UNTIL phi=360+step2;
    DDD.CalcNewDCoords(objnum);
    itext.t:=" Cylinder created!";
    Grawin.RefreshAllWins(TRUE);
    Grawin.TextToWinTitle(actwin,itext);
    dontwriteinfo:=TRUE;|

    ORD(pyramid) :
    text[1].t:="Please enter";
    text[2].t:="x-radius of";
    text[3].t:="pyramid:";
    text[4].t:="";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(rx,"30.0");
    UNTIL Done;
    text[2].t:="y-radius of";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(ry,"30.0");
    UNTIL Done;
    text[2].t:="heigth of";
    REPEAT
      h:=60;
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(h);
    UNTIL Done;

    text[2].t:="granularity of";
    REPEAT
      sections:=8;
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(sections);
    UNTIL Done AND ((360 MOD sections)=0);

    step2:=360 DIV sections;

    phi:=0;

    REPEAT

      horwin:=FLOAT(phi)/360.0 * 2.0 * PI;
      horwin2:=FLOAT(phi+step2)/360.0 * 2.0 * PI;

      FOR winnum:=xywin TO yzwin DO

        p1.x:=ROUND(cos(horwin2)*rx);
        p1.y:=ROUND(sin(horwin2)*ry);
        p1.z:=curpos.z;

        p2.x:=ROUND(cos(horwin)*rx);
        p2.y:=ROUND(sin(horwin)*ry);
        p2.z:=p1.z;

        p3.x:=curpos.x;
        p3.y:=curpos.y;
        p3.z:=h;

        IF phi>0 THEN
          a:=DDD.GiveXY(winnum,p1);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,FALSE);
          a:=DDD.GiveXY(winnum,p2);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
          a:=DDD.GiveXY(winnum,p3);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
        END;
      END;
      phi:=phi+step2;
    UNTIL phi=360+step2;
    DDD.CalcNewDCoords(objnum);
    itext.t:=" Pyramid created!";
    Grawin.RefreshAllWins(TRUE);
    Grawin.TextToWinTitle(actwin,itext);
    dontwriteinfo:=TRUE;|

    ORD(spindle) :

    text[1].t:="Please enter";
    text[2].t:="x-radius of";
    text[3].t:="spindle:";
    text[4].t:="";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(rx,"20.0");
    UNTIL Done;
    text[2].t:="y-radius of";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(ry,"20.0");
    UNTIL Done;
    text[2].t:="heigth of";
    REPEAT
      h:=50;
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(h);
    UNTIL Done;
    text[2].t:="granularity of";
    REPEAT
      sections:=10;
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(sections);
    UNTIL Done AND ((360 MOD sections)=0);

    step2:=360 DIV sections;

    phi:=0;

    REPEAT

      horwin:=FLOAT(phi)/360.0 * 2.0 * PI;
      horwin2:=FLOAT(phi+step2)/360.0 * 2.0 * PI;

      FOR winnum:=xywin TO yzwin DO

        p1.x:=ROUND(cos(horwin2)*rx);
        p1.y:=ROUND(sin(horwin2)*ry);
        p1.z:=curpos.z;

        p2.x:=ROUND(cos(horwin)*rx);
        p2.y:=ROUND(sin(horwin)*ry);
        p2.z:=p1.z;

        p3.x:=curpos.x;
        p3.y:=curpos.y;
        p3.z:=h;

        p4:=p3;
        p4.z:=-1*INTEGER(h);

        IF phi>0 THEN
          a:=DDD.GiveXY(winnum,p1);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,FALSE);
          a:=DDD.GiveXY(winnum,p2);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
          a:=DDD.GiveXY(winnum,p3);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
          a:=DDD.GiveXY(winnum,p2);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
          a:=DDD.GiveXY(winnum,p4);
          Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);

        END;
      END;
      phi:=phi+step2;
    UNTIL phi=360+step2;
    DDD.CalcNewDCoords(objnum);
    itext.t:=" Spindle created!";
    Grawin.RefreshAllWins(TRUE);
    Grawin.TextToWinTitle(actwin,itext);
    dontwriteinfo:=TRUE;|

    ORD(toroid) :
    text[1].t:="Please enter";
    text[2].t:="x-radius of";
    text[3].t:="toroid:";
    text[4].t:="";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(rx,"30.0");
    UNTIL Done;
    text[2].t:="y-radius of";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(ry,"30.0");
    UNTIL Done;
    text[2].t:="radius of";
    REPEAT
      Grawin.ShowInfoBox(34,14,4,text);
      ReadReal(r,"10.0");
    UNTIL Done;
    REPEAT
      sections1:=8;
      text[2].t:="1. granularity";
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(sections1);
    UNTIL Done AND ((360 MOD sections1)=0);

    REPEAT
      sections2:=8;
      text[2].t:="2. granularity";
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(sections2);
    UNTIL Done AND ((360 MOD sections2)=0);

    step1:=360 DIV sections1;
    step2:=360 DIV sections2;

    phi:=0;
    REPEAT

      phisin:=sin((FLOAT(phi)-0.0)/360.0 * 2.0 * PI);
      phicos:=cos((FLOAT(phi)-0.0)/360.0 * 2.0 * PI);
      phisin2:=sin((FLOAT(phi+step1)-0.0)/360.0 * 2.0 * PI);
      phicos2:=cos((FLOAT(phi+step1)-0.0)/360.0 * 2.0 * PI);

      teta:=0;
      REPEAT

        verwin:=FLOAT(teta)/360.0 * 2.0 * PI;

        FOR winnum:=xywin TO yzwin DO

          p1.x:=ROUND(sin(verwin)*phicos*r+phicos*rx);
          p1.y:=ROUND(sin(verwin)*phisin*r+phisin*ry);
          p1.z:=ROUND(cos(verwin)*r);
          p2.x:=ROUND(sin(verwin)*phicos2*r+phicos2*rx);
          p2.y:=ROUND(sin(verwin)*phisin2*r+phisin2*ry);
          p2.z:=ROUND(cos(verwin)*r);

          a:=DDD.GiveXY(winnum,p1);
          b:=DDD.GiveXY(winnum,p2);
          IF teta=0 THEN
            Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,FALSE);
            Grawin.AddObjPoint(winnum,objnum,b.x,b.y,actcol,TRUE);
            Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,FALSE);
          ELSE
            Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
            Grawin.AddObjPoint(winnum,objnum,b.x,b.y,actcol,TRUE);
            Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,FALSE);
          END;
        END;
        teta:=teta+step2;
      UNTIL teta=360+step2;
      phi:=phi+step1;
    UNTIL phi=360;
    DDD.CalcNewDCoords(objnum);
    itext.t:=" Toroid created!";
    Grawin.RefreshAllWins(TRUE);
    Grawin.TextToWinTitle(actwin,itext);
    dontwriteinfo:=TRUE;|

    ORD(quader):

    text[1].t:="Please enter";
    text[2].t:="x-size of";
    text[3].t:="quader:";
    text[4].t:="";
    REPEAT
      rcx:=30;
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(rcx);
    UNTIL Done;
    text[2].t:="y-size of";
    REPEAT
      rcy:=30;
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(rcy);
    UNTIL Done;
    text[2].t:="z-size of";
    REPEAT
      rcz:=30;
      Grawin.ShowInfoBox(34,14,4,text);
      ReadCard(rcz);
    UNTIL Done;

    FOR winnum:=xywin TO yzwin DO

      p1.x:=-INTEGER(rcx) DIV 2;
      p1.y:=-INTEGER(rcy) DIV 2;
      p1.z:=-INTEGER(rcz) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,Colors.black,FALSE);
      p1.x:=INTEGER(rcx) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
      p1.y:=INTEGER(rcy) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
      p1.x:=-INTEGER(rcx) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
      p1.y:=-INTEGER(rcy) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);

      p1.z:=INTEGER(rcz) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
      p1.x:=INTEGER(rcx) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
      p1.y:=INTEGER(rcy) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
      p1.x:=-INTEGER(rcx) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
      p1.y:=-INTEGER(rcy) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);

      p1.x:=INTEGER(rcx) DIV 2;
      p1.y:=-INTEGER(rcy) DIV 2;
      p1.z:=-INTEGER(rcz) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,Colors.black,FALSE);
      p1.z:=INTEGER(rcz) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);

      p1.y:=INTEGER(rcy) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,Colors.black,FALSE);
      p1.z:=-INTEGER(rcz) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);

      p1.x:=-INTEGER(rcx) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,Colors.black,FALSE);
      p1.z:=INTEGER(rcz) DIV 2;
      a:=DDD.GiveXY(winnum,p1);
      Grawin.AddObjPoint(winnum,objnum,a.x,a.y,actcol,TRUE);
    END;
    itext.t:=" Quader created!";
    DDD.CalcNewDCoords(objnum);
    Grawin.RefreshAllWins(TRUE);
    Grawin.TextToWinTitle(actwin,itext);
    dontwriteinfo:=TRUE;
  ELSE
    Grawin.RefreshAllWins(TRUE);
  END;

  lastpoints:=Grawin.GetObjMaxPointNumber(xywin,objnum)-m1;

END Obj3Dlib;

(* Object-libary for 2D-objects *)

PROCEDURE Obj2Dlib(VAR actwin, objnum : CARDINAL);

TYPE objects = (nil, ellipse, angleellipse, rectangle, spiralmult, spiralexp);
VAR key : CHAR;
    p : Grawin.Point;
    pc, pp : Grawin.Coord;
    selected : CARDINAL;
    angle, h, i, ii, step1, step2, sections : INTEGER;
    m1, winnum, rcx, rcy: CARDINAL;
    nowcol : Grawin.RGB;
    curpos, p1, p2, p3, p4 : DDD.DCoord;
    r, x,y, rx, ry, rz : REAL;
    rx1, ry1, rx2, ry2 : REAL;
    horwin : REAL;
    sc : Grawin.Scale;

BEGIN
  IF Grawin.InErrorState() THEN Error; RETURN; END;
  DDD.MakeObjBackup(objnum);
  UseDefault;
  m1:=Grawin.GetObjMaxPointNumber(xywin,objnum);

  keys[ORD(ellipse)]:="e";
  keys[ORD(angleellipse)]:="a";
  keys[ORD(rectangle)]:="r";
  keys[ORD(spiralmult)]:="t";
  keys[ORD(spiralexp)]:="p";

  key:=Grawin.WaitForKey(500);
  CASE key OF
    'e' : selected:=1; |
    'a' : selected:=2; |
    'r' : selected:=3; |
    't' : selected:=4; |
    'p' : selected:=5;
  ELSE

    text[1].t:="2D-Object-Library.";
    text[2].t:="Please choose:    ";
    text[1].c:=Colors.ititlecol;
    text[2].c:=Colors.ipromptcol;
    Grawin.ShowInfoBox(10,10,2,text);

    Grawin.ColFromTo(text,Colors.itextcol,1,5);
    text[ORD(ellipse)     ].t:="Ellipse.........";
    text[ORD(angleellipse)].t:="Angle-Ellipse...";
    text[ORD(rectangle)   ].t:="Rectangle.......";
    text[ORD(spiralmult)  ].t:="Spiral (mult)...";
    text[ORD(spiralexp)   ].t:="Spiral (exp)....";

    selected:=Grawin.ShowChooseBox(12,14,5,text,nokeys,alltrue,1);
  END;

  Grawin.ColFromTo(text,Colors.ipromptcol,1,3);
  text[4].c:=Colors.ientercol;

  CASE selected OF
    ORD(ellipse) :
        text[1].t:="Please enter";
        text[2].t:="x-radius of";
        text[3].t:="ellipse:";
        text[4].t:="";
        REPEAT
          Grawin.ShowInfoBox(34,14,4,text);
          ReadReal(rx,"20.0");
        UNTIL Done;
        text[2].t:="y-radius of";
        REPEAT
          Grawin.ShowInfoBox(34,14,4,text);
          ReadReal(ry,"20.0");
        UNTIL Done;
        text[2].t:="granularity of";
        REPEAT
          sections:=10;
          Grawin.ShowInfoBox(34,14,4,text);
          ReadInt(sections);
        UNTIL Done AND ((360 MOD sections)=0);

        step1:=360 DIV sections;

        i:=0;

        REPEAT
          horwin:=FLOAT(i)/180.0*PI;
          x:=sin(horwin)*rx;
          y:=cos(horwin)*ry;
          nowcol:=actcol;

          Grawin.AddObjPoint(actwin,obj,ROUND(x),ROUND(y),nowcol,i<>0);
          IF actwin=xywin THEN
            Grawin.AddObjPoint(xzwin,objnum,ROUND(x),0,nowcol,i<>0);
            Grawin.AddObjPoint(yzwin,objnum,ROUND(y),0,nowcol,i<>0);
          END;
          IF actwin=xzwin THEN
            Grawin.AddObjPoint(xywin,objnum,ROUND(x),0,nowcol,i<>0);
            Grawin.AddObjPoint(yzwin,objnum,0,ROUND(y),nowcol,i<>0);
          END;
          IF actwin=yzwin THEN
            Grawin.AddObjPoint(xywin,objnum,0,ROUND(x),nowcol,i<>0);
            Grawin.AddObjPoint(xzwin,objnum,0,ROUND(y),nowcol,i<>0);
          END;
          i:=i+INTEGER(step1);
        UNTIL i=INTEGER(360+step1);
        itext.t:=" Ellipse created!";
        DDD.CalcNewDCoords(objnum);
        Grawin.RefreshAllWins(TRUE);
        Grawin.TextToWinTitle(actwin,itext);
        dontwriteinfo:=TRUE;|

    ORD(angleellipse) :
        text[1].t:="Please enter";
        text[2].t:="x-radius of";
        text[3].t:="angle-ellipse:";
        text[4].t:="";
        REPEAT
          Grawin.ShowInfoBox(34,14,4,text);
          ReadReal(rx,"20.0");
        UNTIL Done;
        text[2].t:="y-radius of";
        REPEAT
          Grawin.ShowInfoBox(34,14,4,text);
          ReadReal(ry,"20.0");
        UNTIL Done;

        text[2].t:="angle of";
        REPEAT
          angle:=270;
          Grawin.ShowInfoBox(34,14,4,text);
          ReadInt(angle);
        UNTIL Done;
        pc:=Grawin.GetCurPos(actwin);
        h:=ROUND(CalcAbsAngle(FLOAT(pc.x),FLOAT(pc.y)));

        text[2].t:="granularity of";
        REPEAT
          sections:=10;
          Grawin.ShowInfoBox(34,14,4,text);
          ReadInt(sections);
        UNTIL Done AND ((angle MOD sections)=0);

        step1:=angle DIV sections;
        i:=h;
        REPEAT
          horwin:=FLOAT(i)/180.0*PI;
          x:=cos(horwin)*rx;
          y:=sin(horwin)*ry;

          Grawin.AddObjPoint(actwin,objnum,ROUND(x),ROUND(y),nowcol,i<>h);
          IF actwin=xywin THEN
            Grawin.AddObjPoint(xzwin,objnum,ROUND(x),0,nowcol,i<>h);
            Grawin.AddObjPoint(yzwin,objnum,ROUND(y),0,nowcol,i<>h);
          END;
          IF actwin=xzwin THEN
            Grawin.AddObjPoint(xywin,objnum,ROUND(x),0,nowcol,i<>h);
            Grawin.AddObjPoint(yzwin,objnum,0,ROUND(y),nowcol,i<>h);
          END;
          IF actwin=yzwin THEN
            Grawin.AddObjPoint(xywin,objnum,0,ROUND(x),nowcol,i<>h);
            Grawin.AddObjPoint(xzwin,objnum,0,ROUND(y),nowcol,i<>h);
          END;
          i:=i+step1;
          nowcol:=actcol;
        UNTIL i=h+angle+step1;
        itext.t:=" Angleellipse created!";
        DDD.CalcNewDCoords(objnum);
        Grawin.RefreshAllWins(TRUE);
        Grawin.TextToWinTitle(actwin,itext);
        dontwriteinfo:=TRUE;|

    ORD(rectangle) :
        text[1].t:="Please enter";
        text[2].t:="x-size of";
        text[3].t:="rectangle:";
        text[4].t:="";
        REPEAT
          rcx:=20;
          Grawin.ShowInfoBox(34,14,4,text);
          ReadCard(rcx);
        UNTIL Done;
        text[2].t:="y-size of";
        REPEAT
          rcy:=20;
          Grawin.ShowInfoBox(34,14,4,text);
          ReadCard(rcy);
        UNTIL Done;
        p1.z:=0;
        p1.x:=-INTEGER(rcx) DIV 2; p1.y:=-INTEGER(rcy) DIV 2;
        FOR winnum:=xywin TO yzwin DO
          pc:=DDD.GiveXY(winnum,p1);
          Grawin.AddObjPoint(winnum,objnum,pc.x,pc.y,Colors.black,FALSE);
        END;
        p1.x:=INTEGER(rcx) DIV 2;
        p1.y:=-INTEGER(rcy) DIV 2;
        FOR winnum:=xywin TO yzwin DO
          pc:=DDD.GiveXY(winnum,p1);
          Grawin.AddObjPoint(winnum,objnum,pc.x,pc.y,actcol,TRUE);
        END;
        p1.x:=INTEGER(rcx) DIV 2;
        p1.y:=INTEGER(rcy) DIV 2;
        FOR winnum:=xywin TO yzwin DO
          pc:=DDD.GiveXY(winnum,p1);
          Grawin.AddObjPoint(winnum,objnum,pc.x,pc.y,actcol,TRUE);
        END;

        p1.x:=-INTEGER(rcx) DIV 2;
        p1.y:=INTEGER(rcy) DIV 2;

        FOR winnum:=xywin TO yzwin DO
          pc:=DDD.GiveXY(winnum,p1);
          Grawin.AddObjPoint(winnum,objnum,pc.x,pc.y,actcol,TRUE);
        END;

        p1.x:=-INTEGER(rcx) DIV 2;
        p1.y:=-INTEGER(rcy) DIV 2;

        FOR winnum:=xywin TO yzwin DO
          pc:=DDD.GiveXY(winnum,p1);
          Grawin.AddObjPoint(winnum,objnum,pc.x,pc.y,actcol,TRUE);
        END;
        itext.t:=" Rectangle created!";
        DDD.CalcNewDCoords(objnum);
        Grawin.RefreshAllWins(TRUE);
        Grawin.TextToWinTitle(actwin,itext);
        dontwriteinfo:=TRUE;|

    ORD(spiralmult), ORD(spiralexp) :
        text[1].t:="Please enter";
        text[2].t:="x-start-radius";
        text[3].t:="of spiral:";
        text[4].t:="";
        REPEAT
          Grawin.ShowInfoBox(34,14,4,text);
          ReadReal(rx,"5.0");
        UNTIL Done;
        text[2].t:="y-start-radius";
        REPEAT
          Grawin.ShowInfoBox(34,14,4,text);
          ReadReal(ry,"5.0");
        UNTIL Done;

        text[2].t:="size of";
        REPEAT
          Grawin.ShowInfoBox(34,14,4,text);
          ReadReal(r,"5.0");
        UNTIL Done;
        angle:=ROUND(r*360.0);
        pc:=Grawin.GetCurPos(actwin);
        h:=ROUND(CalcAbsAngle(FLOAT(pc.x),FLOAT(pc.y)));

        text[2].t:="granularity of";
        REPEAT
          sections:=10;
          Grawin.ShowInfoBox(34,14,4,text);
          ReadInt(sections);
        UNTIL Done AND ((360 MOD sections)=0);

        IF selected=ORD(spiralmult) THEN
          text[2].t:="mult-factor";
        ELSE
          text[2].t:="exp-factor";
        END;
        REPEAT
          Grawin.ShowInfoBox(34,14,4,text);
          IF selected=ORD(spiralmult) THEN
            ReadReal(r,"0.2");
          ELSE
            ReadReal(r,"1.06");
          END;
        UNTIL Done;
        pc:=Grawin.GetCurPos(actwin);
        h:=ROUND(CalcAbsAngle(FLOAT(pc.x),FLOAT(pc.y)));

        step1:=360 DIV sections;
        ii:=h;
        rz:=1.0;

        REPEAT
          horwin:=FLOAT(ii)/180.0*PI;
          x:=cos(horwin)*rx*rz;
          y:=sin(horwin)*ry*rz;

          IF selected=ORD(spiralmult) THEN
            rz:=rz+r;
          ELSE
            rz:=rz*r;
          END;

          Grawin.AddObjPoint(actwin,objnum,ROUND(x),ROUND(y),nowcol,ii<>h);
          IF actwin=xywin THEN
            Grawin.AddObjPoint(xzwin,objnum,ROUND(x),0,nowcol,ii<>h);
            Grawin.AddObjPoint(yzwin,objnum,ROUND(y),0,nowcol,ii<>h);
          END;
          IF actwin=xzwin THEN
            Grawin.AddObjPoint(xywin,objnum,ROUND(x),0,nowcol,ii<>h);
            Grawin.AddObjPoint(yzwin,objnum,0,ROUND(y),nowcol,ii<>h);
          END;
          IF actwin=yzwin THEN
            Grawin.AddObjPoint(xywin,objnum,0,ROUND(x),nowcol,ii<>h);
            Grawin.AddObjPoint(xzwin,objnum,0,ROUND(y),nowcol,ii<>h);
          END;
          ii:=ii+step1;
          nowcol:=actcol;
        UNTIL ii>=h+angle+step1;
        itext.t:=" Spiral created!";
        DDD.CalcNewDCoords(objnum);
        Grawin.RefreshAllWins(TRUE);
        Grawin.TextToWinTitle(actwin,itext);
        dontwriteinfo:=TRUE;
  ELSE
    Grawin.RefreshAllWins(TRUE);
  END;

  lastpoints:=Grawin.GetObjMaxPointNumber(xywin,objnum)-m1;

END Obj2Dlib;

PROCEDURE Undo(VAR actwin,objnum : CARDINAL);
BEGIN
  DDD.RestoreStObjBackup;
  pointselected:=FALSE;
  DDD.ShowWhere(objnum);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Undo!";
  Grawin.TextToWinTitle(actwin,itext);
  dontwriteinfo:=TRUE;
END Undo;

PROCEDURE SetSceneColors();
VAR winnum : CARDINAL;

BEGIN
  DDD.SetPlaneCol(Colors.splanecol);
  DDD.SetCrossCol(Colors.scrosscol);
  DDD.SetWhereCol(Colors.swherecol);
  DDD.SetEyeCol(Colors.seyecol);
  DDD.SetOrgCol(Colors.sorgcol);

  Grawin.SetMenuBorCol1(Colors.smenborcol1);
  Grawin.SetMenuBorCol2(Colors.smenborcol2);
  Grawin.SetMenuItemCol(Colors.smenitemcol);
  Grawin.SetMenuActItemCol(Colors.smenhiitemcol);
  Grawin.SetMenuBackCol(Colors.smenbackcol);
  Grawin.SetMenuTitleCol(Colors.smentitlecol);

  Grawin.SetScreenBackCol(Colors.sscreenbackcol);
  Grawin.SetInfoBackCol(Colors.sinfobackcol);
  Grawin.SetInfoCol(Colors.itextcol);
  Grawin.SetInfoActCol(Colors.ihitextcol);
  Grawin.SetInfoBorCol1(Colors.iborcol1);
  Grawin.SetInfoBorCol2(Colors.iborcol2);

  FOR winnum:=xywin TO dddwin DO
    Grawin.SetWinBorCol(winnum,Colors.swinborcol);
    Grawin.SetWinBackCol(winnum,Colors.swinbackcol);
    Grawin.SetWinTitleCol(winnum,Colors.swintitlecol);
  END;
  Grawin.SetWinActCol(Colors.swinhicol);

  SetBGColor(Colors.sscreenbackcol.r,
             Colors.sscreenbackcol.g,
             Colors.sscreenbackcol.b);

  SetMaxWindow;
  Scroll(0);
END SetSceneColors;

PROCEDURE SetSceneMenus;
VAR winnum : CARDINAL;
BEGIN
  FOR winnum:=xywin TO yzwin DO
    Grawin.SetWinMenBindkey(winnum,ORD(objlib3d),'3');
    Grawin.SetWinMenBindkey(winnum,ORD(objlib2d),'2');
    Grawin.SetWinMenBindkey(winnum,ORD(operations),'o');
    Grawin.SetWinMenBindkey(winnum,ORD(objmisc),'f');
    Grawin.SetWinMenBindkey(winnum,ORD(handler),'l');
    Grawin.SetWinMenBindkey(winnum,ORD(helppage),'h');
    Grawin.SetWinMenBindkey(winnum,ORD(colorpicker),'c');
    Grawin.SetWinMenBindkey(winnum,ORD(planeeye),'v');
    Grawin.SetWinMenBindkey(winnum,ORD(laygrid),'g');
    Grawin.SetWinMenBindkey(winnum,ORD(disk),'d');
    Grawin.SetWinMenBindkey(winnum,ORD(preferences),'x');
    Grawin.SetWinMenBindkey(winnum,ORD(undo),'u');
    Grawin.SetWinMenBindkey(winnum,ORD(done),'q');

    Grawin.SetWinMenItem(winnum,ORD(objlib3d),    '3D-Library     ',Obj3Dlib);
    Grawin.SetWinMenItem(winnum,ORD(objlib2d),    '2D-Library     ',Obj2Dlib);
    Grawin.SetWinMenItem(winnum,ORD(operations),  'Operations     ',Operate);
    Grawin.SetWinMenItem(winnum,ORD(objmisc),     'Functions      ',Object);
    Grawin.SetWinMenItem(winnum,ORD(handler),     'Handler        ',ObjectHandler);
    Grawin.SetWinMenItem(winnum,ORD(helppage),    'Helppages      ',Helppages);
    Grawin.SetWinMenItem(winnum,ORD(colorpicker), 'Color-Picker   ',Color);
    Grawin.SetWinMenItem(winnum,ORD(planeeye),    'Viewpoint      ',PlaneEye);
    Grawin.SetWinMenItem(winnum,ORD(laygrid),     'Lay Grid       ',Grid);
    Grawin.SetWinMenItem(winnum,ORD(disk),        'Disk           ',DiskFunc);
    Grawin.SetWinMenItem(winnum,ORD(preferences), 'Preferences    ',Preferences);
    Grawin.SetWinMenItem(winnum,ORD(undo),        'Undo           ',Undo);
    Grawin.SetWinMenItem(winnum,ORD(done),        'Scene Done     ',SceneDone);
  END;

  Grawin.SetWinMenItem(dddwin,ORD(view),'View',View);
  Grawin.SetWinMenItem(dddwin,ORD(stereoview),'Stereo-View',View3D);
END SetSceneMenus;

PROCEDURE CursorBlink();
VAR winnum : CARDINAL;
BEGIN
  FOR winnum:=xywin TO dddwin DO
    Grawin.ShowCursor(winnum,Colors.scurcol,addpointsmode);
  END;
END CursorBlink;

(* Main-procedure: object-editor *)

PROCEDURE ObjectEdit(lasteditedobj : CARDINAL):CARDINAL;

VAR c : CHAR;
    i, ii, sections, winnum, lastwin, max : CARDINAL;
    nowcol : Grawin.RGB;
    pp, ppp : Grawin.Coord;
    (* p *) pd : DDD.DCoord;
    dpoi : DDD.DPoint;
    poi : Grawin.Point;
    sc : Grawin.Scale;
    x, y : CARDINAL;
    dt, h, m, s, as, s100, as100 : INTEGER;
    zoom : REAL;
    relflag, double, strg, left, key, pos, right : BOOLEAN;
    sleft, sright : BOOLEAN;

BEGIN
  rotstate:=inactive;
  tubestate:=inactive;
  handleract:=FALSE;
  relflag:=FALSE;
  itext.c:=Colors.swintitlecol;

  lastpoints:=0;
  obj:=lasteditedobj;

  Grawin.SetErrProc(Error);
  Grawin.SetCursorstep(cursorstep);

  SetSceneColors;
  SetSceneMenus;

  DDD.ShowWhere(obj);
  Grawin.SelectObj(obj);

  DDD.CopyFromLocalNames(objnames);

  FOR winnum:=xywin TO yzwin DO
    Grawin.SetWinSizeProc(winnum,AdjustSize);
    Grawin.SetWinMoveProc(winnum,AdjustSize);
    Grawin.SetWinRefreshProc(winnum,Refresh);
    Grawin.SetWinScrollProc(winnum,ScrollWin);
    Grawin.SetWinZoomProc(winnum,ZoomWin);
    Grawin.SetWinResetProc(winnum,ResetWin);
  END;
  Grawin.SetWinSizeProc(dddwin,AdjustSize);
  Grawin.SetWinMoveProc(dddwin,AdjustSize);
  Grawin.SetWinRefreshProc(dddwin,Refresh);
  Grawin.SetWinZoomProc(dddwin,ZoomWin);
  Grawin.SetWinScrollProc(dddwin,ScrollWin);

  scenedone:=FALSE;
  pp:=Grawin.GetCurPos(actwin);
  ppp:=Grawin.GetWinOrg(actwin);
  Grawin.SetMouseAtWinPos(actwin,pp.x,pp.y);

  Grawin.RefreshAllWins(TRUE);
  SetWaitProc(CursorBlink);
  EnableWaitProcEvery(10);

  LOOP
    lastwin:=actwin;

    GetMouseState(x,y,left,right);

    IF right OR left AND NOT(relflag) THEN
      sleft:=left;
      sright:=right;
      Info.GetTime(h,m,s,s100);
      as:=s;
      as100:=s100;
      REPEAT
        Info.GetTime(h,m,s,s100);
        dt:=ABS(s-as)*100+(s100-as100);
        GetMouseState(x,y,left,right);
      UNTIL (sright AND NOT(right)) OR (sleft AND NOT(left)) OR (dt>40);
      IF dt>40 THEN
        IF sleft THEN
          c:='s';
          relflag:=TRUE;
        END;
        left:=FALSE;
        right:=sright;
      ELSE
        IF sright THEN c:='d'; right:=FALSE; END;
        IF sleft  THEN c:=' '; left:=FALSE;  END;
      END;
    ELSE
      dt:=0;
      ConfLeftButton;
      ConfRightButton;
      ConfPosChanged;
      WaitForEvents(left,right,pos,key,strg,c);
      IF right THEN c:='d'; END;
      IF left AND NOT(relflag) THEN c:=' '; END;
      left:=FALSE;
      right:=FALSE;
      relflag:=FALSE;
    END;

    Grawin.WindowHandler(left,right,c,strg,actwin);
    EnableWaitProcEvery(10);

    IF actwin<>dddwin THEN
      Grawin.CursorHandler(c,actwin,Colors.scurcol,addpointsmode);
    END;

    cur:=Grawin.GetCurPos(actwin);
    CASE actwin OF
      xywin : p.x:=cur.x; p.y:=cur.y; |
      xzwin : p.x:=cur.x; p.z:=cur.y; |
      yzwin : p.y:=cur.x; p.z:=cur.y;
    END;

    FOR winnum:=xywin TO yzwin DO
      a[winnum]:=DDD.GiveXY(winnum,p);
      IF winnum<>actwin THEN
        Grawin.SetCursor(winnum,a[winnum].x,a[winnum].y,Colors.scurcol,addpointsmode);
      END;
      sc:=Grawin.GetObjScale(winnum,obj);
      a[winnum]:=DDD.GiveXY(winnum,p);
      pp:=Grawin.GetObjOrg(winnum,obj);
      ppp:=Grawin.GetWinOrg(winnum);
      b[winnum].x:=ROUND((FLOAT(a[winnum].x)-FLOAT(pp.x-ppp.x))/sc.scx);
      b[winnum].y:=ROUND((FLOAT(a[winnum].y)-FLOAT(pp.y-ppp.y))/sc.scy);
    END;
    sc:=Grawin.GetObjScale(dddwin,obj);
    a[dddwin]:=DDD.GiveXY(dddwin,p);
    Grawin.SetCursor(dddwin,a[dddwin].x,a[dddwin].y,Colors.scurcol,addpointsmode);

    pp:=Grawin.GetObjOrg(dddwin,obj);
    ppp:=Grawin.GetWinOrg(dddwin);
    b[dddwin].x:=ROUND((FLOAT(a[dddwin].x)-FLOAT(pp.x-ppp.x))/sc.scx);
    b[dddwin].y:=ROUND((FLOAT(a[dddwin].y)-FLOAT(pp.y-ppp.y))/sc.scy);

    IF NOT(dontwriteinfo) THEN WinInfoLine(actwin); END;
    dontwriteinfo:=FALSE;

    IF (actwin<>dddwin) AND NOT(strg) THEN

      CASE c OF
        ' ', 's' : CASE c OF
                     ' ' : Grawin.NormalTick1; |
                     's' : Grawin.NormalTick2;
                   END;

                   DDD.MakeObjBackup(obj);
                   IF addpointsmode THEN
                     lastpoints:=1;
                     FOR winnum:=xywin TO dddwin DO

                       Grawin.AddObjPoint(winnum,obj,b[winnum].x,b[winnum].y,actcol,NOT((c='s') OR
                                                 (Grawin.GetObjPointNumber(winnum,obj)=0)));

                       xormode:=TRUE;
                       IF winnum<>actwin THEN
                         Grawin.UnsetMarker1(winnum);
                       END;

                     END;
                     DDD.ShowWhere(obj);

                     AllWinsParUpdateCon(actwin,obj);

                     itext.t:=" Point added!";
                     Grawin.TextToWinTitle(actwin,itext);
                     dontwriteinfo:=TRUE;

                   ELSE

                     IF NOT(pointselected) THEN
                       DDD.SetXYZObjPointNumber(obj,1);
                       FOR i:=1 TO Grawin.GetObjMaxPointNumber(actwin,obj) DO
                         dpoi:=DDD.GetXYZObjPoint(obj);
                         IF (dpoi.x=b[xywin].x) AND (dpoi.y=b[xywin].y) AND
                            (dpoi.z=b[yzwin].y) THEN
                           pointselected:=TRUE;
                         END;
                       END;

                       IF NOT(pointselected) THEN
                         itext.t:=" !?! No point found!";
                         Grawin.TextToWinTitle(actwin,itext);
                         dontwriteinfo:=TRUE;
                         Grawin.ErrorTick();
                       ELSE
                         FOR winnum:=xywin TO yzwin DO
                           pointselcoords[winnum]:=b[winnum];
                         END;
                         itext.t:=" Point selected!";
                         Grawin.TextToWinTitle(actwin,itext);
                         dontwriteinfo:=TRUE;
                       END;

                     ELSE (* point allready selected, now change *)

                       FOR i:=1 TO Grawin.GetObjMaxPointNumber(winnum,obj) DO
                         DDD.SetXYZObjPointNumber(obj,i);
                         dpoi:=DDD.ReadXYZObjPoint(obj);
                         IF (dpoi.x=pointselcoords[xywin].x) AND
                            (dpoi.y=pointselcoords[xywin].y) AND
                            (dpoi.z=pointselcoords[yzwin].y) THEN
                            dpoi.x:=b[xywin].x;
                            dpoi.y:=b[xywin].y;
                            dpoi.z:=b[yzwin].y;
                           DDD.ChangeXYZObjPoint(obj,dpoi);
                         END;
                       END;

                       pointselcoords:=b;

                       DDD.CalcNewDCoords(obj);
                       DDD.ShowWhere(obj);
                       Grawin.RefreshAllWins(FALSE);

                       itext.t:=" Point changed!";
                       Grawin.TextToWinTitle(actwin,itext);
                       dontwriteinfo:=TRUE;
                     END;
                   END;
                   DDD.ShowWhere(obj); |

             'o' : Grawin.NormalTick1;
                   FOR winnum:=xywin TO yzwin DO
                     Grawin.SetCursor(winnum,0,0,Colors.scurcol,addpointsmode);
                   END; p.x:=0; p.y:=0; p.z:=0;
                   pp:=DDD.GiveXY(dddwin,p);
                   Grawin.SetCursor(dddwin,pp.x,pp.y,Colors.scurcol,addpointsmode);
                   b[xywin].x:=0;
                   b[xywin].y:=0;
                   b[yzwin].x:=0;
                   b[yzwin].y:=0;
                   Grawin.SetMouseAtWinOrg(actwin);
                   WinInfoLine(actwin);
                   itext.t:=" To window-origin!";
                   Grawin.TextToWinTitle(actwin,itext);
                   dontwriteinfo:=TRUE; |

             'O' : Grawin.NormalTick1();
                   FOR winnum:=xywin TO yzwin DO
                     pp:=Grawin.GetObjOrg(winnum,obj);
                     ppp:=Grawin.GetWinOrg(winnum);
                     pp.x:=pp.x-ppp.x;
                     pp.y:=pp.y-ppp.y;
                     IF winnum=xywin THEN p.x:=pp.x; p.y:=pp.y; END;
                     IF winnum=yzwin THEN p.z:=pp.y; END;
                     b[winnum]:=pp;
                     Grawin.SetCursor(winnum,pp.x,pp.y,Colors.scurcol,addpointsmode);
                   END;
                   pp:=DDD.GiveXY(dddwin,p);
                   Grawin.SetCursor(dddwin,pp.x,pp.y,Colors.scurcol,addpointsmode);
                   pp:=Grawin.GetObjOrg(actwin,obj);
                   ppp:=Grawin.GetWinOrg(actwin);
                   Grawin.SetMouseAtWinPos(actwin,pp.x-ppp.x,pp.y-ppp.y);
                   WinInfoLine(actwin);
                   itext.t:=" To object-origin!";
                   Grawin.TextToWinTitle(actwin,itext);
                   dontwriteinfo:=TRUE; |

             'd' : Grawin.NormalTick2();
                   IF Grawin.GetObjPointNumber(actwin,obj)=0 THEN
                     itext.t:=" !?! No more points!";
                     Grawin.TextToWinTitle(actwin,itext);
                     dontwriteinfo:=TRUE;
                     Grawin.ErrorTick;
                   ELSE

                     DDD.MakeObjBackup(obj);

                     IF addpointsmode THEN
                       FOR i:=1 TO lastpoints DO
                         FOR winnum:=xywin TO dddwin DO
                           Grawin.DeleteObjPoint(winnum,obj);
                         END;
                       END;
                       lastpoints:=1;
                       DDD.ShowWhere(obj);
                       Grawin.RefreshAllWins(FALSE);
                       itext.t:=" Point deleted!";
                       Grawin.TextToWinTitle(actwin,itext);
                       dontwriteinfo:=TRUE;
                     ELSE

                       IF pointselected THEN

                         DDD.CreateXYZObj(tempobj1);
                         DDD.SetXYZObjPointNumber(obj,1);
                         DDD.SetXYZObjScale(tempobj1,DDD.GetXYZObjScale(obj));
                         DDD.SetXYZObjOrg(tempobj1,DDD.GetXYZObjOrg(obj));

                         FOR i:=1 TO Grawin.GetObjMaxPointNumber(winnum,obj) DO
                           dpoi:=DDD.GetXYZObjPoint(obj);
                           IF NOT((dpoi.x=pointselcoords[xywin].x) AND
                                  (dpoi.y=pointselcoords[xywin].y) AND
                                  (dpoi.z=pointselcoords[yzwin].y)) THEN
                             DDD.AddXYZObjPoint(tempobj1,dpoi);
                           END;
                         END;

                         DDD.DestroyXYZObj(obj);
                         DDD.ClearDDDObj(obj);

                         DDD.CopyObjFromTo(tempobj1,obj);
                         DDD.DestroyXYZObj(tempobj1);
                         DDD.CalcNewDCoords(obj);

                         pointselected:=FALSE;
                         DDD.ShowWhere(obj);
                         Grawin.RefreshAllWins(FALSE);
                         itext.t:=" Point deleted!";
                         Grawin.TextToWinTitle(actwin,itext);
                         dontwriteinfo:=TRUE;
                       ELSE
                         itext.t:=" !?! Select a point first!";
                         Grawin.TextToWinTitle(actwin,itext);
                         dontwriteinfo:=TRUE;
                         Grawin.ErrorTick;
                       END;
                     END;
                   END; |

             '*' : Grawin.NormalTick1();
                   IF dispflag THEN
                     absdisp:=NOT(absdisp);
                     IF absdisp THEN
                       itext.t:=" Absolute coordinates!";
                     ELSE
                       itext.t:=" Relative coordinates!";
                     END;
                     Grawin.TextToWinTitle(actwin,itext);
                     dontwriteinfo:=TRUE;
                   END; |

             '+' : Grawin.NormalTick1();
                   dispflag:=NOT(dispflag);
                   IF dispflag THEN
                     itext.t:=" Coordinates on!";
                   ELSE
                     itext.t:=" Coordinates off!";
                   END;
                   (* Grawin.RefreshAllWins(FALSE); *)
                   Grawin.TextToWinTitle(actwin,itext);
                   dontwriteinfo:=TRUE; |

             'm' : Grawin.NormalTick1();
                   addpointsmode:=NOT(addpointsmode);
                   pointselected:=FALSE;
                   Grawin.RefreshAllWins(FALSE);
                   IF addpointsmode THEN
                     itext.t:=" Add points!";
                   ELSE
                     itext.t:=" Select a point!";
                   END;
                   Grawin.TextToWinTitle(actwin,itext);
                   dontwriteinfo:=TRUE; |

             'n' : Grawin.NormalTick1();
                   DDD.TurnWhereOn;
                   DDD.StoreObj(obj);
                   REPEAT
                     INC(obj);
                     IF obj>lastobj THEN obj:=firstobj; END;
                   UNTIL DDD.DoesObjExists(obj);
                   DDD.RestoreStObj(obj);
                   Grawin.SelectObj(obj);
                   DDD.ShowWhere(obj);
                   Grawin.RefreshAllWins(FALSE);
                   itext.t:=" Next object!";
                   Grawin.TextToWinTitle(actwin,itext);
                   dontwriteinfo:=TRUE; |

             'p' : Grawin.NormalTick1();
                   DDD.TurnWhereOn;
                   DDD.StoreObj(obj);
                   REPEAT
                     DEC(obj);
                     IF obj<firstobj THEN obj:=lastobj; END;
                   UNTIL DDD.DoesObjExists(obj);
                   DDD.RestoreStObj(obj);
                   Grawin.SelectObj(obj);
                   DDD.ShowWhere(obj);
                   Grawin.RefreshAllWins(FALSE);
                   itext.t:=" Previous object!";
                   Grawin.TextToWinTitle(actwin,itext);
                   dontwriteinfo:=TRUE; |

             '.' : Grawin.NormalTick1();
                   showallpoints:=NOT(showallpoints);
                   Grawin.RefreshAllWins(FALSE);
                   IF showallpoints THEN
                     itext.t:=" Show points!";
                   ELSE
                     itext.t:=" Don't show points!";
                   END;
                   Grawin.TextToWinTitle(actwin,itext);
                   dontwriteinfo:=TRUE; |

             '#' : Grawin.NormalTick1();
                   Grawin.ToggleSnap;
                   IF Grawin.InSnapMode() THEN
                     itext.t:=" Snapmode on!";
                   ELSE
                     itext.t:=" Snapmode off!";
                   END;
                   Grawin.TextToWinTitle(actwin,itext);
                   dontwriteinfo:=TRUE;

      END;
    END;

    IF scenedone THEN
      EXIT;
    END;
  END;
  RETURN(obj);
END ObjectEdit;

(* end of capsle *)

BEGIN

  absdisp:=FALSE;
  dispflag:=TRUE;
  gridflag:=FALSE;
  showallpoints:=FALSE;
  gridstep:=10;
  cursorstep:=10;
  addpointsmode:=TRUE;
  dontwriteinfo:=FALSE;

  p.z:=0;
  p.x:=0;
  p.y:=0;
  actwin:=xywin;
  setscenemenus:=SetSceneMenus;

  FOR i:=1 TO HIGH(alltrue) DO
    alltrue[i]:=TRUE;
  END;
  FOR i:=1 TO HIGH(nokeys) DO
    nokeys[i]:="";
  END;

END SceneEd.

