IMPLEMENTATION MODULE WorldEd;

IMPORT Guitool;
IMPORT Handler;
IMPORT Info;
IMPORT Grawin;
IMPORT SceneEd;
IMPORT ObjView;
IMPORT DDD;
IMPORT Colors;
IMPORT InOut;
IMPORT Disk;
IMPORT IntMen;

FROM Mouse    IMPORT SetMousePos, WaitForEvents, WaitForAnything, StoreMousePos,
                     RestoreMousePos, InitMouse, GetMouseState, ConfPosChanged,
                     SetWaitProc, EnableWaitProcEvery, DisableWaitProc;

FROM FIO      IMPORT PathTail;
FROM KeyConst IMPORT Space, Enter, PgUp, PgDown, CurLeft, CurRight, CurUp, CurDown, StrgCurUp, StrgCurDown, StrgCurLeft, StrgCurRight;
FROM Str      IMPORT Length, Concat, IntToStr;
FROM NewTerm  IMPORT Scan, GotoXY, SetFGColor, SetBGColor, Scroll, SetMaxWindow, xormode;
FROM NewIO    IMPORT WriteLn, Read, ReadCard, ReadInt, Write, Done, UseDefault;
FROM NewIO    IMPORT WriteString, WriteInt, WriteCard, WriteLongCard, ReadString;
FROM DDD      IMPORT Max, Min, ROUND, PI (*, WriteColor, ReadColor,
                           Write2DCoord, Read2DCoord, WriteBOOL, ReadBOOL,
                           Write3DCoord, Read3DCoord; *) ;

TYPE functions = (nil, scale, rotate, scenemisc, handler, helppage, seteye, setplane,
                       laygrid, disk, preferences, about, undo, done);

     funtions2 = (nil2, view, stereoview);

     objtable = RECORD
                  crossflag     : BOOLEAN;
                  eyeflag       : BOOLEAN;
                  planeflag     : BOOLEAN;
                  orgflag       : BOOLEAN;
                  lasteditedobj : CARDINAL;
                  activewin     : CARDINAL;
                  eyepos        : DDD.DCoord;
                  curpos        : DDD.DCoord;
                  fz            : INTEGER;
                  names  : SceneEd.tobjnames;
                  flags  : ARRAY[SceneEd.firstobj..SceneEd.lastobj] OF BOOLEAN;
                  scale  : ARRAY[SceneEd.firstobj..SceneEd.lastobj] OF DDD.DScale;
                  org    : ARRAY[SceneEd.firstobj..SceneEd.lastobj] OF ARRAY[SceneEd.xywin..SceneEd.yzwin] OF Grawin.Coord;
                  allorg : ARRAY[SceneEd.xywin..SceneEd.yzwin]      OF Grawin.Coord;
                  index  : ARRAY[SceneEd.firstobj..SceneEd.lastobj] OF RECORD start, end : CARDINAL; END;
                END;

VAR winorg  : ARRAY[SceneEd.xywin..SceneEd.dddwin] OF Grawin.Coord;
    winfrom : ARRAY[SceneEd.xywin..SceneEd.dddwin] OF Grawin.Coord;
    winto   : ARRAY[SceneEd.xywin..SceneEd.dddwin] OF Grawin.Coord;
    winzoom : ARRAY[SceneEd.xywin..SceneEd.dddwin] OF REAL;

    xareamin, xareamax : INTEGER;
    yareamin, yareamax : INTEGER;
    zareamin, zareamax : INTEGER;

    table : ARRAY[firstscene..lastscene] OF objtable;
    cur, pp : Grawin.Coord;
    i, ii, scene, actwin, winnum, lastwin : CARDINAL;
    gridstep, cursorstep : CARDINAL;
    oeyepos : DDD.DCoord;
    ofz : INTEGER;
    dontwriteinfo, dispflag, absdisp, worlddone, handleract, gridflag, orgflag : BOOLEAN;

    pz, p : DDD.DCoord;
    c : CHAR;
    a : ARRAY[xywin..dddwin] OF Grawin.Coord;
    sceneflags : ARRAY[firstscene..lastscene] OF BOOLEAN;

    alltrue : ARRAY[1..20] OF BOOLEAN;
    nokeys  : ARRAY[1..20] OF CHAR;
    setworldmenus : PROC;

    text : ARRAY[1..27] OF Grawin.CTLine;
    itext  : Grawin.CTLine;
    keys : ARRAY[1..10] OF CHAR;

PROCEDURE SetGridstep(step : CARDINAL);
BEGIN
  gridstep:=step;
END SetGridstep;

PROCEDURE GetGridstep():CARDINAL;
BEGIN
  RETURN(gridstep);
END GetGridstep;

PROCEDURE SetCursorstep(step : CARDINAL);
BEGIN
  cursorstep:=step;
END SetCursorstep;

PROCEDURE GetCursorstep():CARDINAL;
BEGIN
  RETURN(cursorstep);
END GetCursorstep;

PROCEDURE SetXArea(min, max : INTEGER);
BEGIN
  xareamin:=min;
  xareamax:=max;
END SetXArea;

PROCEDURE SetYArea(min, max : INTEGER);
BEGIN
  yareamin:=min;
  yareamax:=max;
END SetYArea;

PROCEDURE SetZArea(min, max : INTEGER);
BEGIN
  zareamin:=min;
  zareamax:=max;
END SetZArea;

PROCEDURE WinInfoLine(actwin : CARDINAL);
VAR pp, ppp : Grawin.Coord;
    poi : Grawin.Point;
    winbackcol : Grawin.RGB;
BEGIN
  xormode:=FALSE;
  Grawin.ClipWithWin(actwin);
  winbackcol:=Grawin.GetWinBackCol(actwin);
  SetFGColor(Colors.swinhicol.r,Colors.swinhicol.g,Colors.swinhicol.b);
  SetBGColor(winbackcol.r,winbackcol.g,winbackcol.b);
  pp:=Grawin.GetWinPos(actwin);
  GotoXY((pp.x+1)*8,(pp.y+1)*16);
  IF dispflag AND (actwin<>dddwin) THEN
    Write(" ");
    IF DDD.IsWhereOn() THEN Write("F"); ELSE Write("-"); END;
    Write(" ");
    IF Grawin.InSnapMode() THEN Write("#"); ELSE Write("~"); END;
    Write(" ");
    IF absdisp THEN
      WriteInt(p.x,5);
      Write(",");
      WriteInt(p.y,5);
      Write(",");
      WriteInt(p.z,5);
    ELSE
      ppp:=Grawin.GetObjOrg(xywin,scene);
      pp:=Grawin.GetWinOrg(xywin);
      WriteInt(p.x+pp.x-ppp.x,5);
      Write("|");
      WriteInt(p.y+pp.y-ppp.y,5);
      Write("|");
      ppp:=Grawin.GetObjOrg(yzwin,scene);
      pp:=Grawin.GetWinOrg(yzwin);
      WriteInt(p.z+pp.y-ppp.y,5);
    END;
    Write(" ");
    Write(" ");
  END;
END WinInfoLine;

(* Procedure called by module GRAWIN, if size of window has changed *)

PROCEDURE Inform(scenenum : CARDINAL);
VAR winbackcol : Grawin.RGB;
    string : Grawin.LString;
    ok : BOOLEAN;
    ttext : Grawin.CTLine;

BEGIN

  xormode:=FALSE;
  winbackcol:=Grawin.GetWinBackCol(dddwin);
  SetFGColor(Colors.wwintitlecol.r,Colors.wwintitlecol.g,Colors.wwintitlecol.b);
  SetBGColor(winbackcol.r,winbackcol.g,winbackcol.b);
  ttext.c:=itext.c;

  IF scenenum<=lastscene THEN
    Concat(ttext.t,"4 World-3D  Name: ",scenenames[scenenum]);
  ELSE
    ttext.t:="4 World-3D  Name: -----";
  END;

  IntToStr(LONGINT(Grawin.GetObjMaxPointNumber(dddwin,scenenum)),
           string,10,ok);
  Concat(string," Points: ",string);
  Concat(ttext.t,ttext.t,string);

  IntToStr(LONGINT(Info.GetFreeKB()),string,10,ok);
  Concat(string," Mem: ",string);
  Concat(ttext.t,ttext.t,string);

  Grawin.ClipWithWin(dddwin);
  Grawin.ConTextToWinTitle(dddwin,ttext);

END Inform;

PROCEDURE Adjust(VAR actwin, scenenum: CARDINAL);
VAR pp : Grawin.Coord;

BEGIN
  Grawin.RefreshAllWins(TRUE);
END Adjust;

PROCEDURE Refresh(VAR actwin, scenenum : CARDINAL);
VAR pp, ppp : Grawin.Coord;

    i, fx, fy : INTEGER;
    r : REAL;
BEGIN

  xormode:=FALSE;
  IF gridflag AND (actwin<>dddwin) THEN
    pp:=Grawin.GetWinOrg(actwin);
    r:=Grawin.GetWinZoom(actwin);
    fx:=ROUND(REAL(gridstep)*r);
    fy:=ROUND(REAL(gridstep)*r);
    Grawin.LayGrid(actwin,fx,fy,ABS(pp.x) MOD fx,ABS(pp.y) MOD fy,Colors.wgridcol);
  END;

  DDD.ShowPlane(actwin);
  DDD.ShowEye(actwin);
  DDD.ShowOrg(actwin,scenenum);

  DDD.DrawStObjsToWin(actwin);
  Grawin.DrawWinObjlist(actwin,FALSE);

  IF actwin=dddwin THEN
    Inform(scenenum);
  END;

  Grawin.ShowCursor(actwin,Colors.wcurcol,TRUE);
END Refresh;

PROCEDURE Error();
BEGIN
  IntMen.Error();
END Error;

PROCEDURE Scale(VAR actwin, scenenum : CARDINAL);
BEGIN
  DDD.MakeObjBackup(scenenum);
  IntMen.ScaleInt(scenenum);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Scene scaled!";
  Grawin.TextToWinTitle(actwin,itext);
  dontwriteinfo:=TRUE;
END Scale;

PROCEDURE Rotate(VAR actwin, scenenum : CARDINAL);

BEGIN
  DDD.MakeObjBackup(scenenum);
  IntMen.RotateInt(scenenum);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Scene rotated!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END Rotate;

PROCEDURE CreateScene(VAR actwin, scenenum : CARDINAL);

BEGIN
  DDD.CopyToLocalNames(scenenames);
  scene:=IntMen.CreateObjInt(scenenum,TRUE);
  DDD.CopyFromLocalNames(scenenames);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Scene created!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END CreateScene;

PROCEDURE SelectScene(VAR actwin, scenenum : CARDINAL);
BEGIN
  DDD.CopyToLocalNames(scenenames);
  scene:=IntMen.SelectObjInt(scenenum);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Scene selected!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END SelectScene;

PROCEDURE InitSceneTable(scene : CARDINAL);
VAR ii : CARDINAL;
BEGIN
  WITH table[scene] DO
    FOR ii:=SceneEd.firstobj TO SceneEd.lastobj DO
      names[ii]:=" : _____";
      names[ii,1]:=CHR(65+ii-SceneEd.firstobj);
      flags[ii]:=TRUE;
    END;

    scenenames[scene]:=" : _____";
    scenenames[scene,1]:=CHR(65+scene-firstscene);

    lasteditedobj:=0;
    eyeflag:=TRUE;
    planeflag:=TRUE;
    crossflag:=TRUE;
    orgflag:=TRUE;
    activewin:=SceneEd.xywin;
    eyepos.x:=60;
    eyepos.y:=60;
    eyepos.z:=60;
    fz:=-60;
  END;
END InitSceneTable;

PROCEDURE DestroyScene(VAR actwin, scenenum : CARDINAL);

VAR c: CHAR;
BEGIN
  DDD.CopyToLocalNames(scenenames);
  scene:=IntMen.DestroyObjInt(scenenum);
  DDD.CopyFromLocalNames(scenenames);
  DDD.DestroyStObjBackup();
  InitSceneTable(scene);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Scene destroyed!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END DestroyScene;

PROCEDURE MoveScene(VAR actwin, scenenum : CARDINAL);

BEGIN
  DDD.MakeObjBackup(scene);
  IntMen.MoveObj(scenenum,a);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Scene moved!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END MoveScene;

PROCEDURE ResetWin(VAR actwin, scenenum : CARDINAL);
BEGIN
  IntMen.ResetWin(actwin,scenenum);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Window reseted!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END ResetWin;

PROCEDURE ScrollWin(VAR actwin, objnum : CARDINAL);
VAR keyflag, strg, bleft, bright, pos, flag : BOOLEAN;
    mousex, mousey : CARDINAL;
    dx, dy : INTEGER;
    key : CHAR;
    pp : Grawin.Coord;

BEGIN
  flag:=dispflag;
  dispflag:=FALSE;
  Grawin.DrawWin(actwin,TRUE,FALSE);
  itext.t:=' Scroll: cur.keys, mouse';
  itext.c:=Colors.swintitlecol;
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
  StoreMousePos;
  InitMouse(0,0,2*800,2*600);
  SetMousePos(800,600);
  pp:=Grawin.GetWinOrg(actwin);
  dx:=0;
  dy:=0;
  REPEAT
    ConfPosChanged;
    WaitForEvents(bleft,bright,pos,keyflag,strg,key);
    IF keyflag AND strg THEN
      CASE key OF
        CurLeft  : DEC(dx); |
        CurRight : INC(dx); |
        CurUp    : DEC(dy); |
        CurDown  : INC(dy);
      END;
      SetMousePos(800+dx*10,600+dy*10);
    ELSIF pos THEN
      GetMouseState(mousex,mousey,bleft,bright);
      dx:=(INTEGER(mousex)-800) DIV 10;
      dy:=(INTEGER(mousey)-600) DIV 10;
    END;
    IntMen.ScrollInt(actwin,pp,dx,dy);
  UNTIL (key=Enter) OR bleft;
  Grawin.NormalTick2();
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Window scrolled!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
  dispflag:=flag;
  RestoreMousePos;
END ScrollWin;

PROCEDURE ZoomWin(VAR actwin, objnum : CARDINAL);
VAR pp : Grawin.Coord;
    keyflag, strg, bleft, bright, pos, flag : BOOLEAN;
    mousex, mousey : CARDINAL;
    key : CHAR;
    zoom : REAL;
    dy : INTEGER;

BEGIN
  flag:=dispflag;
  dispflag:=FALSE;
  Grawin.DrawWin(actwin,TRUE,FALSE);
  itext.t:=' Zoom: cur.keys, mouse';
  itext.c:=Colors.swintitlecol;
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
  StoreMousePos;
  InitMouse(0,0,1,510);

  zoom:=Grawin.GetWinZoom(actwin);
  SetMousePos(0,ROUND(zoom*50.0));

  dy:=0;
  REPEAT
    WaitForEvents(bleft,bright,pos,keyflag,strg,key);
    IF keyflag AND strg THEN
      IF key=CurUp THEN
        DEC(dy);
        mousey:=CARDINAL(Min(510,INTEGER(ROUND(zoom*50.0))+dy*10));
        SetMousePos(0,mousey);
      END;
      IF key=CurDown THEN
        INC(dy);
        mousey:=CARDINAL(Max(0,INTEGER(ROUND(zoom*50.0))+dy*10));
        SetMousePos(0,mousey);
      END;
      GetMouseState(mousex,mousey,bleft,bright);
      dy:=((INTEGER(mousey)-ROUND(zoom*50.0)) DIV 10);
    ELSIF pos THEN
      GetMouseState(mousex,mousey,bleft,bright);
      dy:=((INTEGER(mousey)-ROUND(zoom*50.0)) DIV 10);
    END;
    IntMen.ZoomInt(actwin,zoom,dy);
  UNTIL (key=Enter) OR bleft;
  Grawin.NormalTick2();
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Window zoomed!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
  dispflag:=flag;
  pp:=Grawin.GetCurPos(actwin);
  RestoreMousePos;
  Grawin.SetMouseAtWinPos(actwin,pp.x,pp.y);

END ZoomWin;

PROCEDURE SceneHandler(VAR actwin, scenenum : CARDINAL);
VAR winnum : CARDINAL;

BEGIN
  IF Grawin.GetObjMaxPointNumber(actwin,scenenum)<2 THEN
    itext.t:=" !?! No points!";
    Grawin.RefreshAllWins(TRUE);
    Grawin.ErrorTick();
    dontwriteinfo:=TRUE;
    Grawin.TextToWinTitle(actwin,itext);
    RETURN;
  END;
  DDD.MakeObjBackup(scenenum);
  handleract:=TRUE;
  Handler.ObjectHandlerInt(actwin,scenenum);
  handleract:=FALSE;
  FOR winnum:=xywin TO dddwin DO
    Grawin.SetWinScrollProc(winnum,ScrollWin);
    Grawin.SetWinZoomProc(winnum,ZoomWin);
  END;
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Scene handled!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
  setworldmenus; (* Compiler austricksen *)
END SceneHandler;

PROCEDURE Scene(VAR actwin, scenenum : CARDINAL);
VAR winnum, i : CARDINAL;
    key : CHAR;

BEGIN
  DDD.CopyToLocalNames(scenenames);
  key:=Grawin.WaitForKey(500);
  itext.c:=Colors.swinhicol;

  keys[1]:="i";
  keys[2]:="n";
  keys[3]:="x";
  keys[4]:="r";
  keys[5]:="c";
  keys[6]:="m";
  keys[7]:="w";
  keys[8]:="a";
  keys[9]:="z";
  keys[10]:="y";

  IF key='' THEN

    text[1].c:=Colors.ititlecol;
    text[2].c:=Colors.ipromptcol;
    itext.c:=Colors.swintitlecol;
    text[1].t:='Scene-Function.';
    text[2].t:='Please choose: ';
    Grawin.ShowInfoBox(10,10,2,text);

    Grawin.ColFromTo(text,Colors.itextcol,1,10);

    text[1].t:='Hide/show some scenes......';
    text[2].t:='Create new scene...........';
    text[3].t:='Destroy existing scene.....';
    text[4].t:='Rename existing scene......';
    text[5].t:='Copy actual scene..........';
    text[6].t:='Move actual scene..........';
    text[7].t:='Where is actual scene......';
    text[8].t:='Select actual scene........';
    text[9].t:='Interactiv scene-handler...';
    text[10].t:='Yank scenes together.......';

    i:=Grawin.ShowChooseBox(12,14,10,text,keys,alltrue,1);
    IF i>0 THEN key:=keys[i]; ELSE key:=''; END;
  END;
  CASE key OF
    'i' : IntMen.HideShowObjInt(scene);
          Grawin.RefreshAllWins(TRUE);
          itext.t:=" Scene hide/show!";
          dontwriteinfo:=TRUE;
          Grawin.TextToWinTitle(actwin,itext);|
    'n' : CreateScene(actwin,scene); |
    'a' : SelectScene(actwin,scene); |
    'r' : IntMen.RenameObjInt(scene);
          DDD.CopyFromLocalNames(scenenames);
          Grawin.RefreshAllWins(TRUE);
          itext.t:=" Scene renamed!";
          dontwriteinfo:=TRUE;
          Grawin.TextToWinTitle(actwin,itext); |
    'x' : DestroyScene(actwin,scene); |
    'w' : DDD.ToggleWhere;
          DDD.ShowWhere(scene);
          Grawin.RefreshAllWins(TRUE);
          IF DDD.IsWhereOn() THEN
            itext.t:=" Whereframe on!";
          ELSE
            itext.t:=" Whereframe off!";
          END;
          dontwriteinfo:=TRUE;
          Grawin.TextToWinTitle(actwin,itext); |
    'm' : MoveScene(actwin,scene); |
    'z' : SceneHandler(actwin,scene); |
    'y' : scene:=IntMen.YankObjsTogetherInt(scene);
          DDD.CopyFromLocalNames(scenenames);
          Grawin.RefreshAllWins(TRUE);
          itext.t:=" Scenes yanked!";
          dontwriteinfo:=TRUE;
          Grawin.TextToWinTitle(actwin,itext); |
    'c' : scene:=IntMen.CopyObjInt(scene);
          DDD.CopyFromLocalNames(scenenames);
          Grawin.RefreshAllWins(TRUE);
          itext.t:=" Scene copied!";
          dontwriteinfo:=TRUE;
          Grawin.TextToWinTitle(actwin,itext); |
    ''  : Grawin.RefreshAllWins(TRUE);
  END;
END Scene;

PROCEDURE View(VAR actwin, scenenum : CARDINAL);

BEGIN
  ObjView.View(scenenum, FALSE);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Viewer done!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END View;

PROCEDURE View3D(VAR actwin, scenenum : CARDINAL);

BEGIN
  ObjView.View(scenenum,TRUE);
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Viewer done!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END View3D;

PROCEDURE WorldDone(VAR actwin, scenenum : CARDINAL);
BEGIN
  IF Grawin.InErrorState() THEN RETURN; END;
  worlddone:=TRUE;
END WorldDone;

PROCEDURE Helppages(VAR actwin, scenenum : CARDINAL);
VAR
    c : CHAR;
    selected, i : CARDINAL;

BEGIN

  selected:=1;
  REPEAT

    text[1].t:="Helppages.";
    text[2].t:="Please choose:";
    text[1].c:=Colors.ititlecol;
    text[2].c:=Colors.ipromptcol;
    Grawin.ShowInfoBox(10,10,2,text);

    text[1].t:="Mouse- or keyboard-handling";
    text[2].t:="Menus & bindkeys";
    text[3].t:="Windowhandling";

    Grawin.ColFromTo(text,Colors.itextcol,1,3);
    selected:=Grawin.ShowChooseBox(12,14,3,text,nokeys,alltrue,selected);

    CASE selected OF
      1 : Grawin.ColFromTo(text,Colors.ipromptcol,3,12);
          text[1].t:=" How to use the scene-editor with the mouse or keyboard _____________ ";
          text[1].c:=Colors.ititlecol;
          text[2].t:=" ____________________________________________________________________ ";
          text[2].c:=Colors.ialacol;
          text[3].t:=" CURSORKEYS (+/- ALT) | MOUSE             = Move the cursor!";
          text[4].t:=" SPACE | LEFT MOUSEBUTTON, pressed short  = Edit actual scene";
          text[5].t:=" ____________________________________________________________________ ";
          text[5].c:=Colors.ialacol;

          text[6].t:=" o = Set cursor to window-origin";
          text[7].t:=" O = Set cursor to scene-origin";
          text[8].t:=" + = Turn cursor-position-display on/off";
          text[9].t:=" * = Toggel between relative and absolute cursor-cordinates";
          text[10].t:=" # = Turn snap-mode on/off";
          text[11].t:=" n = Select next scene and show frame-box";
          text[12].t:=" p = Select previous scene and show frame-box";
          Grawin.ShowInfoBox(4,2,12,text); |

      2 : Grawin.ColFromTo(text,Colors.ipromptcol,3,27);
          Grawin.ColFromTo(text,Colors.itextcol,10,23);
          text[1].t:=" How to use world-editor's menus and bindkeys ____________________ ";
          text[1].c:=Colors.ititlecol;
          text[2].t:=" _________________________________________________________________ ";
          text[2].c:=Colors.ialacol;
          text[3].t:=" ENTER | RIGHT MOUSEBUTTON = Window's menu pops up";
          text[4].t:=" ALT <key>, <key>...       = Call menu-item directly";
          text[5].t:=" When the window's menu poped up, you can use:";
          text[5].c:=Colors.itextcol;
          text[6].t:=" SPACE      | RIGHT MOUSEBUTTON    = Toggle between menu-pages";
          text[7].t:=" CURSORKEYS | MOUSE UP, MOUSE DOWN = Choose one menu-items";
          text[8].t:=" ENTER      | LEFT MOUSEBUTTON     = Activate menu-item!";
          text[9].t:=" ESC                               = Quit window's menu";
          text[10].t:="__________________________________________________________________ ";
          text[10].c:=Colors.ialacol;
          text[11].t:=" Menuitems can be activated as described above, but there is also";
          text[12].t:=" a faster method: use the bindkeys!  Each bindkeys lets you acti-";
          text[13].t:=" vate the item directly without opening the menu-pages.  You have";
          text[14].t:=" to press ALT and the listed bindkey. For example, if you want to";
          text[15].t:=" create a new object, you first press ALT f, then (quickly) n.";
          text[16].t:=" If you wait to long for the second key, a choosebox will pop up;";
          text[17].t:=" bindkeys are also listed.  ATTENTION: choosebox-bindkeys are NOT";
          text[18].t:=" activated with ALT and key, press simply the key that is listed.";
          text[19].t:=" If choosebox has poped-up,  you also have to confirm with ENTER.";
          text[20].t:=" You need not press ENTER if you press the  second key BEFORE the";
          text[21].t:=" box pops up.  Other example: press ALT u to undo last operation.";
          text[22].t:="__________________________________________________________________ ";
          text[22].c:=Colors.ialacol;
          text[23].t:=" When a choose-box pops up, you can use:";
          text[23].c:=Colors.itextcol;
          text[24].t:=" ESC | RIGHT MOUSEBUTTON           = Quit choose-box";
          text[25].t:=" CURSORKEYS | MOUSE UP, MOUSE DOWN = Choose one choose-box-item";
          text[26].t:=" ENTER      | LEFT MOUSEBUTTON     = Activate choose-box-item!";
          text[27].t:=" <listed bindkey>                  = Choose item with that bindkey";
          Grawin.ShowInfoBox(4,1,27,text); |

      3 : Grawin.ColFromTo(text,Colors.ipromptcol,3,19);
          text[1].t:=" How to manage the windows __________________________________________ ";
          text[1].c:=Colors.ititlecol;
          text[2].t:=" ____________________________________________________________________ ";
          text[2].c:=Colors.ialacol;
          text[3].t:=" ENTER | RIGHT MOUSEBUTTON = Window's menu pops up";
          text[4].t:=" ALT <key>, <key>...       = Call menu-item directly";
          text[5].t:=" When the window's menu poped up, you can use:";
          text[5].c:=Colors.itextcol;
          text[6].t:=" SPACE      | RIGHT MOUSEBUTTON    = Toggle between menu-pages";
          text[7].t:=" CURSORKEYS | MOUSE UP, MOUSE DOWN = Choose on menu-items";
          text[8].t:=" ENTER      | LEFT MOUSEBUTTON     = Activate menu-item!";
          text[9].t:=" ESC                               = Quit window's menu";
          text[10].t:="____________________________________________________________________ ";
          text[10].c:=Colors.ialacol;
          text[11].t:=" TAB  = Bring next window in window-list to front, cycling";
          text[12].t:=" 0..9 = Bring window with pressed number-key to front ";
          text[13].t:=" F1   = Move window with MOUSE | CURSORKEYS, SPACE, R. MB, ENTER";
          text[14].t:=" F2   = Size window with MOUSE | CURSORKEYS, SPACE, R. MB, ENTER";
          text[15].t:=" F3   = Refresh all windows";
          text[16].t:=" F4   = Clean up desktop, bring all windows to their inital-position";
          text[17].t:=" F5   = Zoom   window's contents with MOUSE | CURSORK., ENTER, R. MB";
          text[18].t:=" F6   = Scroll window's contents with MOUSE | CURSORK., ENTER, R. MB";
          text[19].t:=" HOM  = Reset current window";
          Grawin.ShowInfoBox(4,6,19,text);
    END;

    IF selected<>0 THEN
      WaitForAnything;
    END;
    Grawin.RefreshAllWins(TRUE);
  UNTIL selected=0;

  itext.t:=" Helppages shown!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);

END Helppages;

PROCEDURE About(VAR actwin, scenenum : CARDINAL);
BEGIN
  IntMen.About();
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Aboutbox shown!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END About;

PROCEDURE Preferences(VAR actwin, scenenum : CARDINAL);
VAR selected, i : CARDINAL;
    min, max : INTEGER;
    p : Grawin.Coord;

BEGIN

  UseDefault;
  text[1].t:="Preferences.";
  text[2].t:="Please choose:";
  text[1].c:=Colors.ititlecol;
  text[2].c:=Colors.ipromptcol;

  Grawin.ShowInfoBox(10,10,2,text);

  text[1].t:="Change Colors.......";
  text[2].t:="Change gridstep.....";
  text[3].t:="Change Cursorstep...";
  text[4].t:="Change [Xmin;Xmax]..";
  text[5].t:="Change [Ymin;Ymax]..";
  text[6].t:="Change [Zmin;Zmax]..";

  Grawin.ColFromTo(text,Colors.itextcol,1,6);

  selected:=Grawin.ShowChooseBox(12,14,6,text,nokeys,alltrue,1);

  text[1].c:=Colors.ititlecol;
  text[2].c:=Colors.ipromptcol;
  text[3].c:=Colors.ipromptcol;

  CASE selected OF
    1 : IntMen.ChangeColorsInt(actwin,scenenum);
        Grawin.RefreshAllWins(TRUE);
        itext.t:=" Colors changed!";
        dontwriteinfo:=TRUE;
        Grawin.TextToWinTitle(actwin,itext);|
    2 : text[1].t:="Change Gridstep.";
        text[2].t:="Please enter new";
        text[3].t:="gridstep: ";
        REPEAT
          Grawin.ShowInfoBox(37,14,3,text);
          ReadCard(gridstep);
        UNTIL Done AND (gridstep>=5);
        Grawin.RefreshAllWins(TRUE);
        itext.t:=" Gridstep changed!";
        dontwriteinfo:=TRUE;
        Grawin.TextToWinTitle(actwin,itext);|
    3 : text[1].t:="Change Cursorstep.";
        text[2].t:="Please enter new";
        text[3].t:="cursorstep: ";
        REPEAT
          Grawin.ShowInfoBox(37,14,3,text);
          ReadCard(cursorstep);
        UNTIL Done AND (cursorstep>=5);
        Grawin.SetCursorstep(cursorstep);
        Grawin.RefreshAllWins(TRUE);
        itext.t:=" Cursorstep changed!";
        dontwriteinfo:=TRUE;
        Grawin.TextToWinTitle(actwin,itext); |

    4, 5, 6 :
        CASE selected OF
          4 : text[1].t:=" Change [Xmin;Xmax].";
              text[3].t:=" Xmin: ";
              min:=xareamin;
              max:=xareamax; |
          5 : text[1].t:=" Change [Ymin;Ymax].";
              text[3].t:=" Ymin: ";
              min:=yareamin;
              max:=yareamax; |
          6 : text[1].t:=" Change [Zmin;Zmax].";
              text[3].t:=" Zmin: ";
              min:=zareamin;
              max:=zareamax;
        END;

        text[2].t:=" Please enter new";

        REPEAT
          Grawin.ShowInfoBox(37,14,3,text);
          ReadInt(min);
        UNTIL Done AND (min>=-1000) AND (min<=1000);

        CASE selected OF
          4 : text[3].t:=" Xmax: "; |
          5 : text[3].t:=" Ymax: "; |
          6 : text[3].t:=" Zmax: ";
        END;

        REPEAT
          Grawin.ShowInfoBox(37,14,3,text);
          ReadInt(max);
        UNTIL Done AND (max>min);

         CASE selected OF
           4 : xareamin:=min;
               xareamax:=max; |
           5 : yareamin:=min;
               yareamax:=max; |
           6 : zareamin:=min;
               zareamax:=max;
         END;

         Grawin.RefreshAllWins(TRUE);
         itext.t:=" Area changed!";
         dontwriteinfo:=TRUE;
         Grawin.TextToWinTitle(actwin,itext);
  ELSE
    Grawin.RefreshAllWins(TRUE);
  END;

END Preferences;

PROCEDURE AdjustEye(VAR actwin, scenenum : CARDINAL);
VAR i : CARDINAL;
    pd : DDD.DCoord;
BEGIN

  pd.x:=a[xywin].x;
  pd.y:=a[xywin].y;
  pd.z:=a[yzwin].y;
  DDD.SetEyePos(pd);
  DDD.AdjustDCross(dddwin,crossobj,cursorstep);

  FOR i:=firstscene TO lastscene DO
    IF DDD.IsAName(scenenames[i]) THEN
      DDD.CalcNewDCoords(i);
    END;
  END;
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Eyeposition changed!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END AdjustEye;

PROCEDURE AdjustPlane(VAR actwin, scenenum : CARDINAL);
VAR i : CARDINAL;
    pd : DDD.DCoord;

BEGIN

  DDD.SetPlaneDist(a[yzwin].y);
  DDD.AdjustDCross(dddwin,crossobj,cursorstep);

  FOR i:=firstscene TO lastscene DO
    IF DDD.IsAName(scenenames[i]) THEN
      DDD.CalcNewDCoords(i);
    END;
  END;
  Grawin.RefreshAllWins(TRUE);
  itext.t:=" Planedistance changed!";
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END AdjustPlane;

PROCEDURE Grid(VAR actwin, scenenum : CARDINAL);

BEGIN
  gridflag:=NOT(gridflag);
  Grawin.RefreshAllWins(TRUE);
  IF gridflag THEN
    itext.t:=" Grid on!";
  ELSE
    itext.t:=" Grid off!";
  END;
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END Grid;

(* Save and load to/from disk *)

PROCEDURE DiskFunc(VAR actwin, scenenum : CARDINAL);

VAR key : CHAR;
    name, name2 : Grawin.LString;
    a : INTEGER;
    p, pp : Grawin.Coord;
    pd : DDD.DCoord;
    obj, max, winnum, x, y, i, ii, n : CARDINAL;
    r : REAL;
    c : CHAR;
    fn : PathTail;
    flag : BOOLEAN;

BEGIN

  DDD.CopyToLocalNames(scenenames);


  keys[1]:="s";
  keys[2]:="l";
  keys[3]:="t";
  keys[4]:="c";
  keys[5]:="d";

  DDD.StoreObj(scenenum);

  key:=Grawin.WaitForKey(500);
  CASE key OF
    's' : i:=1; |
    'l' : i:=2; |
    't' : i:=3; |
    'c' : i:=4; |
    'd' : i:=5;
  ELSE

    text[1].t:='Disk-Function';   
    text[2].t:='Please choose: ';
    text[1].c:=Colors.ititlecol;
    text[2].c:=Colors.ipromptcol;
    Grawin.ShowInfoBox(10,10,2,text);

    Grawin.ColFromTo(text,Colors.itextcol,1,5);
    text[1].t:='Save World.........';
    text[2].t:='Load World.........';
    text[3].t:='TeX-Output.........';
    text[4].t:='Save Config........';
    text[5].t:='Show Directory.....';

    i:=Grawin.ShowChooseBox(12,14,5,text,keys,alltrue,1);
  END;

  IF i=0 THEN
    DDD.RestoreStObj(scenenum);
    Grawin.RefreshAllWins(TRUE);
    RETURN;
  END;

  IF i=3 THEN
     text[1].t:='Save TeX-File.';
     text[2].t:='Please choose:';
     text[1].c:=Colors.ititlecol;
     text[2].c:=Colors.ipromptcol;
     Grawin.ShowInfoBox(10,10,2,text);

     text[1].t:='XY-Window...';
     text[2].t:='XZ-Window...';
     text[3].t:='YZ-Window...';
     text[4].t:='3D-Window...';
     Grawin.ColFromTo(text,Colors.itextcol,1,4);

     ii:=Grawin.ShowChooseBox(12,14,4,text,nokeys,alltrue,1);
     IF ii=0 THEN Grawin.RefreshAllWins(TRUE); RETURN; END;
  END;

  IF (i=1) OR (i=3) THEN
    text[1].t:="Please enter file-  ";
    text[2].t:="name:               ";
    text[3].t:="";
    text[1].c:=Colors.ipromptcol;
    text[2].c:=Colors.ipromptcol;
    text[3].c:=Colors.ientercol;

    REPEAT
      Grawin.ShowInfoBox(12,14,3,text);
      ReadString(fn);
      IF fn[1]='' THEN Grawin.RefreshAllWins(TRUE); DDD.RestoreStObj(scenenum); RETURN; END;
    UNTIL Done AND (Length(fn)<9);
  ELSE
    fn:="pw.cfg";
  END;
  IF i=2 THEN
    fn:=Guitool.PickFile("wor");
    IF fn[1]=CHR(0) THEN
      DDD.RestoreStObj(scenenum);
      Grawin.RefreshAllWins(TRUE); RETURN;
    END;
  END;

  CASE i OF
    1 : Disk.SaveStObjects(fn,'wor');

        FOR winnum:=xywin TO dddwin DO
          pp:=Grawin.GetWinPos(winnum);
          Disk.Write2DCoord(pp);

          pp:=Grawin.GetWinSize(winnum);
          Disk.Write2DCoord(pp);

          pp:=Grawin.GetWinOrg(winnum);
          Disk.Write2DCoord(pp);

          r:=Grawin.GetWinZoom(winnum);
          InOut.WriteInt(ROUND(r*1000.0),1); InOut.WriteLn;
        END;

        FOR winnum:=SceneEd.xywin TO SceneEd.dddwin DO
          Disk.Write2DCoord(winorg[winnum]);
          Disk.Write2DCoord(winfrom[winnum]);
          Disk.Write2DCoord(winto[winnum]);
          r:=winzoom[winnum];
          InOut.WriteInt(ROUND(r*1000.0),1); InOut.WriteLn;
        END;

        FOR i:=firstscene TO lastscene DO
          IF DDD.IsAName(scenenames[i]) THEN
            WITH table[i] DO
              Disk.WriteBOOL(crossflag);
              Disk.WriteBOOL(eyeflag);
              Disk.WriteBOOL(planeflag);
              Disk.WriteBOOL(orgflag);
              InOut.WriteCard(lasteditedobj,1); InOut.WriteLn;
              Disk.Write3DCoord(eyepos);
              Disk.Write3DCoord(curpos);
              InOut.WriteInt(fz,1); InOut.WriteLn;

              max:=0;
              FOR ii:=SceneEd.firstobj TO SceneEd.lastobj DO
                IF DDD.IsAName(names[ii]) THEN
                  INC(max);
                END;
              END;

              InOut.WriteCard(max,1); InOut.WriteLn;

              FOR ii:=SceneEd.firstobj TO SceneEd.lastobj DO
                IF DDD.IsAName(names[ii]) THEN

                  InOut.WriteCard(ii,1); InOut.WriteLn;
                  Disk.WriteDiskString(names[ii]);

                  Disk.WriteBOOL(flags[ii]);

                  pd.x:=ROUND(scale[ii].scx*1000.0);
                  pd.y:=ROUND(scale[ii].scy*1000.0);
                  pd.z:=ROUND(scale[ii].scz*1000.0);
                  Disk.Write3DCoord(pd);

                  FOR winnum:=SceneEd.xywin TO SceneEd.yzwin DO
                    Disk.Write2DCoord(org[ii,winnum]);
                  END;
                  InOut.WriteCard(index[ii].start,1); InOut.WriteLn;
                  InOut.WriteCard(index[ii].end,1);   InOut.WriteLn;
                END;
              END;
              FOR winnum:=SceneEd.xywin TO SceneEd.yzwin DO
                Disk.Write2DCoord(allorg[winnum]);
              END;
            END;
          END;
        END;

        Grawin.Reset;
        InOut.CloseOutput;
        itext.t:=" World saved!";
        Grawin.RefreshAllWins(TRUE);
        dontwriteinfo:=TRUE;
        Grawin.TextToWinTitle(actwin,itext); |

    2 : IF Disk.LoadStObjects(fn,'wor') THEN
          FOR winnum:=xywin TO dddwin DO

            Disk.Read2DCoord(p);
            Disk.Read2DCoord(pp);

            Grawin.SetWinPos(winnum,p.x,p.y,FALSE);
            Grawin.SetWinSize(winnum,pp.x,pp.y,FALSE);

            Disk.Read2DCoord(pp);
            Grawin.SetWinOrg(winnum,pp.x,pp.y);

            InOut.ReadInt(a);
            Grawin.SetWinZoom(winnum,FLOAT(a)/1000.0);
          END;

          FOR winnum:=SceneEd.xywin TO SceneEd.dddwin DO
            Disk.Read2DCoord(winorg[winnum]);
            Disk.Read2DCoord(winfrom[winnum]);
            Disk.Read2DCoord(winto[winnum]);
            InOut.ReadInt(a);
            winzoom[winnum]:=FLOAT(a)/1000.0;
          END;

          DDD.CopyFromLocalNames(scenenames);

          FOR i:=firstscene TO lastscene DO
            IF DDD.IsAName(scenenames[i]) THEN
              WITH table[i] DO
                Disk.ReadBOOL(crossflag);
                Disk.ReadBOOL(eyeflag);
                Disk.ReadBOOL(planeflag);
                Disk.ReadBOOL(orgflag);
                InOut.ReadCard(lasteditedobj);
                Disk.Read3DCoord(eyepos);
                Disk.Read3DCoord(curpos);
                InOut.ReadInt(fz);

                InOut.ReadCard(max);

                FOR ii:=1 TO max DO
                  InOut.ReadCard(obj);

                  Disk.ReadDiskString(names[obj]);
                  Disk.ReadBOOL(flags[obj]);

                  Disk.Read3DCoord(pd);
                  scale[obj].scx:=FLOAT(pd.x)/1000.0;
                  scale[obj].scy:=FLOAT(pd.y)/1000.0;
                  scale[obj].scz:=FLOAT(pd.z)/1000.0;

                  FOR winnum:=SceneEd.xywin TO SceneEd.yzwin DO
                    Disk.Read2DCoord(org[obj,winnum]);
                  END;
                  InOut.ReadCard(index[obj].start);
                  InOut.ReadCard(index[obj].end);
                END;
                FOR winnum:=SceneEd.xywin TO SceneEd.yzwin DO
                  Disk.Read2DCoord(allorg[winnum]);
                END;
              END;
            END;
          END;
        END;

        Grawin.Reset;
        InOut.CloseInput;
        DDD.CopyFromLocalNames(scenenames);
        itext.t:=" World loaded!";
        Grawin.RefreshAllWins(TRUE);
        dontwriteinfo:=TRUE;
        Grawin.TextToWinTitle(actwin,itext);|

    3 : text[1].t:="Please enter";
        text[2].t:="TeX-x-picture-";
        text[3].t:="size: ";
        Grawin.ColFromTo(text,Colors.ipromptcol,1,3);
        REPEAT
          x:=100;
          Grawin.ShowInfoBox(12,14,3,text);
          ReadCard(x);
        UNTIL Done AND (x>0);
        text[2].t:="TeX-y-picture-";
        REPEAT
          y:=80;
          Grawin.ShowInfoBox(12,14,3,text);
          ReadCard(y);
        UNTIL Done AND (y>0);
        CASE ii OF
          1 : Disk.TexOutput(fn,'pic',x,y,xywin); |
          2 : Disk.TexOutput(fn,'pic',x,y,xzwin); |
          3 : Disk.TexOutput(fn,'pic',x,y,yzwin); |
          4 : Disk.TexOutput(fn,'pic',x,y,dddwin);
        END;
        itext.t:=" TeX-file generated!";
        Grawin.RefreshAllWins(TRUE);
        dontwriteinfo:=TRUE;
        Grawin.TextToWinTitle(actwin,itext); |

    4 : InOut.OpenNamedOutput(fn,'cfg');
        Disk.WriteColor(Colors.itextcol);
        Disk.WriteColor(Colors.ipromptcol);
        Disk.WriteColor(Colors.ientercol);
        Disk.WriteColor(Colors.ialacol);
        Disk.WriteColor(Colors.ititlecol);
        Disk.WriteColor(Colors.ihitextcol);
        Disk.WriteColor(Colors.iborcol1);
        Disk.WriteColor(Colors.iborcol2);
        Disk.WriteColor(Colors.iselcol);
        Disk.WriteColor(Colors.iunselcol);
        Disk.WriteColor(Colors.iexitcol);

        Disk.WriteColor(Colors.wmenborcol1);
        Disk.WriteColor(Colors.wmenborcol2);
        Disk.WriteColor(Colors.wmenitemcol);
        Disk.WriteColor(Colors.wmenhiitemcol);
        Disk.WriteColor(Colors.wmenbackcol);
        Disk.WriteColor(Colors.wmentitlecol);

        Disk.WriteColor(Colors.wwinhicol);
        Disk.WriteColor(Colors.wwintitlecol);
        Disk.WriteColor(Colors.wwinborcol);
        Disk.WriteColor(Colors.wwinbackcol);
        Disk.WriteColor(Colors.winfobackcol);
        Disk.WriteColor(Colors.wscreenbackcol);
        Disk.WriteColor(Colors.wwherecol);
        Disk.WriteColor(Colors.wplanecol);
        Disk.WriteColor(Colors.weyecol);
        Disk.WriteColor(Colors.wcrosscol);
        Disk.WriteColor(Colors.worgcol);
        Disk.WriteColor(Colors.wgridcol);
        Disk.WriteColor(Colors.wcurcol);
        Disk.WriteColor(Colors.wmarcol);

        Disk.WriteColor(Colors.smenborcol1);
        Disk.WriteColor(Colors.smenborcol2);
        Disk.WriteColor(Colors.smenitemcol);
        Disk.WriteColor(Colors.smenhiitemcol);
        Disk.WriteColor(Colors.smenbackcol);
        Disk.WriteColor(Colors.smentitlecol);

        Disk.WriteColor(Colors.swinhicol);
        Disk.WriteColor(Colors.swintitlecol);
        Disk.WriteColor(Colors.swinborcol);
        Disk.WriteColor(Colors.swinbackcol);
        Disk.WriteColor(Colors.sinfobackcol);
        Disk.WriteColor(Colors.sscreenbackcol);
        Disk.WriteColor(Colors.swherecol);
        Disk.WriteColor(Colors.splanecol);
        Disk.WriteColor(Colors.seyecol);
        Disk.WriteColor(Colors.scrosscol);
        Disk.WriteColor(Colors.sorgcol);
        Disk.WriteColor(Colors.sgridcol);
        Disk.WriteColor(Colors.scurcol);
        Disk.WriteColor(Colors.smarcol);

        Disk.WriteColor(Colors.stereored);
        Disk.WriteColor(Colors.stereogreen);
        Disk.WriteColor(Colors.viewinfocol);
        Disk.WriteColor(Colors.viewscreencol);

        Disk.WriteColor(SceneEd.GetActCol());

        InOut.WriteCard(gridstep,1);
        InOut.WriteLn;
        InOut.WriteCard(cursorstep,1);
        InOut.WriteLn;

        InOut.WriteCard(SceneEd.GetGridstep(),1);
        InOut.WriteLn;
        InOut.WriteCard(SceneEd.GetCursorstep(),1);
        InOut.WriteLn;

        InOut.WriteInt(xareamin,1);
        InOut.WriteLn;
        InOut.WriteInt(xareamax,1);
        InOut.WriteLn;
        InOut.WriteInt(yareamin,1);
        InOut.WriteLn;
        InOut.WriteInt(yareamax,1);
        InOut.WriteLn;
        InOut.WriteInt(zareamin,1);
        InOut.WriteLn;
        InOut.WriteInt(zareamax,1);
        InOut.WriteLn;

        InOut.CloseOutput();
        itext.t:=" Config saved!";
        Grawin.RefreshAllWins(TRUE);
        dontwriteinfo:=TRUE;
        Grawin.TextToWinTitle(actwin,itext); |

    5 : Guitool.ShowDir("*");
        itext.t:=" Directory shown!";
        Grawin.RefreshAllWins(TRUE);
        dontwriteinfo:=TRUE;
        Grawin.TextToWinTitle(actwin,itext);

  ELSE
    Grawin.RefreshAllWins(TRUE);
  END;

  IF i=2 THEN
    DDD.RestoreStObj(scenenum);
    DDD.DestroyStObj(scenenum);
  ELSE
    DDD.RestoreStObj(scenenum);
  END;

END DiskFunc;

PROCEDURE Undo(VAR actwin, scenenum : CARDINAL);
BEGIN
  DDD.RestoreStObjBackup();
  itext.t:=" Undo!";
  DDD.ShowWhere(scenenum);
  Grawin.RefreshAllWins(TRUE);
  dontwriteinfo:=TRUE;
  Grawin.TextToWinTitle(actwin,itext);
END Undo;

PROCEDURE SetWorldColors();
VAR winnum : CARDINAL;

BEGIN
  DDD.SetPlaneCol(Colors.wplanecol);
   DDD.SetCrossCol(Colors.wcrosscol);
  DDD.SetWhereCol(Colors.wwherecol);
  DDD.SetEyeCol(Colors.weyecol);
  DDD.SetOrgCol(Colors.worgcol);

  Grawin.SetMenuBorCol1(Colors.wmenborcol1);
  Grawin.SetMenuBorCol2(Colors.wmenborcol2);
  Grawin.SetMenuItemCol(Colors.wmenitemcol);
  Grawin.SetMenuActItemCol(Colors.wmenhiitemcol);
  Grawin.SetMenuBackCol(Colors.wmenbackcol);
  Grawin.SetMenuTitleCol(Colors.wmentitlecol);

  Grawin.SetScreenBackCol(Colors.wscreenbackcol);
  Grawin.SetInfoBackCol(Colors.winfobackcol);
  Grawin.SetInfoCol(Colors.itextcol);
  Grawin.SetInfoActCol(Colors.ihitextcol);
  Grawin.SetInfoBorCol1(Colors.iborcol1);
  Grawin.SetInfoBorCol2(Colors.iborcol2);

  FOR winnum:=xywin TO dddwin DO
    Grawin.SetWinBorCol(winnum,Colors.wwinborcol);
    Grawin.SetWinBackCol(winnum,Colors.wwinbackcol);
    Grawin.SetWinTitleCol(winnum,Colors.wwintitlecol);
  END;
  Grawin.SetWinActCol(Colors.wwinhicol);

  SetBGColor(Colors.wscreenbackcol.r,
             Colors.wscreenbackcol.g,
             Colors.wscreenbackcol.b);

  SetMaxWindow();
  Scroll(0);
END SetWorldColors;

PROCEDURE SetWorldMenus();

VAR winnum : CARDINAL;

BEGIN
  FOR winnum:=xywin TO yzwin DO
    Grawin.SetWinMenBindkey(winnum,ORD(scale),'s');
    Grawin.SetWinMenBindkey(winnum,ORD(rotate),'r');
    Grawin.SetWinMenBindkey(winnum,ORD(scenemisc),'f');
    Grawin.SetWinMenBindkey(winnum,ORD(handler),'l');
    Grawin.SetWinMenBindkey(winnum,ORD(helppage),'h');
    Grawin.SetWinMenBindkey(winnum,ORD(seteye),'e');
    Grawin.SetWinMenBindkey(winnum,ORD(setplane),'p');
    Grawin.SetWinMenBindkey(winnum,ORD(laygrid),'g');
    Grawin.SetWinMenBindkey(winnum,ORD(disk),'d');
    Grawin.SetWinMenBindkey(winnum,ORD(preferences),'x');
    Grawin.SetWinMenBindkey(winnum,ORD(about),'a');
    Grawin.SetWinMenBindkey(winnum,ORD(undo),'u');
    Grawin.SetWinMenBindkey(winnum,ORD(done),'q');

    Grawin.SetWinMenItem(winnum,ORD(scale)       ,'Scale Scene    ',Scale);
    Grawin.SetWinMenItem(winnum,ORD(rotate)      ,'Rotate Scene   ',Rotate);
    Grawin.SetWinMenItem(winnum,ORD(scenemisc)   ,'Functions      ',Scene);
    Grawin.SetWinMenItem(winnum,ORD(handler)     ,'Handler        ',SceneHandler);
    Grawin.SetWinMenItem(winnum,ORD(helppage)    ,'Helppages      ',Helppages);
    Grawin.SetWinMenItem(winnum,ORD(seteye)      ,'Set Eye        ',AdjustEye);
    Grawin.SetWinMenItem(winnum,ORD(setplane)    ,'Set Plane      ',AdjustPlane);
    Grawin.SetWinMenItem(winnum,ORD(laygrid)     ,'Lay Grid       ',Grid);
    Grawin.SetWinMenItem(winnum,ORD(disk)        ,'Disk           ',DiskFunc);
    Grawin.SetWinMenItem(winnum,ORD(preferences) ,'Preferences    ',Preferences);
    Grawin.SetWinMenItem(winnum,ORD(about)       ,'About PoorWorld',About);
    Grawin.SetWinMenItem(winnum,ORD(undo)        ,'Undo           ',Undo);
    Grawin.SetWinMenItem(winnum,ORD(done)        ,'World Done     ',WorldDone);
  END;

  Grawin.SetWinMenItem(dddwin,ORD(view),'View',View);
  Grawin.SetWinMenItem(dddwin,ORD(stereoview),'Stereo-view',View3D);

END SetWorldMenus;

PROCEDURE CursorBlink();
VAR winnum : CARDINAL;
BEGIN
  FOR winnum:=xywin TO dddwin DO
    Grawin.ShowCursor(winnum,Colors.wcurcol,TRUE);
  END;
END CursorBlink;

PROCEDURE WorldEdit;
VAR obj, ind, winnum , ii, i, co : CARDINAL;
    sc : Grawin.Scale;
    dsc : DDD.DScale;
    poi : Grawin.Point;
    pp, ppxy, ppyz, pppxy, pppyz, ppp : Grawin.Coord;
    from, to, worg : Grawin.Coord;
    zoom : REAL;
    pd : DDD.DPoint;
    name : Grawin.String;
    flag, oeyeflag, oplaneflag, ocrossflag, oorgflag : BOOLEAN;
    left, right, pos, key, strg : BOOLEAN;

BEGIN

  DDD.SetEyePos(oeyepos);
  DDD.SetPlaneDist(ofz);

  Grawin.SetErrProc(Error);
  Grawin.SetCursorstep(cursorstep);

  DDD.SetWorldMode();
  DDD.CopyToLocalNames(scenenames);

  SetWorldColors();
  DDD.TurnPlaneOn;
  DDD.TurnEyeOn;
  DDD.TurnOrgOn;

  itext.c:=Colors.wwintitlecol;

  FOR i:=firstscene TO lastscene DO
    InitSceneTable(i);
  END;

  Grawin.CreateWin('World x-y',xywin, 0, 0,33,17,Colors.wwinborcol,Colors.wwinbackcol,Colors.wwintitlecol,FALSE,FALSE);
  Grawin.CreateWin('World x-z',xzwin, 33,0,66,17,Colors.wwinborcol,Colors.wwinbackcol,Colors.wwintitlecol,FALSE,FALSE);
  Grawin.CreateWin('World y-z',yzwin, 66,0,99,17,Colors.wwinborcol,Colors.wwinbackcol,Colors.wwintitlecol,FALSE,FALSE);
  Grawin.CreateWin('World 3D' ,dddwin,0,17,99,37,Colors.wwinborcol,Colors.wwinbackcol,Colors.wwintitlecol,FALSE,FALSE);

  Grawin.SetWinArea(xywin,xareamin,xareamax,yareamin,yareamax);
  Grawin.SetWinArea(xzwin,xareamin,xareamax,zareamin,zareamax);
  Grawin.SetWinArea(yzwin,yareamin,yareamax,zareamin,zareamax);

  winfrom[SceneEd.xywin].x:=0;
  winfrom[SceneEd.xywin].y:=0;

  winfrom[SceneEd.xzwin].x:=33;
  winfrom[SceneEd.xzwin].y:=0;

  winfrom[SceneEd.yzwin].x:=66;
  winfrom[SceneEd.yzwin].y:=0;

  winfrom[SceneEd.dddwin].x:=0;
  winfrom[SceneEd.dddwin].y:=17;

  winto[SceneEd.xywin].x:=33;
  winto[SceneEd.xywin].y:=17;

  winto[SceneEd.xzwin].x:=66;
  winto[SceneEd.xzwin].y:=17;

  winto[SceneEd.yzwin].x:=99;
  winto[SceneEd.yzwin].y:=17;

  winto[SceneEd.dddwin].x:=99;
  winto[SceneEd.dddwin].y:=37;

  FOR winnum:=SceneEd.xywin TO SceneEd.dddwin DO
    pp:=Grawin.GetWinGraphicSize(winnum-SceneEd.xywin+xywin);
    pp.x:=pp.x DIV 2;
    pp.y:=pp.y DIV 2;
    winorg[winnum]:=pp;
    winzoom[winnum]:=1.0;
  END;

  SetWorldMenus;

  FOR winnum:=xywin TO yzwin DO
    pp:=Grawin.GetWinGraphicSize(winnum);
    Grawin.SetWinOrg(winnum,pp.x DIV 2,pp.y DIV 2);
    Grawin.CreateObj(winnum,crossobj,1.0,1.0,pp.x DIV 2,pp.y DIV 2);
    Grawin.CreateObj(winnum,whereframeobj,1.0,1.0,pp.x DIV 2,pp.y DIV 2);
    Grawin.SetWinSizeProc(winnum,Adjust);
    Grawin.SetWinMoveProc(winnum,Adjust);
    Grawin.SetWinRefreshProc(winnum,Refresh);

    Grawin.SetWinZoomProc(winnum,ZoomWin);
    Grawin.SetWinScrollProc(winnum,ScrollWin);
    Grawin.SetWinResetProc(winnum,ResetWin);

    Grawin.SetWinSizeProc(winnum,Adjust);
    Grawin.SetWinMoveProc(winnum,Adjust);
    Grawin.SetWinRefreshProc(winnum,Refresh);
  END;

  pp:=Grawin.GetWinGraphicSize(dddwin);
  Grawin.SetWinOrg(dddwin,pp.x DIV 2,pp.y DIV 2);

  Grawin.CreateObj(dddwin,crossobj,1.0,1.0,pp.x DIV 2,pp.y DIV 2);
  Grawin.SetWinSizeProc(dddwin,Adjust);
  Grawin.SetWinMoveProc(dddwin,Adjust);
  Grawin.SetWinRefreshProc(dddwin,Refresh);
  Grawin.SetWinZoomProc(dddwin,ZoomWin);
  Grawin.SetWinScrollProc(dddwin,ScrollWin);

  FOR winnum:=xywin TO yzwin DO
    DDD.CreateCross(winnum,crossobj,cursorstep);
  END;
  p.x:=0;
  p.y:=0;
  DDD.CreateDCross(dddwin,crossobj,cursorstep);
  a[dddwin]:=DDD.GiveXY(dddwin,p);
  Grawin.SetCursor(dddwin,a[dddwin].x,a[dddwin].y,Colors.wcurcol,TRUE);

  Grawin.BringWinToFront(actwin);
  scene:=firstscene;
  Grawin.SelectObj(scene);
  Grawin.RefreshAllWins(TRUE);

  About(actwin,scene);

  CreateScene(actwin,scene);
  (* Grawin.RefreshAllWins(TRUE); *)

  Grawin.SnapCursorOn;
  Grawin.SetMouseAtWinOrg(actwin);
  SetWaitProc(CursorBlink);
  EnableWaitProcEvery(10);

  LOOP

    WaitForEvents(left,right,pos,key,strg,c);
    Grawin.WindowHandler(left,right,c,strg,actwin);
    EnableWaitProcEvery(10);

    IF actwin<>dddwin THEN
      Grawin.CursorHandler(c,actwin,Colors.wcurcol,TRUE);
    END;
    cur:=Grawin.GetCurPos(actwin);

    CASE actwin OF
      xywin : p.x:=cur.x; p.y:=cur.y; |
      xzwin : p.x:=cur.x; p.z:=cur.y; |
      yzwin : p.y:=cur.x; p.z:=cur.y;
    END;

    FOR winnum:=xywin TO dddwin DO
      a[winnum]:=DDD.GiveXY(winnum,p);
      IF winnum<>actwin THEN
        Grawin.SetCursor(winnum,a[winnum].x,a[winnum].y,Colors.wcurcol,TRUE);
      END;
    END;

    IF NOT(dontwriteinfo) THEN WinInfoLine(actwin); END;
    dontwriteinfo:=FALSE;

    IF NOT(strg) AND (actwin<>dddwin) THEN
      IF left THEN
        c:=Space;
      END;
      CASE c OF
        Space : Grawin.NormalTick1();
              DDD.MakeObjBackup(scene);

              oeyepos:=DDD.GetEyePos();
              ofz:=DDD.GetPlaneDist();
              oeyeflag:=DDD.IsEyeOn();
              oplaneflag:=DDD.IsPlaneOn();
              ocrossflag:=Grawin.IsObjDrawable(actwin,crossobj);
              oorgflag:=DDD.IsOrgOn();

              FOR i:=firstscene TO lastscene DO
                sceneflags[i]:=DDD.IsStObjDrawable(i);
              END;
              sceneflags[scene]:=Grawin.IsObjDrawable(xywin,scene);

              DDD.SetSceneMode();

              FOR winnum:=SceneEd.xywin TO SceneEd.dddwin DO

                IF winnum=SceneEd.xywin THEN
                  name:='Scene x-y';
                ELSIF winnum=SceneEd.xzwin THEN
                  name:='Scene x-z';
                ELSIF winnum=SceneEd.yzwin THEN
                  name:='Scene y-z';
                ELSE
                  name:='Scene 3D';
                END;
                from:=winfrom[winnum];
                to:=winto[winnum];
                zoom:=winzoom[winnum];
                worg:=winorg[winnum];
                Grawin.CreateWin(name,winnum,from.x,from.y,to.x,to.y,Colors.swinborcol,Colors.swinbackcol,Colors.swintitlecol,FALSE,FALSE);
                Grawin.SetWinOrg(winnum,worg.x,worg.y);
                Grawin.SetWinZoom(winnum,zoom);
              END;

              Grawin.SetWinArea(SceneEd.xywin,xareamin,xareamax,yareamin,yareamax);
              Grawin.SetWinArea(SceneEd.xzwin,xareamin,xareamax,zareamin,zareamax);
              Grawin.SetWinArea(SceneEd.yzwin,yareamin,yareamax,zareamin,zareamax);

              Grawin.BringWinToFront(table[scene].activewin);

              FOR winnum:=SceneEd.xywin TO SceneEd.dddwin DO
                pp:=Grawin.GetWinOrg(winnum);
                Grawin.CreateObj(winnum,crossobj,1.0,1.0,pp.x,pp.y);
                Grawin.CreateObj(winnum,whereframeobj,1.0,1.0,pp.x,pp.y);
                Grawin.DontRefreshWin(winnum-SceneEd.xywin+1);
              END;

              WITH table[scene] DO
                DDD.CopyToLocalNames(names);
                DDD.SetEyePos(eyepos);
                DDD.SetPlaneDist(fz);

                Grawin.SetCursor(SceneEd.xywin,curpos.x,curpos.y,Colors.scurcol,TRUE);
                Grawin.SetCursor(SceneEd.xzwin,curpos.x,curpos.z,Colors.scurcol,TRUE);
                Grawin.SetCursor(SceneEd.yzwin,curpos.y,curpos.z,Colors.scurcol,TRUE);
                pp:=DDD.GiveXY(SceneEd.dddwin,curpos);
                Grawin.SetCursor(SceneEd.dddwin,pp.x,pp.y,Colors.scurcol,TRUE);

                IF eyeflag THEN
                  DDD.TurnEyeOn();
                ELSE
                  DDD.TurnEyeOff();
                END;
                IF planeflag THEN
                  DDD.TurnPlaneOn();
                ELSE
                  DDD.TurnPlaneOff();
                END;
                IF orgflag THEN
                  DDD.TurnOrgOn();
                ELSE
                  DDD.TurnOrgOff();
                END;

                DDD.SetCrossCol(Colors.scrosscol);
                FOR winnum:=SceneEd.xywin TO SceneEd.yzwin DO
                  DDD.CreateCross(winnum,crossobj,cursorstep);
                END;
                DDD.CreateDCross(SceneEd.dddwin,crossobj,cursorstep);

                FOR winnum:=SceneEd.xywin TO SceneEd.dddwin DO
                  IF crossflag THEN
                    Grawin.AllowDrawObj(winnum,crossobj);
                  ELSE
                    Grawin.DontDrawObj(winnum,crossobj);
                  END;
                END;
              END;

              IF table[scene].lasteditedobj=0 THEN
                obj:=IntMen.CreateObjInt(SceneEd.firstobj,FALSE);
                table[scene].lasteditedobj:=obj;
              ELSE

                FOR obj:=SceneEd.firstobj TO SceneEd.lastobj DO
                  IF DDD.DoesObjExists(obj) THEN
                    IF (obj<>table[scene].lasteditedobj) THEN
                      WITH table[scene] DO
                        dsc:=scale[obj];
                        DDD.DestroyStObj(obj);
                        DDD.CreateStObj(obj,dsc,org[obj,SceneEd.xywin],
                                                org[obj,SceneEd.xzwin],
                                                org[obj,SceneEd.yzwin]);

                        Grawin.SetObjPointNumber(WorldEd.xywin,scene,table[scene].index[obj].start);
                        Grawin.SetObjPointNumber(WorldEd.yzwin,scene,table[scene].index[obj].start);
                        co:=0;
                      END;
                      WITH table[scene] DO
                        ppxy:=org[obj,SceneEd.xywin];
                        pppxy:=allorg[SceneEd.xywin];
                        ppyz:=org[obj,SceneEd.yzwin];
                        pppyz:=allorg[SceneEd.yzwin];
                        dsc:=scale[obj];
                      END;

                      FOR i:=table[scene].index[obj].start TO table[scene].index[obj].end DO
                         poi:=Grawin.GetObjPoint(WorldEd.xywin,scene);
                         pd.x:=ROUND((FLOAT(poi.x)-FLOAT(ppxy.x-pppxy.x))/dsc.scx);

                         poi:=Grawin.GetObjPoint(WorldEd.yzwin,scene);
                         pd.y:=ROUND((FLOAT(poi.x)-FLOAT(ppyz.x-pppyz.x))/dsc.scy);
                         pd.z:=ROUND((FLOAT(poi.y)-FLOAT(ppyz.y-pppyz.y))/dsc.scz);
                         pd.col:=poi.col;
                         pd.drawline:=poi.drawline;

                         DDD.AddStObjPoint(obj,pd);
                      END;
                    ELSE

                      pp:=Grawin.GetWinOrg(dddwin);
                      Grawin.CreateObj(SceneEd.dddwin,obj,1.0,1.0,pp.x, pp.y);

                      FOR winnum:=xywin TO yzwin DO
                        ind:=winnum-xywin+SceneEd.xywin;
                        dsc:=table[scene].scale[obj];
                        IF winnum=xywin THEN sc.scx:=dsc.scx; sc.scy:=dsc.scy; END;
                        IF winnum=xzwin THEN sc.scx:=dsc.scx; sc.scy:=dsc.scz; END;
                        IF winnum=yzwin THEN sc.scx:=dsc.scy; sc.scy:=dsc.scz; END;

                        WITH table[scene] DO
                          Grawin.CreateObj(ind,obj,sc.scx,
                                                   sc.scy,
                                                   org[obj,ind].x,
                                                   org[obj,ind].y);
                        END;

                        Grawin.SetObjPointNumber(winnum,scene,table[scene].index[obj].start);
                        pp:=table[scene].org[obj,ind];
                        ppp:=table[scene].allorg[ind];

                        FOR i:=table[scene].index[obj].start TO table[scene].index[obj].end DO

                          WITH table[scene] DO

                            poi:=Grawin.GetObjPoint(winnum,scene);

                            poi.x:=ROUND((FLOAT(poi.x)-FLOAT(pp.x-ppp.x))/sc.scx);
                            poi.y:=ROUND((FLOAT(poi.y)-FLOAT(pp.y-ppp.y))/sc.scy);

                            Grawin.AddObjPoint(ind,obj,poi.x,poi.y,poi.col,poi.drawline);
                          END;
                        END;
                      END;
                    END;
                  END;
                END;
              END;

              DDD.AddNewDCoords(table[scene].lasteditedobj);

              FOR obj:=SceneEd.firstobj TO SceneEd.lastobj DO
                IF NOT(table[scene].flags[obj]) THEN
                  IF obj<>table[scene].lasteditedobj THEN
                    DDD.DontDrawStObj(obj);
                  ELSE
                    FOR winnum:=SceneEd.xywin TO SceneEd.dddwin DO
                      Grawin.DontDrawObj(winnum,obj);
                    END;
                  END;
                END;
              END;

              sc:=Grawin.GetObjScale(xywin,scene);
              dsc.scx:=sc.scx;
              dsc.scy:=sc.scy;
              sc:=Grawin.GetObjScale(xzwin,scene);
              dsc.scz:=sc.scy;

              FOR winnum:=xywin TO dddwin DO
                Grawin.DeleteObj(winnum,scene);
              END;

              obj:=SceneEd.ObjectEdit(table[scene].lasteditedobj);

              DDD.StoreObj(obj);

              Grawin.SelectObj(scene);

              WITH table[scene] DO
                DDD.CopyFromLocalNames(names);
                lasteditedobj:=obj;
                eyepos:=DDD.GetEyePos();

                pp:=Grawin.GetCurPos(SceneEd.xywin);
                curpos.x:=pp.x;
                curpos.y:=pp.y;
                pp:=Grawin.GetCurPos(SceneEd.yzwin);
                curpos.z:=pp.y;

                fz:=DDD.GetPlaneDist();
                eyeflag:=DDD.IsEyeOn();
                crossflag:=Grawin.IsObjDrawable(SceneEd.xywin,crossobj);
                planeflag:=DDD.IsPlaneOn();
                orgflag:=DDD.IsOrgOn();
                activewin:=Grawin.GetActiveWin();

                FOR obj:=SceneEd.firstobj TO SceneEd.lastobj DO
                  flags[obj]:=DDD.IsStObjDrawable(obj);
                END;
              END;

              pp:=Grawin.GetWinOrg(dddwin);
              Grawin.CreateObj(dddwin,scene,1.0,1.0,pp.x,pp.y);

              FOR winnum:=SceneEd.xywin TO SceneEd.yzwin DO
                i:=0;
                ind:=winnum-SceneEd.xywin+WorldEd.xywin;
                ppp.x:=0;
                ppp.y:=0;
                FOR obj:=SceneEd.firstobj TO SceneEd.lastobj DO (* alle Objekte der akt. scene *)

                  IF DDD.DoesObjExists(obj) THEN

                    INC(i);
                    IF winnum=SceneEd.xywin THEN
                      pp:=DDD.GetStObjXYOrg(obj);
                    END;
                    IF winnum=SceneEd.xzwin THEN
                      pp:=DDD.GetStObjXZOrg(obj);
                    END;
                    IF winnum=SceneEd.yzwin THEN
                      pp:=DDD.GetStObjYZOrg(obj);
                    END;

                    table[scene].org[obj,winnum]:=pp;
                    table[scene].scale[obj]:=DDD.GetStObjScale(obj);

                    ppp.x:=ppp.x+pp.x;
                    ppp.y:=ppp.y+pp.y;

                  END;
                END;

                ppp.x:=ppp.x DIV INTEGER(i);
                ppp.y:=ppp.y DIV INTEGER(i);

                IF ind=xywin THEN sc.scx:=dsc.scx; sc.scy:=dsc.scy; END;
                IF ind=xzwin THEN sc.scx:=dsc.scx; sc.scy:=dsc.scz; END;
                IF ind=yzwin THEN sc.scx:=dsc.scy; sc.scy:=dsc.scz; END;

                Grawin.CreateObj(ind,scene,sc.scx,sc.scy,ppp.x,ppp.y);
                table[scene].allorg[winnum]:=ppp;
              END;

              FOR winnum:=xywin TO yzwin DO
                FOR obj:=SceneEd.firstobj TO SceneEd.lastobj DO
                  IF DDD.DoesObjExists(obj) THEN
                    table[scene].index[obj].start:=Grawin.GetObjPointNumber(winnum,scene)+1;

                    dsc:=DDD.GetStObjScale(obj);

                    IF winnum=xywin THEN
                      pp:=DDD.GetStObjXYOrg(obj);
                      sc.scx:=dsc.scx;
                      sc.scy:=dsc.scy;
                    END;
                    IF winnum=xzwin THEN
                      pp:=DDD.GetStObjXZOrg(obj);
                      sc.scx:=dsc.scx;
                      sc.scy:=dsc.scz;
                    END;
                    IF winnum=yzwin THEN
                      pp:=DDD.GetStObjYZOrg(obj);
                      sc.scx:=dsc.scy;
                      sc.scy:=dsc.scz;
                    END;

                    ppp:=Grawin.GetObjOrg(winnum,scene);
                    ppp.x:=ppp.x-pp.x;
                    ppp.y:=ppp.y-pp.y;

                    FOR i:=1 TO DDD.GetStObjSize(obj) DO
                      pd:=DDD.GetStObjPoint(obj,i);
                      IF winnum=xywin THEN
                        poi.x:=pd.x; poi.y:=pd.y;
                      END;
                      IF winnum=xzwin THEN
                        poi.x:=pd.x; poi.y:=pd.z;
                      END;
                      IF winnum=yzwin THEN
                        poi.x:=pd.y; poi.y:=pd.z;
                      END;

                      IF i=1 THEN pd.drawline:=FALSE; END;

                      poi.x:=ROUND((FLOAT(poi.x)*sc.scx - FLOAT(ppp.x)));
                      poi.y:=ROUND((FLOAT(poi.y)*sc.scy - FLOAT(ppp.y)));
                      Grawin.AddObjPoint(winnum,scene,poi.x,poi.y,pd.col,
                                                        pd.drawline);
                                                        (* AND table[scene].flags[obj]); *)
                    END;
                    table[scene].index[obj].end:=Grawin.GetObjPointNumber(winnum,scene);
                  END;
                END;
              END;


              FOR obj:=SceneEd.firstobj TO SceneEd.lastobj DO
                DDD.DestroyStObj(obj);
              END;


              FOR winnum:=SceneEd.xywin TO SceneEd.dddwin DO

                winfrom[winnum]:=Grawin.GetWinPos(winnum);
                winto[winnum]:=Grawin.GetWinSize(winnum);
                winto[winnum].x:=winto[winnum].x+winfrom[winnum].x;
                winto[winnum].y:=winto[winnum].y+winfrom[winnum].y;

                winzoom[winnum]:=Grawin.GetWinZoom(winnum);
                winorg[winnum]:=Grawin.GetWinOrg(winnum);

                Grawin.SetWinRefreshProc(winnum,Grawin.NilProc);
                Grawin.DestroyWin(winnum);
                Grawin.AllowRefreshWin(winnum-SceneEd.xywin+1);
              END;

              DDD.SetWorldMode();
              DDD.CopyToLocalNames(scenenames);

              DDD.SetEyePos(oeyepos);
              DDD.SetPlaneDist(ofz);

              IF ocrossflag THEN
                Grawin.AllowDrawObj(actwin,crossobj);
              ELSE
                Grawin.DontDrawObj(actwin,crossobj);
              END;
              IF oeyeflag THEN
                DDD.TurnEyeOn();
              ELSE
                DDD.TurnEyeOff();
              END;
              IF oplaneflag THEN
                DDD.TurnPlaneOn();
              ELSE
                DDD.TurnPlaneOff();
              END;
              IF oorgflag THEN
                DDD.TurnOrgOn();
              ELSE
                DDD.TurnOrgOff();
              END;
              FOR winnum:=xywin TO dddwin DO
                FOR i:=firstscene TO lastscene DO
                  IF sceneflags[i] THEN
                    IF i=scene THEN
                      Grawin.AllowDrawObj(winnum,i);
                    ELSE
                      DDD.AllowDrawStObj(i);
                    END;
                  ELSE
                    IF i=scene THEN
                      Grawin.DontDrawObj(winnum,i);
                    ELSE
                      DDD.DontDrawStObj(i);
                    END;
                  END;
                END;
              END;

              DDD.AddNewDCoords(scene);

              MoveScene(actwin,scene);

              SetWorldColors();
              DDD.ShowWhere(scene);
              Grawin.SetCursorstep(cursorstep);
              Grawin.RefreshAllWins(TRUE);
              itext.t:=" Scene included!";
              dontwriteinfo:=TRUE;
              Grawin.TextToWinTitle(actwin,itext);

              pp:=Grawin.GetObjOrg(actwin,scene);
              ppp:=Grawin.GetWinOrg(actwin);
              Grawin.SetMouseAtWinPos(actwin,pp.x-ppp.x,pp.y-ppp.y);
              SetWaitProc(CursorBlink);
              EnableWaitProcEvery(10); |

        'o' : Grawin.NormalTick1();
              FOR winnum:=xywin TO yzwin DO
                Grawin.SetCursor(winnum,0,0,Colors.wcurcol,TRUE);
              END; p.x:=0; p.y:=0; p.z:=0;
              pp:=DDD.GiveXY(dddwin,p);
              Grawin.SetCursor(dddwin,pp.x,pp.y,Colors.wcurcol,TRUE);
              Grawin.SetMouseAtWinOrg(actwin);
              itext.t:=" To window-origin!";
              dontwriteinfo:=TRUE;
              Grawin.TextToWinTitle(actwin,itext); |

        'O' : Grawin.NormalTick1();
              FOR winnum:=xywin TO yzwin DO
                pp:=Grawin.GetObjOrg(winnum,scene);
                ppp:=Grawin.GetWinOrg(winnum);
                pp.x:=pp.x-ppp.x;
                pp.y:=pp.y-ppp.y;
                IF winnum=xywin THEN p.x:=pp.x; p.y:=pp.y; END;
                IF winnum=yzwin THEN p.z:=pp.y; END;
                Grawin.SetCursor(winnum,pp.x,pp.y,Colors.wcurcol,TRUE);
              END;
              pp:=DDD.GiveXY(dddwin,p);
              Grawin.SetCursor(dddwin,pp.x,pp.y,Colors.wcurcol,TRUE);
              pp:=Grawin.GetObjOrg(actwin,scene);
              ppp:=Grawin.GetWinOrg(actwin);
              Grawin.SetMouseAtWinPos(actwin,pp.x-ppp.x,pp.y-ppp.y);
              itext.t:=" To scene-origin!";
              dontwriteinfo:=TRUE;
              Grawin.TextToWinTitle(actwin,itext); |

        '#' : Grawin.NormalTick1();
              Grawin.ToggleSnap;
              IF Grawin.InSnapMode() THEN
                itext.t:=" Snapmode on!";
              ELSE
                itext.t:=" Snapmode off!";
              END;
              dontwriteinfo:=TRUE;
              Grawin.TextToWinTitle(actwin,itext); |

        '*' : Grawin.NormalTick1();
              IF dispflag THEN
                absdisp:=NOT(absdisp);
                IF absdisp THEN
                  itext.t:=" Absolute coordinates!";
                ELSE
                  itext.t:=" Relative coordinates!";
                END;
                dontwriteinfo:=TRUE;
                Grawin.TextToWinTitle(actwin,itext);
              END; |

        '+' : Grawin.NormalTick1();
              dispflag:=NOT(dispflag);
              IF dispflag THEN
                itext.t:=" Coordinates on!";
              ELSE
                itext.t:=" Coordinates off!";
              END;
              dontwriteinfo:=TRUE;
              Grawin.TextToWinTitle(actwin,itext); |

        'n' : Grawin.NormalTick1();
              DDD.TurnWhereOn;
              DDD.StoreObj(scene);
              REPEAT
                INC(scene);
                IF scene>lastscene THEN scene:=firstscene; END;
              UNTIL DDD.DoesObjExists(scene);
              DDD.RestoreStObj(scene);
              Grawin.SelectObj(scene);
              DDD.ShowWhere(scene);
              Grawin.RefreshAllWins(FALSE);
              itext.t:=" Next scene!";
              dontwriteinfo:=TRUE;
              Grawin.TextToWinTitle(actwin,itext); |

        'p' : Grawin.NormalTick1();
              DDD.TurnWhereOn;
              DDD.StoreObj(scene);
              REPEAT
                DEC(scene);
                IF scene<firstscene THEN scene:=lastscene; END;
              UNTIL DDD.DoesObjExists(scene);
              DDD.RestoreStObj(scene);
              Grawin.SelectObj(scene);
              DDD.ShowWhere(scene);
              Grawin.RefreshAllWins(FALSE);
              itext.t:=" Previous scene!";
              dontwriteinfo:=TRUE;
              Grawin.TextToWinTitle(actwin,itext);
      END;
    END;

    IF worlddone THEN
      FOR winnum:=xywin TO dddwin DO
        Grawin.DestroyWin(winnum);
      END;
      FOR i:=firstscene TO lastscene DO
        DDD.DestroyStObj(i);
      END;
      EXIT;
    END;
  END;
END WorldEdit;

(* init of local data *)

BEGIN

  gridflag:=FALSE;
  handleract:=FALSE;

  dispflag:=TRUE;
  absdisp:=TRUE;
  dontwriteinfo:=FALSE;
  oeyepos.x:=60;
  oeyepos.y:=60;
  oeyepos.z:=60;

  setworldmenus:=SetWorldMenus;
  ofz:=-60;

  actwin:=xywin;
  p.z:=0;
  p.x:=0;
  p.y:=0;

  FOR i:=1 TO HIGH(alltrue) DO
    alltrue[i]:=TRUE;
  END;
  FOR i:=1 TO HIGH(nokeys) DO
    nokeys[i]:="";
  END;

END WorldEd.