/* Rotating Toroid, 1/95 and 11/95 Michael Wessel */

#include <string.h>
#include <math.h>
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>


#define BACK_FACE_REMOVAL 0

#define POINT1 1
#define POINT2 2
#define EYE 3

#define CUR_LEFT 75
#define CUR_RIGHT 77
#define CUR_UP 72
#define CUR_DOWN 80
#define PAGE_DOWN 81
#define PAGE_UP 73

#define MAXAREAS 150
#define SEGMENTS 12
#define SMALL_FLOAT 0.0001

#define AXCOL 10
#define TEXTCOL 6
#define HITEXTCOL 14
#define MENCOL 1
#define BACKCOL 0


/* type-declarations */

enum kors {x, y, z, s};

typedef struct {int x, y;} screen_point;
typedef int areapoints[8];
typedef float matrix[4][4];
typedef	float vektor[4];
typedef struct {vektor p; int c;} col_point;
typedef struct {vektor p[4]; int c;} area;
typedef	struct {int number;
		area areas[MAXAREAS];
		areapoints areapoints[MAXAREAS];
		float draw_it[MAXAREAS];
		int zbuffer[MAXAREAS]; } objekt;

/* ansi-c-prototypes */

void init_rot_matrix(float angle, vektor p1, vektor p2, matrix rotmat);
void clear_obj(objekt *ob);
void define_toroid(objekt *obj);
void my_convert(float value, char* str);
void vekXvek(vektor u, vektor v, vektor w);
void vekXmat(vektor a, matrix b, vektor c);
void matXmat(matrix a, matrix b, matrix c);
void clear_mat(matrix a);
float dotprod(vektor v, vektor w);
void norm_vektor(vektor points[4], vektor n);
void help_page(void);
screen_point calc(vektor pos, vektor augpos, float r, float f);
void project(objekt *ob, vektor augpos, matrix rotmat, float f, float zoom);


/* mainprogram */

main()
{ matrix rotmat;
  objekt obj;
  vektor p1, p2, augen;
  screen_point axp1, axp2;
  unsigned int sign, pagenum =0, i, ii;
  unsigned int mode = EYE, info = 1, axis = 1;
  unsigned char key;
  float f, zoom = 1.3;
  int step = 10, angle = 5, now_angle=0 ;

  char* string1 = "           ";
  char* string2 = "           ";
  char *bgi_path;

  char str_eyex[] = "Eye X  : ";
  char str_eyey[] = "Eye Y  : ";
  char str_eyez[] = "Eye Z  : ";
  char str_p1x[]  = "P1 X   : ";
  char str_p1y[]  = "P1 Y   : ";
  char str_p1z[]  = "P1 Z   : ";
  char str_p2x[]  = "P2 X   : ";
  char str_p2y[]  = "P2 Y   : ";
  char str_p2z[]  = "P2 Z   : ";

  int gdriver = VGA, gmode = 1, errorcode;

  struct palettetype pal;

  nosound();

  bgi_path = getenv("BGIPATH");
  initgraph(&gdriver, &gmode,bgi_path);

  /* read result of initialization */

  errorcode = graphresult();
  if (errorcode != grOk)
   /* an error occurred */
   {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:");
      getch();
      /* terminate with an error code */
      exit(1);
  }

  help_page();

  getpalette(&pal);
  for(i=1;i<=15;i++)
    setrgbpalette(pal.colors[i],4,i*3+10,i*4+3);


  /* unsichtbares zeichnen */

  obj.number=MAXAREAS-1;

  clear_obj(&obj);

  define_toroid(&obj);

  /* los gehts */

  augen[x]=40;
  augen[y]=50;
  augen[z]=-250;
  f=100.0;


  setactivepage(pagenum);
  setvisualpage(1-pagenum);

  setbkcolor(BACKCOL);
  cleardevice();

  /* Drehachse durch p1 und p2 */

  p2[x]=130.0; p2[y]=130.0; p2[z]=0.0;   p2[s]=1.0;
  p1[x]=-40.0; p1[y]=-20.0; p1[z]=-50.0; p1[s]=1.0;


  /* rot-matrix festlegen */

  while(1) {

    now_angle+=angle;
    now_angle%=360;

    init_rot_matrix(now_angle,p1,p2,rotmat);

    /* projektion */

    cleardevice();

    if (axis) {
      axp1=calc(p1,augen,zoom,f);
      axp2=calc(p2,augen,zoom,f);
      setcolor(AXCOL);
      line(axp1.x,axp1.y,axp2.x,axp2.y);
    }


    project(&obj,augen,rotmat,f,zoom);

    /* evt. info darstellen */

    if (info) {
      setcolor(HITEXTCOL);
      rectangle(495,5,632,155);
      setcolor(TEXTCOL);

      switch (mode) {
	case EYE    : outtextxy(500,10,"Mode   : Eye"); break;
	case POINT1 : outtextxy(500,10,"Mode   : Point 1"); break;
	case POINT2 : outtextxy(500,10,"Mode   : Point 2"); break;
      }

      for(i=x;i<=z;i++) {

	switch (mode) {
	  case EYE :
	    my_convert(augen[i],string2);
	    sign=(augen[i])<0;
	    switch (i) {
	      case x : string1=str_eyex; break;
	      case y : string1=str_eyey; break;
	      case z : string1=str_eyez; break;
	    }
	    break;
	  case POINT1 :
	    my_convert(p1[i],string2);
	    sign=(p1[i])<0;
	    switch (i) {
	      case x : string1=str_p1x; break;
	      case y : string1=str_p1y; break;
	      case z : string1=str_p1z; break;
	    }
	    break;
	  case POINT2 :
	    my_convert(p2[i],string2);
	    sign=(p2[i])<0;
	    switch (i) {
	      case x : string1=str_p2x; break;
	      case y : string1=str_p2y; break;
	      case z : string1=str_p2z; break;
	    }
	    break;
	}
	outtextxy(500,20+i*10,string1);
	if (sign) outtextxy(570,20+i*10,"-"); else outtextxy(570,20+i*10," ");
	outtextxy(578,20+i*10,string2);
      }

      my_convert(f,string2);
      sign=f<0;
      outtextxy(500,60,"Plane  : ");
      if (sign) outtextxy(570,60,"-"); else outtextxy(570,60," ");
      outtextxy(578,60,string2);

      my_convert(zoom*100.0,string2);
      sign=zoom<0.0;
      outtextxy(500,80,"Zoom % : ");
      if (sign) outtextxy(570,80,"-"); else outtextxy(570,80," ");
      outtextxy(578,80,string2);

      my_convert(angle,string2);
      sign=angle<0.0;
      outtextxy(500,130,"Angle  : ");
      if (sign) outtextxy(570,130,"-"); else outtextxy(570,130," ");
      outtextxy(578,130,string2);

      my_convert(step,string2);
      sign=step<0.0;
      outtextxy(500,140,"Step   : ");
      if (sign) outtextxy(570,140,"-"); else outtextxy(570,140," ");
      outtextxy(578,140,string2);

    }


    /* unsichtbares zeichnen, pages umschalten */

    setvisualpage(pagenum);
    setactivepage(1-pagenum);


    pagenum = 1-pagenum;

    /* tasten auswerten */

    if (kbhit())
      { key=getch();
	if (!key) key=getch();
	switch (key) {

	  case CUR_LEFT  : switch(mode) {
			     case EYE    : augen[x]-=step; break;
			     case POINT1 : p1[x]-=step; break;
			     case POINT2 : p2[x]-=step; break;
			   }
			   if (mode!=EYE) {
			     init_rot_matrix(angle,p1,p2,rotmat);

			   }
			   break;

	  case CUR_RIGHT : switch(mode) {
			     case EYE    : augen[x]+=step; break;
			     case POINT1 : p1[x]+=step; break;
			     case POINT2 : p2[x]+=step; break;
			   }
			   if (mode!=EYE) {
			     init_rot_matrix(angle,p1,p2,rotmat);

			   }
			   break;

	  case CUR_UP    : switch(mode) {
			     case EYE    : augen[y]-=step; break;
			     case POINT1 : p1[y]-=step; break;
			     case POINT2 : p2[y]-=step; break;
			   }
			   if (mode!=EYE) {
			     init_rot_matrix(angle,p1,p2,rotmat);

			   }
			   break;

	  case CUR_DOWN  : switch(mode) {
			     case EYE    : augen[y]+=step; break;
			     case POINT1 : p1[y]+=step; break;
			     case POINT2 : p2[y]+=step; break;
			   }
			   if (mode!=EYE) {
			     init_rot_matrix(angle,p1,p2,rotmat);

			   }
			   break;

	  case PAGE_UP   : switch(mode) {
			     case EYE    : augen[z]-=step; break;
			     case POINT1 : p1[z]-=step; break;
			     case POINT2 : p2[z]-=step; break;
			   }
			   if (mode!=EYE) {
			     init_rot_matrix(angle,p1,p2,rotmat);

			   }
			   break;

	  case PAGE_DOWN : switch(mode) {
			     case EYE    : augen[z]+=step; break;
			     case POINT1 : p1[z]+=step; break;
			     case POINT2 : p2[z]+=step; break;
			   }
			   if (mode!=EYE) {
			     init_rot_matrix(angle,p1,p2,rotmat);

			   }
			   break;

	  case 'x'       : axis=1-axis; break;

	  case 'i'       : info=1-info; break;

	  case '<'       : f-=step; break;

	  case '>'       : f+=step; break;

	  case '-'       : zoom-=step/100.0; break;

	  case '+'       : zoom+=step/100.0; break;

	  case '1'       : mode=POINT1; break;

	  case '2'       : mode=POINT2; break;

	  case 'e'       : mode=EYE; break;

	  case 'r'       : init_rot_matrix(angle,p1,p2,rotmat);

			   define_toroid(&obj);
			   now_angle=0;
			   break;

	  case 'a'       : setvisualpage(pagenum);
			   gotoxy(1,1);
			   printf("  Enter new angle (%d): ",angle);
			   scanf("%d",&angle);
			   init_rot_matrix(angle,p1,p2,rotmat);
			   break;

	  case ' '       : setvisualpage(pagenum);
			   gotoxy(1,1);
			   printf("  Enter new step (%d): ",step);
			   scanf("%d",&step);
			   break;

	  case 'h'       : setvisualpage(pagenum);
			   help_page();
			   break;

	  case 'q'       : closegraph();
			   return(0);
			   break;

	  default        : setvisualpage(pagenum);
			   help_page();
			   break;
	}

    }
  }
}


void my_convert(float value, char *str)
{ char* string1 = "             ";
  unsigned int dec, sign;

  value=abs(value);
  string1 = ecvt(value,3,&dec,&sign);

  strncpy(str,string1,dec);

  str[dec]=0;

}

void help_page(void)
{
  setfillstyle(SOLID_FILL,MENCOL);
  bar(5,12,360,226);
  setcolor(HITEXTCOL);
  rectangle(5,12,360,226);

  outtextxy(10,20," Helppage ______________ (C) 1995 MW-Soft");
  setcolor(TEXTCOL);
  outtextxy(10,40," 1 : Change point 1 of axis");
  outtextxy(10,50," 2 : Change point 2 of axis");
  outtextxy(10,60," e : Change eye     of axis");
  outtextxy(10,70," CURSORKEYS    : Change this X,Y-position");
  outtextxy(10,80," PAGE UP, DOWN : Change this   Z-position");
  outtextxy(10,90," < : Decrement projection-plane-distance");
  outtextxy(10,100," > : Increment projection-plane-distance");
  outtextxy(10,110," - : Decrement zoom-factor");
  outtextxy(10,120," + : Increment zoom-factor");
  outtextxy(10,130," r : Reset object, clear allignment");
  outtextxy(10,140," h : This helppage");
  outtextxy(10,150," i : Toggle info on / off");
  outtextxy(10,160," x : Toggle axis on / off");
  outtextxy(10,170," q : Quit!");
  outtextxy(10,180," a : Change rot-angle");
  outtextxy(10,190," SPACE : Change movement-step-size");
  setcolor(HITEXTCOL);
  outtextxy(10,210," !> TORUS <! was written with Borland-C.");
  getch();
}



void init_rot_matrix(float angle, vektor p1, vektor p2, matrix rotmat)
{ vektor rotvek;
  matrix rotx, roty, rotz, irotx, iroty, trans, itrans;
  matrix mat1, mat2, mat3, mat4;
  float l, a, b, c, d, sinu, cosi, gamma;
  unsigned int ii, i;
  l=0.0;

  for(ii=x;ii<=z;ii++) {
    rotvek[ii]=p2[ii]-p1[ii];
  }
  rotvek[s]=1.0;

  if ((p2[y]==p1[y]) && (p2[z]==p1[z])) rotvek[y]=SMALL_FLOAT;

  for(ii=x;ii<=z;ii++) {
    l += rotvek[ii]*rotvek[ii];
  }

  l=sqrt(l);

  if (l<SMALL_FLOAT) l=SMALL_FLOAT;

  a=rotvek[x]/l;
  b=rotvek[y]/l;
  c=rotvek[z]/l;
  d=sqrt(b*b+c*c);

  clear_mat(rotx);
  clear_mat(irotx);
  clear_mat(roty);
  clear_mat(iroty);
  clear_mat(rotz);
  clear_mat(trans);
  clear_mat(itrans);
  clear_mat(mat1);
  clear_mat(mat2);
  clear_mat(mat3);
  clear_mat(mat4);

  /* Translationsmatrix um den Vektor -P1 */

  trans[x][x]=1.0;
  trans[y][y]=1.0;
  trans[z][z]=1.0;
  trans[s][s]=1.0;
  trans[s][x]=-p1[x];
  trans[s][y]=-p1[y];
  trans[s][z]=-p1[z];

  /* Rcktranslation um den Vektor P1 */

  itrans[x][x]=1.0;
  itrans[y][y]=1.0;
  itrans[z][z]=1.0;
  itrans[s][s]=1.0;
  itrans[s][x]=p1[x];
  itrans[s][y]=p1[y];
  itrans[s][z]=p1[z];

  /* Rotation um x-Achse */

  rotx[x][x]=1.0;
  rotx[y][y]= c/d; rotx[y][z]=b/d;
  rotx[z][y]=-b/d; rotx[z][z]=c/d;

  /* Rotation um y-Achse */

  roty[x][x]=d;  roty[x][z]=a;
  roty[y][y]=1.0;
  roty[z][x]=-a; roty[z][z]=d;

  /* Inverse Rotation um y-Achse */

  iroty[x][x]=d/(a*a+d*d); iroty[x][z]=-a/(a*a+d*d);
  iroty[y][y]=1.0;
  iroty[z][x]=a/(a*a+d*d); iroty[z][z]=d/(a*a+d*d);

  /* Inverse Rotation um x-Achse */

  irotx[x][x]=1.0;
  irotx[y][y]=d*c/(b*b+c*c); irotx[y][z]=-b*d/(b*b+c*c);
  irotx[z][y]=b*d/(b*b+c*c); irotx[z][z]=d*c/(b*b+c*c);

  /* Einige Matrizen vorberechnen */

  matXmat(trans,rotx,mat1);
  matXmat(mat1,roty,mat2);
  matXmat(iroty,irotx,mat1);
  matXmat(mat1,itrans,mat3);

  gamma=angle/180.0*M_PI;

  /* Rotationsmatrix fr z-Achse festlegen */

  cosi=cos(gamma); sinu=sin(gamma);

  rotz[x][x]=cosi;  rotz[x][y]=sinu;
  rotz[y][x]=-sinu; rotz[y][y]=cosi;
  rotz[z][z]=1.0;

  /* Matrixmultiplikationen ausfhren */

  matXmat(mat2,rotz,mat1);
  matXmat(mat1,mat3,rotmat);
}


void define_toroid(objekt *obj) {
  int index, step1, step2, i, ii, t, counter = 0;
  float r = 50.0, u= 15.0;
  float xpos, ypos, zpos;
  float xbase[2], ybase[2], irad[2], iirad[2];

  step1 = 360 / SEGMENTS;
  step2 = 360 / SEGMENTS;

  for(i=0; i<= 360-step1 ; i+=step1) {

    irad[0] = i/180.0*M_PI;
    irad[1] = (i+step1)/180.0*M_PI;

    for (t=0; t<=1 ; t++) {
      xbase[t] = r*cos(irad[t]);
      ybase[t] = r*sin(irad[t]);
    }


    for(ii=0; ii<=360-step2 ; ii+=step2) {

      iirad[0] = ii / 180.0 * M_PI;
      iirad[1] = (ii+step2) / 180.0 * M_PI;

      for (t=0; t<=3 ; t++) {

	switch (t) {
	  case 0 : index=0; break;
	  case 1 : index=1; break;
	  case 2 : index=1; break;
	  case 3 : index=0;
	}

	xpos= xbase[t / 2]+u*sin(iirad[index])*cos(irad[t / 2]);
	ypos= ybase[t / 2]+u*sin(iirad[index])*sin(irad[t / 2]);

	zpos=u*cos(iirad[index]);

	obj->areas[counter].p[t][x]=xpos;
	obj->areas[counter].p[t][y]=ypos;
	obj->areas[counter].p[t][z]=zpos;
	obj->areas[counter].p[t][s]=1.0;
	obj->areas[counter].c=counter;

      }

      counter++;

    }

  }

  obj->number=counter-1;

}

void vekXmat(vektor a, matrix b, vektor c)
{
  c[x]=a[x]*b[x][x]+a[y]*b[y][x]+a[z]*b[z][x]+a[s]*b[s][x];

  c[y]=a[x]*b[x][y]+a[y]*b[y][y]+a[z]*b[z][y]+a[s]*b[s][y];

  c[z]=a[x]*b[x][z]+a[y]*b[y][z]+a[z]*b[z][z]+a[s]*b[s][z];

  c[s]=a[x]*b[x][s]+a[y]*b[y][s]+a[z]*b[z][s]+a[s]*b[s][s];

}

void vekXvek(vektor v, vektor w, vektor x)
{
  x[x]=v[y]*w[z]-v[z]*w[y];
  x[y]=v[z]*w[x]-v[x]*w[z];
  x[z]=v[x]*w[y]-v[y]*w[x];
}

float dotprod(vektor v, vektor w)
{ return(v[x]*w[x]+v[y]*w[y]+v[z]*w[z]);
}


void matXmat(matrix a, matrix b, matrix c)
{ unsigned int i, ii, iii;
  for(i=x;i<=s;i++) {
    for(ii=x;ii<=s;ii++) {
      c[i][ii]=0.0;
      for(iii=x;iii<=s;iii++) {
	c[i][ii] += a[i][iii]*b[iii][ii];
      }
    }
  }
}

void clear_mat(matrix a)
{ unsigned int i, ii;
  for(i=x;i<=s;i++) {
    for(ii=x;ii<=s;ii++) {
      a[i][ii]=0.0;
    }
  }
  a[s][s]=1.0;
}

void clear_obj(objekt *ob)
{ unsigned int i, ii, iii;

  for(i=0;i<=ob->number;i++)
    for(ii=0;ii<=3;ii++) {

      for(iii=x;iii<=z;iii++)
	ob->areas[i].p[ii][iii]=0.0;

      ob->areas[i].p[ii][s]=1.0;
      ob->areas[i].c=0;
    }
}

screen_point calc(vektor pos, vektor augpos, float r, float f) {
  screen_point sp;
  float d;

  d = augpos[z]-pos[z];

  if (!d==0.0) {
    sp.x = 320+pos[x]*r+(f-pos[z]*r)*(augpos[x]-pos[x]*r)/d;
    sp.y = 200-pos[y]*r+(f-pos[z]*r)*(augpos[y]-pos[y]*r)/d; }
  else {
    sp.x=320; sp.y=200; }
  return(sp);
}

void norm_vektor(vektor points[4], vektor n) {
  vektor v, w;

  v[x] = points[1][x]-points[0][x];
  v[y] = points[1][y]-points[0][y];
  v[z] = points[1][z]-points[0][z];

  w[x] = points[1][x]-points[2][x];
  w[y] = points[1][y]-points[2][y];
  w[z] = points[1][z]-points[2][z];

  n[x] = v[y]*w[z]-v[z]*w[y];
  n[y] = v[z]*w[x]-v[x]*w[z];
  n[z] = v[x]*w[y]-v[y]*w[x];

}


void project(objekt *ob, vektor augpos, matrix rotmat, float f, float zoom)
{ vektor p, pos;

  int count = 0, ii, i = 0;
  int now, min = 32000, max = -32000;
  vektor n, points[4];
  float color = 0.0 , d, xp, yp, ax, ay, r, zsum, dsum;

  for(i=0;i<=ob->number;i++) {


    zsum=0.0;
    dsum=0.0;


    for(ii=0;ii<=3;ii++) {

      vekXmat(ob->areas[i].p[ii],rotmat,pos);

      points[ii][x]=pos[x];
      points[ii][y]=pos[y];
      points[ii][z]=pos[z];

      r = ob->areas[i].p[ii][s]*zoom;

      d = augpos[z]-pos[z];

      zsum+=pos[z];
      dsum+=d;

      if (!d==0.0) {
	p[x] = pos[x]*r+(f-pos[z]*r)*(augpos[x]-pos[x]*r)/d;
	p[y] = pos[y]*r+(f-pos[z]*r)*(augpos[y]-pos[y]*r)/d; }
      else { p[x]=0; p[y]=0;}

      ob->areapoints[i][2*ii  ]=p[x]+320;
      ob->areapoints[i][2*ii+1]=200-p[y];

    }

    if (BACK_FACE_REMOVAL) {
      norm_vektor(points,n);
      ob->draw_it[i]=dotprod(augpos,n);
    }

    ob->zbuffer[i]=(int)zsum;
    ob->areas[i].c=(int)(dsum/4.0);

    now=ob->zbuffer[i];
    if (now<min) {min=now; } ;
    if (now>max) {max=now; } ;

  }

  for (ii=min;ii<=max;ii++) {

    color=(float)(ii-min)/(float)(max-min)*15.0;

    for (i=0;i<=ob->number;i++) {

      if ( (BACK_FACE_REMOVAL && ob->draw_it[i]>=0) || !BACK_FACE_REMOVAL) {

	now=ob->zbuffer[i];

	if (now<=ii) {

	  ob->zbuffer[i]=1000;

	  setcolor(color);
	  setfillstyle(SOLID_FILL,color);
	  fillpoly(4,ob->areapoints[i]);


	}

      }

    }

  }

}
