Program Viergewinnt;

(* --------------------------------------------------- *)
(* 4/93-9/93 by Michael Wessel, MW-Soft! 20.9.1993     *)
(* Thanks to Malte Woydt for "strategical assistance"! *)
(* --------------------------------------------------- *)
(* PC-Version for Windows, (C) 4.6.1994 by MW-Soft!    *)
(* Thanks to Sven for troubleshooting !                *)

(* Konstante und Variablen, Units einbinden *)

{$R gewi}

USES WinTypes, WinProcs, Strings, BWCC;

const
      ymax     = 6;
      xmax     = 7;
      maxlevel = 2;
      AppName  = 'Vier Gewinnt';
      id_OK    = 101; (* OK-Button *)


type
     spielbrett = array[1..xmax,0..ymax]        of integer;
     bewertung  = array[0..2,0..xmax]           of integer;
     rfeld      = array[0..maxlevel+1,-1..xmax] of integer;
     zugmem     = array[1..xmax*ymax]           of integer;

var feld    : spielbrett;
    zugmemx : zugmem;
    zugmemy : zugmem;
    bewe    : bewertung;
    demo    : boolean;

    col : ARRAY[0..5] OF tColorRef;
    size: trect;

    sizex, sizey : integer;
    funktion, yl, lzug, knopf, y, fertig : integer;
    zug, i, ii, spieler, zugzaehl, werzieht, level : integer;


(* Prozeduren fr die grafische Oberflche des Spieles *)
(* Textausgabe-Routine, setze Text an (x,y)            *)

procedure gtext(Window: hWnd; text: string; x, y : integer; farbe, hfarbe : integer);

var pstring: ARRAY[0..30] OF CHAR;
    DC: hDC;

begin

  DC:=GetDC(Window);
  SetBKMode(DC,transparent);
  StrPCopy(pstring,text);

  SetTextColor(DC,col[hfarbe]);
  TextOut(DC,x+3,y+2,pstring,StrLen(pstring));

  SetTextColor(DC,col[farbe]);
  TextOut(DC,x,y,pstring,StrLen(pstring));
  ReleaseDC(Window,DC);

end;

(* Bedienungselemente zeichnen *)

procedure faerbe(Window: hWnd; dx, dy, knopf, funktion, farbe : integer);

var fa, x, y, ofx, ofy, gx, gy, rx, ry : integer;
    r : tRect;
    DC: hDC;
    brush1, brush2, brush3: hBrush;

begin

  if (knopf=0) and (funktion=0) then exit;
  DC:=GetDC(Window);
  ofx:=dx div 4;
  ofy:=dy div 7;
  rx:=round((dx-ofx-30)/8*3/8);
  ry:=round((dy-ofy-23)/7*3/8);

  brush1:=CreateSolidBrush(col[farbe]);
  SelectObject(DC, brush1);

  if (knopf>0) and (knopf<8) then begin
    gx:=round(ofx+knopf*(dx-ofx-30)/8);
    FloodFill(DC,gx,(ofy div 5)+ry,col[3]);
  end;

  if (funktion>0) and (funktion<7) then begin
    gy:=round(ofy+funktion*(dy-ofy-23)/7);

    r.right:=round(ofx*4/5)+3;
    r.bottom:=gy+ry+2;
    r.left:=round(ofx/5);
    r.top:=gy-ry+2;

    brush2:=CreateSolidBrush(col[3]);
    FillRect(DC,r,brush2);

    r.right:=round(ofx*4/5);
    r.bottom:=gy+ry;
    r.left:=round(ofx/5)-3;
    r.top:=gy-ry;

    brush3:=CreateSolidBrush(col[farbe]);
    FillRect(DC,r,brush3);

    x:=round(ofx*5/10)-26;
    y:=gy+round(ry/3)-14;
    if (farbe=2) then fa:=0;
    if (farbe=1) then begin farbe:=3; fa:=2; end;

    case funktion of
      1 : GText(Window,' Move  ',x,y,3-farbe,fa);
      2 : GText(Window,' Back  ',x,y,3-farbe,fa);
      3 : GText(Window,' Level ',x,y,3-farbe,fa);
      4 : GText(Window,' New!  ',x,y,3-farbe,fa);
      5 : GText(Window,' Demo  ',x,y,3-farbe,fa);
      6 : GText(Window,' Info  ',x,y,3-farbe,fa);
    end;
  end;

  ReleaseDC(Window,DC);
  DeleteObject(brush1);
  DeleteObject(brush2);
  DeleteObject(brush3);

end;

(* Farbwechsel *)

procedure showwho(Window: hWnd; dx,dy : integer; var werzieht : integer);

var ofx, ofy, rx, ry : integer;
    DC: hDC;
    brush1, brush2: hBrush;
    pen1, pen2: hPen;

begin

  DC:=GetDC(Window);

  ofx:=dx div 4;
  ofy:=dy div 7;
  rx:=round((dx-ofx-30)/8*3/8);
  ry:=round((dy-ofy-23)/7*3/8);

  pen1:=CreatePen(ps_Solid, 1, col[3]);
  SelectObject(DC, pen1);

  brush1:=CreateSolidBrush(col[3]);
  SelectObject(DC,brush1);

  Ellipse(DC,ofx div 2 +3-rx,round(ofy*2/3)+2-ry,ofx DIV 2 + 3 + rx,round(ofy*2/3)+2+ry);

  pen2 := CreatePen (ps_Solid, 1, col[werzieht]);
  SelectObject(DC, pen2);

  brush2:=CreateSolidBrush(col[werzieht]);
  SelectObject(DC,brush2);

  Ellipse(DC,ofx div 2   -rx,round(ofy*2/3)  -ry,ofx div 2     + rx,round(ofy*2/3)  +ry);

  ReleaseDC(Window,DC);
  DeleteObject(pen1);
  DeleteObject(pen2);
  DeleteObject(brush1);
  DeleteObject(brush2);

end;

(* Maus-Klick auswerten - welcher Knopf ist gedrckt worden? *)

procedure mausknopf(Window: hWnd; x, y, dx, dy : integer; var knopf, funktion : integer);

var ofx, ofy, rx, ry, gx, gy, i, ii : integer;

begin

  ofx:=dx div 4;
  ofy:=dy div 7;
  rx:=round((dx-ofx-30)/8*3/8);
  ry:=round((dy-ofy-23)/7*3/8);

  knopf:=0;

  for i:=1 to 7 do begin
    gx:=round(ofx+i*(dx-ofx-30)/8);
    if (x>gx-rx) and (x<gx+rx) and
       (y>ofy div 5) and (y<(ofy div 5)+2*ry) then begin
      knopf:=i;
      ii:=gx;
    end;
  end;

  if (knopf>0) then faerbe(Window,dx,dy,knopf,0,1);
  funktion:=0;

  for i:=1 to 6 do begin
    gy:=round(ofy+i*(dy-ofy-23)/7);
    if (x>ofx div 5 -3) and (x<round(ofx*4/5)) and
       (y>gy-ry) and (y<gy+ry) then begin
         funktion:=i;
         ii:=gy;
    end;
  end;

  if (funktion>0) then faerbe(Window,dx,dy,0,funktion,1);

end;

(* Spielbrett etc. zeichnen *)

procedure brett(Window: hWnd; feld : spielbrett);

var ofx, ofy, dx, dy, rx, ry, gx, gy, x, y : integer;
    DC: hDC;
    pen1, pen2: hPen;
    r: tRect;
    brush1, brush2, brush3 : hBrush;

begin

  DC:=GetDC(Window);
  GetClientRect(Window,r);

  brush1:=CreateSolidBrush(col[4]);
  SelectObject(DC,brush1);
  FillRect(DC,r,brush1);
  ReleaseDC(Window,DC);
  DeleteObject(brush1);

  dx:=r.Right;
  dy:=r.Bottom;

  showwho(window,dx,dy,werzieht);

  ofx:=dx div 4;
  ofy:=dy div 7;
  rx:=round((dx-ofx-30)/8*3/8);
  ry:=round((dy-ofy-23)/7*3/8);

  r.right:=dx-26;
  r.bottom:=dy-21;
  r.left:=ofx+4;
  r.top:=ofy+2;

  brush1:=CreateSolidBrush(col[1]);
  FillRect(DC,r,brush1);

  r.right:=dx-30;
  r.bottom:=dy-23;
  r.left:=ofx;
  r.top:=ofy;

  brush2:=CreateSolidBrush(col[2]);
  FillRect(DC,r,brush2);

  r.right:=dx-34;
  r.bottom:=dy-25;
  r.left:=ofx+4;
  r.top:=ofy+2;

  brush3:=CreateSolidBrush(col[3]);
  FillRect(DC,r,brush3);

  ReleaseDC(Window,DC);
  DeleteObject(brush1);
  DeleteObject(brush2);
  DeleteObject(brush3);

  for x:=1 to 7 do begin
    gx:=round(ofx+x*(dx-ofx-30)/8);

    DC:=GetDC(Window);

    pen1:=CreatePen(ps_Solid,1,col[3]);
    SelectObject(DC,pen1);
    brush1:=CreateSolidBrush(col[3]);
    SelectObject(DC, brush1);

    MoveTo(DC,gx-rx,ofy div 5);
    LineTo(DC,gx+rx,ofy div 5);
    LineTo(DC,gx,(ofy div 5)+2*ry);
    LineTo(DC,gx-rx,ofy div 5);
    FloodFill(DC,gx,(ofy div 5)+ry,col[3]);

    pen2:=CreatePen(ps_Solid,1,col[4]);
    SelectObject(DC,pen2);
    brush2 := CreateSolidBrush(col[2]);
    SelectObject(DC, brush2);

    MoveTo(DC,gx-rx+(rx div 2),(ofy div 5)+(ry div 2));
    LineTo(DC,gx+rx-(rx div 2),(ofy div 5)+(ry div 2));
    LineTo(DC,gx,(ofy div 5)+2*ry-(ry div 2));
    LineTo(DC,gx-rx+(rx div 2), (ofy div 5)+(ry div 2));
    FloodFill(DC,gx,(ofy div 5)+ry,col[4]);

    ReleaseDC(Window,DC);
    DeleteObject(pen1);
    DeleteObject(pen2);
    DeleteObject(brush1);
    DeleteObject(brush2);

    for y:=1 to 6 do begin
      gy:=round(ofy+y*(dy-ofy-23)/7);
      if (x=1) then faerbe(Window,dx,dy,0,y,2);

      DC:=GetDC(Window);

      if feld[x,7-y]=0 then
        brush1:=CreateSolidBrush(col[4])
      else
        brush1:=CreateSolidBrush(col[feld[x,7-y]]);
      SelectObject(DC,brush1);

      pen1:=CreatePen(ps_Solid,1,col[5]);
      SelectObject(DC,pen1);

      Ellipse(DC,gx-rx,gy-ry,gx+rx,gy+ry);

      ReleaseDC(Window,DC);
      DeleteObject(brush1);
      DeleteObject(pen1);
    end;
  end;

end;

(* Stein darstellen *)

procedure zeigestein(Window: hWnd; dx, dy, x, y, farbe : integer);

var ofx, ofy, rx, ry, gx, gy : integer;
    DC: hDC;
    brush: hBrush;
    pen: hPen;

begin

  DC:=GetDC(Window);

  y:=7-y;
  ofx:=dx div 4;
  ofy:=dy div 7;
  rx:=round((dx-ofx-30)/8*3/8);
  ry:=round((dy-ofy-23)/7*3/8);
  gx:=round(ofx+x*(dx-ofx-30)/8);
  gy:=round(ofy+y*(dy-ofy-23)/7);

  brush:=CreateSolidBrush(col[farbe]);
  SelectObject(DC,brush);

  pen:=CreatePen(ps_Solid,1,col[5]);
  SelectObject(DC,pen);

  Ellipse(DC,gx-rx,gy-ry,gx+rx,gy+ry);

  ReleaseDC(Window,DC);
  DeleteObject(pen);
  DeleteObject(brush);

end;

(* Alle Maschinen-unabhngigen Routinen f. das Spiel *)
(* Stein einwerfen                                   *)

function ziehe(var feld : spielbrett; zug, werzieht : integer):integer;

var y : integer;

begin

  y:=feld[zug,0];
  if (y=ymax) then ziehe:=0
  else begin
    inc(feld[zug,0]);
    feld[zug,y+1]:=werzieht;
    ziehe:=y+1;
  end;

end;

(* Stein entnehmen *)

procedure entnehme(var feld : spielbrett; zug : integer);

var y : integer;

begin

  y:=feld[zug,0];
  if (y>0) then begin
    dec(feld[zug,0]);
    feld[zug,y]:=0;
  end;

end;

(* Maximum-Funktion *)

function max(a, b : integer):integer;

begin
  if (a>b) then max:=a else max:=b;
end;

(* Minimum-Funktion *)

function min(a, b : integer):integer;

begin
  if (a>b) then min:=b else min:=a;
end;

(* Punkte vergeben *)

procedure punkte(var summe : integer; anz, tanz, frei, setz : integer);

begin

  case tanz of
    0 : ;
    1 : if (frei>2) then summe:=summe+(anz+frei+setz   );
    2 : if (frei>1) then summe:=summe+(anz+frei+setz+15);
  else
        if (frei>0) then summe:=summe+(anz+frei+setz+70);
  end;

end;

(* Situationsbewertung, lokale Brettanalyse um einen Punkt (ix,iy) *)

procedure suche(var summe  : integer; var dreier : integer;
                var vierer : boolean; ix, iy     : integer;
                var feld   : spielbrett; typ     : integer);

var stein, t, z, dreix, dreiy, z1, z2  : integer;
    last, lastd1, lastd2               : integer;
    dreid1, dreid2                     : integer;
    tsumx, tsumd1,        tsumd2       : integer;
    sumx,  sumy,  sumd1,  sumd2        : integer;
    freix, freiy, freid1, freid2       : integer;
    sable, d1sable,       d2sable      : integer;
    tsable, td1sable,    td2sable      : integer;
    s1, s2, s1d1, s2d1, s1d2, s2d2     : integer;
    dazx, dazd1,dazd2                  : integer;
    tdazx, tdazd1, tdazd2              : integer;
    flag1, flag2, flag3, flag4         : boolean;
    sp1flag, sp2flag, spxflag          : boolean;
    sp1d1flag, sp2d1flag, spd1flag     : boolean;
    sp1d2flag, sp2d2flag, spd2flag     : boolean;
    d1flag1, d1flag2, d2flag1, d2flag2 : boolean;
    d1flag3, d2flag3, d1flag4, d2flag4 : boolean;
    flag2x, flag2d1, flag2d2           : boolean;

begin

  (* Horizontale *)

  flag1:=true; flag2:=true;
  flag3:=true; flag4:=true;

  sumx  :=0; tsumx:=0;
  freix :=0; last :=-1;
  dazx  :=0; tdazx:=0;
  tsable:=0; s1   :=0;

  sp1flag:=false; flag2x:=false;

  for t:=ix to xmax do begin

    stein:=feld[t,iy];
    if (stein=typ) then begin
      if (last=t-1) then flag2x:=true;
      if flag1 then inc( sumx);  (* zusammenhngende Eigene ab ix *)
      if flag2 then inc(tsumx); (* alle Eigenen, nur leere dazwischen *)
      if (not flag1) and flag2 and flag4 then begin
        if flag3 then dazx:=s1;
        tdazx:=freix;
        flag4:=false;
      end;
      last:=t;
    end
    else begin
      flag1:=false;
      if (stein=3-typ) then flag2:=false;
      if (stein=0) and flag2 then begin
        inc(freix); (* alle eigenen Leerstellen *)
        if (iy=1) or ((iy>1) and (feld[t,iy-1]<>0)) then begin
          inc(tsable); (* setzbare Positionen *)
          if flag3 then begin inc(s1); sp1flag:=true; end; (* zus. setzb. *)
        end
        else flag3:=false;
      end;
    end;
  end;

  flag1:=true; flag2:=true; flag3:=true; flag4:=true;
  sp2flag:=false; last:=-1; s2:=0; z:=freix;

  for t:=ix downto 1 do begin

    stein:=feld[t,iy];
    if (stein=typ) then begin
      if (last=t+1) then flag2x:=true;
      if flag1 then inc( sumx);
      if flag2 then inc(tsumx);
      if (not flag1) and flag2 and flag4 then begin
        if ( dazx<>1) and flag3 then  dazx:=s2;
        if (tdazx<>1)           then tdazx:=freix-z;
        flag4:=false;
      end;
      last:=t;
    end
    else begin
      flag1:=false;
      if (stein=3-typ) then flag2:=false;
      if (stein=0) and flag2 then begin
        inc(freix);
        if (iy=1) or ((iy>1) and (feld[t,iy-1]<>0)) then begin
          inc(tsable);
          if flag3 then begin inc(s2); sp2flag:=true; end;
        end
        else flag3:=false;
      end;
    end;
  end;

  if (sumx>0) then begin dec(sumx); dec(tsumx); end;
  if (sumx=0) and (freix>0) then dec(freix);
  spxflag:=sp1flag and sp2flag;
  sable:=s1+s2;

  (* Vertikale *)

  flag1:=true; flag2:=true;
  sumy :=0;    freiy:=0;

  for t:=iy to ymax do begin

    stein:=feld[ix,t];
    if (stein=typ) and flag1 then
      inc(sumy)
    else begin
      flag1:=false;
      if (stein=0) and flag2 then inc(freiy) else flag2:=false;
    end;
  end;

  flag1:=true;

  for t:=iy downto 1 do begin

    stein:=feld[ix,t];
    if (stein=typ) and flag1 then inc(sumy) else flag1:=false;
  end;

  if (sumy>0) then dec(sumy);
  if (sumy=0) and (freiy>0) then dec(freiy);

  (* Diagonalen *)

  d1flag1:=true; d2flag1:=true;
  d1flag2:=true; d2flag2:=true;
  d1flag3:=true; d2flag3:=true;
  d1flag4:=true; d2flag4:=true;

  sp1d1flag:=false; sp2d1flag:=false;
  sp1d2flag:=false; sp2d2flag:=false;
  flag2d1  :=false; flag2d2  :=false;

  tsumd1  :=0;  tsumd2  :=0;
  sumd1   :=0;  sumd2   :=0;
  freid1  :=0;  freid2  :=0;
  td1sable:=0;  td2sable:=0;
  s1d1    :=0;  s2d1    :=0;
  s1d2    :=0;  s2d2    :=0;
  dazd1   :=0;  dazd2   :=0;
  tdazd1  :=0;  tdazd2  :=0;
  lastd1  :=-1; lastd2  :=-1;

  for t:=iy to max(xmax,ymax) do begin

    if (t<=ymax) and ((t-iy+ix)<=xmax) then begin
      stein:=feld[ix+t-iy,t];
      if (stein=typ) then begin
        if (lastd1=t-1) then flag2d1:=true;
        if d1flag1 then inc( sumd1);
        if d1flag2 then inc(tsumd1);
        if (not d1flag1) and d1flag2 and d1flag4 then begin
          if d1flag3 then dazd1:=s1d1;
          tdazd1:=freid1;
          d1flag4:=false;
        end;
        lastd1:=t;
      end
      else begin
        d1flag1:=false;
        if (stein=3-typ) then d1flag2:=false;
        if (stein=0) and d1flag2 then begin
          inc(freid1);
          if (t=1) or ((t>1) and (feld[ix+t-iy,t-1]<>0)) then begin
            inc(td1sable);
            if d1flag3 then begin inc(s1d1); sp1d1flag:=true; end;
          end
          else d1flag3:=false;
        end;
      end;
    end;

    if (t<=ymax) and ((ix-t+iy)>=1) then begin
      stein:=feld[ix-t+iy,t];
      if (stein=typ) then begin
        if (lastd2=t-1) then flag2d2:=true;
        if d2flag1 then inc( sumd2);
        if d2flag2 then inc(tsumd2);
        if (not d2flag1) and d2flag2 and d2flag4 then begin
          if d2flag3 then dazd2:=s1d2;
          tdazd2:=freid2;
          d2flag4:=false;
        end;
        lastd2:=t;
      end
      else begin
        d2flag1:=false;
        if (stein=3-typ) then d2flag2:=false;
        if (stein=0) and d2flag2 then begin
          inc(freid2);
          if (t=1) or ((t>1) and (feld[ix-t+iy,t-1]<>0)) then begin
            inc(td2sable);
            if d2flag3 then begin inc(s1d2); sp1d2flag:=true; end;
          end
          else d2flag3:=false;
        end;
      end;
    end;
  end;

  d1flag1:=true; d2flag1:=true;
  d1flag2:=true; d2flag2:=true;
  d1flag3:=true; d2flag3:=true;
  d1flag4:=true; d2flag4:=true;

  lastd1:=-1; z1:=freid1;
  lastd2:=-1; z2:=freid2;

  for t:=iy downto 1 do begin

    if ((ix+t-iy)>=1) then begin
      stein:=feld[ix+t-iy,t];
      if (stein=typ) then begin
        if (lastd1=t+1) then flag2d1:=true;
        if d1flag1 then inc( sumd1);
        if d1flag2 then inc(tsumd1);
        if (not d1flag1) and d1flag2 and d1flag4 then begin
          if ( dazd1<>1) and d1flag3 then dazd1:=s2d1;
          if (tdazd1<>1)             then tdazd1:=freid1-z1;
          d1flag4:=false;
        end;
        lastd1:=t;
      end
      else begin
        d1flag1:=false;
        if (stein=3-typ) then d1flag2:=false;
        if (stein=0) and d1flag2 then begin
          inc(freid1);
          if (t=1) or ((t>1) and (feld[ix+t-iy,t-1]<>0)) then begin
            inc(td1sable);
            if d1flag3 then begin inc(s2d1); sp2d1flag:=true; end;
          end
          else d1flag3:=false;
        end;
      end;
    end;

    if ((ix-t+iy)<=xmax) then begin
      stein:=feld[ix-t+iy,t];
      if (stein=typ) then begin
        if (lastd2=t+1) then flag2d2:=true;
        if d2flag1 then inc( sumd2);
        if d2flag2 then inc(tsumd2);
        if (not d2flag1) and d2flag2 and d2flag4 then begin
          if ( dazd2<>1) and d2flag3 then  dazd2:=s2d2;
          if (tdazd2<>1)             then tdazd2:=freid2-z2;
          d2flag4:=false;
        end;
        lastd2:=t;
      end
      else begin
        d2flag1:=false;
        if (stein=3-typ) then d2flag2:=false;
        if (stein=0) and d2flag2 then begin
          inc(freid2);
          if (t=1) or ((t>1) and (feld[ix-t+iy,t-1]<>0)) then begin
            inc(td2sable);
            if d2flag3 then begin inc(s2d2); sp2d2flag:=true; end;
          end
          else d2flag3:=false;
        end;
      end;
    end;
  end;

  if (sumd1>0) then begin dec(sumd1); dec(tsumd1); end;
  if (sumd2>0) then begin dec(sumd2); dec(tsumd2); end;

  if (sumd1=0) and (freid1>0) then dec(freid1);
  if (sumd2=0) and (freid2>0) then dec(freid2);

  spd1flag:=sp1d1flag and sp2d1flag;
  spd2flag:=sp1d2flag and sp2d2flag;

  d1sable:=s1d1+s2d1;
  d2sable:=s1d2+s2d2;

  (* Punkte vergeben, auswerten *)

  summe:=0;
  vierer:=false;
  if (sumx>3) or (sumy>3) or (sumd1>3) or (sumd2>3) then vierer:=true;

  dreier:=0;
  flag1:=false; flag2:=false; flag3:=false;

  if not vierer then begin
    dreix:=0; dreiy:=0; dreid1:=0; dreid2:=0;

    punkte(summe,sumx,tsumx,freix,sable);
    punkte(summe,sumy,sumy,freiy,freiy);
    punkte(summe,sumd1,tsumd1,freid1,d1sable);
    punkte(summe,sumd2,tsumd2,freid2,d2sable);

    (* Dreierkennungen vergeben *)

    if (tsumx>=3) then begin
      if (freix>=1) then begin
        if flag2x and (tdazx=1) then dreix:=2;
        if (sumx=3) then if (sable>0) then dreix:=1 else dreix:=2;
        if flag2x and (dazx=1)  then dreix:=1;
        if (sumx=3) and spxflag then flag1:=true;
      end
      else dreix:=3;
    end;

    if (sumy=3) then begin
      if (freiy>=1) then dreiy:=1 else dreiy:=3;
    end;

    if (tsumd1>=3) then begin
      if (freid1>=1) then begin
        if flag2d1 and (tdazd1=1) then dreid1:=2;
        if (sumd1=3) then if (d1sable>0) then dreid1:=1 else dreid1:=2;
        if flag2d1 and (dazd1=1)  then dreid1:=1;
        if (sumd1=3) and spd1flag then flag2:=true;
      end
      else dreid1:=3;
    end;

    if (tsumd2>=3) then begin
      if (freid2>=1) then begin
        if flag2d2 and (tdazd2=1) then dreid2:=2;
        if (sumd2=3) then if (d2sable>0) then dreid2:=1 else dreid2:=2;
        if flag2d2 and (dazd2=1)  then dreid2:=1;
        if (sumd2=3) and spd2flag then flag3:=true;
      end
      else dreid2:=3;
    end;

    (* Dreier-Codierung: -1 : keiner, 1 : Zugzwang f. Gegner, 2 : setzbar,
                          3 : nicht vervollstndigbar,        0 : Zwickmhle,
                          4 : Horizontal-Zwickmhle *)
    dreier:=-1;
    if (dreix=3) or (dreiy=3) or (dreid1=3) or (dreid2=3) then dreier:=3;
    if (dreix=2) or (dreiy=2) or (dreid1=2) or (dreid2=2) then dreier:=2;
    if (dreix=1) or (dreiy=1) or (dreid1=1) or (dreid2=1) then begin
      if (dreix<>1)  then dreix:=0;
      if (dreiy<>1)  then dreiy:=0;
      if (dreid1<>1) then dreid1:=0;
      if (dreid2<>1) then dreid2:=0;

      if (dreix+dreiy+dreid1+dreid2>1) then dreier:=0 else dreier:=1;
      if (dreier<>0) and (flag1 or flag2 or flag3) then dreier:=4;
    end;
  end;

end;

(* zentraler Aufruf der Such-Funktionen *)

procedure bewerte(var summe  : integer; var dreier : integer;
                  var vierer : boolean; ix, iy     : integer;
                  var feld   : spielbrett; typ     : integer);

var a, b, dreier2 : integer;
    vierer2       : boolean;

begin

  suche(summe,dreier,vierer,ix,iy,feld,typ);
  if (iy<ymax) and not((dreier=1) or (dreier=0) or (dreier=4) or vierer) then begin
    feld[ix,iy+1]:=typ;
    feld[ix,iy  ]:=3-typ;
    suche(b,dreier2,vierer2,ix,iy+1,feld,typ);
    feld[ix,iy  ]:=typ;
    feld[ix,iy+1]:=0;
    if vierer2 then dreier:=1;
  end;

end;

(* Ist das Spiel beendet ? *)

function ready(var feld : spielbrett):integer;

var summe, dreier, typ, fertig, x, y : integer;
    vierer, flag                          : boolean;

begin

  fertig:=0;
  vierer:=false;

  for typ:=1 to 2 do
    for x:=1 to xmax do
      for y:=1 to ymax do begin
        suche(summe,dreier,vierer,x,y,feld,typ);
        if vierer then fertig:=typ;
  end;

  if (fertig=0) then begin
    flag:=true;
    for x:=1 to xmax do
      if (feld[x,ymax]=0) then flag:=false;
    if flag then ready:=3 else ready:=fertig;
  end
  else
    ready:=fertig;

end;

(* Bewerten der Spalten *)

procedure denke(var feld : spielbrett; var bewe : bewertung;
                    typ  : integer);

var dreier, x, y, psumme : integer;
    vierer               : boolean;

begin

  for x:=1 to xmax do begin
    y:=ziehe(feld,x,typ);
    if (y<>0) then begin
      bewerte(psumme,dreier,vierer,x,y,feld,typ);
      bewe[1,x]:=psumme;
      bewe[2,x]:=0;
      bewe[0,x]:=dreier;
      if vierer then bewe[2,x]:=1;
      entnehme(feld,x);
    end
    else begin
      bewe[1,x]:=-1;
      bewe[2,x]:=0;
      bewe[0,x]:=-1;
    end;
  end;

end;

(* Parallel-Dreier vorhanden? *)

function vorpardreier(feld : spielbrett; x, wer : integer):boolean;

var summe, dreier, y : integer;
    vierer, avierer  : boolean;

begin

  avierer:=false;
  vorpardreier:=false;
  y:=ziehe(feld,x,wer);
  if (y<>0) then begin
    entnehme(feld,x);
    for y:=y to ymax do begin
      feld[x,y]:=wer;
      suche(summe,dreier,vierer,x,y,feld,wer);
      if vierer and avierer then vorpardreier:=true;
      feld[x,y]:=0;
      avierer:=vierer;
    end;
  end;

end;

(* Problem der parallelen, offenen Dreier *)

function pardreier(feld : spielbrett; wer, x, y : integer):boolean;

var summe, dreier : integer;
    flag, vierer  : boolean;

begin

  pardreier:=false;
  vierer:=false;
  flag:=false;

  if (y>1) and (feld[x,y-1]=0) then begin
    feld[x,y-1]:=wer;
    suche(summe,dreier,vierer,x,y-1,feld,wer);
    feld[x,y-1]:=0;
    flag:=vierer;
  end
  else flag:=false;

  if (feld[x,y]=0) then begin
    feld[x,y]:=wer;
    suche(summe,dreier,vierer,x,y,feld,wer);
    feld[x,y]:=0;
    if vierer and flag then pardreier:=true;
    flag:=vierer;
  end
  else flag:=false;

  if (y<ymax) and (feld[x,y+1]=0) then begin
    feld[x,y+1]:=wer;
    suche(summe,dreier,vierer,x,y+1,feld,wer);
    feld[x,y+1]:=0;
    if vierer and flag then pardreier:=true;
  end;

end;

(* testen, ob Parallel-Zugzwang-Dreier *)

function check(feld : spielbrett; wer, x : integer):boolean;

var a, b, y      : integer;
    flagr, flagl : boolean;

begin

  y:=ziehe(feld,x,wer);

  flagr:=false; flagl:=false;

  (* Horizontale *)

  if (y<>0) then begin
    a:=-1;
    repeat
      inc(a);
    until ((x+a)=xmax) or (feld[x+a,y]<>wer);
    b:=-1;
    repeat
      inc(b);
    until ((x-b)=1) or (feld[x-b,y]<>wer);

    if (feld[x+a,y]=0) then flagr:=pardreier(feld,wer,x+a,y);
    if (feld[x-b,y]=0) then flagl:=pardreier(feld,wer,x-b,y);

    (* Diagonale 1, luro *)

    a:=-1;
    repeat
      inc(a);
    until ((x+a)=xmax) or ((y+a)=ymax) or (feld[x+a,y+a]<>wer);
    b:=-1;
    repeat
      inc(b);
    until ((x-b)=1) or ((y-b)=1) or (feld[x-b,y-b]<>wer);

    if (feld[x+a,y+a]=0) then flagr:=pardreier(feld,wer,x+a,y+a);
    if (feld[x-b,y-b]=0) then flagl:=pardreier(feld,wer,x-b,y-b);

    (* Diagonale 2, loru *)

    a:=-1;
    repeat
      inc(a);
    until ((x+a)=xmax) or ((y-a)=1) or (feld[x+a,y-a]<>wer);
    b:=-1;
    repeat
      inc(b);
    until ((x-b)=1) or ((y+b)=ymax) or (feld[x-b,y+b]<>wer);

    if (feld[x+a,y-a]=0) then flagr:=pardreier(feld,wer,x+a,y-a);
    if (feld[x-b,y+b]=0) then flagl:=pardreier(feld,wer,x-b,y+b);

    if flagl or flagr then check:=true else check:=false;
  end
  else
    check:=false;
end;

(* Zugzwang-Analysator *)

function zugzwang(wer : integer; var feld : spielbrett; zugx, phase, depth : integer; var endrek : integer):integer;

var zzz, zz, a, b, ry, x, xphase : integer;
    ya, summe, dreier, typ, rek  : integer;
    vierer                       : boolean;
    bewe                         : bewertung;

begin

  vierer:=false;
  zz:=-1; rek:=-1;
  inc(phase);
  xphase:=-1;

  ya:=ziehe(feld,zugx,wer);
  if (ya=0) then zz:=0;

  ry:=ready(feld);

  if (ry=1) or (ry=2) then begin zz:=ry; rek:=ry; end;
  if (ry=3)           then begin zz:=0;  rek:=0;  end;
  if (ry<>0)          then xphase:=phase;

  if (zz=-1) and ((phase<depth) or (depth=-1)) then begin
    zz:=0;

    if (wer=2) then begin
      for typ:=1 to 2 do
        for x:=1 to xmax do begin
          if (typ=1) then bewe[0,x]:=0;
          a:=ziehe(feld,x,typ);

          if (a<>0) then begin
            bewerte(summe,dreier,vierer,x,a,feld,typ);
            entnehme(feld,x);

            if vierer and (typ=1) then begin
              rek:=1; zz:=1;
              xphase:=phase+1;
            end;

            if ((dreier=0) or (dreier=1) or (dreier=4)) and (typ=1) then bewe[0,x]:=1;

            zzz:=0;
            if vierer and (typ=2) and (zz=0) then
              zzz:=zugzwang(1,feld,x,phase,depth,endrek);
            if (zzz=2) then zz:=2;
            if (zzz=1) then if (zz=0) then zz:=1;
          end;
      end;
                           (* kann der Gegner mich zwingen ?    *)
      if (zz=0) then begin (* absolut keine Zugzwangmglichkeit *)
        for x:=1 to xmax do begin
          if (bewe[0,x]=1) then begin
            zzz:=0;
            zzz:=zugzwang(1,feld,x,phase,depth,endrek);
            if (zzz=1) then zz:=1; (* der Gegner kann mich fertig machen ! *)
          end;
        end;
      end;
    end
    else begin
      for typ:=2 downto 1 do
        for x:=1 to xmax do begin
          if (typ=2) then bewe[0,x]:=0;
          a:=ziehe(feld,x,typ);

          if (a<>0) then begin
            bewerte(summe,dreier,vierer,x,a,feld,typ);
            entnehme(feld,x);

            if vierer and (typ=2) then begin
               rek:=2; zz:=2;
               xphase:=phase+1;
            end;

            if ((dreier=0) or (dreier=1) or (dreier=4)) and (typ=2) then bewe[0,x]:=1;

            zzz:=0;
            if vierer and (typ=1) and (zz=0) then
              zzz:=zugzwang(2,feld,x,phase,depth,endrek);
            if (zzz=1) then zz:=1;
            if (zzz=2) then if (zz=0) then zz:=2;
          end;
      end;

      if (zz=0) then begin
        for x:=1 to xmax do begin
          if (bewe[0,x]=1) then begin
            zzz:=0;
            zzz:=zugzwang(2,feld,x,phase,depth,endrek);
            if (zzz=2) then zz:=2;
          end;
        end;
      end;
    end;
  end;

  zugzwang:=zz;
  if (rek<>-1) then if
    (endrek=-1) or (xphase<endrek) then endrek:=xphase;

  if (ya<>0) then entnehme(feld,zugx);

end;

(* generiert den Zug des Computers *)

function comzug(level : integer; feld : spielbrett; wer : integer):integer;

var endrek1, endrek2, depth : integer;
    zugx, x, a, b, t        : integer;
    setf, flag, c, d        : boolean;

    bewe : array[1..2] of bewertung;

begin

  for t:=1 to 2 do begin
    for x:=1 to xmax do begin
       bewe[t,1,x]:=0; bewe[t,2,x]:=0; bewe[t,0,x]:=-1; end;
    denke(feld,bewe[t],t);
  end;

  zugx:=0;

  (* bewe : Spieler, 0..2, Position. 0: Dreierkennung, 1: Bewertung,
                                     2: 1 = gewonnen, 0 = nicht gewonnen *)
  (* Kann jemand gewinnen? *)

  for x:=1 to xmax do begin
    if (bewe[3-wer,2,x]=1) then zugx:=x;
  end;

  for x:=1 to xmax do begin
    if (bewe[wer,2,x]=1) then zugx:=x;
  end;

  (* Zugzwang-Kontrolle *)

  if (zugx=0) then begin

    case level of
      0 : depth:=2;
      1 : depth:=6;
      2 : depth:=-1;
    end;

    for x:=1 to xmax do begin
      if (feld[x,ymax]=0) then begin

        endrek1:=-1;
        endrek2:=-1;
        a:=zugzwang(wer  ,feld,x,0,depth,endrek1);
        b:=zugzwang(3-wer,feld,x,0,depth,endrek2);
        c:=vorpardreier(feld,x,  wer);
        d:=vorpardreier(feld,x,3-wer);
        if (c or d) and not((a=0) and (b=0)) then begin
          c:=false; d:=false;
        end;

       (* keiner darf ziehen, sonst gewinnt Gegner *)

        if (a=3-wer) and (b=wer) then begin
          bewe[wer,1,x]:=-(4-wer);
          bewe[wer,2,x]:=endrek1;
          bewe[wer,0,x]:=-2;
        end;

        (* die darf ich nicht setzen, tragisch *)

        if ((a=3-wer) and (b=0)) or d then begin
          bewe[wer,1,x]:=-(4-wer);
          bewe[wer,2,x]:=endrek1;
          bewe[wer,0,x]:=-2;
        end;

        (* setzen, Zugzwangkaskade aufbaubar ! *)

        if (a=wer) or c then begin
          bewe[wer,1,x]:=-(wer+1);
          bewe[wer,2,x]:=endrek1;
          bewe[wer,0,x]:=-2;
        end;

        (* wenn ich diesen setze, macht Gegner kaputt *)

        if (a=0) and (b=wer) and
           ((level=2) or (zugzaehl>=(xmax*ymax-6))) then begin
          bewe[wer,1,x]:=-4; (* Spezialkennung eingefhrt! *)
          bewe[wer,2,x]:=endrek2;
          bewe[wer,0,x]:=-2;
        end;

        (* verhindern *)

        if (b=3-wer) and (a=0) then begin
          bewe[3-wer,1,x]:=-(4-wer);
          bewe[3-wer,2,x]:=endrek2;
          bewe[3-wer,0,x]:=-2;
        end;

        (* sowieso Hoffnungslos *)

        if (b=3-wer) and (a=3-wer) then begin
          bewe[wer,1,x]:=-(4-wer);
          bewe[wer,2,x]:=min(endrek2,endrek1);
          bewe[wer,0,x]:=-2;
        end;
      end;
    end;

    (* Zugzwang-Kaskaden ?                 *)
    (* Gegner kann gewinnen -> verhindern! *)

    zugx:=0; a:=-1; flag:=true;
    t:=xmax*ymax;

    for x:=1 to xmax do
      if (bewe[3-wer,2,x]<=t) and (bewe[3-wer,1,x]=-(4-wer)) then begin
        if (bewe[3-wer,2,x]=t) then begin
          if (bewe[wer,1,x]>a) then zugx:=x;
          a:=bewe[wer,1,x];
          flag:=false;
        end;
        if flag then begin a:=bewe[wer,1,x]; zugx:=x; end;
        t:=bewe[3-wer,2,x];
    end;

    (* Computer gewinnt, Zugzwang f. Gegner *)

    t:=xmax*ymax;
    for x:=1 to xmax do
      if (bewe[wer,2,x]<=t) and (bewe[wer,1,x]=-(wer+1)) then begin
        zugx:=x;
        t:=bewe[wer,2,x];
    end;

    (* keine Kaskaden *)

    if (zugx=0) then begin

      flag:=true;
      for x:=1 to xmax do
        if (bewe[wer,1,x]<>-(4-wer)) and (bewe[wer,1,x]<>-1) then flag:=false;

      (* hoffnungslos? den besten schlechten Zug nehmen, evt. Dummheit des Gegners *)

      if flag then begin
        t:=0;
        for x:=1 to xmax do
          if (bewe[wer,2,x]>=t) and (bewe[wer,1,x]=-(4-wer)) then begin
            zugx:=x;
            t:=bewe[wer,2,x];
        end;
      end;

      if (zugx=0) then begin

        (* hat Gegner Zwickmhlen? nur f. Level 1 ntig *)

        for t:=4 downto 0 do
          if (t=4) or (t=0) then begin
            a:=0;
            for x:=1 to xmax do
              if (bewe[wer,1,x]>=a) and (bewe[3-wer,0,x]=t) then begin
                zugx:=x;
                a:=bewe[wer,1,x];
            end;
        end;

        (* eigenen Zugzwang-Dreier ausspielen *)

        t:=0;
        for x:=1 to xmax do
          if (bewe[wer,1,x]>=t) and (bewe[wer,0,x]=1) then begin
            zugx:=x;
            t:=bewe[wer,1,x];
        end;

        (* eigene Zwickmhle ausspielen *)

        for t:=4 downto 0 do
          if (t=4) or (t=0) then begin
            a:=0;
            for x:=1 to xmax do
              if (bewe[wer,1,x]>=a) and (bewe[wer,0,x]=t) then begin
                zugx:=x;
                a:=bewe[wer,1,x];
            end;
        end;

        (* kann Computer parallelen Zugzwang-Dreier aufbauen? *)

        t:=0; setf:=false;

        if (zugx=0) then
          for x:=1 to xmax do
            if (not setf) and ((level=2) or (bewe[wer,0,x]=2)) then begin
              setf:=check(feld,wer,x);
              if setf and (bewe[wer,1,x]>=t) then begin
                zugx:=x;
                t:=bewe[wer,1,x];
              end;
        end;

        (* Gegner ist nicht im Zugzwang, also evt. par. ZZ-3er des Geg. verh. *)

        t:=0; setf:=false;

        if (zugx=0) then
          for x:=1 to xmax do
            if (not setf) and ((level=2) or (bewe[3-wer,0,x]=2)) then begin
              setf:=check(feld,3-wer,x);
              if setf and (bewe[wer,1,x]>=t) then begin
                zugx:=x;
                t:=bewe[wer,1,x];
              end;
        end;
      end;

      (* keine kritischen Zuege vorhanden !   *)
      (* strategische Analysen starten        *)

      (* vervollstndigbarer Dreier? *)

      if (zugx=0) then begin

        t:=0;
        for x:=1 to xmax do
          if (bewe[wer,1,x]>=t) and (bewe[wer,0,x]=2) then begin
            zugx:=x;
            t:=bewe[wer,1,x];
        end;
      end;

      (* Mitte noch frei?, sonst besten Zug nehmen! *)

      if (zugx=0) then begin

        t:=0;
        if (feld[round(xmax/2),ymax]=0) and
           (bewe[wer,1,round(xmax/2)]>=0) then begin
          zugx:=round(xmax/2)
        end
        else begin
          for x:=1 to xmax do
            if (bewe[wer,1,x]>=t) then begin
              t:=bewe[wer,1,x];
              zugx:=x;
          end;

          (* kein vernnftiger Zug mehr -> den Gegner rgern! *)

          if (zugx<>0) and (t=0) then begin
            for x:=1 to xmax do
              if (bewe[3-wer,1,x]>=t) and (bewe[wer,1,x]>=0) then begin
                t:=bewe[3-wer,1,x];
                zugx:=x;
            end;
          end;

        end;
      end;
    end;

    (* Codierung: -1 : Spalte voll, -3 : Gegner gewinnt, -2 : Comp. gewinnt *)
    (* Endspiel: Gegner gewinnt, Gegner zerstrt meinen 3er *)

    if (zugx=0) then begin

      for x:=1 to xmax do
        if (bewe[wer,1,x]=-(4-wer)) then zugx:=x;
      for x:=1 to xmax do
        if (bewe[wer,1,x]=-4)       then zugx:=x;
    end;
  end;

  comzug:=zugx;

end;

(* Windows-Dialogbox-Aktionen auswerten *)
(* About-Box                            *)

function About(Dialog: HWnd; Message, WParam: Word; LParam: Longint): Bool; export;
begin

  About:= True;
  case Message of
    wm_InitDialog:
      Exit;
    wm_Command:
      if (WParam = id_ok) or (WParam = id_Cancel) then
      begin
        EndDialog(Dialog, 1);
        Exit;
      end;
  end;
  About:= False;

end;

(* Level-Dialogbox *)

function LevelDialog(Dialog: HWnd; Message, WParam: Word; LParam: Longint): Bool; export;
begin

  LevelDialog:= True;
  case Message of
    wm_InitDialog:
      Exit;
    wm_Command:
      if ((WParam>100) and (WParam<104)) or (WParam = id_Cancel) then
      begin
        level:=WParam-101;
        EndDialog(Dialog, 1);
        Exit;
      end;
  end;
  LevelDialog:= False;

end;

(* Funktion wird von einem Timer aufgerufen, Demo-Knopf! *)

function DemoProc(Window: hWnd; Message, WParam: Word; LParam: Longint): Longint; export;

var r: trect;
    AboutProc: tFarProc;
    dx, dy: integer;
    Sanduhr : hCursor;

begin

  KillTimer(Window,2);
  GetClientRect(Window,r);
  Sanduhr:=LoadCursor(0,MAKEINTRESOURCE(idc_Wait));
  SetCursor(Sanduhr);

  if fertig<>0 then exit;

  dx:=r.Right;
  dy:=r.Bottom;

  spieler:=-1;

  if ((zugzaehl<3) and (level<>2)) then
    zug:=random(xmax-2)+2
  else

    (* Computerzug berechnen *)

    zug:=comzug(level,feld,werzieht);
    y:=ziehe(feld,zug,werzieht);
    inc(zugzaehl);
    zugmemx[zugzaehl]:=zug;
    zugmemy[zugzaehl]:=y;
    if (lzug>0) and (lzug<>zug) then faerbe(Window,dx,dy,lzug,0,2);
    faerbe(Window,dx,dy,zug,0,1);
    zeigestein(Window,dx,dy,zug,y,werzieht);
    werzieht:=3-werzieht;
    showwho(Window,dx,dy,werzieht);

    if (y<>0) then if knopf<>0 then lzug:=knopf;
    if (zug<>0) then lzug:=zug;

    (* ist die Demo beendet? *)

    fertig:=ready(feld);

    if fertig<>0 then begin
      demo:=false;
      spieler:=werzieht;
      AboutProc:= MakeProcInstance(@About, hInstance);
      if (fertig=1) then DialogBox(hInstance, 'yelwinbox', Window, AboutProc);
      if (fertig=2) then DialogBox(hInstance, 'redwinbox', Window, AboutProc);
      if (fertig=3) then DialogBox(hInstance, 'nowinbox', Window, AboutProc);
      FreeProcInstance(AboutProc);
      faerbe(Window,dx,dy,0,5,2);
   end
   else SetTimer(Window,2,50,@DemoProc);

end;

(* Auswerten aller Messages meines API-Windows *)

function WindowProc(Window: hWnd; Message, WParam: Word; LParam: Longint): Longint; export;

VAR mousex, mousey, dx, dy   : integer;
    wx, wy, rx, ry, ofx, ofy : integer;
    r, w : tRect;
    AboutProc, LevelProc: tFarProc;
    Sanduhr : HCursor;

begin

  GetClientRect(Window,r);
  dx:=r.Right;
  dy:=r.Bottom;
  WindowProc:=0;

  (* Fenster schlieen? *)

  if (message=wm_Destroy) THEN
  begin
    PostQuitMessage(0);
    Exit;
  end;

  (* Knopf-Lampe lschen *)

  if (message=wm_timer) and (funktion<>0)  then
  begin
    KillTimer(window,1);
    faerbe(Window,dx,dy,0,funktion,2);
  end;

  (* Grenvernderung oder bermalung? *)

  if (message=wm_paint) or (message=wm_size)  THEN
  begin
    GetWindowRect(window,w);
    wx:=w.right-w.left;
    wy:=w.bottom-w.top;
    if (wy<sizey) or (wx<sizex) then
    begin
      if (wy<sizey) then wy:=sizey;
      if (wx<sizex) then wx:=sizex;
      MoveWindow(window,w.left,w.top,wx,wy,false);
      GetClientRect(Window,r);
      dx:=r.Right;
      dy:=r.Bottom;
    end;
    brett(Window,feld);
    faerbe(Window,dx,dy,lzug,0,1);
    if demo then faerbe(Window,dx,dy,0,5,1);
  end;

  (* Knopf gedrckt? Auswerten! *)

  if (Message=wm_LButtonDown)  THEN
  begin

    mousex:=lParam mod 65536;
    mousey:=lParam div 65536;

    ofx:=dx div 4;
    ofy:=dy div 7;
    rx:=round((dx-ofx-30)/8*3/8);
    ry:=round((dy-ofy-23)/7*3/8);

    (* Kreis-Symbol angeklickt? *)

    if (mousex > ofx div 2 -rx) and (mousey > round(ofy*2/3)-ry) and
       (mousex < ofx div 2 +rx) and (mousey < round(ofy*2/3)+ry) THEN
    begin
      werzieht:=3-werzieht;
      showwho(Window,dx,dy,werzieht);
      SetTimer(Window,1,350,@WindowProc);
    end;

    (* Mausposition auswerten *)

    knopf:=0;
    funktion:=0;

    mausknopf(Window,mousex,mousey,dx,dy,knopf,funktion);

    (* Knopf gedrckt? Einfrben! *)

    if (fertig<>0) and not((funktion=2) or (funktion=3) or (funktion=6)) then
    begin
      faerbe(Window,dx,dy,0,funktion,2);
      if (lzug<>knopf) then faerbe(Window,dx,dy,knopf,0,2);
    end;

    if (demo and (funktion<>5)) then
    begin
      faerbe(Window,dx,dy,0,funktion,2);
      faerbe(Window,dx,dy,knopf,0,2);
    end;

    IF (((knopf<>0) or (funktion<>0)) and (not demo)) or
       (demo and (funktion=5)) THEN
    begin

      (* Stein einwerfen *)

      if (knopf<>0) and (fertig=0) then begin
        y:=ziehe(feld,knopf,werzieht);
        if (y<>0) then begin
          spieler:=werzieht;
          inc(zugzaehl);
          zugmemx[zugzaehl]:=knopf;
          zugmemy[zugzaehl]:=y;
          if (lzug>0) and (lzug<>knopf) then faerbe(Window,dx,dy,lzug,0,2);
          zeigestein(Window,dx,dy,knopf,y,werzieht);
          werzieht:=3-werzieht;
          showwho(Window,dx,dy,werzieht);
        end
        else
          faerbe(Window,dx,dy,knopf,0,2);
      end;

      (* Demo starten, DEMO*)

      if (funktion=5) and (fertig=0) then
      begin
        demo:=not demo;
        if demo THEN SetTimer(Window,2,50,@DemoProc) else
        begin
          KillTimer(Window,2);
          SetTimer(Window,1,350,@WindowProc);
        end;
      end;

      (* Computerzug ausfhren!, MOVE *)

      zug:=0;
      if (funktion=1) and (fertig=0) then begin
        Sanduhr:=LoadCursor(0,MAKEINTRESOURCE(idc_Wait));
        SetCursor(Sanduhr);
        if demo then spieler:=-1 else spieler:=3-werzieht;
        if ((zugzaehl<3) and (level<>2)) then
          zug:=random(xmax-2)+2
        else
          zug:=comzug(level,feld,werzieht);
        y:=ziehe(feld,zug,werzieht);
        inc(zugzaehl);
        zugmemx[zugzaehl]:=zug;
        zugmemy[zugzaehl]:=y;
        if (lzug>0) and (lzug<>zug) then faerbe(Window,dx,dy,lzug,0,2);
        faerbe(Window,dx,dy,zug,0,1);
        zeigestein(Window,dx,dy,zug,y,werzieht);
        werzieht:=3-werzieht;
        showwho(Window,dx,dy,werzieht);
        if (not demo) then SetTimer(Window,1,350,@WindowProc);
      end;

      (* letzen Zug zurcknehmen, BACK *)

      if (funktion=2) then
      begin
        if (zugzaehl>0) then begin
          knopf:=zugmemx[zugzaehl];
          y:=zugmemy[zugzaehl];
          entnehme(feld,knopf);
          if (lzug>0) and (lzug<>zug) then faerbe(Window,dx,dy,lzug,0,2);
          zeigestein(Window,dx,dy,knopf,y,4);
          faerbe(Window,dx,dy,knopf,0,1);
          werzieht:=3-werzieht;
          showwho(Window,dx,dy,werzieht);
          dec(zugzaehl);
        end;
        SetTimer(Window,1,350,@WindowProc);
      end;

      (* Level-Knopf; LEVEL *)

      if (funktion=3) then
      begin
        LevelProc:= MakeProcInstance(@LevelDialog, hInstance);
        DialogBox(hInstance, 'levelbox', Window, LevelProc);
        FreeProcInstance(LevelProc);
        SetTimer(Window,1,350,@WindowProc);
        Exit;
      end;

      (* Spiel neu starten; NEW! *)

      if (funktion=4) then begin
        fertig:=0;
        for i:=1 to xmax do
          for ii:=0 to ymax do
            feld[i,ii]:=0;
        werzieht:=2;
        zugzaehl:=0;
        brett(window,feld);
        faerbe(Window,dx,dy,0,funktion,1);
        SetTimer(Window,1,350,@WindowProc);
      end;

      (* Info-Boxen anzeigen; INFO *)

      if (funktion=6) then begin
        AboutProc:= MakeProcInstance(@About, hInstance);
        DialogBox(hInstance, 'aboutbox', Window, AboutProc);
        FreeProcInstance(AboutProc);
        AboutProc:= MakeProcInstance(@About, hInstance);
        DialogBox(hInstance, 'infobox', Window, AboutProc);
        FreeProcInstance(AboutProc);
        SetTimer(Window,1,350,@WindowProc);
        Exit;
      end;

      if (fertig=0) then begin
        if (y<>0) then if (knopf<>0) then lzug:=knopf;
        if (zug<>0) then lzug:=zug;
      end;

      (* Ist das Spiel beendet? *)

      fertig:=ready(feld);

      if fertig<>0 then begin
        AboutProc:= MakeProcInstance(@About, hInstance);
        if (fertig=spieler)   then DialogBox(hInstance, 'menwinbox', Window, AboutProc);
        if (fertig=3-spieler) then DialogBox(hInstance, 'compwinbox', Window, AboutProc);
        if (fertig=3)         then DialogBox(hInstance, 'nowinbox', Window, AboutProc);
        FreeProcInstance(AboutProc);
        Exit;
      end;
    end;
  end;
  WindowProc:=DefWindowProc(Window,Message,WParam,LParam);

end;

(* Window registrieren, creieren, anzeigen *)

procedure WinMain;
var
  Window: HWnd;
  Message: TMsg;
  LevelProc: tFarProc;

const WindowClass: TWndClass = (
    style: cs_HRedraw + cs_VRedraw;
    lpfnWndProc: @WindowProc;
    cbClsExtra: 0;
    cbWndExtra: 0;
    hInstance: 0;
    hIcon: 0;
    hCursor: 0;
    hbrBackground: 0;
    lpszMenuName: NIL;
    lpszClassName: AppName);

begin

  if HPrevInst = 0 then
  begin
    WindowClass.hInstance := HInstance;
    WindowClass.hIcon := LoadIcon(0, idi_application);
    WindowClass.hCursor := LoadCursor(0, idc_Arrow);
    WindowClass.hbrBackground := GetStockObject(white_Brush);
    if not RegisterClass(WindowClass) then Halt(255);
  end;
  Window := CreateWindow(
    AppName,
    AppName,
    ws_OverlappedWindow,
    155,
    100,
    330,
    280,
    0,
    0,
    HInstance,
    nil);

  ShowWindow(Window, CmdShow);
  UpdateWindow(Window);

  GetWindowRect(Window,size);
  sizex:=size.right-size.left;
  sizey:=size.bottom-size.top;

  LevelProc:= MakeProcInstance(@LevelDialog, hInstance);
  DialogBox(hInstance, 'levelbox', Window, LevelProc);
  FreeProcInstance(LevelProc);

  (* Window-Message-Loop *)

  while GetMessage(Message, 0, 0, 0) do
  begin
    TranslateMessage(Message);
    DispatchMessage(Message);
  end;
  Halt(Message.wParam);

end;

(* Hauptprogramm *)

begin

    demo:=false;

    (* Farben bereitstellen *)

    col[0]:=PaletteIndex(0);
    col[1]:=PaletteIndex(15);
    col[2]:=PaletteIndex(13);
    col[3]:=PaletteIndex(16);
    col[4]:=PaletteIndex(18);
    col[5]:=PaletteIndex(0);

    (* Spielbrett lschen *)

    for i:=1 to xmax do
      for ii:=0 to ymax do
        feld[i,ii]:=0;

    (* Start der Anwendung *)

    werzieht:=2;
    lzug:=0;
    zugzaehl:=0;
    WinMain;

end.

